/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/cancellation","vs/base/common/arrays","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/base/common/strings","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/workspace/common/workspace","vs/platform/windows/electron-main/windows","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/map","vs/platform/state/node/state","vs/base/common/process","vs/platform/environment/common/environment","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/lazy","vs/base/common/normalization","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/code/electron-main/auth","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(K){for(var e=[],P=0,O=K.length;P<O;P++)e[P]=te[K[P]];return e};define(te[132],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;function P(b,d,g){const r=O(b,d);if(r!==-1)return b[r]}e.$db=P;function O(b,d,g=b.length-1){for(let r=g;r>=0;r--){const $=b[r];if(d($))return r}return-1}e.$eb=O;function s(b,d){const g=M(b,d);return g===-1?void 0:b[g]}e.$fb=s;function M(b,d,g=0,r=b.length){let $=g,E=r;for(;$<E;){const u=Math.floor(($+E)/2);d(b[u])?$=u+1:E=u}return $-1}e.$gb=M;function D(b,d){const g=S(b,d);return g===b.length?void 0:b[g]}e.$hb=D;function S(b,d,g=0,r=b.length){let $=g,E=r;for(;$<E;){const u=Math.floor(($+E)/2);d(b[u])?E=u:$=u+1}return $}e.$ib=S;function h(b,d,g=0,r=b.length){const $=S(b,d,g,r);return $===b.length?-1:$}e.$jb=h;class c{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(c.assertInvariants){if(this.d){for(const r of this.e)if(this.d(r)&&!d(r))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const g=M(this.e,d,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$kb=c;function m(b,d){if(b.length===0)return;let g=b[0];for(let r=1;r<b.length;r++){const $=b[r];d($,g)>0&&(g=$)}return g}e.$lb=m;function w(b,d){if(b.length===0)return;let g=b[0];for(let r=1;r<b.length;r++){const $=b[r];d($,g)>=0&&(g=$)}return g}e.$mb=w;function y(b,d){return m(b,(g,r)=>-d(g,r))}e.$nb=y;function f(b,d){if(b.length===0)return-1;let g=0;for(let r=1;r<b.length;r++){const $=b[r];d($,b[g])>0&&(g=r)}return g}e.$ob=f;function v(b,d){for(const g of b){const r=d(g);if(r!==void 0)return r}}e.$pb=v}),define(te[133],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function P(D,S){const h=Object.create(null);for(const c of D){const m=S(c);let w=h[m];w||(w=h[m]=[]),w.push(c)}return h}e.$I=P;function O(D,S){const h=[],c=[];for(const m of D)S.has(m)||h.push(m);for(const m of S)D.has(m)||c.push(m);return{removed:h,added:c}}e.$J=O;function s(D,S){const h=[],c=[];for(const[m,w]of D)S.has(m)||h.push(w);for(const[m,w]of S)D.has(m)||c.push(w);return{removed:h,added:c}}e.$K=s;class M{constructor(){this.a=new Map}add(S,h){let c=this.a.get(S);c||(c=new Set,this.a.set(S,c)),c.add(h)}delete(S,h){const c=this.a.get(S);c&&(c.delete(h),c.size===0&&this.a.delete(S))}forEach(S,h){const c=this.a.get(S);c&&c.forEach(h)}get(S){const h=this.a.get(S);return h||new Set}}e.$L=M}),define(te[134],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=e.$Ns=e.$Ms=e.$Ls=void 0;function P(S,h){const c=Math.pow(10,h);return Math.round(S*c)/c}class O{constructor(h,c,m,w=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,m))|0,this.a=P(Math.max(Math.min(1,w),0),3)}static equals(h,c){return h.r===c.r&&h.g===c.g&&h.b===c.b&&h.a===c.a}}e.$Ls=O;class s{constructor(h,c,m,w){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=P(Math.max(Math.min(1,c),0),3),this.l=P(Math.max(Math.min(1,m),0),3),this.a=P(Math.max(Math.min(1,w),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.l===c.l&&h.a===c.a}static fromRGBA(h){const c=h.r/255,m=h.g/255,w=h.b/255,y=h.a,f=Math.max(c,m,w),v=Math.min(c,m,w);let b=0,d=0;const g=(v+f)/2,r=f-v;if(r>0){switch(d=Math.min(g<=.5?r/(2*g):r/(2-2*g),1),f){case c:b=(m-w)/r+(m<w?6:0);break;case m:b=(w-c)/r+2;break;case w:b=(c-m)/r+4;break}b*=60,b=Math.round(b)}return new s(b,d,g,y)}static i(h,c,m){return m<0&&(m+=1),m>1&&(m-=1),m<1/6?h+(c-h)*6*m:m<1/2?c:m<2/3?h+(c-h)*(2/3-m)*6:h}static toRGBA(h){const c=h.h/360,{s:m,l:w,a:y}=h;let f,v,b;if(m===0)f=v=b=w;else{const d=w<.5?w*(1+m):w+m-w*m,g=2*w-d;f=s.i(g,d,c+1/3),v=s.i(g,d,c),b=s.i(g,d,c-1/3)}return new O(Math.round(f*255),Math.round(v*255),Math.round(b*255),y)}}e.$Ms=s;class M{constructor(h,c,m,w){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=P(Math.max(Math.min(1,c),0),3),this.v=P(Math.max(Math.min(1,m),0),3),this.a=P(Math.max(Math.min(1,w),0),3)}static equals(h,c){return h.h===c.h&&h.s===c.s&&h.v===c.v&&h.a===c.a}static fromRGBA(h){const c=h.r/255,m=h.g/255,w=h.b/255,y=Math.max(c,m,w),f=Math.min(c,m,w),v=y-f,b=y===0?0:v/y;let d;return v===0?d=0:y===c?d=((m-w)/v%6+6)%6:y===m?d=(w-c)/v+2:d=(c-m)/v+4,new M(Math.round(d*60),b,y,h.a)}static toRGBA(h){const{h:c,s:m,v:w,a:y}=h,f=w*m,v=f*(1-Math.abs(c/60%2-1)),b=w-f;let[d,g,r]=[0,0,0];return c<60?(d=f,g=v):c<120?(d=v,g=f):c<180?(g=f,r=v):c<240?(g=v,r=f):c<300?(d=v,r=f):c<=360&&(d=f,r=v),d=Math.round((d+b)*255),g=Math.round((g+b)*255),r=Math.round((r+b)*255),new O(d,g,r,y)}}e.$Ns=M;class D{static fromHex(h){return D.Format.CSS.parseHex(h)||D.red}static equals(h,c){return!h&&!c?!0:!h||!c?!1:h.equals(c)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof O)this.rgba=h;else if(h instanceof s)this.i=h,this.rgba=s.toRGBA(h);else if(h instanceof M)this.j=h,this.rgba=M.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&O.equals(this.rgba,h.rgba)&&s.equals(this.hsla,h.hsla)&&M.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=D.k(this.rgba.r),c=D.k(this.rgba.g),m=D.k(this.rgba.b),w=.2126*h+.7152*c+.0722*m;return P(w,4)}static k(h){const c=h/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(h){const c=this.getRelativeLuminance(),m=h.getRelativeLuminance();return c>m?(c+.05)/(m+.05):(m+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const c=this.getRelativeLuminance(),m=h.getRelativeLuminance();return c>m}isDarkerThan(h){const c=this.getRelativeLuminance(),m=h.getRelativeLuminance();return c<m}lighten(h){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:c,g:m,b:w,a:y}=this.rgba;return new D(new O(c,m,w,y*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new O(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const c=h.rgba,m=this.rgba.a,w=c.a,y=m+w*(1-m);if(y<1e-6)return D.transparent;const f=this.rgba.r*m/y+c.r*w*(1-m)/y,v=this.rgba.g*m/y+c.g*w*(1-m)/y,b=this.rgba.b*m/y+c.b*w*(1-m)/y;return new D(new O(f,v,b,y))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:c,g:m,b:w,a:y}=this.rgba;return new D(new O(h.rgba.r-y*(h.rgba.r-c),h.rgba.g-y*(h.rgba.g-m),h.rgba.b-y*(h.rgba.b-w),1))}flatten(...h){const c=h.reduceRight((m,w)=>D.o(w,m));return D.o(this,c)}static o(h,c){const m=1-h.rgba.a;return new D(new O(m*c.rgba.r+h.rgba.a*h.rgba.r,m*c.rgba.g+h.rgba.a*h.rgba.g,m*c.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(h,c,m){if(h.isLighterThan(c))return h;m=m||.5;const w=h.getRelativeLuminance(),y=c.getRelativeLuminance();return m=m*(y-w)/y,h.lighten(m)}static getDarkerColor(h,c,m){if(h.isDarkerThan(c))return h;m=m||.5;const w=h.getRelativeLuminance(),y=c.getRelativeLuminance();return m=m*(w-y)/w,h.darken(m)}static{this.white=new D(new O(255,255,255,1))}static{this.black=new D(new O(0,0,0,1))}static{this.red=new D(new O(255,0,0,1))}static{this.blue=new D(new O(0,0,255,1))}static{this.green=new D(new O(0,255,0,1))}static{this.cyan=new D(new O(0,255,255,1))}static{this.lightgrey=new D(new O(211,211,211,1))}static{this.transparent=new D(new O(0,0,0,0))}}e.$Os=D,function(S){let h;(function(c){let m;(function(w){function y(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:S.Format.CSS.formatRGBA(t)}w.formatRGB=y;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}w.formatRGBA=f;function v(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(t)}w.formatHSL=v;function b(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}w.formatHSLA=b;function d(t){const l=t.toString(16);return l.length!==2?"0"+l:l}function g(t){return`#${d(t.rgba.r)}${d(t.rgba.g)}${d(t.rgba.b)}`}w.formatHex=g;function r(t,l=!1){return l&&t.rgba.a===1?S.Format.CSS.formatHex(t):`#${d(t.rgba.r)}${d(t.rgba.g)}${d(t.rgba.b)}${d(Math.round(t.rgba.a*255))}`}w.formatHexA=r;function $(t){return t.isOpaque()?S.Format.CSS.formatHex(t):S.Format.CSS.formatRGBA(t)}w.format=$;function E(t){const l=t.length;if(l===0||t.charCodeAt(0)!==35)return null;if(l===7){const o=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6));return new S(new O(o,i,n,1))}if(l===9){const o=16*u(t.charCodeAt(1))+u(t.charCodeAt(2)),i=16*u(t.charCodeAt(3))+u(t.charCodeAt(4)),n=16*u(t.charCodeAt(5))+u(t.charCodeAt(6)),a=16*u(t.charCodeAt(7))+u(t.charCodeAt(8));return new S(new O(o,i,n,a/255))}if(l===4){const o=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3));return new S(new O(16*o+o,16*i+i,16*n+n))}if(l===5){const o=u(t.charCodeAt(1)),i=u(t.charCodeAt(2)),n=u(t.charCodeAt(3)),a=u(t.charCodeAt(4));return new S(new O(16*o+o,16*i+i,16*n+n,(16*a+a)/255))}return null}w.parseHex=E;function u(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(m=c.CSS||(c.CSS={}))})(h=S.Format||(S.Format={}))}(D||(e.$Os=D={}))}),define(te[55],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8g=e.$7g=e.$6g=void 0;function P(D){return(S,h,c)=>{let m=null,w=null;if(typeof c.value=="function"?(m="value",w=c.value):typeof c.get=="function"&&(m="get",w=c.get),!w)throw new Error("not supported");c[m]=D(w,h)}}function O(D,S,h){let c=null,m=null;if(typeof h.value=="function"?(c="value",m=h.value,m.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(c="get",m=h.get),!m)throw new Error("not supported");const w=`$memoize$${S}`;h[c]=function(...y){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:m.apply(this,y)}),this[w]}}e.$6g=O;function s(D,S,h){return P((c,m)=>{const w=`$debounce$${m}`,y=`$debounce$result$${m}`;return function(...f){this[y]||(this[y]=h?h():void 0),clearTimeout(this[w]),S&&(this[y]=S(this[y],...f),f=[this[y]]),this[w]=setTimeout(()=>{c.apply(this,f),this[y]=h?h():void 0},D)}})}e.$7g=s;function M(D,S,h){return P((c,m)=>{const w=`$throttle$timer$${m}`,y=`$throttle$result$${m}`,f=`$throttle$lastRun$${m}`,v=`$throttle$pending$${m}`;return function(...b){if(this[y]||(this[y]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),S&&(this[y]=S(this[y],...b)),this[v])return;const d=this[f]+D;d<=Date.now()?(this[f]=Date.now(),c.apply(this,[this[y]]),this[y]=h?h():void 0):(this[v]=!0,this[w]=setTimeout(()=>{this[v]=!1,this[f]=Date.now(),c.apply(this,[this[y]]),this[y]=h?h():void 0},d-Date.now()))}})}e.$8g=M}),define(te[14],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class P{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?$.isErrorNoTelemetry(t)?new $(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(l=>{l(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$U=P,e.$V=new P;function O(u){e.$V.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=O;function s(u){if(!u||typeof u!="object")return!1;const t=u;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$X=s;function M(u){c(u)||e.$V.onUnexpectedError(u)}e.$Y=M;function D(u){c(u)||e.$V.onUnexpectedExternalError(u)}e.$Z=D;function S(u){if(u instanceof Error){const{name:t,message:l}=u,o=u.stacktrace||u.stack;return{$isError:!0,name:t,message:l,stack:o,noTelemetry:$.isErrorNoTelemetry(u)}}return u}e.$1=S;const h="Canceled";function c(u){return u instanceof m?!0:u instanceof Error&&u.name===h&&u.message===h}e.$2=c;class m extends Error{constructor(){super(h),this.name=this.message}}e.$3=m;function w(){const u=new Error(h);return u.name=u.message,u}e.$4=w;function y(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.$5=y;function f(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.$6=f;class v extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$7=v;function b(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.$8=b;class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$9=d;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$0=g;class r extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$$=r;class $ extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof $)return t;const l=new $;return l.message=t.message,l.stack=t.stack,l}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$_=$;class E extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$ab=E}),define(te[23],ie([0,1,14,132]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.$5b=e.CompareResult=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.top=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=e.$qb=void 0;function s(T,H=0){return T[T.length-(1+H)]}e.$qb=s;function M(T){if(T.length===0)throw new Error("Invalid tail call");return[T.slice(0,T.length-1),T[T.length-1]]}e.$rb=M;function D(T,H,B=(ne,fe)=>ne===fe){if(T===H)return!0;if(!T||!H||T.length!==H.length)return!1;for(let ne=0,fe=T.length;ne<fe;ne++)if(!B(T[ne],H[ne]))return!1;return!0}e.$sb=D;function S(T,H){const B=T.length-1;H<B&&(T[H]=T[B]),T.pop()}e.$tb=S;function h(T,H,B){return c(T.length,ne=>B(T[ne],H))}e.$ub=h;function c(T,H){let B=0,ne=T-1;for(;B<=ne;){const fe=(B+ne)/2|0,ge=H(fe);if(ge<0)B=fe+1;else if(ge>0)ne=fe-1;else return fe}return-(B+1)}e.$vb=c;function m(T,H,B){if(T=T|0,T>=H.length)throw new TypeError("invalid index");const ne=H[Math.floor(H.length*Math.random())],fe=[],ge=[],ue=[];for(const we of H){const me=B(we,ne);me<0?fe.push(we):me>0?ge.push(we):ue.push(we)}return T<fe.length?m(T,fe,B):T<fe.length+ue.length?ue[0]:m(T-(fe.length+ue.length),ge,B)}e.$wb=m;function w(T,H){const B=[];let ne;for(const fe of T.slice(0).sort(H))!ne||H(ne[0],fe)!==0?(ne=[fe],B.push(ne)):ne.push(fe);return B}e.$xb=w;function*y(T,H){let B,ne;for(const fe of T)ne!==void 0&&H(ne,fe)?B.push(fe):(B&&(yield B),B=[fe]),ne=fe;B&&(yield B)}e.$yb=y;function f(T,H){for(let B=0;B<=T.length;B++)H(B===0?void 0:T[B-1],B===T.length?void 0:T[B])}e.$zb=f;function v(T,H){for(let B=0;B<T.length;B++)H(B===0?void 0:T[B-1],T[B],B+1===T.length?void 0:T[B+1])}e.$Ab=v;function b(T,H,B){const ne=[];function fe(we,me,Se){if(me===0&&Se.length===0)return;const Ie=ne[ne.length-1];Ie&&Ie.start+Ie.deleteCount===we?(Ie.deleteCount+=me,Ie.toInsert.push(...Se)):ne.push({start:we,deleteCount:me,toInsert:Se})}let ge=0,ue=0;for(;;){if(ge===T.length){fe(ge,0,H.slice(ue));break}if(ue===H.length){fe(ge,T.length-ge,[]);break}const we=T[ge],me=H[ue],Se=B(we,me);Se===0?(ge+=1,ue+=1):Se<0?(fe(ge,1,[]),ge+=1):Se>0&&(fe(ge,0,[me]),ue+=1)}return ne}e.$Bb=b;function d(T,H,B){const ne=b(T,H,B),fe=[],ge=[];for(const ue of ne)fe.push(...T.slice(ue.start,ue.start+ue.deleteCount)),ge.push(...ue.toInsert);return{removed:fe,added:ge}}e.$Cb=d;function g(T,H,B){if(B===0)return[];const ne=T.slice(0,B).sort(H);return $(T,H,ne,B,T.length),ne}e.top=g;function r(T,H,B,ne,fe){return B===0?Promise.resolve([]):new Promise((ge,ue)=>{(async()=>{const we=T.length,me=T.slice(0,B).sort(H);for(let Se=B,Ie=Math.min(B+ne,we);Se<we;Se=Ie,Ie=Math.min(Ie+ne,we)){if(Se>B&&await new Promise(je=>setTimeout(je)),fe&&fe.isCancellationRequested)throw new P.$3;$(T,H,me,Se,Ie)}return me})().then(ge,ue)})}e.$Eb=r;function $(T,H,B,ne,fe){for(const ge=B.length;ne<fe;ne++){const ue=T[ne];if(H(ue,B[ge-1])<0){B.pop();const we=(0,O.$ib)(B,me=>H(ue,me)<0);B.splice(we,0,ue)}}}function E(T){return T.filter(H=>!!H)}e.$Fb=E;function u(T){let H=0;for(let B=0;B<T.length;B++)T[B]&&(T[H]=T[B],H+=1);T.length=H}e.$Gb=u;function t(T,H,B){T.splice(B,0,T.splice(H,1)[0])}e.$Hb=t;function l(T){return!Array.isArray(T)||T.length===0}e.$Ib=l;function o(T){return Array.isArray(T)&&T.length>0}e.$Jb=o;function i(T,H=B=>B){const B=new Set;return T.filter(ne=>{const fe=H(ne);return B.has(fe)?!1:(B.add(fe),!0)})}e.$Kb=i;function n(T){const H=new Set;return B=>{const ne=T(B);return H.has(ne)?!1:(H.add(ne),!0)}}e.$Lb=n;function a(T,H){return T.length>0?T[0]:H}e.$Mb=a;function k(T,H){return T.length>0?T[T.length-1]:H}e.$Nb=k;function I(T,H,B=(ne,fe)=>ne===fe){let ne=0;for(let fe=0,ge=Math.min(T.length,H.length);fe<ge&&B(T[fe],H[fe]);fe++)ne++;return ne}e.$Ob=I;function C(T){return[].concat(...T)}e.$Pb=C;function p(T,H){let B=typeof H=="number"?T:0;typeof H=="number"?B=T:(B=0,H=T);const ne=[];if(B<=H)for(let fe=B;fe<H;fe++)ne.push(fe);else for(let fe=B;fe>H;fe--)ne.push(fe);return ne}e.$Qb=p;function A(T,H,B){return T.reduce((ne,fe)=>(ne[H(fe)]=B?B(fe):fe,ne),Object.create(null))}e.$Rb=A;function L(T,H){return T.push(H),()=>U(T,H)}e.$Sb=L;function U(T,H){const B=T.indexOf(H);if(B>-1)return T.splice(B,1),H}e.$Tb=U;function z(T,H,B){const ne=T.slice(0,H),fe=T.slice(H);return ne.concat(B,fe)}e.$Ub=z;function re(T,H){let B;if(typeof H=="number"){let ne=H;B=()=>{const fe=Math.sin(ne++)*179426549;return fe-Math.floor(fe)}}else B=Math.random;for(let ne=T.length-1;ne>0;ne-=1){const fe=Math.floor(B()*(ne+1)),ge=T[ne];T[ne]=T[fe],T[fe]=ge}}e.$Vb=re;function ee(T,H){const B=T.indexOf(H);B>-1&&(T.splice(B,1),T.unshift(H))}e.$Wb=ee;function ae(T,H){const B=T.indexOf(H);B>-1&&(T.splice(B,1),T.push(H))}e.$Xb=ae;function se(T,H){for(const B of H)T.push(B)}e.$Yb=se;function oe(T,H){return Array.isArray(T)?T.map(H):H(T)}e.$Zb=oe;function G(T){return Array.isArray(T)?T:[T]}e.$1b=G;function J(T){return T[Math.floor(Math.random()*T.length)]}e.$2b=J;function q(T,H,B){const ne=N(T,H),fe=T.length,ge=B.length;T.length=fe+ge;for(let ue=fe-1;ue>=ne;ue--)T[ue+ge]=T[ue];for(let ue=0;ue<ge;ue++)T[ue+ne]=B[ue]}e.$3b=q;function F(T,H,B,ne){const fe=N(T,H);let ge=T.splice(fe,B);return ge===void 0&&(ge=[]),q(T,fe,ne),ge}e.$4b=F;function N(T,H){return H<0?Math.max(H+T.length,0):Math.min(H,T.length)}var V;(function(T){function H(ge){return ge<0}T.isLessThan=H;function B(ge){return ge<=0}T.isLessThanOrEqual=B;function ne(ge){return ge>0}T.isGreaterThan=ne;function fe(ge){return ge===0}T.isNeitherLessOrGreaterThan=fe,T.greaterThan=1,T.lessThan=-1,T.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function Q(T,H){return(B,ne)=>H(T(B),T(ne))}e.$5b=Q;function x(...T){return(H,B)=>{for(const ne of T){const fe=ne(H,B);if(!V.isNeitherLessOrGreaterThan(fe))return fe}return V.neitherLessOrGreaterThan}}e.$6b=x;const ce=(T,H)=>T-H;e.$7b=ce;const Y=(T,H)=>(0,e.$7b)(T?1:0,H?1:0);e.$8b=Y;function R(T){return(H,B)=>-T(H,B)}e.$9b=R;class j{constructor(H){this.g=H,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(H){let B=this.c;for(;B<this.g.length&&H(this.g[B]);)B++;const ne=B===this.c?null:this.g.slice(this.c,B);return this.c=B,ne}takeFromEndWhile(H){let B=this.d;for(;B>=0&&H(this.g[B]);)B--;const ne=B===this.d?null:this.g.slice(B+1,this.d+1);return this.d=B,ne}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const H=this.g[this.c];return this.c++,H}removeLast(){const H=this.g[this.d];return this.d--,H}takeCount(H){const B=this.g.slice(this.c,this.c+H);return this.c+=H,B}}e.$0b=j;class W{static{this.empty=new W(H=>{})}constructor(H){this.iterate=H}forEach(H){this.iterate(B=>(H(B),!0))}toArray(){const H=[];return this.iterate(B=>(H.push(B),!0)),H}filter(H){return new W(B=>this.iterate(ne=>H(ne)?B(ne):!0))}map(H){return new W(B=>this.iterate(ne=>B(H(ne))))}some(H){let B=!1;return this.iterate(ne=>(B=H(ne),!B)),B}findFirst(H){let B;return this.iterate(ne=>H(ne)?(B=ne,!1):!0),B}findLast(H){let B;return this.iterate(ne=>(H(ne)&&(B=ne),!0)),B}findLastMaxBy(H){let B,ne=!0;return this.iterate(fe=>((ne||V.isGreaterThan(H(fe,B)))&&(ne=!1,B=fe),!0)),B}}e.$$b=W}),define(te[135],ie([0,1,14]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yc=e.$xc=e.$wc=e.$vc=e.ok=void 0;function O(h,c){if(!h)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=O;function s(h,c="Unreachable"){throw new Error(c)}e.$vc=s;function M(h){if(!h)throw new P.$ab("Assertion Failed")}e.$wc=M;function D(h){if(!h()){debugger;h(),(0,P.$Y)(new P.$ab("Assertion Failed"))}}e.$xc=D;function S(h,c){let m=0;for(;m<h.length-1;){const w=h[m],y=h[m+1];if(!c(w,y))return!1;m++}return!0}e.$yc=S}),define(te[49],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=void 0;function P(O){const s=this;let M=!1,D;return function(){return M||(M=!0,D=O.apply(s,arguments)),D}}e.$bb=P}),define(te[68],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(O){function s(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}O.is=s;const M=Object.freeze([]);function D(){return M}O.empty=D;function*S(u){yield u}O.single=S;function h(u){return s(u)?u:S(u)}O.wrap=h;function c(u){return u||M}O.from=c;function*m(u){for(let t=u.length-1;t>=0;t--)yield u[t]}O.reverse=m;function w(u){return!u||u[Symbol.iterator]().next().done===!0}O.isEmpty=w;function y(u){return u[Symbol.iterator]().next().value}O.first=y;function f(u,t){for(const l of u)if(t(l))return!0;return!1}O.some=f;function v(u,t){for(const l of u)if(t(l))return l}O.find=v;function*b(u,t){for(const l of u)t(l)&&(yield l)}O.filter=b;function*d(u,t){let l=0;for(const o of u)yield t(o,l++)}O.map=d;function*g(...u){for(const t of u)for(const l of t)yield l}O.concat=g;function r(u,t,l){let o=l;for(const i of u)o=t(o,i);return o}O.reduce=r;function*$(u,t,l=u.length){for(t<0&&(t+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);t<l;t++)yield u[t]}O.slice=$;function E(u,t=Number.POSITIVE_INFINITY){const l=[];if(t===0)return[l,u];const o=u[Symbol.iterator]();for(let i=0;i<t;i++){const n=o.next();if(n.done)return[l,O.empty()];l.push(n.value)}return[l,{[Symbol.iterator](){return o}}]}O.consume=E})(P||(e.Iterable=P={}))}),define(te[44],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Um=e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var O;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function D(t,l=!1){let o=0;const i=t.length;let n="",a=0,k=16,I=0;function C(ee){let ae=0,se=0;for(;ae<ee;){const oe=t.charCodeAt(o);if(oe>=48&&oe<=57)se=se*16+oe-48;else if(oe>=65&&oe<=70)se=se*16+oe-65+10;else if(oe>=97&&oe<=102)se=se*16+oe-97+10;else break;o++,ae++}return ae<ee&&(se=-1),se}function p(ee){o=ee,n="",a=0,k=16,I=0}function A(){const ee=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&c(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&c(t.charCodeAt(o)))for(o++;o<t.length&&c(t.charCodeAt(o));)o++;else return I=3,t.substring(ee,o);let ae=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&c(t.charCodeAt(o))){for(o++;o<t.length&&c(t.charCodeAt(o));)o++;ae=o}else I=3;return t.substring(ee,ae)}function L(){let ee="",ae=o;for(;;){if(o>=i){ee+=t.substring(ae,o),I=2;break}const se=t.charCodeAt(o);if(se===34){ee+=t.substring(ae,o),o++;break}if(se===92){if(ee+=t.substring(ae,o),o++,o>=i){I=2;break}switch(t.charCodeAt(o++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:{const G=C(4);G>=0?ee+=String.fromCharCode(G):I=4;break}default:I=5}ae=o;continue}if(se>=0&&se<=31)if(h(se)){ee+=t.substring(ae,o),I=2;break}else I=6;o++}return ee}function U(){if(n="",I=0,a=o,o>=i)return a=i,k=17;let ee=t.charCodeAt(o);if(S(ee)){do o++,n+=String.fromCharCode(ee),ee=t.charCodeAt(o);while(S(ee));return k=15}if(h(ee))return o++,n+=String.fromCharCode(ee),ee===13&&t.charCodeAt(o)===10&&(o++,n+=`
`),k=14;switch(ee){case 123:return o++,k=1;case 125:return o++,k=2;case 91:return o++,k=3;case 93:return o++,k=4;case 58:return o++,k=6;case 44:return o++,k=5;case 34:return o++,n=L(),k=10;case 47:{const ae=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<i&&!h(t.charCodeAt(o));)o++;return n=t.substring(ae,o),k=12}if(t.charCodeAt(o+1)===42){o+=2;const se=i-1;let oe=!1;for(;o<se;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,oe=!0;break}o++}return oe||(o++,I=1),n=t.substring(ae,o),k=13}return n+=String.fromCharCode(ee),o++,k=16}case 45:if(n+=String.fromCharCode(ee),o++,o===i||!c(t.charCodeAt(o)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=A(),k=11;default:for(;o<i&&z(ee);)o++,ee=t.charCodeAt(o);if(a!==o){switch(n=t.substring(a,o),n){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return n+=String.fromCharCode(ee),o++,k=16}}function z(ee){if(S(ee)||h(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ee;do ee=U();while(ee>=12&&ee<=15);return ee}return{setPosition:p,getPosition:()=>o,scan:l?re:U,getToken:()=>k,getTokenValue:()=>n,getTokenOffset:()=>a,getTokenLength:()=>o-a,getTokenError:()=>I}}e.$Jm=D;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var m;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(m||(m={}));function w(t,l){const o=[],i=new Object;let n;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function I(C,p,A,L){a.value=C,a.offset=p,a.length=A,a.type=L,a.colonOffset=void 0,n=a}try{$(t,{onObjectBegin:(C,p)=>{if(l<=C)throw i;n=void 0,k=l>C,o.push("")},onObjectProperty:(C,p,A)=>{if(l<p||(I(C,p,A,"property"),o[o.length-1]=C,l<=p+A))throw i},onObjectEnd:(C,p)=>{if(l<=C)throw i;n=void 0,o.pop()},onArrayBegin:(C,p)=>{if(l<=C)throw i;n=void 0,o.push(0)},onArrayEnd:(C,p)=>{if(l<=C)throw i;n=void 0,o.pop()},onLiteralValue:(C,p,A)=>{if(l<p||(I(C,p,A,u(C)),l<=p+A))throw i},onSeparator:(C,p,A)=>{if(l<=p)throw i;if(C===":"&&n&&n.type==="property")n.colonOffset=p,k=!1,n=void 0;else if(C===","){const L=o[o.length-1];typeof L=="number"?o[o.length-1]=L+1:(k=!0,o[o.length-1]=""),n=void 0}}})}catch(C){if(C!==i)throw C}return{path:o,previousNode:n,isAtPropertyKey:k,matches:C=>{let p=0;for(let A=0;p<C.length&&A<o.length;A++)if(C[p]===o[A]||C[p]==="*")p++;else if(C[p]!=="**")return!1;return p===C.length}}}e.$Km=w;function y(t,l=[],o=M.DEFAULT){let i=null,n=[];const a=[];function k(C){Array.isArray(n)?n.push(C):i!==null&&(n[i]=C)}return $(t,{onObjectBegin:()=>{const C={};k(C),a.push(n),n=C,i=null},onObjectProperty:C=>{i=C},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{const C=[];k(C),a.push(n),n=C,i=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:k,onError:(C,p,A)=>{l.push({error:C,offset:p,length:A})}},o),n[0]}e.$Lm=y;function f(t,l=[],o=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(C){i.type==="property"&&(i.length=C-i.offset,i=i.parent)}function a(C){return i.children.push(C),C}$(t,{onObjectBegin:C=>{i=a({type:"object",offset:C,length:-1,parent:i,children:[]})},onObjectProperty:(C,p,A)=>{i=a({type:"property",offset:p,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:C,offset:p,length:A,parent:i})},onObjectEnd:(C,p)=>{i.length=C+p-i.offset,i=i.parent,n(C+p)},onArrayBegin:(C,p)=>{i=a({type:"array",offset:C,length:-1,parent:i,children:[]})},onArrayEnd:(C,p)=>{i.length=C+p-i.offset,i=i.parent,n(C+p)},onLiteralValue:(C,p,A)=>{a({type:u(C),offset:p,length:A,parent:i,value:C}),n(p+A)},onSeparator:(C,p,A)=>{i.type==="property"&&(C===":"?i.colonOffset=p:C===","&&n(p))},onError:(C,p,A)=>{l.push({error:C,offset:p,length:A})}},o);const I=i.children[0];return I&&delete I.parent,I}e.$Mm=f;function v(t,l){if(!t)return;let o=t;for(const i of l)if(typeof i=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let n=!1;for(const a of o.children)if(Array.isArray(a.children)&&a.children[0].value===i){o=a.children[1],n=!0;break}if(!n)return}else{const n=i;if(o.type!=="array"||n<0||!Array.isArray(o.children)||n>=o.children.length)return;o=o.children[n]}return o}e.$Nm=v;function b(t){if(!t.parent||!t.parent.children)return[];const l=b(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;l.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&l.push(o)}return l}e.$Om=b;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const l=Object.create(null);for(const o of t.children){const i=o.children[1];i&&(l[o.children[0].value]=d(i))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$Pm=d;function g(t,l,o=!1){return l>=t.offset&&l<t.offset+t.length||o&&l===t.offset+t.length}e.$Qm=g;function r(t,l,o=!1){if(g(t,l,o)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=l;n++){const a=r(i[n],l,o);if(a)return a}return t}}e.$Rm=r;function $(t,l,o=M.DEFAULT){const i=D(t,!1);function n(Q){return Q?()=>Q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(Q){return Q?x=>Q(x,i.getTokenOffset(),i.getTokenLength()):()=>!0}const k=n(l.onObjectBegin),I=a(l.onObjectProperty),C=n(l.onObjectEnd),p=n(l.onArrayBegin),A=n(l.onArrayEnd),L=a(l.onLiteralValue),U=a(l.onSeparator),z=n(l.onComment),re=a(l.onError),ee=o&&o.disallowComments,ae=o&&o.allowTrailingComma;function se(){for(;;){const Q=i.scan();switch(i.getTokenError()){case 4:oe(14);break;case 5:oe(15);break;case 3:oe(13);break;case 1:ee||oe(11);break;case 2:oe(12);break;case 6:oe(16);break}switch(Q){case 12:case 13:ee?oe(10):z();break;case 16:oe(1);break;case 15:case 14:break;default:return Q}}}function oe(Q,x=[],ce=[]){if(re(Q),x.length+ce.length>0){let Y=i.getToken();for(;Y!==17;){if(x.indexOf(Y)!==-1){se();break}else if(ce.indexOf(Y)!==-1)break;Y=se()}}}function G(Q){const x=i.getTokenValue();return Q?L(x):I(x),se(),!0}function J(){switch(i.getToken()){case 11:{let Q=0;try{Q=JSON.parse(i.getTokenValue()),typeof Q!="number"&&(oe(2),Q=0)}catch{oe(2)}L(Q);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return se(),!0}function q(){return i.getToken()!==10?(oe(3,[],[2,5]),!1):(G(!1),i.getToken()===6?(U(":"),se(),V()||oe(4,[],[2,5])):oe(5,[],[2,5]),!0)}function F(){k(),se();let Q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Q||oe(4,[],[]),U(","),se(),i.getToken()===2&&ae)break}else Q&&oe(6,[],[]);q()||oe(4,[],[2,5]),Q=!0}return C(),i.getToken()!==2?oe(7,[2],[]):se(),!0}function N(){p(),se();let Q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Q||oe(4,[],[]),U(","),se(),i.getToken()===4&&ae)break}else Q&&oe(6,[],[]);V()||oe(4,[],[4,5]),Q=!0}return A(),i.getToken()!==4?oe(8,[4],[]):se(),!0}function V(){switch(i.getToken()){case 3:return N();case 1:return F();case 10:return G(!0);default:return J()}}return se(),i.getToken()===17?o.allowEmptyContent?!0:(oe(4,[],[]),!1):V()?(i.getToken()!==17&&oe(9,[],[]),!0):(oe(4,[],[]),!1)}e.$Sm=$;function E(t,l){const o=D(t),i=[];let n,a=0,k;do switch(k=o.getPosition(),n=o.scan(),n){case 12:case 13:case 17:a!==k&&i.push(t.substring(a,k)),l!==void 0&&i.push(o.getTokenValue().replace(/[^\r\n]/g,l)),a=o.getPosition();break}while(n!==17);return i.join("")}e.$Tm=E;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Um=u}),define(te[136],ie([0,1,44]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AS=e.$zS=e.$yS=e.$xS=void 0;function O(c,m,w){let y,f,v,b,d;if(m){for(b=m.offset,d=b+m.length,v=b;v>0&&!h(c,v-1);)v--;let k=d;for(;k<c.length&&!h(c,k);)k++;f=c.substring(v,k),y=D(f,w)}else f=c,y=0,v=0,b=0,d=c.length;const g=S(w,c);let r=!1,$=0,E;w.insertSpaces?E=M(" ",w.tabSize||4):E="	";const u=(0,P.$Jm)(f,!1);let t=!1;function l(){return g+M(E,y+$)}function o(){let k=u.scan();for(r=!1;k===15||k===14;)r=r||k===14,k=u.scan();return t=k===16||u.getTokenError()!==0,k}const i=[];function n(k,I,C){!t&&I<d&&C>b&&c.substring(I,C)!==k&&i.push({offset:I,length:C-I,content:k})}let a=o();if(a!==17){const k=u.getTokenOffset()+v,I=M(E,y);n(I,v,k)}for(;a!==17;){let k=u.getTokenOffset()+u.getTokenLength()+v,I=o(),C="";for(;!r&&(I===12||I===13);){const A=u.getTokenOffset()+v;n(" ",k,A),k=u.getTokenOffset()+u.getTokenLength()+v,C=I===12?l():"",I=o()}if(I===2)a!==1&&($--,C=l());else if(I===4)a!==3&&($--,C=l());else{switch(a){case 3:case 1:$++,C=l();break;case 5:case 12:C=l();break;case 13:r?C=l():C=" ";break;case 6:C=" ";break;case 10:if(I===6){C="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?C=" ":I!==5&&I!==17&&(t=!0);break;case 16:t=!0;break}r&&(I===12||I===13)&&(C=l())}const p=u.getTokenOffset()+v;n(C,k,p),a=I}return i}e.$xS=O;function s(c,m){const w=JSON.stringify(c,void 0,m.insertSpaces?m.tabSize||4:"	");return m.eol!==void 0?w.replace(/\r\n|\r|\n/g,m.eol):w}e.$yS=s;function M(c,m){let w="";for(let y=0;y<m;y++)w+=c;return w}function D(c,m){let w=0,y=0;const f=m.tabSize||4;for(;w<c.length;){const v=c.charAt(w);if(v===" ")y++;else if(v==="	")y+=f;else break;w++}return Math.floor(y/f)}function S(c,m){for(let w=0;w<m.length;w++){const y=m.charAt(w);if(y==="\r")return w+1<m.length&&m.charAt(w+1)===`
`?`\r
`:"\r";if(y===`
`)return`
`}return c&&c.eol||`
`}e.$zS=S;function h(c,m){return`\r
`.indexOf(c.charAt(m))!==-1}e.$AS=h}),define(te[137],ie([0,1,44,136]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FS=e.$ES=e.$DS=e.$CS=e.$BS=void 0;function s(c,m,w){return M(c,m,void 0,w)}e.$BS=s;function M(c,m,w,y,f){const v=m.slice(),b=[],d=(0,P.$Mm)(c,b);let g,r;for(;v.length>0&&(r=v.pop(),g=(0,P.$Nm)(d,v),g===void 0&&w!==void 0);)typeof r=="string"?w={[r]:w}:w=[w];if(g)if(g.type==="object"&&typeof r=="string"&&Array.isArray(g.children)){const $=(0,P.$Nm)(g,[r]);if($!==void 0)if(w===void 0){if(!$.parent)throw new Error("Malformed AST");const E=g.children.indexOf($.parent);let u,t=$.parent.offset+$.parent.length;if(E>0){const l=g.children[E-1];u=l.offset+l.length}else u=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return D(c,{offset:u,length:t-u,content:""},y)}else return D(c,{offset:$.offset,length:$.length,content:JSON.stringify(w)},y);else{if(w===void 0)return[];const E=`${JSON.stringify(r)}: ${JSON.stringify(w)}`,u=f?f(g.children.map(l=>l.children[0].value)):g.children.length;let t;if(u>0){const l=g.children[u-1];t={offset:l.offset+l.length,length:0,content:","+E}}else g.children.length===0?t={offset:g.offset+1,length:0,content:E}:t={offset:g.offset+1,length:0,content:E+","};return D(c,t,y)}}else if(g.type==="array"&&typeof r=="number"&&Array.isArray(g.children))if(w!==void 0){const $=`${JSON.stringify(w)}`;let E;if(g.children.length===0||r===0)E={offset:g.offset+1,length:0,content:g.children.length===0?$:$+","};else{const u=r===-1||r>g.children.length?g.children.length:r,t=g.children[u-1];E={offset:t.offset+t.length,length:0,content:","+$}}return D(c,E,y)}else{const $=r,E=g.children[$];let u;if(g.children.length===1)u={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===$){const t=g.children[$-1],l=t.offset+t.length,o=g.offset+g.length;u={offset:l,length:o-2-l,content:""}}else u={offset:E.offset,length:g.children[$+1].offset-E.offset,content:""};return D(c,u,y)}else throw new Error(`Can not add ${typeof r!="number"?"index":"property"} to parent of type ${g.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return D(c,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(w)},y)}}e.$CS=M;function D(c,m,w){let y=S(c,m),f=m.offset,v=m.offset+m.content.length;if(m.length===0||m.content.length===0){for(;f>0&&!(0,O.$AS)(y,f-1);)f--;for(;v<y.length&&!(0,O.$AS)(y,v);)v++}const b=(0,O.$xS)(y,{offset:f,length:v-f},w);for(let g=b.length-1;g>=0;g--){const r=b[g];y=S(y,r),f=Math.min(f,r.offset),v=Math.max(v,r.offset+r.length),v+=r.content.length-r.length}const d=c.length-(y.length-v)-f;return[{offset:f,length:d,content:y.substring(f,v)}]}e.$DS=D;function S(c,m){return c.substring(0,m.offset)+m.content+c.substring(m.offset+m.length)}e.$ES=S;function h(c,m){const w=m.slice(0).sort((f,v)=>{const b=f.offset-v.offset;return b===0?f.length-v.length:b});let y=c.length;for(let f=w.length-1;f>=0;f--){const v=w[f];if(v.offset+v.length<=y)c=S(c,v);else throw new Error("Overlapping edit");y=v.offset}return c}e.$FS=h}),define(te[84],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=P}),define(te[2],ie([0,1,23,133,49,68]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=void 0;const D=!1;let S=null;class h{constructor(){this.b=new Map}static{this.a=0}c(p){let A=this.b.get(p);return A||(A={parent:null,source:null,isSingleton:!1,value:p,idx:h.a++},this.b.set(p,A)),A}trackDisposable(p){const A=this.c(p);A.source||(A.source=new Error().stack)}setParent(p,A){const L=this.c(p);L.parent=A}markAsDisposed(p){this.b.delete(p)}markAsSingleton(p){this.c(p).isSingleton=!0}f(p,A){const L=A.get(p);if(L)return L;const U=p.parent?this.f(this.c(p.parent),A):p;return A.set(p,U),U}getTrackedDisposables(){const p=new Map;return[...this.b.entries()].filter(([,L])=>L.source!==null&&!this.f(L,p).isSingleton).map(([L])=>L).flat()}computeLeakingDisposables(p=10,A){let L;if(A)L=A;else{const ae=new Map,se=[...this.b.values()].filter(G=>G.source!==null&&!this.f(G,ae).isSingleton);if(se.length===0)return;const oe=new Set(se.map(G=>G.value));if(L=se.filter(G=>!(G.parent&&oe.has(G.parent))),L.length===0)throw new Error("There are cyclic diposable chains!")}if(!L)return;function U(ae){function se(G,J){for(;G.length>0&&J.some(q=>typeof q=="string"?q===G[0]:G[0].match(q));)G.shift()}const oe=ae.source.split(`
`).map(G=>G.trim().replace("at ","")).filter(G=>G!=="");return se(oe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),oe.reverse()}const z=new O.$L;for(const ae of L){const se=U(ae);for(let oe=0;oe<=se.length;oe++)z.add(se.slice(0,oe).join(`
`),ae)}L.sort((0,P.$5b)(ae=>ae.idx,P.$7b));let re="",ee=0;for(const ae of L.slice(0,p)){ee++;const se=U(ae),oe=[];for(let G=0;G<se.length;G++){let J=se[G];J=`(shared with ${z.get(se.slice(0,G+1).join(`
`)).size}/${L.length} leaks) at ${J}`;const F=z.get(se.slice(0,G).join(`
`)),N=(0,O.$I)([...F].map(V=>U(V)[G]),V=>V);delete N[se[G]];for(const[V,Q]of Object.entries(N))oe.unshift(`    - stacktraces of ${Q.length} other leaks continue with ${V}`);oe.unshift(J)}re+=`


==================== Leaking disposable ${ee}/${L.length}: ${ae.value.constructor.name} ====================
${oe.join(`
`)}
============================================================

`}return L.length>p&&(re+=`


... and ${L.length-p} more leaking disposables

`),{leaks:L,details:re}}}e.$_b=h;function c(C){S=C}if(e.$ac=c,D){const C="__is_disposable_tracked__";c(new class{trackDisposable(p){const A=new Error("Potentially leaked disposable").stack;setTimeout(()=>{p[C]||console.log(A)},3e3)}setParent(p,A){if(p&&p!==u.None)try{p[C]=!0}catch{}}markAsDisposed(p){if(p&&p!==u.None)try{p[C]=!0}catch{}}markAsSingleton(p){}})}function m(C){return S?.trackDisposable(C),C}e.$bc=m;function w(C){S?.markAsDisposed(C)}e.$cc=w;function y(C,p){S?.setParent(C,p)}function f(C,p){if(S)for(const A of C)S.setParent(A,p)}function v(C){return S?.markAsSingleton(C),C}e.$dc=v;function b(C){return typeof C.dispose=="function"&&C.dispose.length===0}e.$ec=b;function d(C){if(M.Iterable.is(C)){const p=[];for(const A of C)if(A)try{A.dispose()}catch(L){p.push(L)}if(p.length===1)throw p[0];if(p.length>1)throw new AggregateError(p,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}e.$fc=d;function g(C){for(const p of C)b(p)&&p.dispose();return[]}e.$gc=g;function r(...C){const p=$(()=>d(C));return f(C,p),p}e.$hc=r;function $(C){const p=m({dispose:(0,s.$bb)(()=>{w(p),C()})});return p}e.$ic=$;class E{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,m(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{d(this.f)}finally{this.f.clear()}}add(p){if(!p)return p;if(p===this)throw new Error("Cannot register a disposable on itself!");return y(p,this),this.g?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(p),p}delete(p){if(p){if(p===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(p),p.dispose()}}deleteAndLeak(p){p&&this.f.has(p)&&(this.f.delete(p),y(p,null))}}e.$jc=E;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new E,m(this),y(this.q,this)}dispose(){w(this),this.q.dispose()}B(p){if(p===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(p)}}e.$kc=u;class t{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(p){this.b||p===this.a||(this.a?.dispose(),p&&y(p,this),this.a=p)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const p=this.a;return this.a=void 0,p&&y(p,null),p}}e.$lc=t;class l{constructor(p){this.b=p,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$mc=l;class o{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(p){let A=p;return this.unset=()=>A=void 0,this.isset=()=>A!==void 0,this.dispose=()=>{A&&(A(),A=void 0,w(this))},this}}e.$nc=o;class i{constructor(){this.a=new Map}acquire(p,...A){let L=this.a.get(p);L||(L={counter:0,object:this.b(p,...A)},this.a.set(p,L));const{object:U}=L,z=(0,s.$bb)(()=>{--L.counter===0&&(this.c(p,L.object),this.a.delete(p))});return L.counter++,{object:U,dispose:z}}}e.$oc=i;class n{constructor(p){this.a=p}async acquire(p,...A){const L=this.a.acquire(p,...A);try{return{object:await L.object,dispose:()=>L.dispose()}}catch(U){throw L.dispose(),U}}}e.$pc=n;class a{constructor(p){this.object=p}dispose(){}}e.$qc=a;function k(C){const p=new E;try{C(p)}finally{p.dispose()}}e.$rc=k;class I{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(p){return this.a.has(p)}get size(){return this.a.size}get(p){return this.a.get(p)}set(p,A,L=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),L||this.a.get(p)?.dispose(),this.a.set(p,A)}deleteAndDispose(p){this.a.get(p)?.dispose(),this.a.delete(p)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$sc=I}),define(te[101],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=void 0;class P{static{this.Undefined=new P(void 0)}constructor(M){this.element=M,this.next=P.Undefined,this.prev=P.Undefined}}class O{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let M=this.a;for(;M!==P.Undefined;){const D=M.next;M.prev=P.Undefined,M.next=P.Undefined,M=D}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,D){const S=new P(M);if(this.a===P.Undefined)this.a=S,this.b=S;else if(D){const c=this.b;this.b=S,S.prev=c,c.next=S}else{const c=this.a;this.a=S,S.next=c,c.prev=S}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(S))}}shift(){if(this.a!==P.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==P.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==P.Undefined&&M.next!==P.Undefined){const D=M.prev;D.next=M.next,M.next.prev=D}else M.prev===P.Undefined&&M.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):M.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):M.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==P.Undefined;)yield M.element,M=M.next}}e.$tc=O}),define(te[33],ie([0,1]),function(K,e){"use strict";var P,O,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.Touch=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=void 0;function M(g,r,$){let E=g.get(r);return E===void 0&&(E=$,g.set(r,E)),E}e.$wi=M;function D(g){const r=[];return g.forEach(($,E)=>{r.push(`${E} => ${$}`)}),`Map(${g.size}) {${r.join(", ")}}`}e.$xi=D;function S(g){const r=[];return g.forEach($=>{r.push($)}),`Set(${g.size}) {${r.join(", ")}}`}e.$yi=S;class h{constructor(r,$){this.uri=r,this.value=$}}function c(g){return Array.isArray(g)}class m{static{this.a=r=>r.toString()}constructor(r,$){if(this[P]="ResourceMap",r instanceof m)this.b=new Map(r.b),this.c=$??m.a;else if(c(r)){this.b=new Map,this.c=$??m.a;for(const[E,u]of r)this.set(E,u)}else this.b=new Map,this.c=r??m.a}set(r,$){return this.b.set(this.c(r),new h(r,$)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,$){typeof $<"u"&&(r=r.bind($));for(const[E,u]of this.b)r(u.value,u.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}e.$zi=m;class w{constructor(r,$){this[O]="ResourceSet",!r||typeof r=="function"?this.a=new m(r):(this.a=new m($),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,$){this.a.forEach((E,u)=>r.call($,u,u,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ai=w;var y;(function(g){g[g.None=0]="None",g[g.AsOld=1]="AsOld",g[g.AsNew=2]="AsNew"})(y||(e.Touch=y={}));class f{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,$=0){const E=this.a.get(r);if(E)return $!==0&&this.j(E,$),E.value}set(r,$,E=0){let u=this.a.get(r);if(u)u.value=$,E!==0&&this.j(u,E);else{switch(u={key:r,value:$,next:void 0,previous:void 0},E){case 0:this.h(u);break;case 1:this.g(u);break;case 2:this.h(u);break;default:this.h(u);break}this.a.set(r,u),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const $=this.a.get(r);if($)return this.a.delete(r),this.i($),this.d--,$.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,$){const E=this.e;let u=this.b;for(;u;){if($?r.bind($)(u.value,u.key,this):r(u.value,u.key,this),this.e!==E)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,$=this.e;let E=this.b;const u={[Symbol.iterator](){return u},next(){if(r.e!==$)throw new Error("LinkedMap got modified during iteration.");if(E){const t={value:E.key,done:!1};return E=E.next,t}else return{value:void 0,done:!0}}};return u}values(){const r=this,$=this.e;let E=this.b;const u={[Symbol.iterator](){return u},next(){if(r.e!==$)throw new Error("LinkedMap got modified during iteration.");if(E){const t={value:E.value,done:!1};return E=E.next,t}else return{value:void 0,done:!0}}};return u}entries(){const r=this,$=this.e;let E=this.b;const u={[Symbol.iterator](){return u},next(){if(r.e!==$)throw new Error("LinkedMap got modified during iteration.");if(E){const t={value:[E.key,E.value],done:!1};return E=E.next,t}else return{value:void 0,done:!0}}};return u}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let $=this.b,E=this.size;for(;$&&E>r;)this.a.delete($.key),$=$.next,E--;this.b=$,this.d=E,$&&($.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const $=r.next,E=r.previous;if(!$||!E)throw new Error("Invalid list");$.previous=E,E.next=$}r.next=void 0,r.previous=void 0,this.e++}j(r,$){if(!this.b||!this.c)throw new Error("Invalid list");if(!($!==1&&$!==2)){if($===1){if(r===this.b)return;const E=r.next,u=r.previous;r===this.c?(u.next=void 0,this.c=u):(E.previous=u,u.next=E),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if($===2){if(r===this.c)return;const E=r.next,u=r.previous;r===this.b?(E.previous=void 0,this.b=E):(E.previous=u,u.next=E),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach(($,E)=>{r.push([E,$])}),r}fromJSON(r){this.clear();for(const[$,E]of r)this.set($,E)}}e.$Bi=f;class v extends f{constructor(r,$=1){super(),this.k=r,this.l=Math.min(Math.max(0,$),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,$=2){return super.get(r,$)}peek(r){return super.get(r,0)}set(r,$){return super.set(r,$,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Ci=v;class b{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let $=this.a.get(r)||0;return $===0?!1:($--,$===0?this.a.delete(r):this.a.set(r,$),!0)}has(r){return this.a.has(r)}}e.$Di=b;class d{constructor(r){if(this.a=new Map,this.b=new Map,r)for(const[$,E]of r)this.set($,E)}clear(){this.a.clear(),this.b.clear()}set(r,$){this.a.set(r,$),this.b.set($,r)}get(r){return this.a.get(r)}getKey(r){return this.b.get(r)}delete(r){const $=this.a.get(r);return $===void 0?!1:(this.a.delete(r),this.b.delete($),!0)}forEach(r,$){this.a.forEach((E,u)=>{r.call($,E,u,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ei=d}),define(te[85],ie([0,1,33]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jl=e.$il=e.$hl=void 0;const O=new P.$Ci(1e4);function s(c){return h(c,"NFC",O)}e.$hl=s;const M=new P.$Ci(1e4);function D(c){return h(c,"NFD",M)}e.$il=D;const S=/[^\u0000-\u0080]/;function h(c,m,w){if(!c)return c;const y=w.get(c);if(y)return y;let f;return S.test(c)?f=c.normalize(m):f=c,w.set(c,f),f}e.$jl=function(){const c=/[\u0300-\u036f]/g;return function(m){return D(m).replace(c,"")}}()}),define(te[138],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ll=e.$Kl=e.$Jl=e.rot=e.$Hl=void 0;function P(S,h,c){return Math.min(Math.max(S,h),c)}e.$Hl=P;function O(S,h){return(h+S%h)%h}e.rot=O;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$Jl=s;class M{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Kl=M;class D{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const c=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Ll=D}),function(){function K(s){const M=[];typeof s=="number"&&M.push("code/timeOrigin",s);function D(h){M.push(h,Date.now())}function S(){const h=[];for(let c=0;c<M.length;c+=2)h.push({name:M[c],startTime:M[c+1]});return h}return{mark:D,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))M.push({name:D.name,startTime:Math.round(s+D.startTime)});return M}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=P(O))}(),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var O in P)(typeof exports=="object"?exports:K)[O]=P[O]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function P(O){if(e[O])return e[O].exports;var s=e[O]={i:O,l:!1,exports:{}};return K[O].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=K,P.c=e,P.d=function(O,s,M){P.o(O,s)||Object.defineProperty(O,s,{enumerable:!0,get:M})},P.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},P.t=function(O,s){if(1&s&&(O=P(O)),8&s||4&s&&typeof O=="object"&&O&&O.__esModule)return O;var M=Object.create(null);if(P.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:O}),2&s&&typeof O!="string")for(var D in O)P.d(M,D,function(S){return O[S]}.bind(null,D));return M},P.n=function(O){var s=O&&O.__esModule?function(){return O.default}:function(){return O};return P.d(s,"a",s),s},P.o=function(O,s){return Object.prototype.hasOwnProperty.call(O,s)},P.p="",P(P.s=0)}([function(K,e,P){(function(O){var s;e=K.exports=ce,s=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var X=Array.prototype.slice.call(arguments,0);X.unshift("SEMVER"),console.log.apply(console,X)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],h=e.src=[],c=0,m=c++;h[m]="0|[1-9]\\d*";var w=c++;h[w]="[0-9]+";var y=c++;h[y]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=c++;h[f]="("+h[m]+")\\.("+h[m]+")\\.("+h[m]+")";var v=c++;h[v]="("+h[w]+")\\.("+h[w]+")\\.("+h[w]+")";var b=c++;h[b]="(?:"+h[m]+"|"+h[y]+")";var d=c++;h[d]="(?:"+h[w]+"|"+h[y]+")";var g=c++;h[g]="(?:-("+h[b]+"(?:\\."+h[b]+")*))";var r=c++;h[r]="(?:-?("+h[d]+"(?:\\."+h[d]+")*))";var $=c++;h[$]="[0-9A-Za-z-]+";var E=c++;h[E]="(?:\\+("+h[$]+"(?:\\."+h[$]+")*))";var u=c++,t="v?"+h[f]+h[g]+"?"+h[E]+"?";h[u]="^"+t+"$";var l="[v=\\s]*"+h[v]+h[r]+"?"+h[E]+"?",o=c++;h[o]="^"+l+"$";var i=c++;h[i]="((?:<|>)?=?)";var n=c++;h[n]=h[w]+"|x|X|\\*";var a=c++;h[a]=h[m]+"|x|X|\\*";var k=c++;h[k]="[v=\\s]*("+h[a]+")(?:\\.("+h[a]+")(?:\\.("+h[a]+")(?:"+h[g]+")?"+h[E]+"?)?)?";var I=c++;h[I]="[v=\\s]*("+h[n]+")(?:\\.("+h[n]+")(?:\\.("+h[n]+")(?:"+h[r]+")?"+h[E]+"?)?)?";var C=c++;h[C]="^"+h[i]+"\\s*"+h[k]+"$";var p=c++;h[p]="^"+h[i]+"\\s*"+h[I]+"$";var A=c++;h[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=c++;h[L]="(?:~>?)";var U=c++;h[U]="(\\s*)"+h[L]+"\\s+",S[U]=new RegExp(h[U],"g");var z=c++;h[z]="^"+h[L]+h[k]+"$";var re=c++;h[re]="^"+h[L]+h[I]+"$";var ee=c++;h[ee]="(?:\\^)";var ae=c++;h[ae]="(\\s*)"+h[ee]+"\\s+",S[ae]=new RegExp(h[ae],"g");var se=c++;h[se]="^"+h[ee]+h[k]+"$";var oe=c++;h[oe]="^"+h[ee]+h[I]+"$";var G=c++;h[G]="^"+h[i]+"\\s*("+l+")$|^$";var J=c++;h[J]="^"+h[i]+"\\s*("+t+")$|^$";var q=c++;h[q]="(\\s*)"+h[i]+"\\s*("+l+"|"+h[k]+")",S[q]=new RegExp(h[q],"g");var F=c++;h[F]="^\\s*("+h[k]+")\\s+-\\s+("+h[k]+")\\s*$";var N=c++;h[N]="^\\s*("+h[I]+")\\s+-\\s+("+h[I]+")\\s*$";var V=c++;h[V]="(<|>)?=?\\s*\\*";for(var Q=0;Q<35;Q++)s(Q,h[Q]),S[Q]||(S[Q]=new RegExp(h[Q]));function x(X,le){if(X instanceof ce)return X;if(typeof X!="string"||X.length>M||!(le?S[o]:S[u]).test(X))return null;try{return new ce(X,le)}catch{return null}}function ce(X,le){if(X instanceof ce){if(X.loose===le)return X;X=X.version}else if(typeof X!="string")throw new TypeError("Invalid Version: "+X);if(X.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ce))return new ce(X,le);s("SemVer",X,le),this.loose=le;var de=X.trim().match(le?S[o]:S[u]);if(!de)throw new TypeError("Invalid Version: "+X);if(this.raw=X,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Re=+Ee;if(Re>=0&&Re<D)return Re}return Ee}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=x,e.valid=function(X,le){var de=x(X,le);return de?de.version:null},e.clean=function(X,le){var de=x(X.trim().replace(/^[=v]+/,""),le);return de?de.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(X){return s("SemVer.compare",this.version,this.loose,X),X instanceof ce||(X=new ce(X,this.loose)),this.compareMain(X)||this.comparePre(X)},ce.prototype.compareMain=function(X){return X instanceof ce||(X=new ce(X,this.loose)),R(this.major,X.major)||R(this.minor,X.minor)||R(this.patch,X.patch)},ce.prototype.comparePre=function(X){if(X instanceof ce||(X=new ce(X,this.loose)),this.prerelease.length&&!X.prerelease.length)return-1;if(!this.prerelease.length&&X.prerelease.length)return 1;if(!this.prerelease.length&&!X.prerelease.length)return 0;var le=0;do{var de=this.prerelease[le],Ee=X.prerelease[le];if(s("prerelease compare",le,de,Ee),de===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(de===void 0)return-1;if(de!==Ee)return R(de,Ee)}while(++le)},ce.prototype.inc=function(X,le){switch(X){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",le);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",le);break;case"prepatch":this.prerelease.length=0,this.inc("patch",le),this.inc("pre",le);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",le),this.inc("pre",le);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}le&&(this.prerelease[0]===le?isNaN(this.prerelease[1])&&(this.prerelease=[le,0]):this.prerelease=[le,0]);break;default:throw new Error("invalid increment argument: "+X)}return this.format(),this.raw=this.version,this},e.inc=function(X,le,de,Ee){typeof de=="string"&&(Ee=de,de=void 0);try{return new ce(X,de).inc(le,Ee).version}catch{return null}},e.diff=function(X,le){if(H(X,le))return null;var de=x(X),Ee=x(le);if(de.prerelease.length||Ee.prerelease.length){for(var Re in de)if((Re==="major"||Re==="minor"||Re==="patch")&&de[Re]!==Ee[Re])return"pre"+Re;return"prerelease"}for(var Re in de)if((Re==="major"||Re==="minor"||Re==="patch")&&de[Re]!==Ee[Re])return Re},e.compareIdentifiers=R;var Y=/^[0-9]+$/;function R(X,le){var de=Y.test(X),Ee=Y.test(le);return de&&Ee&&(X=+X,le=+le),de&&!Ee?-1:Ee&&!de?1:X<le?-1:X>le?1:0}function j(X,le,de){return new ce(X,de).compare(new ce(le,de))}function W(X,le,de){return j(X,le,de)>0}function T(X,le,de){return j(X,le,de)<0}function H(X,le,de){return j(X,le,de)===0}function B(X,le,de){return j(X,le,de)!==0}function ne(X,le,de){return j(X,le,de)>=0}function fe(X,le,de){return j(X,le,de)<=0}function ge(X,le,de,Ee){var Re;switch(le){case"===":typeof X=="object"&&(X=X.version),typeof de=="object"&&(de=de.version),Re=X===de;break;case"!==":typeof X=="object"&&(X=X.version),typeof de=="object"&&(de=de.version),Re=X!==de;break;case"":case"=":case"==":Re=H(X,de,Ee);break;case"!=":Re=B(X,de,Ee);break;case">":Re=W(X,de,Ee);break;case">=":Re=ne(X,de,Ee);break;case"<":Re=T(X,de,Ee);break;case"<=":Re=fe(X,de,Ee);break;default:throw new TypeError("Invalid operator: "+le)}return Re}function ue(X,le){if(X instanceof ue){if(X.loose===le)return X;X=X.value}if(!(this instanceof ue))return new ue(X,le);s("comparator",X,le),this.loose=le,this.parse(X),this.semver===we?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(X,le){return R(le,X)},e.major=function(X,le){return new ce(X,le).major},e.minor=function(X,le){return new ce(X,le).minor},e.patch=function(X,le){return new ce(X,le).patch},e.compare=j,e.compareLoose=function(X,le){return j(X,le,!0)},e.rcompare=function(X,le,de){return j(le,X,de)},e.sort=function(X,le){return X.sort(function(de,Ee){return e.compare(de,Ee,le)})},e.rsort=function(X,le){return X.sort(function(de,Ee){return e.rcompare(de,Ee,le)})},e.gt=W,e.lt=T,e.eq=H,e.neq=B,e.gte=ne,e.lte=fe,e.cmp=ge,e.Comparator=ue;var we={};function me(X,le){if(X instanceof me)return X.loose===le?X:new me(X.raw,le);if(X instanceof ue)return new me(X.value,le);if(!(this instanceof me))return new me(X,le);if(this.loose=le,this.raw=X,this.set=X.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+X);this.format()}function Se(X){return!X||X.toLowerCase()==="x"||X==="*"}function Ie(X,le,de,Ee,Re,Ue,Oe,Be,We,Z,he,$e,ye){return((le=Se(de)?"":Se(Ee)?">="+de+".0.0":Se(Re)?">="+de+"."+Ee+".0":">="+le)+" "+(Be=Se(We)?"":Se(Z)?"<"+(+We+1)+".0.0":Se(he)?"<"+We+"."+(+Z+1)+".0":$e?"<="+We+"."+Z+"."+he+"-"+$e:"<="+Be)).trim()}function je(X,le){for(var de=0;de<X.length;de++)if(!X[de].test(le))return!1;if(le.prerelease.length){for(de=0;de<X.length;de++)if(s(X[de].semver),X[de].semver!==we&&X[de].semver.prerelease.length>0){var Ee=X[de].semver;if(Ee.major===le.major&&Ee.minor===le.minor&&Ee.patch===le.patch)return!0}return!1}return!0}function ve(X,le,de){try{le=new me(le,de)}catch{return!1}return le.test(X)}function be(X,le,de,Ee){var Re,Ue,Oe,Be,We;switch(X=new ce(X,Ee),le=new me(le,Ee),de){case">":Re=W,Ue=fe,Oe=T,Be=">",We=">=";break;case"<":Re=T,Ue=ne,Oe=W,Be="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(X,le,Ee))return!1;for(var Z=0;Z<le.set.length;++Z){var he=le.set[Z],$e=null,ye=null;if(he.forEach(function(Ae){Ae.semver===we&&(Ae=new ue(">=0.0.0")),$e=$e||Ae,ye=ye||Ae,Re(Ae.semver,$e.semver,Ee)?$e=Ae:Oe(Ae.semver,ye.semver,Ee)&&(ye=Ae)}),$e.operator===Be||$e.operator===We||(!ye.operator||ye.operator===Be)&&Ue(X,ye.semver)||ye.operator===We&&Oe(X,ye.semver))return!1}return!0}ue.prototype.parse=function(X){var le=this.loose?S[G]:S[J],de=X.match(le);if(!de)throw new TypeError("Invalid comparator: "+X);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new ce(de[2],this.loose):this.semver=we},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(X){return s("Comparator.test",X,this.loose),this.semver===we||(typeof X=="string"&&(X=new ce(X,this.loose)),ge(X,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(X,le){if(!(X instanceof ue))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new me(X.value,le),ve(this.value,de,le);if(X.operator==="")return de=new me(this.value,le),ve(X.semver,de,le);var Ee=!(this.operator!==">="&&this.operator!==">"||X.operator!==">="&&X.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||X.operator!=="<="&&X.operator!=="<"),Ue=this.semver.version===X.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||X.operator!==">="&&X.operator!=="<="),Be=ge(this.semver,"<",X.semver,le)&&(this.operator===">="||this.operator===">")&&(X.operator==="<="||X.operator==="<"),We=ge(this.semver,">",X.semver,le)&&(this.operator==="<="||this.operator==="<")&&(X.operator===">="||X.operator===">");return Ee||Re||Ue&&Oe||Be||We},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(X){return X.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(X){var le=this.loose;X=X.trim(),s("range",X,le);var de=le?S[N]:S[F];X=X.replace(de,Ie),s("hyphen replace",X),X=X.replace(S[q],"$1$2$3"),s("comparator trim",X,S[q]),X=(X=(X=X.replace(S[U],"$1~")).replace(S[ae],"$1^")).split(/\s+/).join(" ");var Ee=le?S[G]:S[J],Re=X.split(" ").map(function(Ue){return function(Oe,Be){return s("comp",Oe),Oe=function(We,Z){return We.trim().split(/\s+/).map(function(he){return function($e,ye){s("caret",$e,ye);var Ae=ye?S[oe]:S[se];return $e.replace(Ae,function(Fe,Le,Ne,ze,qe){var He;return s("caret",$e,Fe,Le,Ne,ze,qe),Se(Le)?He="":Se(Ne)?He=">="+Le+".0.0 <"+(+Le+1)+".0.0":Se(ze)?He=Le==="0"?">="+Le+"."+Ne+".0 <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+".0 <"+(+Le+1)+".0.0":qe?(s("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=Le==="0"?Ne==="0"?">="+Le+"."+Ne+"."+ze+qe+" <"+Le+"."+Ne+"."+(+ze+1):">="+Le+"."+Ne+"."+ze+qe+" <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+"."+ze+qe+" <"+(+Le+1)+".0.0"):(s("no pr"),He=Le==="0"?Ne==="0"?">="+Le+"."+Ne+"."+ze+" <"+Le+"."+Ne+"."+(+ze+1):">="+Le+"."+Ne+"."+ze+" <"+Le+"."+(+Ne+1)+".0":">="+Le+"."+Ne+"."+ze+" <"+(+Le+1)+".0.0"),s("caret return",He),He})}(he,Z)}).join(" ")}(Oe,Be),s("caret",Oe),Oe=function(We,Z){return We.trim().split(/\s+/).map(function(he){return function($e,ye){var Ae=ye?S[re]:S[z];return $e.replace(Ae,function(Fe,Le,Ne,ze,qe){var He;return s("tilde",$e,Fe,Le,Ne,ze,qe),Se(Le)?He="":Se(Ne)?He=">="+Le+".0.0 <"+(+Le+1)+".0.0":Se(ze)?He=">="+Le+"."+Ne+".0 <"+Le+"."+(+Ne+1)+".0":qe?(s("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),He=">="+Le+"."+Ne+"."+ze+qe+" <"+Le+"."+(+Ne+1)+".0"):He=">="+Le+"."+Ne+"."+ze+" <"+Le+"."+(+Ne+1)+".0",s("tilde return",He),He})}(he,Z)}).join(" ")}(Oe,Be),s("tildes",Oe),Oe=function(We,Z){return s("replaceXRanges",We,Z),We.split(/\s+/).map(function(he){return function($e,ye){$e=$e.trim();var Ae=ye?S[p]:S[C];return $e.replace(Ae,function(Fe,Le,Ne,ze,qe,He){s("xRange",$e,Fe,Le,Ne,ze,qe,He);var xe=Se(Ne),Qe=xe||Se(ze),tt=Qe||Se(qe);return Le==="="&&tt&&(Le=""),xe?Fe=Le===">"||Le==="<"?"<0.0.0":"*":Le&&tt?(Qe&&(ze=0),tt&&(qe=0),Le===">"?(Le=">=",Qe?(Ne=+Ne+1,ze=0,qe=0):tt&&(ze=+ze+1,qe=0)):Le==="<="&&(Le="<",Qe?Ne=+Ne+1:ze=+ze+1),Fe=Le+Ne+"."+ze+"."+qe):Qe?Fe=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":tt&&(Fe=">="+Ne+"."+ze+".0 <"+Ne+"."+(+ze+1)+".0"),s("xRange return",Fe),Fe})}(he,Z)}).join(" ")}(Oe,Be),s("xrange",Oe),Oe=function(We,Z){return s("replaceStars",We,Z),We.trim().replace(S[V],"")}(Oe,Be),s("stars",Oe),Oe}(Ue,le)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Ue){return!!Ue.match(Ee)})),Re=Re.map(function(Ue){return new ue(Ue,le)})},me.prototype.intersects=function(X,le){if(!(X instanceof me))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Ee){return X.set.some(function(Re){return Re.every(function(Ue){return Ee.intersects(Ue,le)})})})})},e.toComparators=function(X,le){return new me(X,le).set.map(function(de){return de.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},me.prototype.test=function(X){if(!X)return!1;typeof X=="string"&&(X=new ce(X,this.loose));for(var le=0;le<this.set.length;le++)if(je(this.set[le],X))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(X,le,de){var Ee=null,Re=null;try{var Ue=new me(le,de)}catch{return null}return X.forEach(function(Oe){Ue.test(Oe)&&(Ee&&Re.compare(Oe)!==-1||(Re=new ce(Ee=Oe,de)))}),Ee},e.minSatisfying=function(X,le,de){var Ee=null,Re=null;try{var Ue=new me(le,de)}catch{return null}return X.forEach(function(Oe){Ue.test(Oe)&&(Ee&&Re.compare(Oe)!==1||(Re=new ce(Ee=Oe,de)))}),Ee},e.validRange=function(X,le){try{return new me(X,le).range||"*"}catch{return null}},e.ltr=function(X,le,de){return be(X,le,"<",de)},e.gtr=function(X,le,de){return be(X,le,">",de)},e.outside=be,e.prerelease=function(X,le){var de=x(X,le);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(X,le,de){return X=new me(X,de),le=new me(le,de),X.intersects(le)},e.coerce=function(X){if(X instanceof ce)return X;if(typeof X!="string")return null;var le=X.match(S[A]);return le==null?null:x((le[1]||"0")+"."+(le[2]||"0")+"."+(le[3]||"0"))}}).call(this,P(1))},function(K,e){var P,O,s=K.exports={};function M(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function S(d){if(P===setTimeout)return setTimeout(d,0);if((P===M||!P)&&setTimeout)return P=setTimeout,setTimeout(d,0);try{return P(d,0)}catch{try{return P.call(null,d,0)}catch{return P.call(this,d,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:M}catch{P=M}try{O=typeof clearTimeout=="function"?clearTimeout:D}catch{O=D}})();var h,c=[],m=!1,w=-1;function y(){m&&h&&(m=!1,h.length?c=h.concat(c):w=-1,c.length&&f())}function f(){if(!m){var d=S(y);m=!0;for(var g=c.length;g;){for(h=c,c=[];++w<g;)h&&h[w].run();w=-1,g=c.length}h=null,m=!1,function(r){if(O===clearTimeout)return clearTimeout(r);if((O===D||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(r);try{O(r)}catch{try{return O.call(null,r)}catch{return O.call(this,r)}}}(d)}}function v(d,g){this.fun=d,this.array=g}function b(){}s.nextTick=function(d){var g=new Array(arguments.length-1);if(arguments.length>1)for(var r=1;r<arguments.length;r++)g[r-1]=arguments[r];c.push(new v(d,g)),c.length!==1||m||S(f)},v.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=b,s.addListener=b,s.once=b,s.off=b,s.removeListener=b,s.removeAllListeners=b,s.emit=b,s.prependListener=b,s.prependOnceListener=b,s.listeners=function(d){return[]},s.binding=function(d){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(d){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(te[139],ie([0,1]),function(K,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$or=void 0;class O{constructor(S,h,c){this.level=S,this.key=h,this.value=c,this.forward=[]}}const s=void 0;class M{constructor(S,h=2**16){this.comparator=S,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new O(this.c,s,s)}get size(){return this.f}clear(){this.e=new O(this.c,s,s)}has(S){return!!M.g(this,S,this.comparator)}get(S){return M.g(this,S,this.comparator)?.value}set(S,h){return M.h(this,S,h,this.comparator)&&(this.f+=1),this}delete(S){const h=M.k(this,S,this.comparator);return h&&(this.f-=1),h}forEach(S,h){let c=this.e.forward[0];for(;c;)S.call(h,c.value,c.key,this),c=c.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",h=this.e.forward[0];for(;h;)S+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return S}static g(S,h,c){let m=S.e;for(let w=S.d-1;w>=0;w--)for(;m.forward[w]&&c(m.forward[w].key,h)<0;)m=m.forward[w];if(m=m.forward[0],m&&c(m.key,h)===0)return m}static h(S,h,c,m){const w=[];let y=S.e;for(let f=S.d-1;f>=0;f--){for(;y.forward[f]&&m(y.forward[f].key,h)<0;)y=y.forward[f];w[f]=y}if(y=y.forward[0],y&&m(y.key,h)===0)return y.value=c,!1;{const f=M.j(S);if(f>S.d){for(let v=S.d;v<f;v++)w[v]=S.e;S.d=f}y=new O(f,h,c);for(let v=0;v<f;v++)y.forward[v]=w[v].forward[v],w[v].forward[v]=y;return!0}}static j(S,h=.5){let c=1;for(;Math.random()<h&&c<S.c;)c+=1;return c}static k(S,h,c){const m=[];let w=S.e;for(let y=S.d-1;y>=0;y--){for(;w.forward[y]&&c(w.forward[y].key,h)<0;)w=w.forward[y];m[y]=w}if(w=w.forward[0],!w||c(w.key,h)!==0)return!1;for(let y=0;y<S.d&&m[y].forward[y]===w;y++)m[y].forward[y]=w.forward[y];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$or=M}),define(te[69],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class O{static create(M){return new O(M)}constructor(M){this.c=P&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$bd=O}),define(te[3],ie([0,1,14,49,2,101,69]),function(K,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=e.$dd=e.Event=void 0;const S=!1,h=!1;var c;(function(C){C.None=()=>s.$kc.None;function p(ge){if(h){const{onDidAddListener:ue}=ge,we=v.create();let me=0;ge.onDidAddListener=()=>{++me===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),we.print()),ue?.()}}}function A(ge,ue){return J(ge,()=>{},0,void 0,!0,void 0,ue)}C.defer=A;function L(ge){return(ue,we=null,me)=>{let Se=!1,Ie;return Ie=ge(je=>{if(!Se)return Ie?Ie.dispose():Se=!0,ue.call(we,je)},null,me),Se&&Ie.dispose(),Ie}}C.once=L;function U(ge,ue,we){return oe((me,Se=null,Ie)=>ge(je=>me.call(Se,ue(je)),null,Ie),we)}C.map=U;function z(ge,ue,we){return oe((me,Se=null,Ie)=>ge(je=>{ue(je),me.call(Se,je)},null,Ie),we)}C.forEach=z;function re(ge,ue,we){return oe((me,Se=null,Ie)=>ge(je=>ue(je)&&me.call(Se,je),null,Ie),we)}C.filter=re;function ee(ge){return ge}C.signal=ee;function ae(...ge){return(ue,we=null,me)=>{const Se=(0,s.$hc)(...ge.map(Ie=>Ie(je=>ue.call(we,je))));return G(Se,me)}}C.any=ae;function se(ge,ue,we,me){let Se=we;return U(ge,Ie=>(Se=ue(Se,Ie),Se),me)}C.reduce=se;function oe(ge,ue){let we;const me={onWillAddFirstListener(){we=ge(Se.fire,Se)},onDidRemoveLastListener(){we?.dispose()}};ue||p(me);const Se=new $(me);return ue?.add(Se),Se.event}function G(ge,ue){return ue instanceof Array?ue.push(ge):ue&&ue.add(ge),ge}function J(ge,ue,we=100,me=!1,Se=!1,Ie,je){let ve,be,X,le=0,de;const Ee={leakWarningThreshold:Ie,onWillAddFirstListener(){ve=ge(Ue=>{le++,be=ue(be,Ue),me&&!X&&(Re.fire(be),be=void 0),de=()=>{const Oe=be;be=void 0,X=void 0,(!me||le>1)&&Re.fire(Oe),le=0},typeof we=="number"?(clearTimeout(X),X=setTimeout(de,we)):X===void 0&&(X=0,queueMicrotask(de))})},onWillRemoveListener(){Se&&le>0&&de?.()},onDidRemoveLastListener(){de=void 0,ve.dispose()}};je||p(Ee);const Re=new $(Ee);return je?.add(Re),Re.event}C.debounce=J;function q(ge,ue=0,we){return C.debounce(ge,(me,Se)=>me?(me.push(Se),me):[Se],ue,void 0,!0,void 0,we)}C.accumulate=q;function F(ge,ue=(me,Se)=>me===Se,we){let me=!0,Se;return re(ge,Ie=>{const je=me||!ue(Ie,Se);return me=!1,Se=Ie,je},we)}C.latch=F;function N(ge,ue,we){return[C.filter(ge,ue,we),C.filter(ge,me=>!ue(me),we)]}C.split=N;function V(ge,ue=!1,we=[],me){let Se=we.slice(),Ie=ge(be=>{Se?Se.push(be):ve.fire(be)});me&&me.add(Ie);const je=()=>{Se?.forEach(be=>ve.fire(be)),Se=null},ve=new $({onWillAddFirstListener(){Ie||(Ie=ge(be=>ve.fire(be)),me&&me.add(Ie))},onDidAddFirstListener(){Se&&(ue?setTimeout(je):je())},onDidRemoveLastListener(){Ie&&Ie.dispose(),Ie=null}});return me&&me.add(ve),ve.event}C.buffer=V;function Q(ge,ue){return(me,Se,Ie)=>{const je=ue(new ce);return ge(function(ve){const be=je.evaluate(ve);be!==x&&me.call(Se,be)},void 0,Ie)}}C.chain=Q;const x=Symbol("HaltChainable");class ce{constructor(){this.f=[]}map(ue){return this.f.push(ue),this}forEach(ue){return this.f.push(we=>(ue(we),we)),this}filter(ue){return this.f.push(we=>ue(we)?we:x),this}reduce(ue,we){let me=we;return this.f.push(Se=>(me=ue(me,Se),me)),this}latch(ue=(we,me)=>we===me){let we=!0,me;return this.f.push(Se=>{const Ie=we||!ue(Se,me);return we=!1,me=Se,Ie?Se:x}),this}evaluate(ue){for(const we of this.f)if(ue=we(ue),ue===x)break;return ue}}function Y(ge,ue,we=me=>me){const me=(...ve)=>je.fire(we(...ve)),Se=()=>ge.on(ue,me),Ie=()=>ge.removeListener(ue,me),je=new $({onWillAddFirstListener:Se,onDidRemoveLastListener:Ie});return je.event}C.fromNodeEventEmitter=Y;function R(ge,ue,we=me=>me){const me=(...ve)=>je.fire(we(...ve)),Se=()=>ge.addEventListener(ue,me),Ie=()=>ge.removeEventListener(ue,me),je=new $({onWillAddFirstListener:Se,onDidRemoveLastListener:Ie});return je.event}C.fromDOMEventEmitter=R;function j(ge){return new Promise(ue=>L(ge)(ue))}C.toPromise=j;function W(ge){const ue=new $;return ge.then(we=>{ue.fire(we)},()=>{ue.fire(void 0)}).finally(()=>{ue.dispose()}),ue.event}C.fromPromise=W;function T(ge,ue){return ue(void 0),ge(we=>ue(we))}C.runAndSubscribe=T;function H(ge,ue){let we=null;function me(Ie){we?.dispose(),we=new s.$jc,ue(Ie,we)}me(void 0);const Se=ge(Ie=>me(Ie));return(0,s.$ic)(()=>{Se.dispose(),we?.dispose()})}C.runAndSubscribeWithStore=H;class B{constructor(ue,we){this._observable=ue,this.f=0,this.g=!1;const me={onWillAddFirstListener:()=>{ue.addObserver(this)},onDidRemoveLastListener:()=>{ue.removeObserver(this)}};we||p(me),this.emitter=new $(me),we&&we.add(this.emitter)}beginUpdate(ue){this.f++}handlePossibleChange(ue){}handleChange(ue,we){this.g=!0}endUpdate(ue){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ne(ge,ue){return new B(ge,ue).emitter.event}C.fromObservable=ne;function fe(ge){return ue=>{let we=0,me=!1;const Se={beginUpdate(){we++},endUpdate(){we--,we===0&&(ge.reportChanges(),me&&(me=!1,ue()))},handlePossibleChange(){},handleChange(){me=!0}};return ge.addObserver(Se),ge.reportChanges(),{dispose(){ge.removeObserver(Se)}}}}C.fromObservableLight=fe})(c||(e.Event=c={}));class m{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${m.f++}`,m.all.add(this)}start(p){this.g=new D.$bd,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$dd=m;let w=-1;function y(C){const p=w;return w=C,{dispose(){w=p}}}e.$ed=y;class f{constructor(p,A=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=A,this.g=0}dispose(){this.f?.clear()}check(p,A){const L=this.threshold;if(L<=0||A<L)return;this.f||(this.f=new Map);const U=this.f.get(p.value)||0;if(this.f.set(p.value,U+1),this.g-=1,this.g<=0){this.g=L*.5;let z,re=0;for(const[ee,ae]of this.f)(!z||re<ae)&&(z=ee,re=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${re}):`),console.warn(z)}return()=>{const z=this.f.get(p.value)||0;this.f.set(p.value,z-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class d{constructor(p){this.value=p,this.id=b++}}const g=2,r=(C,p)=>{if(C instanceof d)p(C);else for(let A=0;A<C.length;A++){const L=C[A];L&&p(L)}};class ${constructor(p){this.x=0,this.f=p,this.g=w>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new m(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const p=this.t;queueMicrotask(()=>{r(p,A=>A.stack?.print())})}this.t=void 0,this.x=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,A,L)=>{if(this.g&&this.x>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$kc.None;if(this.m)return s.$kc.None;A&&(p=p.bind(A));const U=new d(p);let z,re;this.g&&this.x>=Math.ceil(this.g.threshold*.2)&&(U.stack=v.create(),z=this.g.check(U.stack,this.x+1)),S&&(U.stack=re??v.create()),this.t?this.t instanceof d?(this.u??=new u,this.t=[this.t,U]):this.t.push(U):(this.f?.onWillAddFirstListener?.(this),this.t=U,this.f?.onDidAddFirstListener?.(this)),this.x++;const ee=(0,s.$ic)(()=>{z?.(),this.y(U)});return L instanceof s.$jc?L.add(ee):Array.isArray(L)&&L.push(ee),ee},this.q}y(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.x===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.x=0;return}const A=this.t,L=A.indexOf(p);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.x),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.x--,A[L]=void 0;const U=this.u.current===this;if(this.x*g<=A.length){let z=0;for(let re=0;re<A.length;re++)A[re]?A[z++]=A[re]:U&&(this.u.end--,z<this.u.i&&this.u.i--);A.length=z}}z(p,A){if(!p)return;const L=this.f?.onListenerError||P.$Y;if(!L){p.value(A);return}try{p.value(A)}catch(U){L(U)}}A(p){const A=p.current.t;for(;p.i<p.end;)this.z(A[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.A(this.u),this.j?.stop()),this.j?.start(this.x),this.t)if(this.t instanceof d)this.z(this.t,p);else{const A=this.u;A.enqueue(this,p,this.t.length),this.A(A)}this.j?.stop()}hasListeners(){return this.x>0}}e.$fd=$;const E=()=>new u;e.$gd=E;class u{constructor(){this.i=-1,this.end=0}enqueue(p,A,L){this.i=0,this.end=L,this.current=p,this.value=A}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends ${async fireAsync(p,A,L){if(this.t)for(this.h||(this.h=new M.$tc),r(this.t,U=>this.h.push([U.value,p]));this.h.size>0&&!A.isCancellationRequested;){const[U,z]=this.h.shift(),re=[],ee={...z,token:A,waitUntil:ae=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");L&&(ae=L(ae,U)),re.push(ae)}};try{U(ee)}catch(ae){(0,P.$Y)(ae);continue}Object.freeze(re),await Promise.allSettled(re).then(ae=>{for(const se of ae)se.status==="rejected"&&(0,P.$Y)(se.reason)})}}}e.$hd=t;class l extends ${get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new M.$tc,this.w=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.w){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.w(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.x&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$id=l;class o extends l{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$jd=o;class i extends ${constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(A=>super.fire(A)),this.h=[]}))}}e.$kd=i;class n{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const A={event:p,listener:null};this.h.push(A),this.g&&this.m(A);const L=()=>{this.g&&this.o(A);const U=this.h.indexOf(A);this.h.splice(U,1)};return(0,s.$ic)((0,O.$bb)(L))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(A=>this.f.fire(A))}o(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.f.dispose()}}e.$ld=n;class a{constructor(p,A,L,U){this.f=new s.$jc;const z=this.f.add(new n),re=this.f.add(new s.$sc);function ee(ae){re.set(ae,z.add(U(ae)))}for(const ae of p)ee(ae);this.f.add(A(ae=>{ee(ae)})),this.f.add(L(ae=>{re.deleteAndDispose(ae)})),this.event=z.event}dispose(){this.f.dispose()}}e.$md=a;class k{constructor(){this.f=[]}wrapEvent(p){return(A,L,U)=>p(z=>{const re=this.f[this.f.length-1];re?re.push(()=>A.call(L,z)):A.call(L,z)},void 0,U)}bufferEvents(p){const A=[];this.f.push(A);const L=p();return this.f.pop(),A.forEach(U=>U()),L}}e.$nd=k;class I{constructor(){this.f=!1,this.g=c.None,this.h=s.$kc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$od=I}),define(te[22],ie([0,1,3]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pd=e.CancellationToken=void 0;const O=Object.freeze(function(S,h){const c=setTimeout(S.bind(h),0);return{dispose(){clearTimeout(c)}}});var s;(function(S){function h(c){return c===S.None||c===S.Cancelled||c instanceof M?!0:!c||typeof c!="object"?!1:typeof c.isCancellationRequested=="boolean"&&typeof c.onCancellationRequested=="function"}S.isCancellationToken=h,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:O})})(s||(e.CancellationToken=s={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?O:(this.b||(this.b=new P.$fd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=s.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=s.None}}e.$pd=D}),define(te[140],ie([0,1,22]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=void 0;class O{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new P.$pd,h=this.b(S.token);return this.a={promise:h,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$he=O;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const h=JSON.stringify(S);return this.b!==h&&(this.b=h,this.a=this.c(S)),this.a}}e.$ie=s;class M{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const h=this.b(S);return this.a.set(S,h),h}}e.$je=M}),define(te[62],ie([0,1,14,2]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=void 0;function s(E){const u=E;return u?typeof u.read=="function":!1}e.$qd=s;function M(E){const u=E;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.$rd=M;function D(E){const u=E;return u?M(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$sd=D;function S(E,u){return new h(E,u)}e.$td=S;class h{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,P.$Y)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let l;switch(u){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const o=l.indexOf(t);o>=0&&l.splice(o,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(E,u){const t=[];let l;for(;(l=E.read())!==null;)t.push(l);return u(t)}e.$ud=c;function m(E,u,t){const l=[];let o;for(;(o=E.read())!==null&&l.length<t;)l.push(o);return o===null&&l.length>0?u(l):{read:()=>{if(l.length>0)return l.shift();if(typeof o<"u"){const i=o;return o=void 0,i}return E.read()}}}e.$vd=m;function w(E,u){return new Promise((t,l)=>{const o=[];y(E,{onData:i=>{u&&o.push(i)},onError:i=>{u?l(i):t(void 0)},onEnd:()=>{t(u?u(o):void 0)}})})}e.$wd=w;function y(E,u,t){E.on("error",l=>{t?.isCancellationRequested||u.onError(l)}),E.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),E.on("data",l=>{t?.isCancellationRequested||u.onData(l)})}e.$xd=y;function f(E,u){return new Promise((t,l)=>{const o=new O.$jc,i=[],n=I=>{if(i.push(I),i.length>u)return o.dispose(),E.pause(),t({stream:E,buffer:i,ended:!1})},a=I=>(o.dispose(),l(I)),k=()=>(o.dispose(),t({stream:E,buffer:i,ended:!0}));o.add((0,O.$ic)(()=>E.removeListener("error",a))),E.on("error",a),o.add((0,O.$ic)(()=>E.removeListener("end",k))),E.on("end",k),o.add((0,O.$ic)(()=>E.removeListener("data",n))),E.on("data",n)})}e.$yd=f;function v(E,u){const t=S(u);return t.end(E),t}e.$zd=v;function b(){const E=S(()=>{throw new Error("not supported")});return E.end(),E}e.$Ad=b;function d(E){let u=!1;return{read:()=>u?null:(u=!0,E)}}e.$Bd=d;function g(E,u,t){const l=S(t);return y(E,{onData:o=>l.write(u.data(o)),onError:o=>l.error(u.error?u.error(o):o),onEnd:()=>l.end()}),l}e.$Cd=g;function r(E,u,t){let l=!1;return{read:()=>{const o=u.read();return l?o:(l=!0,o!==null?t([E,o]):E)}}}e.$Dd=r;function $(E,u,t){let l=!1;const o=S(t);return y(u,{onData:i=>l?o.write(i):(l=!0,o.write(t([E,i]))),onError:i=>o.error(i),onEnd:()=>{l||(l=!0,o.write(E)),o.end()}}),o}e.$Ed=$}),define(te[17],ie([0,1,84,62]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=void 0;const s=typeof Buffer<"u",M=new P.$T(()=>new Uint8Array(256));let D,S;class h{static alloc(A){return s?new h(Buffer.allocUnsafe(A)):new h(new Uint8Array(A))}static wrap(A){return s&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new h(A)}static fromString(A,L){return!(L?.dontUseNodeBuffer||!1)&&s?new h(Buffer.from(A)):(D||(D=new TextEncoder),new h(D.encode(A)))}static fromByteArray(A){const L=h.alloc(A.length);for(let U=0,z=A.length;U<z;U++)L.buffer[U]=A[U];return L}static concat(A,L){if(typeof L>"u"){L=0;for(let re=0,ee=A.length;re<ee;re++)L+=A[re].byteLength}const U=h.alloc(L);let z=0;for(let re=0,ee=A.length;re<ee;re++){const ae=A[re];U.set(ae,z),z+=ae.byteLength}return U}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=h.alloc(this.byteLength);return A.set(this),A}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(A,L){return new h(this.buffer.subarray(A,L))}set(A,L){if(A instanceof h)this.buffer.set(A.buffer,L);else if(A instanceof Uint8Array)this.buffer.set(A,L);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),L);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return y(this.buffer,A)}writeUInt32BE(A,L){f(this.buffer,A,L)}readUInt32LE(A){return v(this.buffer,A)}writeUInt32LE(A,L){b(this.buffer,A,L)}readUInt8(A){return d(this.buffer,A)}writeUInt8(A,L){g(this.buffer,A,L)}indexOf(A,L=0){return c(this.buffer,A instanceof h?A.buffer:A,L)}}e.$Fd=h;function c(p,A,L=0){const U=A.byteLength,z=p.byteLength;if(U===0)return 0;if(U===1)return p.indexOf(A[0]);if(U>z-L)return-1;const re=M.value;re.fill(A.length);for(let oe=0;oe<A.length;oe++)re[A[oe]]=A.length-oe-1;let ee=L+A.length-1,ae=ee,se=-1;for(;ee<z;)if(p[ee]===A[ae]){if(ae===0){se=ee;break}ee--,ae--}else ee+=Math.max(A.length-ae,re[p[ee]]),ae=A.length-1;return se}e.$Gd=c;function m(p,A){return p[A+0]<<0>>>0|p[A+1]<<8>>>0}e.$Hd=m;function w(p,A,L){p[L+0]=A&255,A=A>>>8,p[L+1]=A&255}e.$Id=w;function y(p,A){return p[A]*2**24+p[A+1]*2**16+p[A+2]*2**8+p[A+3]}e.$Jd=y;function f(p,A,L){p[L+3]=A,A=A>>>8,p[L+2]=A,A=A>>>8,p[L+1]=A,A=A>>>8,p[L]=A}e.$Kd=f;function v(p,A){return p[A+0]<<0>>>0|p[A+1]<<8>>>0|p[A+2]<<16>>>0|p[A+3]<<24>>>0}e.$Ld=v;function b(p,A,L){p[L+0]=A&255,A=A>>>8,p[L+1]=A&255,A=A>>>8,p[L+2]=A&255,A=A>>>8,p[L+3]=A&255}e.$Md=b;function d(p,A){return p[A]}e.$Nd=d;function g(p,A,L){p[L]=A}e.$Od=g;function r(p){return O.$ud(p,A=>h.concat(A))}e.$Pd=r;function $(p){return O.$Bd(p)}e.$Qd=$;function E(p){return O.$wd(p,A=>h.concat(A))}e.$Rd=E;async function u(p){return p.ended?h.concat(p.buffer):h.concat([...p.buffer,await E(p.stream)])}e.$Sd=u;function t(p){return O.$zd(p,A=>h.concat(A))}e.$Td=t;function l(p){return O.$Cd(p,{data:A=>typeof A=="string"?h.fromString(A):h.wrap(A)},A=>h.concat(A))}e.$Ud=l;function o(p){return O.$td(A=>h.concat(A),p)}e.$Vd=o;function i(p,A){return O.$Dd(p,A,L=>h.concat(L))}e.$Wd=i;function n(p,A){return O.$Ed(p,A,L=>h.concat(L))}e.$Xd=n;function a(p){let A=0,L=0,U=0;const z=new Uint8Array(Math.floor(p.length/4*3)),re=ae=>{switch(L){case 3:z[U++]=A|ae,L=0;break;case 2:z[U++]=A|ae>>>2,A=ae<<6,L=3;break;case 1:z[U++]=A|ae>>>4,A=ae<<4,L=2;break;default:A=ae<<2,L=1}};for(let ae=0;ae<p.length;ae++){const se=p.charCodeAt(ae);if(se>=65&&se<=90)re(se-65);else if(se>=97&&se<=122)re(se-97+26);else if(se>=48&&se<=57)re(se-48+52);else if(se===43||se===45)re(62);else if(se===47||se===95)re(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${p[ae]}`)}}const ee=U;for(;L>0;)re(0);return h.wrap(z).slice(0,ee)}e.$Yd=a;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:p},A=!0,L=!1){const U=L?I:k;let z="";const re=p.byteLength%3;let ee=0;for(;ee<p.byteLength-re;ee+=3){const ae=p[ee+0],se=p[ee+1],oe=p[ee+2];z+=U[ae>>>2],z+=U[(ae<<4|se>>>4)&63],z+=U[(se<<2|oe>>>6)&63],z+=U[oe&63]}if(re===1){const ae=p[ee+0];z+=U[ae>>>2],z+=U[ae<<4&63],A&&(z+="==")}else if(re===2){const ae=p[ee+0],se=p[ee+1];z+=U[ae>>>2],z+=U[(ae<<4|se>>>4)&63],z+=U[se<<2&63],A&&(z+="=")}return z}e.$Zd=C}),define(te[26],ie([0,1,140,84]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$if=e.$hf=e.$gf=e.$ff=e.GraphemeBreakType=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=void 0;function s(Z){return!Z||typeof Z!="string"?!0:Z.trim().length===0}e.$me=s;const M=/{(\d+)}/g;function D(Z,...he){return he.length===0?Z:Z.replace(M,function($e,ye){const Ae=parseInt(ye,10);return isNaN(Ae)||Ae<0||Ae>=he.length?$e:he[Ae]})}e.$ne=D;const S=/{([^}]+)}/g;function h(Z,he){return Z.replace(S,($e,ye)=>he[ye]??$e)}e.$oe=h;function c(Z){return Z.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.$pe=c;function m(Z){return Z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$qe=m;function w(Z,he){let $e=0;const ye=he.charCodeAt(0);for(let Ae=Z.length-1;Ae>=0;Ae--)Z.charCodeAt(Ae)===ye&&$e++;return $e}e.$re=w;function y(Z,he,$e="\u2026"){return Z.length<=he?Z:`${Z.substr(0,he)}${$e}`}e.$se=y;function f(Z,he=" "){const $e=v(Z,he);return b($e,he)}e.$te=f;function v(Z,he){if(!Z||!he)return Z;const $e=he.length;if($e===0||Z.length===0)return Z;let ye=0;for(;Z.indexOf(he,ye)===ye;)ye=ye+$e;return Z.substring(ye)}e.$ue=v;function b(Z,he){if(!Z||!he)return Z;const $e=he.length,ye=Z.length;if($e===0||ye===0)return Z;let Ae=ye,Fe=-1;for(;Fe=Z.lastIndexOf(he,Ae-1),!(Fe===-1||Fe+$e!==Ae);){if(Fe===0)return"";Ae=Fe}return Z.substring(0,Ae)}e.$ve=b;function d(Z){return Z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$we=d;function g(Z){return Z.replace(/\*/g,"")}e.$xe=g;function r(Z,he,$e={}){if(!Z)throw new Error("Cannot create regex from empty string");he||(Z=m(Z)),$e.wholeWord&&(/\B/.test(Z.charAt(0))||(Z="\\b"+Z),/\B/.test(Z.charAt(Z.length-1))||(Z=Z+"\\b"));let ye="";return $e.global&&(ye+="g"),$e.matchCase||(ye+="i"),$e.multiline&&(ye+="m"),$e.unicode&&(ye+="u"),new RegExp(Z,ye)}e.$ye=r;function $(Z){return Z.source==="^"||Z.source==="^$"||Z.source==="$"||Z.source==="^\\s*$"?!1:!!(Z.exec("")&&Z.lastIndex===0)}e.$ze=$;function E(Z){return Z.split(/\r\n|\r|\n/)}e.$Ae=E;function u(Z){for(let he=0,$e=Z.length;he<$e;he++){const ye=Z.charCodeAt(he);if(ye!==32&&ye!==9)return he}return-1}e.$Be=u;function t(Z,he=0,$e=Z.length){for(let ye=he;ye<$e;ye++){const Ae=Z.charCodeAt(ye);if(Ae!==32&&Ae!==9)return Z.substring(he,ye)}return Z.substring(he,$e)}e.$Ce=t;function l(Z,he=Z.length-1){for(let $e=he;$e>=0;$e--){const ye=Z.charCodeAt($e);if(ye!==32&&ye!==9)return $e}return-1}e.$De=l;function o(Z,he,$e){const ye=[];let Ae=0;for(const Fe of Z.matchAll(he)){if(ye.push(Z.slice(Ae,Fe.index)),Fe.index===void 0)throw new Error("match.index should be defined");Ae=Fe.index+Fe[0].length,ye.push($e(Fe[0],...Fe.slice(1),Fe.index,Z,Fe.groups))}return ye.push(Z.slice(Ae)),Promise.all(ye).then(Fe=>Fe.join(""))}e.$Ee=o;function i(Z,he){return Z<he?-1:Z>he?1:0}e.$Fe=i;function n(Z,he,$e=0,ye=Z.length,Ae=0,Fe=he.length){for(;$e<ye&&Ae<Fe;$e++,Ae++){const ze=Z.charCodeAt($e),qe=he.charCodeAt(Ae);if(ze<qe)return-1;if(ze>qe)return 1}const Le=ye-$e,Ne=Fe-Ae;return Le<Ne?-1:Le>Ne?1:0}e.$Ge=n;function a(Z,he){return k(Z,he,0,Z.length,0,he.length)}e.$He=a;function k(Z,he,$e=0,ye=Z.length,Ae=0,Fe=he.length){for(;$e<ye&&Ae<Fe;$e++,Ae++){let ze=Z.charCodeAt($e),qe=he.charCodeAt(Ae);if(ze===qe)continue;if(ze>=128||qe>=128)return n(Z.toLowerCase(),he.toLowerCase(),$e,ye,Ae,Fe);C(ze)&&(ze-=32),C(qe)&&(qe-=32);const He=ze-qe;if(He!==0)return He}const Le=ye-$e,Ne=Fe-Ae;return Le<Ne?-1:Le>Ne?1:0}e.$Ie=k;function I(Z){return Z>=48&&Z<=57}e.$Je=I;function C(Z){return Z>=97&&Z<=122}e.$Ke=C;function p(Z){return Z>=65&&Z<=90}e.$Le=p;function A(Z,he){return Z.length===he.length&&k(Z,he)===0}e.$Me=A;function L(Z,he){const $e=he.length;return he.length>Z.length?!1:k(Z,he,0,$e)===0}e.$Ne=L;function U(Z,he){const $e=Math.min(Z.length,he.length);let ye;for(ye=0;ye<$e;ye++)if(Z.charCodeAt(ye)!==he.charCodeAt(ye))return ye;return $e}e.$Oe=U;function z(Z,he){const $e=Math.min(Z.length,he.length);let ye;const Ae=Z.length-1,Fe=he.length-1;for(ye=0;ye<$e;ye++)if(Z.charCodeAt(Ae-ye)!==he.charCodeAt(Fe-ye))return ye;return $e}e.$Pe=z;function re(Z){return 55296<=Z&&Z<=56319}e.$Qe=re;function ee(Z){return 56320<=Z&&Z<=57343}e.$Re=ee;function ae(Z,he){return(Z-55296<<10)+(he-56320)+65536}e.$Se=ae;function se(Z,he,$e){const ye=Z.charCodeAt($e);if(re(ye)&&$e+1<he){const Ae=Z.charCodeAt($e+1);if(ee(Ae))return ae(ye,Ae)}return ye}e.$Te=se;function oe(Z,he){const $e=Z.charCodeAt(he-1);if(ee($e)&&he>1){const ye=Z.charCodeAt(he-2);if(re(ye))return ae(ye,$e)}return $e}class G{get offset(){return this.e}constructor(he,$e=0){this.c=he,this.d=he.length,this.e=$e}setOffset(he){this.e=he}prevCodePoint(){const he=oe(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=se(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.$Ue=G;class J{get offset(){return this.c.offset}constructor(he,$e=0){this.c=new G(he,$e)}nextGraphemeLength(){const he=le.getInstance(),$e=this.c,ye=$e.offset;let Ae=he.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const Fe=$e.offset,Le=he.getGraphemeBreakType($e.nextCodePoint());if(be(Ae,Le)){$e.setOffset(Fe);break}Ae=Le}return $e.offset-ye}prevGraphemeLength(){const he=le.getInstance(),$e=this.c,ye=$e.offset;let Ae=he.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const Fe=$e.offset,Le=he.getGraphemeBreakType($e.prevCodePoint());if(be(Le,Ae)){$e.setOffset(Fe);break}Ae=Le}return ye-$e.offset}eol(){return this.c.eol()}}e.$Ve=J;function q(Z,he){return new J(Z,he).nextGraphemeLength()}e.$We=q;function F(Z,he){return new J(Z,he).prevGraphemeLength()}e.$Xe=F;function N(Z,he){he>0&&ee(Z.charCodeAt(he))&&he--;const $e=he+q(Z,he);return[$e-F(Z,$e),$e]}e.$Ye=N;function V(Z){const he=new J(Z);let $e=0;for(;!he.eol();)$e++,he.nextGraphemeLength();return $e}e.$Ze=V;let Q;function x(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ce(Z){return Q||(Q=x()),Q.test(Z)}e.$1e=ce;const Y=/^[\t\n\r\x20-\x7E]*$/;function R(Z){return Y.test(Z)}e.$2e=R,e.$3e=/[\u2028\u2029]/;function j(Z){return e.$3e.test(Z)}e.$4e=j;function W(Z){return Z>=11904&&Z<=55215||Z>=63744&&Z<=64255||Z>=65281&&Z<=65374}e.$5e=W;function T(Z){return Z>=127462&&Z<=127487||Z===8986||Z===8987||Z===9200||Z===9203||Z>=9728&&Z<=10175||Z===11088||Z===11093||Z>=127744&&Z<=128591||Z>=128640&&Z<=128764||Z>=128992&&Z<=129008||Z>=129280&&Z<=129535||Z>=129648&&Z<=129782}e.$6e=T;function H(Z,he){if(Z.length<he)return Z;const $e=/\b/g;let ye=0;for(;$e.test(Z)&&!(Z.length-$e.lastIndex<he);)ye=$e.lastIndex,$e.lastIndex+=1;return Z.substring(ye).replace(/^\s/,"")}e.$7e=H;const B=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ne=/\x1b\].*?\x07/g;function fe(Z){return Z&&(Z=Z.replace(B,"").replace(ne,"")),Z}e.$8e=fe,e.$9e=String.fromCharCode(65279);function ge(Z){return!!(Z&&Z.length>0&&Z.charCodeAt(0)===65279)}e.$0e=ge;function ue(Z){return ge(Z)?Z.substr(1):Z}e.$$e=ue;function we(Z,he){if(!Z||!he||Z.length<he.length)return!1;const $e=he.length,ye=Z.toLowerCase();let Ae=0,Fe=-1;for(;Ae<$e;){const Le=ye.indexOf(he[Ae],Fe+1);if(Le<0)return!1;Fe=Le,Ae++}return!0}e.$_e=we;function me(Z,he=!1){return Z?(he&&(Z=Z.replace(/\\./g,"")),Z.toLowerCase()!==Z):!1}e.$af=me;function Se(Z){return Z.charAt(0).toUpperCase()+Z.slice(1)}e.$bf=Se;function Ie(Z,he=1){if(he===0)return"";let $e=-1;do $e=Z.indexOf(`
`,$e+1),he--;while(he>0&&$e>=0);return $e===-1?Z:(Z[$e-1]==="\r"&&$e--,Z.substr(0,$e))}e.$cf=Ie;function je(Z){return Z=Z%(2*26),Z<26?String.fromCharCode(97+Z):String.fromCharCode(65+Z-26)}e.$df=je;function ve(Z){return le.getInstance().getGraphemeBreakType(Z)}e.$ef=ve;function be(Z,he){return Z===0?he!==5&&he!==7:Z===2&&he===3?!1:Z===4||Z===2||Z===3||he===4||he===2||he===3?!0:!(Z===8&&(he===8||he===9||he===11||he===12)||(Z===11||Z===9)&&(he===9||he===10)||(Z===12||Z===10)&&he===10||he===5||he===13||he===7||Z===1||Z===13&&he===14||Z===6&&he===6)}var X;(function(Z){Z[Z.Other=0]="Other",Z[Z.Prepend=1]="Prepend",Z[Z.CR=2]="CR",Z[Z.LF=3]="LF",Z[Z.Control=4]="Control",Z[Z.Extend=5]="Extend",Z[Z.Regional_Indicator=6]="Regional_Indicator",Z[Z.SpacingMark=7]="SpacingMark",Z[Z.L=8]="L",Z[Z.V=9]="V",Z[Z.T=10]="T",Z[Z.LV=11]="LV",Z[Z.LVT=12]="LVT",Z[Z.ZWJ=13]="ZWJ",Z[Z.Extended_Pictographic=14]="Extended_Pictographic"})(X||(e.GraphemeBreakType=X={}));class le{static{this.c=null}static getInstance(){return le.c||(le.c=new le),le.c}constructor(){this.d=de()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const $e=this.d,ye=$e.length/3;let Ae=1;for(;Ae<=ye;)if(he<$e[3*Ae])Ae=2*Ae;else if(he>$e[3*Ae+1])Ae=2*Ae+1;else return $e[3*Ae+2];return 0}}function de(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ee(Z,he){if(Z===0)return 0;const $e=Re(Z,he);if($e!==void 0)return $e;const ye=new G(he,Z);return ye.prevCodePoint(),ye.offset}e.$ff=Ee;function Re(Z,he){const $e=new G(he,Z);let ye=$e.prevCodePoint();for(;Ue(ye)||ye===65039||ye===8419;){if($e.offset===0)return;ye=$e.prevCodePoint()}if(!T(ye))return;let Ae=$e.offset;return Ae>0&&$e.prevCodePoint()===8205&&(Ae=$e.offset),Ae}function Ue(Z){return 127995<=Z&&Z<=127999}var Oe;(function(Z){Z[Z.zwj=8205]="zwj",Z[Z.emojiVariantSelector=65039]="emojiVariantSelector",Z[Z.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),e.$gf="\xA0";class Be{static{this.c=new O.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$ie(he=>{function $e(He){const xe=new Map;for(let Qe=0;Qe<He.length;Qe+=2)xe.set(He[Qe],He[Qe+1]);return xe}function ye(He,xe){const Qe=new Map(He);for(const[tt,nt]of xe)Qe.set(tt,nt);return Qe}function Ae(He,xe){if(!He)return xe;const Qe=new Map;for(const[tt,nt]of He)xe.has(tt)&&Qe.set(tt,nt);return Qe}const Fe=this.c.value;let Le=he.filter(He=>!He.startsWith("_")&&He in Fe);Le.length===0&&(Le=["_default"]);let Ne;for(const He of Le){const xe=$e(Fe[He]);Ne=Ae(Ne,xe)}const ze=$e(Fe._common),qe=ye(ze,Ne);return new Be(qe)})}static getInstance(he){return Be.d.get(Array.from(he))}static{this.e=new O.$T(()=>Object.keys(Be.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return Be.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$hf=Be;class We{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(We.c())),this.d}static isInvisibleCharacter(he){return We.e().has(he)}static get codePoints(){return We.e()}}e.$if=We}),define(te[56],ie([0,1,26]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=void 0;function O(g){return s(g,0)}e.$pi=O;function s(g,r){switch(typeof g){case"object":return g===null?M(349,r):Array.isArray(g)?h(g,r):c(g,r);case"string":return S(g,r);case"boolean":return D(g,r);case"number":return M(g,r);case"undefined":return M(937,r);default:return M(617,r)}}e.$qi=s;function M(g,r){return(r<<5)-r+g|0}e.$ri=M;function D(g,r){return M(g?433:863,r)}function S(g,r){r=M(149417,r);for(let $=0,E=g.length;$<E;$++)r=M(g.charCodeAt($),r);return r}e.$si=S;function h(g,r){return r=M(104579,r),g.reduce(($,E)=>s(E,$),r)}function c(g,r){return r=M(181387,r),Object.keys(g).sort().reduce(($,E)=>($=S(E,$),s(g[E],$)),r)}class m{constructor(){this.g=0}get value(){return this.g}hash(r){return this.g=s(r,this.g),this.g}}e.$ti=m;var w;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function y(g,r,$=32){const E=$-r,u=~((1<<E)-1);return(g<<r|(u&g)>>>E)>>>0}function f(g,r=0,$=g.byteLength,E=0){for(let u=0;u<$;u++)g[r+u]=E}function v(g,r,$="0"){for(;g.length<r;)g=$+g;return g}function b(g,r=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map($=>$.toString(16).padStart(2,"0")).join(""):v((g>>>0).toString(16),r/4)}e.$ui=b;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(r){const $=r.length;if($===0)return;const E=this.p;let u=this.r,t=this.u,l,o;for(t!==0?(l=t,o=-1,t=0):(l=r.charCodeAt(0),o=0);;){let i=l;if(P.$Qe(l))if(o+1<$){const n=r.charCodeAt(o+1);P.$Re(n)?(o++,i=P.$Se(l,n)):i=65533}else{t=l;break}else P.$Re(l)&&(i=65533);if(u=this.w(E,u,i),o++,o<$)l=r.charCodeAt(o);else break}this.r=u,this.u=t}w(r,$,E){return E<128?r[$++]=E:E<2048?(r[$++]=192|(E&1984)>>>6,r[$++]=128|(E&63)>>>0):E<65536?(r[$++]=224|(E&61440)>>>12,r[$++]=128|(E&4032)>>>6,r[$++]=128|(E&63)>>>0):(r[$++]=240|(E&1835008)>>>18,r[$++]=128|(E&258048)>>>12,r[$++]=128|(E&4032)>>>6,r[$++]=128|(E&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,r[0]=r[64+0],r[1]=r[64+1],r[2]=r[64+2]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const r=8*this.t;this.q.setUint32(56,Math.floor(r/4294967296),!1),this.q.setUint32(60,r%4294967296,!1),this.y()}y(){const r=d.g,$=this.q;for(let k=0;k<64;k+=4)r.setUint32(k,$.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)r.setUint32(k,y(r.getUint32(k-12,!1)^r.getUint32(k-32,!1)^r.getUint32(k-56,!1)^r.getUint32(k-64,!1),1),!1);let E=this.h,u=this.l,t=this.m,l=this.n,o=this.o,i,n,a;for(let k=0;k<80;k++)k<20?(i=u&t|~u&l,n=1518500249):k<40?(i=u^t^l,n=1859775393):k<60?(i=u&t|u&l|t&l,n=2400959708):(i=u^t^l,n=3395469782),a=y(E,5)+i+o+n+r.getUint32(k*4,!1)&4294967295,o=l,l=t,t=y(u,30),u=E,E=a;this.h=this.h+E&4294967295,this.l=this.l+u&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+o&4294967295}}e.$vi=d}),define(te[70],ie([0,1,26]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(O||(O={})),function(s){const M="error",D="warning",S="warn",h="info",c="ignore";function m(y){return y?P.$Me(M,y)?s.Error:P.$Me(D,y)||P.$Me(S,y)?s.Warning:P.$Me(h,y)?s.Info:s.Ignore:s.Ignore}s.fromValue=m;function w(y){switch(y){case s.Error:return M;case s.Warning:return D;case s.Info:return h;default:return c}}s.toString=w}(O||(O={})),e.default=O}),define(te[141],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=void 0,e.$cd=Symbol("MicrotaskDelay")}),define(te[57],ie([0,1,23,26]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;class s{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const v=f.charCodeAt(0),b=this.b.charCodeAt(this.c);return v-b}value(){return this.b[this.c]}}e.$Dh=s;class M{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,O.$Ge)(f,this.b,0,f.length,this.c,this.d):(0,O.$Ie)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Eh=M;class D{constructor(f=!0,v=!0){this.f=f,this.g=v}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let v=f.length-1;v>=0;v--,this.c--){const b=this.b.charCodeAt(v);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,O.$Ge)(f,this.b,0,f.length,this.d,this.e):(0,O.$Ie)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Fh=D;var S;(function(y){y[y.Scheme=1]="Scheme",y[y.Authority=2]="Authority",y[y.Path=3]="Path",y[y.Query=4]="Query",y[y.Fragment=5]="Fragment"})(S||(S={}));class h{constructor(f,v){this.f=f,this.g=v,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,O.$He)(f,this.c.scheme);if(this.d[this.e]===2)return(0,O.$He)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,O.$Fe)(f,this.c.query);if(this.d[this.e]===5)return(0,O.$Fe)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Gh=h;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(y){y[y.Left=-1]="Left",y[y.Mid=0]="Mid",y[y.Right=1]="Right"})(m||(m={}));class w{static forUris(f=()=>!1,v=()=>!1){return new w(new h(f,v))}static forPaths(f=!1){return new w(new D(void 0,!f))}static forStrings(){return new w(new s)}static forConfigKeys(){return new w(new M)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,v){if(v){const b=v.slice(0);(0,P.$Vb)(b);for(const d of b)this.set(d,f)}else{const b=f.slice(0);(0,P.$Vb)(b);for(const d of b)this.set(d[0],d[1])}}set(f,v){const b=this.b.reset(f);let d;this.c||(this.c=new c,this.c.segment=b.value());const g=[];for(d=this.c;;){const $=b.cmp(d.segment);if($>0)d.left||(d.left=new c,d.left.segment=b.value()),g.push([-1,d]),d=d.left;else if($<0)d.right||(d.right=new c,d.right.segment=b.value()),g.push([1,d]),d=d.right;else if(b.hasNext())b.next(),d.mid||(d.mid=new c,d.mid.segment=b.value()),g.push([0,d]),d=d.mid;else break}const r=d.value;d.value=v,d.key=f;for(let $=g.length-1;$>=0;$--){const E=g[$][1];E.updateHeight();const u=E.balanceFactor();if(u<-1||u>1){const t=g[$][0],l=g[$+1][0];if(t===1&&l===1)g[$][1]=E.rotateLeft();else if(t===-1&&l===-1)g[$][1]=E.rotateRight();else if(t===1&&l===-1)E.right=g[$+1][1]=g[$+1][1].rotateRight(),g[$][1]=E.rotateLeft();else if(t===-1&&l===1)E.left=g[$+1][1]=g[$+1][1].rotateLeft(),g[$][1]=E.rotateRight();else throw new Error;if($>0)switch(g[$-1][0]){case-1:g[$-1][1].left=g[$][1];break;case 1:g[$-1][1].right=g[$][1];break;case 0:g[$-1][1].mid=g[$][1];break}else this.c=g[0][1]}}return r}get(f){return this.d(f)?.value}d(f){const v=this.b.reset(f);let b=this.c;for(;b;){const d=v.cmp(b.segment);if(d>0)b=b.left;else if(d<0)b=b.right;else if(v.hasNext())v.next(),b=b.mid;else break}return b}has(f){const v=this.d(f);return!(v?.value===void 0&&v?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,v){const b=this.b.reset(f),d=[];let g=this.c;for(;g;){const r=b.cmp(g.segment);if(r>0)d.push([-1,g]),g=g.left;else if(r<0)d.push([1,g]),g=g.right;else if(b.hasNext())b.next(),d.push([0,g]),g=g.mid;else break}if(g){if(v?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const r=this.f(g.right);if(r.key){const{key:$,value:E,segment:u}=r;this.e(r.key,!1),g.key=$,g.value=E,g.segment=u}}else{const r=g.left??g.right;if(d.length>0){const[$,E]=d[d.length-1];switch($){case-1:E.left=r;break;case 0:E.mid=r;break;case 1:E.right=r;break}}else this.c=r}for(let r=d.length-1;r>=0;r--){const $=d[r][1];$.updateHeight();const E=$.balanceFactor();if(E>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),d[r][1]=$.rotateLeft()):E<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),d[r][1]=$.rotateRight()),r>0)switch(d[r-1][0]){case-1:d[r-1][1].left=d[r][1];break;case 1:d[r-1][1].right=d[r][1];break;case 0:d[r-1][1].mid=d[r][1];break}else this.c=d[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const v=this.b.reset(f);let b=this.c,d;for(;b;){const g=v.cmp(b.segment);if(g>0)b=b.left;else if(g<0)b=b.right;else if(v.hasNext())v.next(),d=b.value||d,b=b.mid;else break}return b&&b.value||d}findSuperstr(f){return this.g(f,!1)}g(f,v){const b=this.b.reset(f);let d=this.c;for(;d;){const g=b.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(b.hasNext())b.next(),d=d.mid;else return d.mid?this.h(d.mid):v?d.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[v,b]of this)f(b,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const v=[];return this.j(f,v),v[Symbol.iterator]()}j(f,v){f&&(f.left&&this.j(f.left,v),f.value&&v.push([f.key,f.value]),f.mid&&this.j(f.mid,v),f.right&&this.j(f.right,v))}_isBalanced(){const f=v=>{if(!v)return!0;const b=v.balanceFactor();return b<-1||b>1?!1:f(v.left)&&f(v.right)};return f(this.c)}}e.$Hh=w}),define(te[12],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=void 0;function P(u){return typeof u=="string"}e.$jf=P;function O(u){return Array.isArray(u)&&u.every(t=>P(t))}e.$kf=O;function s(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.$lf=s;function M(u){const t=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof t}e.$mf=M;function D(u){return typeof u=="number"&&!isNaN(u)}e.$nf=D;function S(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.$of=S;function h(u){return u===!0||u===!1}e.$pf=h;function c(u){return typeof u>"u"}e.$qf=c;function m(u){return!w(u)}e.$rf=m;function w(u){return c(u)||u===null}e.$sf=w;function y(u,t){if(!u)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$tf=y;function f(u){if(w(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.$uf=f;function v(...u){const t=[];for(let l=0;l<u.length;l++){const o=u[l];if(w(o))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);t.push(o)}return t}e.$vf=v;const b=Object.prototype.hasOwnProperty;function d(u){if(!s(u))return!1;for(const t in u)if(b.call(u,t))return!1;return!0}e.$wf=d;function g(u){return typeof u=="function"}e.$xf=g;function r(...u){return u.length>0&&u.every(g)}e.$yf=r;function $(u,t){const l=Math.min(u.length,t.length);for(let o=0;o<l;o++)E(u[o],t[o])}e.$zf=$;function E(u,t){if(P(t)){if(typeof u!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(g(t)){try{if(u instanceof t)return}catch{}if(!w(u)&&u.constructor===t||t.length===1&&t.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Af=E}),define(te[71],ie([0,1,12]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=void 0;const O=Object.create(null);function s(S,h){if((0,P.$jf)(h)){const c=O[h];if(c===void 0)throw new Error(`${S} references an unknown codicon: ${h}`);h=c}return O[S]=h,{id:S}}function M(){return O}e.$Nj=M;function D(){return Object.values(e.$Pj)}e.$Oj=D,e.$Pj={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,12]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function O(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const r=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([$,E])=>{r[$]=E&&typeof E=="object"?O(E):E}),r}e.$Vm=O;function s(g){if(!g||typeof g!="object")return g;const r=[g];for(;r.length>0;){const $=r.shift();Object.freeze($);for(const E in $)if(M.call($,E)){const u=$[E];typeof u=="object"&&!Object.isFrozen(u)&&!(0,P.$mf)(u)&&r.push(u)}}return g}e.$Wm=s;const M=Object.prototype.hasOwnProperty;function D(g,r){return S(g,r,new Set)}e.$Xm=D;function S(g,r,$){if((0,P.$sf)(g))return g;const E=r(g);if(typeof E<"u")return E;if(Array.isArray(g)){const u=[];for(const t of g)u.push(S(t,r,$));return u}if((0,P.$lf)(g)){if($.has(g))throw new Error("Cannot clone recursive data-structure");$.add(g);const u={};for(const t in g)M.call(g,t)&&(u[t]=S(g[t],r,$));return $.delete(g),u}return g}function h(g,r,$=!0){return(0,P.$lf)(g)?((0,P.$lf)(r)&&Object.keys(r).forEach(E=>{E in g?$&&((0,P.$lf)(g[E])&&(0,P.$lf)(r[E])?h(g[E],r[E],$):g[E]=r[E]):g[E]=r[E]}),g):r}e.$Ym=h;function c(g,r){if(g===r)return!0;if(g==null||r===null||r===void 0||typeof g!=typeof r||typeof g!="object"||Array.isArray(g)!==Array.isArray(r))return!1;let $,E;if(Array.isArray(g)){if(g.length!==r.length)return!1;for($=0;$<g.length;$++)if(!c(g[$],r[$]))return!1}else{const u=[];for(E in g)u.push(E);u.sort();const t=[];for(E in r)t.push(E);if(t.sort(),!c(u,t))return!1;for($=0;$<u.length;$++)if(!c(g[u[$]],r[u[$]]))return!1}return!0}e.$Zm=c;function m(g){const r=new Set;return JSON.stringify(g,($,E)=>{if((0,P.$lf)(E)||Array.isArray(E)){if(r.has(E))return"[Circular]";r.add(E)}return E})}e.$1m=m;function w(g,r){const $=Object.create(null);return!g||!r||Object.keys(r).forEach(u=>{const t=g[u],l=r[u];c(t,l)||($[u]=l)}),$}e.$2m=w;function y(g,r){const $=r.toLowerCase(),E=Object.keys(g).find(u=>u.toLowerCase()===$);return E?g[E]:g[r]}e.$3m=y;function f(g,r){const $=Object.create(null);for(const[E,u]of Object.entries(g))r(E,u)&&($[E]=u);return $}e.$4m=f;function v(g){let r=[];for(;Object.prototype!==g;)r=r.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return r}e.$5m=v;function b(g){const r=[];for(const $ of v(g))typeof g[$]=="function"&&r.push($);return r}e.$6m=b;function d(g,r){const $=u=>function(){const t=Array.prototype.slice.call(arguments,0);return r(u,t)},E={};for(const u of g)E[u]=$(u);return E}e.$7m=d}),define(te[102],ie([0,1,71]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Qj=e.ThemeColor=void 0;var O;(function(D){function S(h){return h&&typeof h=="object"&&typeof h.id=="string"}D.isThemeColor=S})(O||(e.ThemeColor=O={}));function s(D){return{id:D}}e.$Qj=s;var M;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function h(r){const $=S.exec(r.id);if(!$)return h(P.$Pj.error);const[,E,u]=$,t=["codicon","codicon-"+E];return u&&t.push("codicon-modifier-"+u.substring(1)),t}D.asClassNameArray=h;function c(r){return h(r).join(" ")}D.asClassName=c;function m(r){return"."+h(r).join(".")}D.asCSSSelector=m;function w(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color>"u"||O.isThemeColor(r.color))}D.isThemeIcon=w;const y=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function f(r){const $=y.exec(r);if(!$)return;const[,E]=$;return{id:E}}D.fromString=f;function v(r){return{id:r}}D.fromId=v;function b(r,$){let E=r.id;const u=E.lastIndexOf("~");return u!==-1&&(E=E.substring(0,u)),$&&(E=`${E}~${$}`),{id:E}}D.modify=b;function d(r){const $=r.id.lastIndexOf("~");if($!==-1)return r.id.substring($+1)}D.getModifier=d;function g(r,$){return r.id===$.id&&r.color?.id===$.color?.id}D.isEqual=g})(M||(e.ThemeIcon=M={}))}),define(te[31],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4f=e.$3f=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(s){return P.test(s)}e.$3f=O,e.$4f=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let h=0;h<S.length;h++)S[h]=Math.floor(Math.random()*256);return S};const M=new Uint8Array(16),D=[];for(let S=0;S<256;S++)D.push(S.toString(16).padStart(2,"0"));return function(){s(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let h=0,c="";return c+=D[M[h++]],c+=D[M[h++]],c+=D[M[h++]],c+=D[M[h++]],c+="-",c+=D[M[h++]],c+=D[M[h++]],c+="-",c+=D[M[h++]],c+=D[M[h++]],c+="-",c+=D[M[h++]],c+=D[M[h++]],c+="-",c+=D[M[h++]],c+=D[M[h++]],c+=D[M[h++]],c+=D[M[h++]],c+=D[M[h++]],c+=D[M[h++]],c}}()}),define(te[142],ie([0,1,72,45,49]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PS=void 0;async function M(D,S){if(await new Promise((m,w)=>{const y=O.createReadStream(D),f=P.createHash("sha1");y.pipe(f);const v=(0,s.$bb)((b,d)=>{y.removeAllListeners(),f.removeAllListeners(),b?w(b):m(d)});y.once("error",v),y.once("end",v),f.once("error",v),f.once("data",b=>v(void 0,b.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$PS=M}),define(te[143],ie([0,1,27]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=void 0;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const S=D.replace(/\-/g,":").toLowerCase();return!O.has(S)}function M(){const D=(0,P.networkInterfaces)();for(const S in D){const h=D[S];if(h){for(const{mac:c}of h)if(s(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$Gm=M}),define(te[86],ie([0,1,27,57,31,143]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=e.$Hm=void 0,e.$Hm=new class{c(c){return this.a||(this.a=O.$Hh.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(c)}value(){if(this.b===void 0){let c=0,m=0;const w=(0,P.networkInterfaces)();for(const y in w){const f=w[y];if(f)for(const{mac:v,internal:b}of f)b||(m+=1,this.c(v.toUpperCase())&&(c+=1))}this.b=m>0?c/m:0}return this.b}};let D;async function S(c){return D||(D=(async()=>await h(c)||s.$4f())()),D}e.$Im=S;async function h(c){try{const m=await new Promise((y,f)=>{K(["crypto"],y,f)}),w=(0,M.$Gm)();return m.createHash("sha256").update(w,"utf8").digest("hex")}catch(m){c(m);return}}}),define(te[103],ie([0,1,87]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=void 0;function O(S,h,c,m=1){let w=!1;return new Promise(y=>{const f=setTimeout(()=>{if(!w)return w=!0,y(0)},c);s(S,h,m,v=>{if(!w)return w=!0,clearTimeout(f),y(v)})})}e.$6f=O;function s(S,h,c,m){if(h===0)return m(0);const w=new P.Socket;w.once("connect",()=>(D(w),s(S+c,h-1,c,m))),w.once("data",()=>{}),w.once("error",y=>(D(w),y.code!=="ECONNREFUSED"?s(S+c,h-1,c,m):m(S))),w.connect(S,"127.0.0.1")}e.$7f={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(S,h,c,m="127.0.0.1"){let w=!1,y,f=1;const v=P.createServer({pauseOnConnect:!0});function b(d,g){w||(w=!0,v.removeAllListeners(),v.close(),y&&clearTimeout(y),g(d))}return new Promise(d=>{y=setTimeout(()=>{b(0,d)},c),v.on("listening",()=>{b(S,d)}),v.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&f<h?(S++,f++,v.listen(S,m)):b(0,d)}),v.on("close",()=>{b(0,d)}),v.listen(S,m)})}e.$8f=M;function D(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(h){console.error(h)}}}),function(){function K(){function e(){return process.uncHostAllowlist}function P(h){const c=new Set;if(Array.isArray(h))for(const m of h)typeof m=="string"&&c.add(m);return Array.from(c)}function O(){const h=e();return h?Array.from(h):[]}function s(h){if(process.platform!=="win32")return;const c=e();if(c)if(typeof h=="string")c.add(h.toLowerCase());else for(const m of P(h))s(m)}function M(h){if(typeof h!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let m;for(const w of c){if(h.indexOf(w)!==0)continue;const f=h.indexOf("\\",w.length);if(f===-1)continue;const v=h.substring(w.length,f);if(v){m=v;break}}return m}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:O,addUNCHostToAllowlist:s,getUNCHost:M,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[144],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TS=e.$SS=void 0,e.$SS="vscode:contextmenu",e.$TS="vscode:onCloseContextMenu"}),define(te[145],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1S=void 0;class P{constructor(s,M){this.a=s,this.onMessage=M}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$1S=P}),define(te[38],ie([0,1,15,14]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$US=void 0;class s{constructor(){this.a=new WeakMap}on(D,S){const h=(c,...m)=>{this.b(D,c)&&S(c,...m)};return this.a.set(S,h),P.ipcMain.on(D,h),this}once(D,S){return P.ipcMain.once(D,(h,...c)=>{this.b(D,h)&&S(h,...c)}),this}handle(D,S){return P.ipcMain.handle(D,(h,...c)=>this.b(D,h)?S(h,...c):Promise.reject(`Invalid channel '${D}' or sender for ipcMain.handle() usage.`)),this}removeHandler(D){return P.ipcMain.removeHandler(D),this}removeListener(D,S){const h=this.a.get(S);return h&&(P.ipcMain.removeListener(D,h),this.a.delete(S)),this}b(D,S){if(!D||!D.startsWith("vscode:"))return(0,O.$Y)(`Refused to handle ipcMain event for channel '${D}' because the channel is unknown.`),!1;const h=S.senderFrame,c=h.url;if(!c||c==="about:blank")return!0;let m="unknown";try{m=new URL(c).host}catch{return(0,O.$Y)(`Refused to handle ipcMain event for channel '${D}' because of a malformed URL '${c}'.`),!1}return m!=="vscode-app"?((0,O.$Y)(`Refused to handle ipcMain event for channel '${D}' because of a bad origin of '${m}'.`),!1):h.parent!==null?((0,O.$Y)(`Refused to handle ipcMain event for channel '${D}' because sender of origin '${m}' is not a main frame.`),!1):!0}}e.$US=new s}),define(te[146],ie([0,1,15,38,144]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VS=void 0;function M(){O.$US.on(s.$SS,(S,h,c,m,w)=>{const y=D(S,m,c);y.popup({window:P.BrowserWindow.fromWebContents(S.sender)??void 0,x:w?w.x:void 0,y:w?w.y:void 0,positioningItem:w?w.positioningItem:void 0,callback:()=>{y&&S.sender.send(s.$TS,h)}})})}e.$VS=M;function D(S,h,c){const m=new P.Menu;return c.forEach(w=>{let y;w.type==="separator"?y=new P.MenuItem({type:w.type}):Array.isArray(w.submenu)?y=new P.MenuItem({submenu:D(S,h,w.submenu),label:w.label}):y=new P.MenuItem({label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:w.enabled,visible:w.visible,click:(f,v,b)=>S.sender.send(h,w.id,b)}),m.append(y)}),m}}),define(te[147],ie([11,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(te[148],ie([0,1,147]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=void 0;const O=60,s=O*60,M=s*24,D=M*7,S=M*30,h=M*365;function c(w,y,f,v){typeof w!="number"&&(w=w.getTime());const b=Math.round((new Date().getTime()-w)/1e3);if(b<-30)return(0,P.localize)(0,null,c(new Date().getTime()+b*1e3,!1));if(!v&&b<30)return(0,P.localize)(1,null);let d;return b<O?(d=b,y?d===1?f?(0,P.localize)(2,null,d):(0,P.localize)(3,null,d):f?(0,P.localize)(4,null,d):(0,P.localize)(5,null,d):d===1?f?(0,P.localize)(6,null,d):(0,P.localize)(7,null,d):f?(0,P.localize)(8,null,d):(0,P.localize)(9,null,d)):b<s?(d=Math.floor(b/O),y?d===1?f?(0,P.localize)(10,null,d):(0,P.localize)(11,null,d):f?(0,P.localize)(12,null,d):(0,P.localize)(13,null,d):d===1?f?(0,P.localize)(14,null,d):(0,P.localize)(15,null,d):f?(0,P.localize)(16,null,d):(0,P.localize)(17,null,d)):b<M?(d=Math.floor(b/s),y?d===1?f?(0,P.localize)(18,null,d):(0,P.localize)(19,null,d):f?(0,P.localize)(20,null,d):(0,P.localize)(21,null,d):d===1?f?(0,P.localize)(22,null,d):(0,P.localize)(23,null,d):f?(0,P.localize)(24,null,d):(0,P.localize)(25,null,d)):b<D?(d=Math.floor(b/M),y?d===1?(0,P.localize)(26,null,d):(0,P.localize)(27,null,d):d===1?(0,P.localize)(28,null,d):(0,P.localize)(29,null,d)):b<S?(d=Math.floor(b/D),y?d===1?f?(0,P.localize)(30,null,d):(0,P.localize)(31,null,d):f?(0,P.localize)(32,null,d):(0,P.localize)(33,null,d):d===1?f?(0,P.localize)(34,null,d):(0,P.localize)(35,null,d):f?(0,P.localize)(36,null,d):(0,P.localize)(37,null,d)):b<h?(d=Math.floor(b/S),y?d===1?f?(0,P.localize)(38,null,d):(0,P.localize)(39,null,d):f?(0,P.localize)(40,null,d):(0,P.localize)(41,null,d):d===1?f?(0,P.localize)(42,null,d):(0,P.localize)(43,null,d):f?(0,P.localize)(44,null,d):(0,P.localize)(45,null,d)):(d=Math.floor(b/h),y?d===1?f?(0,P.localize)(46,null,d):(0,P.localize)(47,null,d):f?(0,P.localize)(48,null,d):(0,P.localize)(49,null,d):d===1?f?(0,P.localize)(50,null,d):(0,P.localize)(51,null,d):f?(0,P.localize)(52,null,d):(0,P.localize)(53,null,d))}e.$6l=c;function m(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$7l=m}),define(te[149],ie([11,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(te[50],ie([0,1,23,12,149]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=void 0;function M(w,y){return y&&(w.stack||w.stacktrace)?s.localize(0,null,S(w),D(w.stack)||D(w.stacktrace)):S(w)}function D(w){return Array.isArray(w)?w.join(`
`):w}function S(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?s.localize(1,null,w.message):w.message||s.localize(2,null)}function h(w=null,y=!1){if(!w)return s.localize(3,null);if(Array.isArray(w)){const f=P.$Fb(w),v=h(f[0],y);return f.length>1?s.localize(4,null,v,f.length):v}if(O.$jf(w))return w;if(w.detail){const f=w.detail;if(f.error)return M(f.error,y);if(f.exception)return M(f.exception,y)}return w.stack?M(w,y):w.message?w.message:s.localize(5,null)}e.$mi=h;function c(w){const y=w;return y instanceof Error&&Array.isArray(y.actions)}e.$ni=c;function m(w,y){let f;return typeof w=="string"?f=new Error(w):f=w,f.actions=y,f}e.$oi=m}),define(te[150],ie([11,10]),function(K,e){return K.create("vs/base/common/jsonErrorMessages",e)}),define(te[151],ie([0,1,150]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=void 0;function O(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.$mp=O}),define(te[152],ie([11,10]),function(K,e){return K.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,152]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let O=!1,s=!1,M=!1,D=!1,S=!1,h=!1,c=!1,m=!1,w=!1,y=!1,f,v=e.$f,b=e.$f,d,g;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let r;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?r=e.$g.vscode.process:typeof process<"u"&&(r=process);const $=typeof r?.versions?.electron=="string",E=$&&r?.type==="renderer";if(typeof navigator=="object"&&!E)g=navigator.userAgent,O=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,m=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=g.indexOf("Linux")>=0,y=g?.indexOf("Mobi")>=0,h=!0,f=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$f,v=f,b=navigator.language;else if(typeof r=="object"){O=r.platform==="win32",s=r.platform==="darwin",M=r.platform==="linux",D=M&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,c=$,w=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$f,v=e.$f;const I=r.env.VSCODE_NLS_CONFIG;if(I)try{const C=JSON.parse(I),p=C.availableLanguages["*"];f=C.locale,b=C.osLocale,v=p||e.$f,d=C._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var u;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(u||(e.Platform=u={}));function t(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let l=0;s?l=1:O?l=3:M&&(l=2),e.$i=O,e.$j=s,e.$k=M,e.$l=D,e.$m=S,e.$n=c,e.$o=h,e.$p=h&&typeof e.$g.importScripts=="function",e.$q=m,e.$r=y,e.$s=w,e.$t=l,e.$u=g,e.$v=v;var o;(function(I){function C(){return e.$v}I.value=C;function p(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}I.isDefaultVariant=p;function A(){return e.$v==="en"}I.isDefault=A})(o||(e.Language=o={})),e.$w=f,e.$x=b,e.$y=d,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const I=[];e.$g.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let A=0,L=I.length;A<L;A++){const U=I[A];if(U.id===p.data.vscodeScheduleAsyncWork){I.splice(A,1),U.callback();return}}});let C=0;return p=>{const A=++C;I.push({id:A,callback:p}),e.$g.postMessage({vscodeScheduleAsyncWork:A},"*")}}return I=>setTimeout(I)})();var i;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=s||m?2:O?1:3;let n=!0,a=!1;function k(){if(!a){a=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,n=new Uint16Array(I.buffer)[0]===(2<<8)+1}return n}e.$C=k,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(te[35],ie([0,1,4]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4d=e.$3d=e.env=e.cwd=void 0;let O;if(typeof P.$g.vscode<"u"&&typeof P.$g.vscode.process<"u"){const s=P.$g.vscode.process;O={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?O={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:O={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=O.cwd,e.env=O.env,e.$3d=O.platform,e.$4d=O.arch}),define(te[9],ie([0,1,35]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=e.sep=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=void 0;const O=65,s=97,M=90,D=122,S=46,h=47,c=92,m=58,w=63;class y extends Error{constructor(l,o,i){let n;typeof o=="string"&&o.indexOf("not ")===0?(n="must not be",o=o.replace(/^not /,"")):n="must be";const a=l.indexOf(".")!==-1?"property":"argument";let k=`The "${l}" ${a} ${n} of type ${o}`;k+=`. Received type ${typeof i}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function f(t,l){if(t===null||typeof t!="object")throw new y(l,"Object",t)}function v(t,l){if(typeof t!="string")throw new y(l,"string",t)}const b=P.$3d==="win32";function d(t){return t===h||t===c}function g(t){return t===h}function r(t){return t>=O&&t<=M||t>=s&&t<=D}function $(t,l,o,i){let n="",a=0,k=-1,I=0,C=0;for(let p=0;p<=t.length;++p){if(p<t.length)C=t.charCodeAt(p);else{if(i(C))break;C=h}if(i(C)){if(!(k===p-1||I===1))if(I===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const A=n.lastIndexOf(o);A===-1?(n="",a=0):(n=n.slice(0,A),a=n.length-1-n.lastIndexOf(o)),k=p,I=0;continue}else if(n.length!==0){n="",a=0,k=p,I=0;continue}}l&&(n+=n.length>0?`${o}..`:"..",a=2)}else n.length>0?n+=`${o}${t.slice(k+1,p)}`:n=t.slice(k+1,p),a=p-k-1;k=p,I=0}else C===S&&I!==-1?++I:I=-1}return n}function E(t,l){f(l,"pathObject");const o=l.dir||l.root,i=l.base||`${l.name||""}${l.ext||""}`;return o?o===l.root?`${o}${i}`:`${o}${t}${i}`:i}e.$5d={resolve(...t){let l="",o="",i=!1;for(let n=t.length-1;n>=-1;n--){let a;if(n>=0){if(a=t[n],v(a,"path"),a.length===0)continue}else l.length===0?a=P.cwd():(a=P.env[`=${l}`]||P.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==l.toLowerCase()&&a.charCodeAt(2)===c)&&(a=`${l}\\`));const k=a.length;let I=0,C="",p=!1;const A=a.charCodeAt(0);if(k===1)d(A)&&(I=1,p=!0);else if(d(A))if(p=!0,d(a.charCodeAt(1))){let L=2,U=L;for(;L<k&&!d(a.charCodeAt(L));)L++;if(L<k&&L!==U){const z=a.slice(U,L);for(U=L;L<k&&d(a.charCodeAt(L));)L++;if(L<k&&L!==U){for(U=L;L<k&&!d(a.charCodeAt(L));)L++;(L===k||L!==U)&&(C=`\\\\${z}\\${a.slice(U,L)}`,I=L)}}}else I=1;else r(A)&&a.charCodeAt(1)===m&&(C=a.slice(0,2),I=2,k>2&&d(a.charCodeAt(2))&&(p=!0,I=3));if(C.length>0)if(l.length>0){if(C.toLowerCase()!==l.toLowerCase())continue}else l=C;if(i){if(l.length>0)break}else if(o=`${a.slice(I)}\\${o}`,i=p,p&&l.length>0)break}return o=$(o,!i,"\\",d),i?`${l}\\${o}`:`${l}${o}`||"."},normalize(t){v(t,"path");const l=t.length;if(l===0)return".";let o=0,i,n=!1;const a=t.charCodeAt(0);if(l===1)return g(a)?"\\":t;if(d(a))if(n=!0,d(t.charCodeAt(1))){let I=2,C=I;for(;I<l&&!d(t.charCodeAt(I));)I++;if(I<l&&I!==C){const p=t.slice(C,I);for(C=I;I<l&&d(t.charCodeAt(I));)I++;if(I<l&&I!==C){for(C=I;I<l&&!d(t.charCodeAt(I));)I++;if(I===l)return`\\\\${p}\\${t.slice(C)}\\`;I!==C&&(i=`\\\\${p}\\${t.slice(C,I)}`,o=I)}}}else o=1;else r(a)&&t.charCodeAt(1)===m&&(i=t.slice(0,2),o=2,l>2&&d(t.charCodeAt(2))&&(n=!0,o=3));let k=o<l?$(t.slice(o),!n,"\\",d):"";return k.length===0&&!n&&(k="."),k.length>0&&d(t.charCodeAt(l-1))&&(k+="\\"),i===void 0?n?`\\${k}`:k:n?`${i}\\${k}`:`${i}${k}`},isAbsolute(t){v(t,"path");const l=t.length;if(l===0)return!1;const o=t.charCodeAt(0);return d(o)||l>2&&r(o)&&t.charCodeAt(1)===m&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,o;for(let a=0;a<t.length;++a){const k=t[a];v(k,"path"),k.length>0&&(l===void 0?l=o=k:l+=`\\${k}`)}if(l===void 0)return".";let i=!0,n=0;if(typeof o=="string"&&d(o.charCodeAt(0))){++n;const a=o.length;a>1&&d(o.charCodeAt(1))&&(++n,a>2&&(d(o.charCodeAt(2))?++n:i=!1))}if(i){for(;n<l.length&&d(l.charCodeAt(n));)n++;n>=2&&(l=`\\${l.slice(n)}`)}return e.$5d.normalize(l)},relative(t,l){if(v(t,"from"),v(l,"to"),t===l)return"";const o=e.$5d.resolve(t),i=e.$5d.resolve(l);if(o===i||(t=o.toLowerCase(),l=i.toLowerCase(),t===l))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===c;)n++;let a=t.length;for(;a-1>n&&t.charCodeAt(a-1)===c;)a--;const k=a-n;let I=0;for(;I<l.length&&l.charCodeAt(I)===c;)I++;let C=l.length;for(;C-1>I&&l.charCodeAt(C-1)===c;)C--;const p=C-I,A=k<p?k:p;let L=-1,U=0;for(;U<A;U++){const re=t.charCodeAt(n+U);if(re!==l.charCodeAt(I+U))break;re===c&&(L=U)}if(U!==A){if(L===-1)return i}else{if(p>A){if(l.charCodeAt(I+U)===c)return i.slice(I+U+1);if(U===2)return i.slice(I+U)}k>A&&(t.charCodeAt(n+U)===c?L=U:U===2&&(L=3)),L===-1&&(L=0)}let z="";for(U=n+L+1;U<=a;++U)(U===a||t.charCodeAt(U)===c)&&(z+=z.length===0?"..":"\\..");return I+=L,z.length>0?`${z}${i.slice(I,C)}`:(i.charCodeAt(I)===c&&++I,i.slice(I,C))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.$5d.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===c){if(l.charCodeAt(1)===c){const o=l.charCodeAt(2);if(o!==w&&o!==S)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(r(l.charCodeAt(0))&&l.charCodeAt(1)===m&&l.charCodeAt(2)===c)return`\\\\?\\${l}`;return t},dirname(t){v(t,"path");const l=t.length;if(l===0)return".";let o=-1,i=0;const n=t.charCodeAt(0);if(l===1)return d(n)?t:".";if(d(n)){if(o=i=1,d(t.charCodeAt(1))){let I=2,C=I;for(;I<l&&!d(t.charCodeAt(I));)I++;if(I<l&&I!==C){for(C=I;I<l&&d(t.charCodeAt(I));)I++;if(I<l&&I!==C){for(C=I;I<l&&!d(t.charCodeAt(I));)I++;if(I===l)return t;I!==C&&(o=i=I+1)}}}}else r(n)&&t.charCodeAt(1)===m&&(o=l>2&&d(t.charCodeAt(2))?3:2,i=o);let a=-1,k=!0;for(let I=l-1;I>=i;--I)if(d(t.charCodeAt(I))){if(!k){a=I;break}}else k=!1;if(a===-1){if(o===-1)return".";a=o}return t.slice(0,a)},basename(t,l){l!==void 0&&v(l,"ext"),v(t,"path");let o=0,i=-1,n=!0,a;if(t.length>=2&&r(t.charCodeAt(0))&&t.charCodeAt(1)===m&&(o=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let k=l.length-1,I=-1;for(a=t.length-1;a>=o;--a){const C=t.charCodeAt(a);if(d(C)){if(!n){o=a+1;break}}else I===-1&&(n=!1,I=a+1),k>=0&&(C===l.charCodeAt(k)?--k===-1&&(i=a):(k=-1,i=I))}return o===i?i=I:i===-1&&(i=t.length),t.slice(o,i)}for(a=t.length-1;a>=o;--a)if(d(t.charCodeAt(a))){if(!n){o=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(o,i)},extname(t){v(t,"path");let l=0,o=-1,i=0,n=-1,a=!0,k=0;t.length>=2&&t.charCodeAt(1)===m&&r(t.charCodeAt(0))&&(l=i=2);for(let I=t.length-1;I>=l;--I){const C=t.charCodeAt(I);if(d(C)){if(!a){i=I+1;break}continue}n===-1&&(a=!1,n=I+1),C===S?o===-1?o=I:k!==1&&(k=1):o!==-1&&(k=-1)}return o===-1||n===-1||k===0||k===1&&o===n-1&&o===i+1?"":t.slice(o,n)},format:E.bind(null,"\\"),parse(t){v(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const o=t.length;let i=0,n=t.charCodeAt(0);if(o===1)return d(n)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(d(n)){if(i=1,d(t.charCodeAt(1))){let L=2,U=L;for(;L<o&&!d(t.charCodeAt(L));)L++;if(L<o&&L!==U){for(U=L;L<o&&d(t.charCodeAt(L));)L++;if(L<o&&L!==U){for(U=L;L<o&&!d(t.charCodeAt(L));)L++;L===o?i=L:L!==U&&(i=L+1)}}}}else if(r(n)&&t.charCodeAt(1)===m){if(o<=2)return l.root=l.dir=t,l;if(i=2,d(t.charCodeAt(2))){if(o===3)return l.root=l.dir=t,l;i=3}}i>0&&(l.root=t.slice(0,i));let a=-1,k=i,I=-1,C=!0,p=t.length-1,A=0;for(;p>=i;--p){if(n=t.charCodeAt(p),d(n)){if(!C){k=p+1;break}continue}I===-1&&(C=!1,I=p+1),n===S?a===-1?a=p:A!==1&&(A=1):a!==-1&&(A=-1)}return I!==-1&&(a===-1||A===0||A===1&&a===I-1&&a===k+1?l.base=l.name=t.slice(k,I):(l.name=t.slice(k,a),l.base=t.slice(k,I),l.ext=t.slice(a,I))),k>0&&k!==i?l.dir=t.slice(0,k-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(b){const t=/\\/g;return()=>{const l=P.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>P.cwd()})();e.$6d={resolve(...t){let l="",o=!1;for(let i=t.length-1;i>=-1&&!o;i--){const n=i>=0?t[i]:u();v(n,"path"),n.length!==0&&(l=`${n}/${l}`,o=n.charCodeAt(0)===h)}return l=$(l,!o,"/",g),o?`/${l}`:l.length>0?l:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===h,o=t.charCodeAt(t.length-1)===h;return t=$(t,!l,"/",g),t.length===0?l?"/":o?"./":".":(o&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let l;for(let o=0;o<t.length;++o){const i=t[o];v(i,"path"),i.length>0&&(l===void 0?l=i:l+=`/${i}`)}return l===void 0?".":e.$6d.normalize(l)},relative(t,l){if(v(t,"from"),v(l,"to"),t===l||(t=e.$6d.resolve(t),l=e.$6d.resolve(l),t===l))return"";const o=1,i=t.length,n=i-o,a=1,k=l.length-a,I=n<k?n:k;let C=-1,p=0;for(;p<I;p++){const L=t.charCodeAt(o+p);if(L!==l.charCodeAt(a+p))break;L===h&&(C=p)}if(p===I)if(k>I){if(l.charCodeAt(a+p)===h)return l.slice(a+p+1);if(p===0)return l.slice(a+p)}else n>I&&(t.charCodeAt(o+p)===h?C=p:p===0&&(C=0));let A="";for(p=o+C+1;p<=i;++p)(p===i||t.charCodeAt(p)===h)&&(A+=A.length===0?"..":"/..");return`${A}${l.slice(a+C)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===h;let o=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===h){if(!i){o=n;break}}else i=!1;return o===-1?l?"/":".":l&&o===1?"//":t.slice(0,o)},basename(t,l){l!==void 0&&v(l,"ext"),v(t,"path");let o=0,i=-1,n=!0,a;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let k=l.length-1,I=-1;for(a=t.length-1;a>=0;--a){const C=t.charCodeAt(a);if(C===h){if(!n){o=a+1;break}}else I===-1&&(n=!1,I=a+1),k>=0&&(C===l.charCodeAt(k)?--k===-1&&(i=a):(k=-1,i=I))}return o===i?i=I:i===-1&&(i=t.length),t.slice(o,i)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===h){if(!n){o=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(o,i)},extname(t){v(t,"path");let l=-1,o=0,i=-1,n=!0,a=0;for(let k=t.length-1;k>=0;--k){const I=t.charCodeAt(k);if(I===h){if(!n){o=k+1;break}continue}i===-1&&(n=!1,i=k+1),I===S?l===-1?l=k:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||i===-1||a===0||a===1&&l===i-1&&l===o+1?"":t.slice(l,i)},format:E.bind(null,"/"),parse(t){v(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const o=t.charCodeAt(0)===h;let i;o?(l.root="/",i=1):i=0;let n=-1,a=0,k=-1,I=!0,C=t.length-1,p=0;for(;C>=i;--C){const A=t.charCodeAt(C);if(A===h){if(!I){a=C+1;break}continue}k===-1&&(I=!1,k=C+1),A===S?n===-1?n=C:p!==1&&(p=1):n!==-1&&(p=-1)}if(k!==-1){const A=a===0&&o?1:a;n===-1||p===0||p===1&&n===k-1&&n===a+1?l.base=l.name=t.slice(A,k):(l.name=t.slice(A,n),l.base=t.slice(A,k),l.ext=t.slice(n,k))}return a>0?l.dir=t.slice(0,a-1):o&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.$6d.win32=e.$5d.win32=e.$5d,e.$6d.posix=e.$5d.posix=e.$6d,e.$7d=b?e.$5d.normalize:e.$6d.normalize,e.$8d=b?e.$5d.isAbsolute:e.$6d.isAbsolute,e.$9d=b?e.$5d.join:e.$6d.join,e.$0d=b?e.$5d.resolve:e.$6d.resolve,e.$$d=b?e.$5d.relative:e.$6d.relative,e.$_d=b?e.$5d.dirname:e.$6d.dirname,e.$ae=b?e.$5d.basename:e.$6d.basename,e.$be=b?e.$5d.extname:e.$6d.extname,e.$ce=b?e.$5d.format:e.$6d.format,e.$de=b?e.$5d.parse:e.$6d.parse,e.$ee=b?e.$5d.toNamespacedPath:e.$6d.toNamespacedPath,e.sep=b?e.$5d.sep:e.$6d.sep,e.$ge=b?e.$5d.delimiter:e.$6d.delimiter}),define(te[32],ie([0,1,9,4,26,12]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=void 0;function D(a){return a===47||a===92}e.$Bf=D;function S(a){return a.replace(/[\\/]/g,P.$6d.sep)}e.$Cf=S;function h(a){return a.indexOf("/")===-1&&(a=S(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Df=h;function c(a,k=P.$6d.sep){if(!a)return"";const I=a.length,C=a.charCodeAt(0);if(D(C)){if(D(a.charCodeAt(1))&&!D(a.charCodeAt(2))){let A=3;const L=A;for(;A<I&&!D(a.charCodeAt(A));A++);if(L!==A&&!D(a.charCodeAt(A+1))){for(A+=1;A<I;A++)if(D(a.charCodeAt(A)))return a.slice(0,A+1).replace(/[\\/]/g,k)}}return k}else if(g(C)&&a.charCodeAt(1)===58)return D(a.charCodeAt(2))?a.slice(0,2)+k:a.slice(0,2);let p=a.indexOf("://");if(p!==-1){for(p+=3;p<I;p++)if(D(a.charCodeAt(p)))return a.slice(0,p+1)}return""}e.$Ef=c;function m(a){if(!O.$i||!a||a.length<5)return!1;let k=a.charCodeAt(0);if(k!==92||(k=a.charCodeAt(1),k!==92))return!1;let I=2;const C=I;for(;I<a.length&&(k=a.charCodeAt(I),k!==92);I++);return!(C===I||(k=a.charCodeAt(I+1),isNaN(k)||k===92))}e.$Ff=m;const w=/[\\/:\*\?"<>\|]/g,y=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(a,k=O.$i){const I=k?w:y;return!(!a||a.length===0||/^\s+$/.test(a)||(I.lastIndex=0,I.test(a))||k&&f.test(a)||a==="."||a===".."||k&&a[a.length-1]==="."||k&&a.length!==a.trim().length||a.length>255)}e.$Gf=v;function b(a,k,I){const C=a===k;return!I||C?C:!a||!k?!1:(0,s.$Me)(a,k)}e.$Hf=b;function d(a,k,I,C=P.sep){if(a===k)return!0;if(!a||!k||k.length>a.length)return!1;if(I){if(!(0,s.$Ne)(a,k))return!1;if(k.length===a.length)return!0;let A=k.length;return k.charAt(k.length-1)===C&&A--,a.charAt(A)===C}return k.charAt(k.length-1)!==C&&(k+=C),a.indexOf(k)===0}e.$If=d;function g(a){return a>=65&&a<=90||a>=97&&a<=122}e.$Jf=g;function r(a,k){return O.$i&&a.endsWith(":")&&(a+=P.sep),(0,P.$8d)(a)||(a=(0,P.$9d)(k,a)),a=(0,P.$7d)(a),O.$i?(a=(0,s.$ve)(a,P.sep),a.endsWith(":")&&(a+=P.sep)):(a=(0,s.$ve)(a,P.sep),a||(a=P.sep)),a}e.$Kf=r;function $(a){const k=(0,P.$7d)(a);return O.$i?a.length>3?!1:E(k)&&(a.length===2||k.charCodeAt(2)===92):k===P.$6d.sep}e.$Lf=$;function E(a,k=O.$i){return k?g(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$Mf=E;function u(a,k=O.$i){return E(a,k)?a[0]:void 0}e.$Nf=u;function t(a,k,I){return k.length>a.length?-1:a===k?0:(I&&(a=a.toLowerCase(),k=k.toLowerCase()),a.indexOf(k))}e.$Of=t;function l(a){const k=a.split(":");let I,C,p;for(const A of k){const L=Number(A);(0,M.$nf)(L)?C===void 0?C=L:p===void 0&&(p=L):I=I?[I,A].join(":"):A}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:C!==void 0?C:void 0,column:p!==void 0?p:C!==void 0?1:void 0}}e.$Pf=l;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(a,k,I=8){let C="";for(let A=0;A<I;A++){let L;A===0&&O.$i&&!k&&(I===3||I===4)?L=i:L=o,C+=L.charAt(Math.floor(Math.random()*L.length))}let p;return k?p=`${k}-${C}`:p=C,a?(0,P.$9d)(a,p):p}e.$Qf=n}),define(te[73],ie([0,1,4]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.TerminateResponseCode=e.Source=void 0;var O;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(O||(e.Source=O={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function M(S,...h){const c=h.reduce((y,f)=>(y[f]=!0,y),{}),m=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(y=>!c[y]).forEach(y=>{for(let f=0;f<m.length;f++)if(y.search(m[f])!==-1){delete S[y];break}})}e.$sl=M;function D(S){S&&(delete S.DEBUG,P.$j&&delete S.DYLD_LIBRARY_PATH,P.$k&&delete S.LD_PRELOAD)}e.$tl=D}),define(te[7],ie([0,1,9,4]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,M=/^\//,D=/^\/\//;function S(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!M.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,n){return!i&&!n?"file":i}function c(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==w&&(n=w+n):n=w;break}return n}const m="",w="/",y=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,a,k,I,C,p=!1){typeof n=="object"?(this.scheme=n.scheme||m,this.authority=n.authority||m,this.path=n.path||m,this.query=n.query||m,this.fragment=n.fragment||m):(this.scheme=h(n,p),this.authority=a||m,this.path=c(this.scheme,k||m),this.query=I||m,this.fragment=C||m,S(this,p))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:k,path:I,query:C,fragment:p}=n;return a===void 0?a=this.scheme:a===null&&(a=m),k===void 0?k=this.authority:k===null&&(k=m),I===void 0?I=this.path:I===null&&(I=m),C===void 0?C=this.query:C===null&&(C=m),p===void 0?p=this.fragment:p===null&&(p=m),a===this.scheme&&k===this.authority&&I===this.path&&C===this.query&&p===this.fragment?this:new d(a,k,I,C,p)}static parse(n,a=!1){const k=y.exec(n);return k?new d(k[2]||m,o(k[4]||m),o(k[5]||m),o(k[7]||m),o(k[9]||m),a):new d(m,m,m,m,m)}static file(n){let a=m;if(O.$i&&(n=n.replace(/\\/g,w)),n[0]===w&&n[1]===w){const k=n.indexOf(w,2);k===-1?(a=n.substring(2),n=w):(a=n.substring(2,k),n=n.substring(k)||w)}return new d("file",a,n,m,m)}static from(n,a){return new d(n.scheme,n.authority,n.path,n.query,n.fragment,a)}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return O.$i&&n.scheme==="file"?k=f.file(P.$5d.join(E(n,!0),...a)).path:k=P.$6d.join(n.path,...a),n.with({path:k})}toString(n=!1){return u(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const a=new d(n);return a._formatted=n.external??null,a._fsPath=n._sep===b?n.fsPath??null:null,a}}else return n}}e.URI=f;function v(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$Sf=v;const b=O.$i?1:void 0;class d extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=b),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function r(i,n,a){let k,I=-1;for(let C=0;C<i.length;C++){const p=i.charCodeAt(C);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||n&&p===47||a&&p===91||a&&p===93||a&&p===58)I!==-1&&(k+=encodeURIComponent(i.substring(I,C)),I=-1),k!==void 0&&(k+=i.charAt(C));else{k===void 0&&(k=i.substr(0,C));const A=g[p];A!==void 0?(I!==-1&&(k+=encodeURIComponent(i.substring(I,C)),I=-1),k+=A):I===-1&&(I=C)}}return I!==-1&&(k+=encodeURIComponent(i.substring(I))),k!==void 0?k:i}function $(i){let n;for(let a=0;a<i.length;a++){const k=i.charCodeAt(a);k===35||k===63?(n===void 0&&(n=i.substr(0,a)),n+=g[k]):n!==void 0&&(n+=i[a])}return n!==void 0?n:i}function E(i,n){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,O.$i&&(a=a.replace(/\//g,"\\")),a}e.$Tf=E;function u(i,n){const a=n?$:r;let k="",{scheme:I,authority:C,path:p,query:A,fragment:L}=i;if(I&&(k+=I,k+=":"),(C||I==="file")&&(k+=w,k+=w),C){let U=C.indexOf("@");if(U!==-1){const z=C.substr(0,U);C=C.substr(U+1),U=z.lastIndexOf(":"),U===-1?k+=a(z,!1,!1):(k+=a(z.substr(0,U),!1,!1),k+=":",k+=a(z.substr(U+1),!1,!0)),k+="@"}C=C.toLowerCase(),U=C.lastIndexOf(":"),U===-1?k+=a(C,!1,!0):(k+=a(C.substr(0,U),!1,!0),k+=C.substr(U))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const U=p.charCodeAt(1);U>=65&&U<=90&&(p=`/${String.fromCharCode(U+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const U=p.charCodeAt(0);U>=65&&U<=90&&(p=`${String.fromCharCode(U+32)}:${p.substr(2)}`)}k+=a(p,!0,!1)}return A&&(k+="?",k+=a(A,!1,!1)),L&&(k+="#",k+=n?L:r(L,!1,!1)),k}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(i){return i.match(l)?i.replace(l,n=>t(n)):i}}),define(te[153],ie([0,1,7]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Pp=e.$Op=e.$Np=void 0;function O(c){const m=c;return m&&typeof m.type=="string"&&typeof m.severity=="string"}e.$Np=O;function s(c){const m=[];let w;try{const y=JSON.parse(c.arguments),f=y[y.length-1];f&&f.__$stack&&(y.pop(),w=f.__$stack),m.push(...y)}catch{m.push("Unable to log remote console arguments",c.arguments)}return{args:m,stack:w}}e.$Op=s;function M(c){if(typeof c!="string")return M(s(c).stack);const m=c;if(m){const w=D(m),y=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(y&&y.length===4)return{uri:P.URI.file(y[1]),line:Number(y[2]),column:Number(y[3])}}}e.$Pp=M;function D(c){if(!c)return c;const m=c.indexOf(`
`);return m===-1?c:c.substring(0,m)}function S(c,m){const{args:w,stack:y}=s(c),f=typeof w[0]=="string"&&w.length===1;let v=D(y);v&&(v=`(${v.trim()})`);let b=[];if(typeof w[0]=="string"?v&&f?b=[`%c[${m}] %c${w[0]} %c${v}`,h("blue"),h(""),h("grey")]:b=[`%c[${m}] %c${w[0]}`,h("blue"),h(""),...w.slice(1)]:b=[`%c[${m}]%`,h("blue"),...w],v&&!f&&b.push(v),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,b)}e.log=S;function h(c){return`color: ${c}`}}),define(te[74],ie([0,1,17,7]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$g=e.$0g=e.$9g=void 0;function s(h){return JSON.stringify(h,D)}e.$9g=s;function M(h){let c=JSON.parse(h);return c=S(c),c}e.$0g=M;function D(h,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function S(h,c=0){if(!h||c>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return O.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof P.$Fd||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let m=0;m<h.length;++m)h[m]=S(h[m],c+1);else for(const m in h)Object.hasOwnProperty.call(h,m)&&(h[m]=S(h[m],c+1))}return h}e.$$g=S}),define(te[13],ie([0,1,14,4,7]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.Schemas=void 0;var M;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$Uf="vscode-tkn",e.$Vf="tkn";class D{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(m){this.d=m}setDelegate(m){this.e=m}setServerRootPath(m){this.f=`${m}/${M.vscodeRemoteResource}`}set(m,w,y){this.a[m]=w,this.b[m]=y}setConnectionToken(m,w){this.c[m]=w}getPreferredWebSchema(){return this.d}rewrite(m){if(this.e)try{return this.e(m)}catch(d){return P.$Y(d),m}const w=m.authority;let y=this.a[w];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const f=this.b[w],v=this.c[w];let b=`path=${encodeURIComponent(m.path)}`;return typeof v=="string"&&(b+=`&${e.$Vf}=${encodeURIComponent(v)}`),s.URI.from({scheme:O.$o?this.d:M.vscodeRemoteResource,authority:`${y}:${f}`,path:this.f,query:b})}}e.$Wf=new D,e.$Xf="vs/../../extensions",e.$Yf="vs/../../node_modules",e.$Zf="vs/../../node_modules.asar",e.$1f="vs/../../node_modules.asar.unpacked";class S{static{this.a="vscode-app"}asBrowserUri(m){const w=this.b(m,K);return this.uriToBrowserUri(w)}uriToBrowserUri(m){return m.scheme===M.vscodeRemote?e.$Wf.rewrite(m):m.scheme===M.file&&(O.$m||O.$p&&O.$g.origin===`${M.vscodeFileResource}://${S.a}`)?m.with({scheme:M.vscodeFileResource,authority:m.authority||S.a,query:null,fragment:null}):m}asFileUri(m){const w=this.b(m,K);return this.uriToFileUri(w)}uriToFileUri(m){return m.scheme===M.vscodeFileResource?m.with({scheme:M.file,authority:m.authority!==S.a?m.authority:null,query:null,fragment:null}):m}b(m,w){return s.URI.isUri(m)?m:s.URI.parse(w.toUrl(m))}}e.$2f=new S;var h;(function(c){const m=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(m.get("3"));const w="vscode-coi";function y(v){let b;typeof v=="string"?b=new URL(v).searchParams:v instanceof URL?b=v.searchParams:s.URI.isUri(v)&&(b=new URL(v.toString(!0)).searchParams);const d=b?.get(w);if(d)return m.get(d)}c.getHeadersFromQuery=y;function f(v,b,d){if(!globalThis.crossOriginIsolated)return;const g=b&&d?"3":d?"2":"1";v instanceof URLSearchParams?v.set(w,g):v[w]=g}c.addSearchParam=f})(h||(e.COI=h={}))}),define(te[19],ie([0,1,32,13,9,4,26,7]),function(K,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=e.DataUri=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=void 0;function h(f){return(0,S.$Tf)(f,!0)}e.$9f=h;class c{constructor(v){this.a=v}compare(v,b,d=!1){return v===b?0:(0,D.$Fe)(this.getComparisonKey(v,d),this.getComparisonKey(b,d))}isEqual(v,b,d=!1){return v===b?!0:!v||!b?!1:this.getComparisonKey(v,d)===this.getComparisonKey(b,d)}getComparisonKey(v,b=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,b,d=!1){if(v.scheme===b.scheme){if(v.scheme===O.Schemas.file)return P.$If(h(v),h(b),this.a(v))&&v.query===b.query&&(d||v.fragment===b.fragment);if((0,e.$ng)(v.authority,b.authority))return P.$If(v.path,b.path,this.a(v),"/")&&v.query===b.query&&(d||v.fragment===b.fragment)}return!1}joinPath(v,...b){return S.URI.joinPath(v,...b)}basenameOrAuthority(v){return(0,e.$fg)(v)||v.authority}basename(v){return s.$6d.basename(v.path)}extname(v){return s.$6d.extname(v.path)}dirname(v){if(v.path.length===0)return v;let b;return v.scheme===O.Schemas.file?b=S.URI.file(s.$_d(h(v))).path:(b=s.$6d.dirname(v.path),v.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),b="/")),v.with({path:b})}normalizePath(v){if(!v.path.length)return v;let b;return v.scheme===O.Schemas.file?b=S.URI.file(s.$7d(h(v))).path:b=s.$6d.normalize(v.path),v.with({path:b})}relativePath(v,b){if(v.scheme!==b.scheme||!(0,e.$ng)(v.authority,b.authority))return;if(v.scheme===O.Schemas.file){const r=s.$$d(h(v),h(b));return M.$i?P.$Cf(r):r}let d=v.path||"/";const g=b.path||"/";if(this.a(v)){let r=0;for(const $=Math.min(d.length,g.length);r<$&&!(d.charCodeAt(r)!==g.charCodeAt(r)&&d.charAt(r).toLowerCase()!==g.charAt(r).toLowerCase());r++);d=g.substr(0,r)+d.substr(r)}return s.$6d.relative(d,g)}resolvePath(v,b){if(v.scheme===O.Schemas.file){const d=S.URI.file(s.$0d(h(v),b));return v.with({authority:d.authority,path:d.path})}return b=P.$Df(b),v.with({path:s.$6d.resolve(v.path,b)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,b){return v===b||v!==void 0&&b!==void 0&&(0,D.$Me)(v,b)}hasTrailingPathSeparator(v,b=s.sep){if(v.scheme===O.Schemas.file){const d=h(v);return d.length>P.$Ef(d).length&&d[d.length-1]===b}else{const d=v.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,b=s.sep){return(0,e.$og)(v,b)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,b=s.sep){let d=!1;if(v.scheme===O.Schemas.file){const g=h(v);d=g!==void 0&&g.length===P.$Ef(g).length&&g[g.length-1]===b}else{b="/";const g=v.path;d=g.length===1&&g.charCodeAt(g.length-1)===47}return!d&&!(0,e.$og)(v,b)?v.with({path:v.path+"/"}):v}}e.$0f=c,e.$$f=new c(()=>!1),e.$_f=new c(f=>f.scheme===O.Schemas.file?!M.$k:!0),e.$ag=new c(f=>!0),e.$bg=e.$$f.isEqual.bind(e.$$f),e.$cg=e.$$f.isEqualOrParent.bind(e.$$f),e.$dg=e.$$f.getComparisonKey.bind(e.$$f),e.$eg=e.$$f.basenameOrAuthority.bind(e.$$f),e.$fg=e.$$f.basename.bind(e.$$f),e.$gg=e.$$f.extname.bind(e.$$f),e.$hg=e.$$f.dirname.bind(e.$$f),e.$ig=e.$$f.joinPath.bind(e.$$f),e.$jg=e.$$f.normalizePath.bind(e.$$f),e.$kg=e.$$f.relativePath.bind(e.$$f),e.$lg=e.$$f.resolvePath.bind(e.$$f),e.$mg=e.$$f.isAbsolutePath.bind(e.$$f),e.$ng=e.$$f.isEqualAuthority.bind(e.$$f),e.$og=e.$$f.hasTrailingPathSeparator.bind(e.$$f),e.$pg=e.$$f.removeTrailingPathSeparator.bind(e.$$f),e.$qg=e.$$f.addTrailingPathSeparator.bind(e.$$f);function m(f,v){const b=[];for(let d=0;d<f.length;d++){const g=v(f[d]);f.some((r,$)=>$===d?!1:(0,e.$cg)(g,v(r)))||b.push(f[d])}return b}e.$rg=m;var w;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function v(b){const d=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach($=>{const[E,u]=$.split(":");E&&u&&d.set(E,u)});const r=b.path.substring(0,b.path.indexOf(";"));return r&&d.set(f.META_DATA_MIME,r),d}f.parseMetaData=v})(w||(e.DataUri=w={}));function y(f,v,b){if(v){let d=f.path;return d&&d[0]!==s.$6d.sep&&(d=s.$6d.sep+d),f.with({scheme:b,authority:v,path:d})}return f.with({scheme:b})}e.$sg=y}),define(te[8],ie([0,1,22,14,3,2,19,4,141]),function(K,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5g=e.$4g=e.$3g=e.Promises=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=void 0;function c(R){return!!R&&typeof R.then=="function"}e.$tg=c;function m(R){const j=new P.$pd,W=R(j.token),T=new Promise((H,B)=>{const ne=j.token.onCancellationRequested(()=>{ne.dispose(),j.dispose(),B(new O.$3)});Promise.resolve(W).then(fe=>{ne.dispose(),j.dispose(),H(fe)},fe=>{ne.dispose(),j.dispose(),B(fe)})});return new class{cancel(){j.cancel()}then(H,B){return T.then(H,B)}catch(H){return this.then(void 0,H)}finally(H){return T.finally(H)}}}e.$ug=m;function w(R,j,W){return new Promise((T,H)=>{const B=j.onCancellationRequested(()=>{B.dispose(),T(W)});R.then(T,H).finally(()=>B.dispose())})}e.$vg=w;function y(R,j){return new Promise((W,T)=>{const H=j.onCancellationRequested(()=>{H.dispose(),T(new O.$3)});R.then(W,T).finally(()=>H.dispose())})}e.$wg=y;async function f(R){let j=-1;const W=R.map((T,H)=>T.then(B=>(j=H,B)));try{return await Promise.race(W)}finally{R.forEach((T,H)=>{H!==j&&T.cancel()})}}e.$xg=f;function v(R,j,W){let T;const H=setTimeout(()=>{T?.(void 0),W?.()},j);return Promise.race([R.finally(()=>clearTimeout(H)),new Promise(B=>T=B)])}e.$yg=v;function b(R){return new Promise((j,W)=>{const T=R();c(T)?T.then(j,W):j(T)})}e.$zg=b;class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(j){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=j,!this.b){const W=()=>{if(this.b=null,this.f)return;const T=this.queue(this.d);return this.d=null,T};this.b=new Promise(T=>{this.a.then(W,W).then(T)})}return new Promise((W,T)=>{this.b.then(W,T)})}return this.a=j(),new Promise((W,T)=>{this.a.then(H=>{this.a=null,W(H)},H=>{this.a=null,T(H)})})}dispose(){this.f=!0}}e.$Ag=d;class g{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.$Bg=g;class r{constructor(){this.a=new Map}queue(j,W){const H=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.a.get(j)===H&&this.a.delete(j)});return this.a.set(j,H),H}}e.$Cg=r;const $=(R,j)=>{let W=!0;const T=setTimeout(()=>{W=!1,j()},R);return{isTriggered:()=>W,dispose:()=>{clearTimeout(T),W=!1}}},E=R=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,R())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class u{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,W=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((H,B)=>{this.d=H,this.f=B}).then(()=>{if(this.b=null,this.d=null,this.g){const H=this.g;return this.g=null,H()}}));const T=()=>{this.a=null,this.d?.(null)};return this.a=W===h.$cd?E(T):$(W,T),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new O.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Dg=u;class t{constructor(j){this.a=new u(j),this.b=new d}trigger(j,W){return this.a.trigger(()=>this.b.queue(j),W)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Eg=t;class l{constructor(){this.a=!1,this.b=new Promise((j,W)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Fg=l;class o extends l{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.$Gg=o;function i(R,j){return j?new Promise((W,T)=>{const H=setTimeout(()=>{B.dispose(),W()},R),B=j.onCancellationRequested(()=>{clearTimeout(H),B.dispose(),T(new O.$3)})}):m(W=>i(R,W))}e.$Hg=i;function n(R,j=0,W){const T=setTimeout(()=>{R(),W&&H.dispose()},j),H=(0,M.$ic)(()=>{clearTimeout(T),W?.deleteAndLeak(H)});return W?.add(H),H}e.$Ig=n;function a(R){const j=[];let W=0;const T=R.length;function H(){return W<T?R[W++]():null}function B(ne){ne!=null&&j.push(ne);const fe=H();return fe?fe.then(B):Promise.resolve(j)}return Promise.resolve(null).then(B)}e.$Jg=a;function k(R,j=T=>!!T,W=null){let T=0;const H=R.length,B=()=>{if(T>=H)return Promise.resolve(W);const ne=R[T++];return Promise.resolve(ne()).then(ge=>j(ge)?Promise.resolve(ge):B())};return B()}e.$Kg=k;function I(R,j=T=>!!T,W=null){if(R.length===0)return Promise.resolve(W);let T=R.length;const H=()=>{T=-1;for(const B of R)B.cancel?.()};return new Promise((B,ne)=>{for(const fe of R)fe.then(ge=>{--T>=0&&j(ge)?(H(),B(ge)):T===0&&B(W)}).catch(ge=>{--T>=0&&(H(),ne(ge))})})}e.$Lg=I;class C{constructor(j){this.a=0,this.d=j,this.f=[],this.b=0,this.g=new s.$fd}get onDrained(){return this.g.event}get size(){return this.a}queue(j){return this.a++,new Promise((W,T)=>{this.f.push({factory:j,c:W,e:T}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const j=this.f.shift();this.b++;const W=j.factory();W.then(j.c,j.e),W.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$Mg=C;class p extends C{constructor(){super(1)}}e.$Ng=p;class A{constructor(){this.a=new J,this.b=0}queue(j){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,j())):this.a.run(this.b++,j())}}e.$Og=A;class L{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const j=new N;return this.b.add(j),j.p}g(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueFor(j,W=D.$$f){const T=W.getComparisonKey(j);let H=this.a.get(T);if(!H){H=new p;const B=this.f++,ne=s.Event.once(H.onDrained)(()=>{H?.dispose(),this.a.delete(T),this.h(),this.d?.deleteAndDispose(B),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$sc),this.d.set(B,ne),this.a.set(T,H)}return H}h(){this.g()&&this.j()}j(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Pg=L;class U{constructor(j,W){this.a=-1,typeof j=="function"&&typeof W=="number"&&this.setIfNotSet(j,W)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,W){this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},W)}setIfNotSet(j,W){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},W))}}e.$Qg=U;class z{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(j,W){this.cancel(),this.a=setInterval(()=>{j()},W)}}e.$Rg=z;class re{constructor(j,W){this.b=-1,this.a=j,this.d=W,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Sg=re;class ee{constructor(j,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.a=j,this.b=W,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Tg=ee;class ae extends re{constructor(j,W){super(j,W),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.$Ug=ae;class se extends M.$kc{constructor(j,W){super(),this.g=j,this.h=W,this.a=[],this.b=this.B(new M.$lc),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const W of j)this.a.push(W);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new re(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Vg=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Wg=R=>{(0,S.$A)(()=>{if(j)return;const W=Date.now()+15;R(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let j=!1;return{dispose(){j||(j=!0)}}}:e.$Wg=(R,j)=>{const W=requestIdleCallback(R,typeof j=="number"?{timeout:j}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(W))}}}}();class oe{constructor(j){this.d=!1,this.a=()=>{try{this.f=j()}catch(W){this.g=W}finally{this.d=!0}},this.b=(0,e.$Wg)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Xg=oe;async function G(R,j,W){let T;for(let H=0;H<W;H++)try{return await R()}catch(B){T=B,await i(j)}throw T}e.$Yg=G;class J{isRunning(j){return typeof j=="number"?this.a?.taskId===j:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(j,W,T){return this.a={taskId:j,cancel:()=>T?.(),promise:W},W.then(()=>this.d(j),()=>this.d(j)),W}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this.b)this.b.run=j;else{let W,T;const H=new Promise((B,ne)=>{W=B,T=ne});this.b={run:j,promise:H,promiseResolve:W,promiseReject:T}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zg=J;class q{constructor(j,W=()=>Date.now()){this.d=j,this.f=W,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.$1g=q;var F;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(F||(F={}));class N{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((j,W)=>{this.a=j,this.b=W})}complete(j){return new Promise(W=>{this.a(j),this.d={outcome:0,value:j},W()})}error(j){return new Promise(W=>{this.b(j),this.d={outcome:1,value:j},W()})}cancel(){return this.error(new O.$3)}}e.$2g=N;var V;(function(R){async function j(T){let H;const B=await Promise.all(T.map(ne=>ne.then(fe=>fe,fe=>{H||(H=fe)})));if(typeof H<"u")throw H;return B}R.settled=j;function W(T){return new Promise(async(H,B)=>{try{await T(H,B)}catch(ne){B(ne)}})}R.withAsyncBody=W})(V||(e.Promises=V={}));var Q;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(Q||(Q={}));class x{static fromArray(j){return new x(W=>{W.emitMany(j)})}static fromPromise(j){return new x(async W=>{W.emitMany(await j)})}static fromPromises(j){return new x(async W=>{await Promise.all(j.map(async T=>W.emitOne(await T)))})}static merge(j){return new x(async W=>{await Promise.all(j.map(async T=>{for await(const H of T)W.emitOne(H)}))})}static{this.EMPTY=x.fromArray([])}constructor(j){this.a=0,this.b=[],this.d=null,this.f=new s.$fd,queueMicrotask(async()=>{const W={emitOne:T=>this.g(T),emitMany:T=>this.h(T),reject:T=>this.k(T)};try{await Promise.resolve(j(W)),this.j()}catch(T){this.k(T)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(j,W){return new x(async T=>{for await(const H of j)T.emitOne(W(H))})}map(j){return x.map(this,j)}static filter(j,W){return new x(async T=>{for await(const H of j)W(H)&&T.emitOne(H)})}filter(j){return x.filter(this,j)}static coalesce(j){return x.filter(j,W=>!!W)}coalesce(){return x.coalesce(this)}static async toPromise(j){const W=[];for await(const T of j)W.push(T);return W}toPromise(){return x.toPromise(this)}g(j){this.a===0&&(this.b.push(j),this.f.fire())}h(j){this.a===0&&(this.b=this.b.concat(j),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(j){this.a===0&&(this.a=2,this.d=j,this.f.fire())}}e.$3g=x;class ce extends x{constructor(j,W){super(W),this.l=j}cancel(){this.l.cancel()}}e.$4g=ce;function Y(R){const j=new P.$pd,W=R(j.token);return new ce(j,async T=>{const H=j.token.onCancellationRequested(()=>{H.dispose(),j.dispose(),T.reject(new O.$3)});try{for await(const B of W){if(j.token.isCancellationRequested)return;T.emitOne(B)}H.dispose(),j.dispose()}catch(B){H.dispose(),j.dispose(),T.reject(B)}})}e.$5g=Y}),define(te[104],ie([0,1,23,8,32,33,9,4,26]),function(K,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=void 0;function c(){return Object.create(null)}e.$mj=c,e.$nj="**",e.$oj="/";const m="[/\\\\]",w="[^/\\\\]",y=/\//g;function f(J,q){switch(J){case 0:return"";case 1:return`${w}*?`;default:return`(?:${m}|${w}+${m}${q?`|${m}${w}+`:""})*?`}}function v(J,q){if(!J)return[];const F=[];let N=!1,V=!1,Q="";for(const x of J){switch(x){case q:if(!N&&!V){F.push(Q),Q="";continue}break;case"{":N=!0;break;case"}":N=!1;break;case"[":V=!0;break;case"]":V=!1;break}Q+=x}return Q&&F.push(Q),F}e.$pj=v;function b(J){if(!J)return"";let q="";const F=v(J,e.$oj);if(F.every(N=>N===e.$nj))q=".*";else{let N=!1;F.forEach((V,Q)=>{if(V===e.$nj){if(N)return;q+=f(2,Q===F.length-1)}else{let x=!1,ce="",Y=!1,R="";for(const j of V){if(j!=="}"&&x){ce+=j;continue}if(Y&&(j!=="]"||!R)){let W;j==="-"?W=j:(j==="^"||j==="!")&&!R?W="^":j===e.$oj?W="":W=(0,h.$qe)(j),R+=W;continue}switch(j){case"{":x=!0;continue;case"[":Y=!0;continue;case"}":{const T=`(?:${v(ce,",").map(H=>b(H)).join("|")})`;q+=T,x=!1,ce="";break}case"]":{q+="["+R+"]",Y=!1,R="";break}case"?":q+=w;continue;case"*":q+=f(1);continue;default:q+=(0,h.$qe)(j)}}Q<F.length-1&&(F[Q+1]!==e.$nj||Q+2<F.length)&&(q+=m)}N=V===e.$nj})}return q}const d=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,r=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,$=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$Ci(1e4),l=function(){return!1},o=function(){return null};function i(J,q){if(!J)return o;let F;typeof J!="string"?F=J.pattern:F=J,F=F.trim();const N=`${F}_${!!q.trimForExclusions}`;let V=t.get(N);if(V)return n(V,J);let Q;return d.test(F)?V=k(F.substr(4),F):(Q=g.exec(a(F,q)))?V=I(Q[1],F):(q.trimForExclusions?$:r).test(F)?V=C(F,q):(Q=E.exec(a(F,q)))?V=p(Q[1].substr(1),F,!0):(Q=u.exec(a(F,q)))?V=p(Q[1],F,!1):V=A(F),t.set(N,V),n(V,J)}function n(J,q){if(typeof q=="string")return J;const F=function(N,V){return(0,s.$If)(N,q.base,!S.$k)?J((0,h.$ue)(N.substr(q.base.length),D.sep),V):null};return F.allBasenames=J.allBasenames,F.allPaths=J.allPaths,F.basenames=J.basenames,F.patterns=J.patterns,F}function a(J,q){return q.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function k(J,q){return function(F,N){return typeof F=="string"&&F.endsWith(J)?q:null}}function I(J,q){const F=`/${J}`,N=`\\${J}`,V=function(x,ce){return typeof x!="string"?null:ce?ce===J?q:null:x===J||x.endsWith(F)||x.endsWith(N)?q:null},Q=[J];return V.basenames=Q,V.patterns=[q],V.allBasenames=Q,V}function C(J,q){const F=oe(J.slice(1,-1).split(",").map(ce=>i(ce,q)).filter(ce=>ce!==o),J),N=F.length;if(!N)return o;if(N===1)return F[0];const V=function(ce,Y){for(let R=0,j=F.length;R<j;R++)if(F[R](ce,Y))return J;return null},Q=F.find(ce=>!!ce.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const x=F.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return x.length&&(V.allPaths=x),V}function p(J,q,F){const N=D.sep===D.$6d.sep,V=N?J:J.replace(y,D.sep),Q=D.sep+V,x=D.$6d.sep+J;let ce;return F?ce=function(Y,R){return typeof Y=="string"&&(Y===V||Y.endsWith(Q)||!N&&(Y===J||Y.endsWith(x)))?q:null}:ce=function(Y,R){return typeof Y=="string"&&(Y===V||!N&&Y===J)?q:null},ce.allPaths=[(F?"*/":"./")+J],ce}function A(J){try{const q=new RegExp(`^${b(J)}$`);return function(F){return q.lastIndex=0,typeof F=="string"&&q.test(F)?J:null}}catch{return o}}function L(J,q,F){return!J||typeof q!="string"?!1:U(J)(q,void 0,F)}e.$qj=L;function U(J,q={}){if(!J)return l;if(typeof J=="string"||z(J)){const F=i(J,q);if(F===o)return l;const N=function(V,Q){return!!F(V,Q)};return F.allBasenames&&(N.allBasenames=F.allBasenames),F.allPaths&&(N.allPaths=F.allPaths),N}return ae(J,q)}e.$rj=U;function z(J){const q=J;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.$sj=z;function re(J){return J.allBasenames||[]}e.$tj=re;function ee(J){return J.allPaths||[]}e.$uj=ee;function ae(J,q){const F=oe(Object.getOwnPropertyNames(J).map(ce=>se(ce,J[ce],q)).filter(ce=>ce!==o)),N=F.length;if(!N)return o;if(!F.some(ce=>!!ce.requiresSiblings)){if(N===1)return F[0];const ce=function(j,W){let T;for(let H=0,B=F.length;H<B;H++){const ne=F[H](j,W);if(typeof ne=="string")return ne;(0,O.$tg)(ne)&&(T||(T=[]),T.push(ne))}return T?(async()=>{for(const H of T){const B=await H;if(typeof B=="string")return B}return null})():null},Y=F.find(j=>!!j.allBasenames);Y&&(ce.allBasenames=Y.allBasenames);const R=F.reduce((j,W)=>W.allPaths?j.concat(W.allPaths):j,[]);return R.length&&(ce.allPaths=R),ce}const V=function(ce,Y,R){let j,W;for(let T=0,H=F.length;T<H;T++){const B=F[T];B.requiresSiblings&&R&&(Y||(Y=(0,D.$ae)(ce)),j||(j=Y.substr(0,Y.length-(0,D.$be)(ce).length)));const ne=B(ce,Y,j,R);if(typeof ne=="string")return ne;(0,O.$tg)(ne)&&(W||(W=[]),W.push(ne))}return W?(async()=>{for(const T of W){const H=await T;if(typeof H=="string")return H}return null})():null},Q=F.find(ce=>!!ce.allBasenames);Q&&(V.allBasenames=Q.allBasenames);const x=F.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return x.length&&(V.allPaths=x),V}function se(J,q,F){if(q===!1)return o;const N=i(J,F);if(N===o)return o;if(typeof q=="boolean")return N;if(q){const V=q.when;if(typeof V=="string"){const Q=(x,ce,Y,R)=>{if(!R||!N(x,ce))return null;const j=V.replace("$(basename)",()=>Y),W=R(j);return(0,O.$tg)(W)?W.then(T=>T?J:null):W?J:null};return Q.requiresSiblings=!0,Q}}return N}function oe(J,q){const F=J.filter(ce=>!!ce.basenames);if(F.length<2)return J;const N=F.reduce((ce,Y)=>{const R=Y.basenames;return R?ce.concat(R):ce},[]);let V;if(q){V=[];for(let ce=0,Y=N.length;ce<Y;ce++)V.push(q)}else V=F.reduce((ce,Y)=>{const R=Y.patterns;return R?ce.concat(R):ce},[]);const Q=function(ce,Y){if(typeof ce!="string")return null;if(!Y){let j;for(j=ce.length;j>0;j--){const W=ce.charCodeAt(j-1);if(W===47||W===92)break}Y=ce.substr(j)}const R=N.indexOf(Y);return R!==-1?V[R]:null};Q.basenames=N,Q.patterns=V,Q.allBasenames=N;const x=J.filter(ce=>!ce.basenames);return x.push(Q),x}function G(J,q){return(0,P.$sb)(J,q,(F,N)=>typeof F=="string"&&typeof N=="string"?F===N:typeof F!="string"&&typeof N!="string"?F.base===N.base&&F.pattern===N.pattern:!1)}e.$vj=G}),define(te[46],ie([0,1,23,32,9,4,19,26]),function(K,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.$kv=e.$jv=e.$iv=e.$hv=void 0;function h(i,n){const{os:a,tildify:k,relative:I}=n;if(I){const A=c(i,I,a);if(typeof A=="string")return A}let C=i.fsPath;if(a===1&&!M.$i?C=C.replace(/\//g,"\\"):a!==1&&M.$i&&(C=C.replace(/\\/g,"/")),a!==1&&k?.userHome){const A=k.userHome.fsPath;let L;i.scheme!==k.userHome.scheme&&i.path.startsWith(s.$6d.sep)?L=k.userHome.with({path:i.path}).fsPath:L=i.fsPath,C=y(L,A,a)}return(a===1?s.$5d:s.$6d).normalize(m(C,a===1))}e.$hv=h;function c(i,n,a){const k=a===1?s.$5d:s.$6d,I=a===3?D.$$f:D.$ag,C=n.getWorkspace(),p=(0,P.$Mb)(C.folders);if(!p)return;i.scheme!==p.uri.scheme&&i.path.startsWith(s.$6d.sep)&&(i=p.uri.with({path:i.path}));const A=n.getWorkspaceFolder(i);if(!A)return;let L;if(I.isEqual(A.uri,i)?L="":L=I.relativePath(A.uri,i)??"",L&&(L=k.normalize(L)),C.folders.length>1&&!n.noPrefix){const U=A.name?A.name:I.basenameOrAuthority(A.uri);L=L?`${U} \u2022 ${L}`:U}return L}function m(i,n=M.$i){return(0,O.$Mf)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$iv=m;let w=Object.create(null);function y(i,n,a=M.OS){if(a===1||!i||!n)return i;let k=w.original===n?w.normalized:void 0;k||(k=n,M.$i&&(k=(0,O.$Cf)(k)),k=`${(0,S.$ve)(k,s.$6d.sep)}${s.$6d.sep}`,w={original:n,normalized:k});let I=i;return M.$i&&(I=(0,O.$Cf)(I)),(a===3?I.startsWith(k):(0,S.$Ne)(I,k))?`~/${I.substr(k.length)}`:i}e.$jv=y;function f(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$kv=f;const v="\u2026",b="\\\\",d="~";function g(i,n=s.sep){const a=new Array(i.length);let k=!1;for(let I=0;I<i.length;I++){const C=i[I];if(C===""){a[I]=`.${n}`;continue}if(!C){a[I]=C;continue}k=!0;let p="",A=C;A.indexOf(b)===0?(p=A.substr(0,A.indexOf(b)+b.length),A=A.substr(A.indexOf(b)+b.length)):A.indexOf(n)===0?(p=A.substr(0,A.indexOf(n)+n.length),A=A.substr(A.indexOf(n)+n.length)):A.indexOf(d)===0&&(p=A.substr(0,A.indexOf(d)+d.length),A=A.substr(A.indexOf(d)+d.length));const L=A.split(n);for(let U=1;k&&U<=L.length;U++)for(let z=L.length-U;k&&z>=0;z--){k=!1;let re=L.slice(z,z+U).join(n);for(let ee=0;!k&&ee<i.length;ee++)if(ee!==I&&i[ee]&&i[ee].indexOf(re)>-1){const ae=z+U===L.length,se=z>0&&i[ee].indexOf(n)>-1?n+re:re,oe=i[ee].endsWith(se);k=!ae||oe}if(!k){let ee="";(L[0].endsWith(":")||p!=="")&&(z===1&&(z=0,U++,re=L[0]+n+re),z>0&&(ee=L[0]+n),ee=p+ee),z>0&&(ee=ee+v+n),ee=ee+re,z+U<L.length&&(ee=ee+n+v),a[I]=ee}}k&&(a[I]=C)}return a}e.$lv=g;var r;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(r||(r={}));function $(i,n=Object.create(null)){const a=[];let k=!1,I="";for(const C of i)if(C==="$"||k&&C==="{")I&&a.push({value:I,type:r.TEXT}),I="",k=!0;else if(C==="}"&&k){const p=n[I];if(typeof p=="string")p.length&&a.push({value:p,type:r.VARIABLE});else if(p){const A=a[a.length-1];(!A||A.type!==r.SEPARATOR)&&a.push({value:p.label,type:r.SEPARATOR})}I="",k=!1}else I+=C;return I&&!k&&a.push({value:I,type:r.TEXT}),a.filter((C,p)=>{if(C.type===r.SEPARATOR){const A=a[p-1],L=a[p+1];return[A,L].every(U=>U&&(U.type===r.VARIABLE||U.type===r.TEXT)&&U.value.length>0)}return!0}).map(C=>C.value).join("")}e.$mv=$;function E(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$nv=E;function u(i,n){return M.$j||n?i.replace(/\(&&\w\)|&&/g,""):M.$i?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$ov=u;function t(i){return i.replace(/&/g,"&&")}e.$pv=t;function l(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const a=o(i.substring(0,n));return{name:a.name,parentPath:a.parentPath+i.substring(n)}}}return o(i)}e.$qv=l;function o(i){const n=i.indexOf("/")!==-1?s.$6d:s.$5d,a=n.basename(i),k=n.dirname(i);return a.length?{name:a,parentPath:k}:{name:k,parentPath:""}}}),define(te[154],ie([0,1,17,7]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=e.$Cm=e.$Bm=void 0;function s(w){return w.toJSON()}class M{constructor(y){this.a=y}transformIncoming(y){const f=this.a.transformIncoming(y);return f===y?y:s(O.URI.from(f))}transformOutgoing(y){const f=this.a.transformOutgoing(y);return f===y?y:s(O.URI.from(f))}transformOutgoingURI(y){const f=this.a.transformOutgoing(y);return f===y?y:O.URI.from(f)}transformOutgoingScheme(y){return this.a.transformOutgoingScheme(y)}}e.$Bm=M,e.$Cm=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function D(w,y,f){if(!w||f>200)return null;if(typeof w=="object"){if(w instanceof O.URI)return y.transformOutgoing(w);for(const v in w)if(Object.hasOwnProperty.call(w,v)){const b=D(w[v],y,f+1);b!==null&&(w[v]=b)}}return null}function S(w,y){const f=D(w,y,0);return f===null?w:f}e.$Dm=S;function h(w,y,f,v){if(!w||v>200)return null;if(typeof w=="object"){if(w.$mid===1)return f?O.URI.revive(y.transformIncoming(w)):y.transformIncoming(w);if(w instanceof P.$Fd)return null;for(const b in w)if(Object.hasOwnProperty.call(w,b)){const d=h(w[b],y,f,v+1);d!==null&&(w[b]=d)}}return null}function c(w,y){const f=h(w,y,!1,0);return f===null?w:f}e.$Em=c;function m(w,y){const f=h(w,y,!0,0);return f===null?w:f}e.$Fm=m}),define(te[21],ie([0,1,45,27,155,8,32,85,9,4,19,7]),function(K,e,P,O,s,M,D,S,h,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(y||(e.RimRafMode=y={}));async function f(se,oe=y.UNLINK,G){if((0,D.$Lf)(se))throw new Error("rimraf - will refuse to recursively delete root");return oe===y.UNLINK?b(se):v(se,G)}async function v(se,oe=(0,D.$Qf)((0,O.tmpdir)())){try{try{await P.promises.rename(se,oe)}catch(G){return G.code==="ENOENT"?void 0:b(se)}b(oe).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function b(se){return(0,s.promisify)(P.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function d(se){if((0,D.$Lf)(se))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function g(se,oe){return E(await(oe?r(se):(0,s.promisify)(P.readdir)(se)))}async function r(se){try{return await(0,s.promisify)(P.readdir)(se,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const oe=[],G=await g(se);for(const J of G){let q=!1,F=!1,N=!1;try{const V=await e.Promises.lstat((0,h.$9d)(se,J));q=V.isFile(),F=V.isDirectory(),N=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}oe.push({name:J,isFile:()=>q,isDirectory:()=>F,isSymbolicLink:()=>N})}return oe}function $(se){return E(P.readdirSync(se))}e.readdirSync=$;function E(se){return se.map(oe=>typeof oe=="string"?c.$j?(0,S.$hl)(oe):oe:(oe.name=c.$j?(0,S.$hl)(oe.name):oe.name,oe))}async function u(se){const oe=await g(se),G=[];for(const J of oe)await l.existsDirectory((0,h.$9d)(se,J))&&G.push(J);return G}function t(se,oe=1e3){return new Promise(G=>{let J=!1;const q=setInterval(()=>{J||(J=!0,P.access(se,F=>{J=!1,F&&(clearInterval(q),G(void 0))}))},oe)})}e.whenDeleted=t;var l;(function(se){async function oe(q){let F;try{if(F=await e.Promises.lstat(q),!F.isSymbolicLink())return{stat:F}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:F?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};if(c.$i&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&F)return{stat:F,symbolicLink:{dangling:!0}};throw V}throw N}}se.stat=oe;async function G(q){try{const{stat:F,symbolicLink:N}=await se.stat(q);return F.isFile()&&N?.dangling!==!0}catch{}return!1}se.existsFile=G;async function J(q){try{const{stat:F,symbolicLink:N}=await se.stat(q);return F.isDirectory()&&N?.dangling!==!0}catch{}return!1}se.existsDirectory=J})(l||(e.SymlinkSupport=l={}));const o=new M.$Pg;function i(se,oe,G){return o.queueFor(w.URI.file(se),m.$_f).queue(()=>{const J=C(G);return new Promise((q,F)=>k(se,oe,J,N=>N?F(N):q()))})}let n=!0;function a(se){n=se}e.configureFlushOnWrite=a;function k(se,oe,G,J){if(!n)return P.writeFile(se,oe,{mode:G.mode,flag:G.flag},J);P.open(se,G.flag,G.mode,(q,F)=>{if(q)return J(q);P.writeFile(F,oe,N=>{if(N)return P.close(F,()=>J(N));P.fdatasync(F,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),a(!1)),P.close(F,Q=>J(Q))))})})}function I(se,oe,G){const J=C(G);if(!n)return P.writeFileSync(se,oe,{mode:J.mode,flag:J.flag});const q=P.openSync(se,J.flag,J.mode);try{P.writeFileSync(q,oe);try{P.fdatasyncSync(q)}catch(F){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",F),a(!1)}}finally{P.closeSync(q)}}e.writeFileSync=I;function C(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function p(se,oe,G=6e4){if(se!==oe)try{c.$i&&typeof G=="number"?await A(se,oe,Date.now(),G):await(0,s.promisify)(P.rename)(se,oe)}catch(J){if(se.toLowerCase()!==oe.toLowerCase()&&J.code==="EXDEV"||se.endsWith("."))await L(se,oe,{preserveSymlinks:!1}),await f(se,y.MOVE);else throw J}}async function A(se,oe,G,J,q=0){try{return await(0,s.promisify)(P.rename)(se,oe)}catch(F){if(F.code!=="EACCES"&&F.code!=="EPERM"&&F.code!=="EBUSY")throw F;if(Date.now()-G>=J)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${F}`),F;if(q===0){let N=!1;try{const{stat:V}=await l.stat(oe);V.isFile()||(N=!0)}catch{}if(N)throw F}return await(0,M.$Hg)(Math.min(100,q*10)),A(se,oe,G,J,q+1)}}async function L(se,oe,G){return z(se,oe,{root:{source:se,target:oe},options:G,handledSourcePaths:new Set})}const U=511;async function z(se,oe,G){if(G.handledSourcePaths.has(se))return;G.handledSourcePaths.add(se);const{stat:J,symbolicLink:q}=await l.stat(se);if(q){if(G.options.preserveSymlinks)try{return await ae(se,oe,G)}catch(F){console.warn("[node.js fs] copy of symlink failed: ",F)}if(q.dangling)return}return J.isDirectory()?re(se,oe,J.mode&U,G):ee(se,oe,J.mode&U)}async function re(se,oe,G,J){await e.Promises.mkdir(oe,{recursive:!0,mode:G});const q=await g(se);for(const F of q)await z((0,h.$9d)(se,F),(0,h.$9d)(oe,F),J)}async function ee(se,oe,G){await e.Promises.copyFile(se,oe),await e.Promises.chmod(oe,G)}async function ae(se,oe,G){let J=await e.Promises.readlink(se);(0,D.$If)(J,G.root.source,!c.$k)&&(J=(0,h.$9d)(G.root.target,J.substr(G.root.source.length+1))),await e.Promises.symlink(J,oe)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(se,oe,G,J,q)=>new Promise((F,N)=>{P.read(se,oe,G,J,q,(V,Q,x)=>V?N(V):F({bytesRead:Q,buffer:x}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(se,oe,G,J,q)=>new Promise((F,N)=>{P.write(se,oe,G,J,q,(V,Q,x)=>V?N(V):F({bytesWritten:Q,buffer:x}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return f}get rename(){return p}get copy(){return L}}}),define(te[105],ie([0,1,45,9,4,26,21]),function(K,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.$Vp=e.$Up=void 0;function S(y){if(s.$k)return y;const f=(0,O.$_d)(y);if(y===f)return y;const v=((0,O.$ae)(y)||y).toLowerCase();try{const d=(0,D.readdirSync)(f).filter(g=>g.toLowerCase()===v);if(d.length===1){const g=S(f);if(g)return(0,O.$9d)(g,d[0])}else if(d.length>1){const g=d.indexOf(v);if(g>=0){const r=S(f);if(r)return(0,O.$9d)(r,d[g])}}}catch{}return null}e.$Up=S;async function h(y){if(s.$k)return y;const f=(0,O.$_d)(y);if(y===f)return y;const v=((0,O.$ae)(y)||y).toLowerCase();try{const d=(await D.Promises.readdir(f)).filter(g=>g.toLowerCase()===v);if(d.length===1){const g=await h(f);if(g)return(0,O.$9d)(g,d[0])}else if(d.length>1){const g=d.indexOf(v);if(g>=0){const r=await h(f);if(r)return(0,O.$9d)(r,d[g])}}}catch{}return null}e.$Vp=h;async function c(y){try{return await D.Promises.realpath(y)}catch{const v=w(y);return await D.Promises.access(v,P.constants.R_OK),v}}e.$Wp=c;function m(y){try{return P.realpathSync(y)}catch{const v=w(y);return P.accessSync(v,P.constants.R_OK),v}}e.$Xp=m;function w(y){return(0,M.$ve)((0,O.$7d)(y),O.sep)}}),define(te[106],ie([0,1,27,9,21]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rl=e.$ql=void 0;const M=/^\d+$/,D=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var h;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(h||(h={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let m;process.env.PROCESSOR_ARCHITEW6432?m=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?m=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?m=1:m=0;class w{constructor(u,t,l){this.exePath=u,this.displayName=t,this.a=l}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function y({useAlternateBitness:E=!1}={}){return E?c===0?process.env["ProgramFiles(x86)"]||null:m===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:E=!1,findPreview:u=!1}={}){const t=y({useAlternateBitness:E});if(!t)return null;const l=O.$9d(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(l))return null;let o=-1,i=null;for(const k of await s.Promises.readdir(l)){let I=-1;if(u){const p=k.indexOf("-");if(p<0)continue;const A=k.substring(0,p);if(!M.test(A)||k.substring(p+1)!=="preview")continue;I=parseInt(A,10)}else{if(!M.test(k))continue;I=parseInt(k,10)}if(I<=o)continue;const C=O.$9d(l,k,"pwsh.exe");await s.SymlinkSupport.existsFile(C)&&(i=C,o=I)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",a=u?" Preview":"";return new w(i,`PowerShell${a}${n}`,!0)}async function v({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const u=O.$9d(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=E?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const o of await s.Promises.readdir(u))if(t.test(o)){const i=O.$9d(u,o,"pwsh.exe");return new w(i,l)}return null}function b(){const E=O.$9d(P.homedir(),".dotnet","tools","pwsh.exe");return new w(E,".NET Core PowerShell Global Tool")}function d(){const E=O.$9d(process.env.windir,c===1&&m!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(E,"Windows PowerShell",!0)}async function*g(){let E=await f();E&&(yield E),E=await f({useAlternateBitness:!0}),E&&(yield E),E=await v(),E&&(yield E),E=b(),E&&(yield E),E=await f({findPreview:!0}),E&&(yield E),E=await v({findPreview:!0}),E&&(yield E),E=await f({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=d(),E&&(yield E)}async function*r(){for await(const E of g())await E.exists()&&(yield E)}e.$ql=r;async function $(){for await(const E of r())return E;return null}e.$rl=$}),define(te[88],ie([0,1,9,4,35,73,12,21]),function(K,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$vl=e.$ul=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function h(w=s.env){return w.comspec||"cmd.exe"}e.$ul=h;function c(w){let y=[],f=!1;const v=function(b){if(f){y.push(b);return}(!w.send(b,g=>{if(g&&console.error(g),f=!1,y.length>0){const r=y.slice(0);y=[],r.forEach($=>v($))}})||O.$i)&&(f=!0)};return{send:v}}e.$vl=c;var m;(function(w){async function y(f,v,b){if(P.$8d(f))return f;if(v===void 0&&(v=s.cwd()),P.$_d(f)!=="."||(b===void 0&&D.$jf(s.env.PATH)&&(b=s.env.PATH.split(P.$ge)),b===void 0||b.length===0))return P.$9d(v,f);async function g(r){if(await S.Promises.exists(r)){let $;try{$=await S.Promises.stat(r)}catch(E){E.message.startsWith("EACCES")&&($=await S.Promises.lstat(r))}return $?!$.isDirectory():!1}return!1}for(const r of b){let $;if(P.$8d(r)?$=P.$9d(r,f):$=P.$9d(v,r,f),await g($))return $;let E=$+".com";if(await g(E)||(E=$+".exe",await g(E)))return E}return P.$9d(v,f)}w.findExecutable=y})(m||(e.win32=m={}))}),define(te[107],ie([0,1,47,13]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;function s(D){return new Promise((S,h)=>{let c;const m=new Map;function w(f,v,b,d,g){const r=m.get(v);if(f===D||r){const $={name:y(b),cmd:b,pid:f,ppid:v,load:d,mem:g};m.set(f,$),f===D&&(c=$),r&&(r.children||(r.children=[]),r.children.push($),r.children.length>1&&(r.children=r.children.sort((E,u)=>E.pid-u.pid)))}}function y(f){const v=/--utility-sub-type=network/i,b=/--ms-enable-electron-run-as-node/i,d=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,r=/conhost\.exe.+--headless/i,$=/--type=([a-zA-Z-]+)/;if(d.exec(f))return"electron-crash-reporter";if(g.exec(f))return"winpty-agent";if(r.exec(f))return"conpty-agent";let E=$.exec(f);if(E&&E.length===2)return E[1]==="renderer"?"window":E[1]==="utility"?v.exec(f)?"utility-network-service":"utility-process":E[1]==="extensionHost"?"extension-host":E[1];const u=/[a-zA-Z-]+\.js/g;let t="";do E=u.exec(f),E&&(t+=E+" ");while(E);return t&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${t})`:b.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substring(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substring(5):v;new Promise((v,b)=>{K(["@vscode/windows-process-tree"],v,b)}).then(v=>{v.getProcessList(D,b=>{if(!b){h(new Error(`Root process ${D} not found`));return}v.getProcessCpuUsage(b,d=>{const g=new Map;d.forEach(r=>{const $=f(r.commandLine||"");g.set(r.pid,{name:y($),cmd:$,pid:r.pid,ppid:r.ppid,load:r.cpu||0,mem:r.memory||0})}),c=g.get(D),c?(g.forEach(r=>{const $=g.get(r.ppid);$&&($.children||($.children=[]),$.children.push(r))}),g.forEach(r=>{r.children&&(r.children=r.children.sort(($,E)=>$.pid-E.pid))}),S(c)):h(new Error(`Root process ${D} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{let f=function(){let v=[c];const b=[];for(;v.length;){const g=v.shift();g&&(b.push(g.pid),g.children&&(v=v.concat(g.children)))}let d=JSON.stringify(O.$2f.asFileUri("vs/base/node/cpuUsage.sh").fsPath);d+=" "+b.join(" "),(0,P.exec)(d,{},(g,r,$)=>{if(g||$)h(g||new Error($.toString()));else{const E=r.toString().split(`
`);for(let u=0;u<b.length;u++){const t=m.get(b[u]);t.load=parseFloat(E[u])}if(!c){h(new Error(`Root process ${D} not found`));return}S(c)}})};(0,P.exec)("which ps",{},(v,b,d)=>{if(v||d)if(process.platform!=="linux")h(v||new Error(d.toString()));else{const g=JSON.stringify(O.$2f.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)(g,{},(r,$,E)=>{r||E?h(r||new Error(E.toString())):(M($,w),f())})}else{const g=b.toString().trim(),r="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${g} ${r}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},($,E,u)=>{$||u&&!u.includes("screen size is bogus")?h($||new Error(u.toString())):(M(E,w),process.platform==="linux"?f():c?S(c):h(new Error(`Root process ${D} not found`)))})}})}})}e.$sr=s;function M(D,S){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=D.toString().split(`
`);for(const m of c){const w=h.exec(m.trim());w&&w.length===6&&S(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(te[108],ie([0,1,27,4,106,88]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=void 0;async function D(w,y){return w===1?O.$i?m():M.$ul(y):h(w,y)}e.$wl=D;let S=null;function h(w,y){if(O.$k&&w===2||O.$j&&w===3)return"/bin/bash";if(!S){let f;if(O.$i)f="/bin/bash";else{if(f=y.SHELL,!f)try{f=(0,P.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}S=f}return S}let c=null;async function m(){return c||(c=(await(0,s.$rl)()).exePath),c}});var ke=this&&this.__decorate||function(K,e,P,O){var s=arguments.length,M=s<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,P):O,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(K,e,P,O);else for(var S=K.length-1;S>=0;S--)(D=K[S])&&(M=(s<3?D(M):s>3?D(e,P,M):D(e,P))||M);return s>3&&M&&Object.defineProperty(e,P,M),M};define(te[42],ie([0,1,23,8,17,22,55,14,3,2,74,26,12]),function(K,e,P,O,s,M,D,S,h,c,m,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=e.ProxyChannel=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.RequestInitiator=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=void 0;var f;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(f||(f={}));function v(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(b||(b={}));function d(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(g||(g={}));function r(q){let F=0;for(let N=0;;N+=7){const V=q.read(1);if(F|=(V.buffer[0]&127)<<N,!(V.buffer[0]&128))return F}}const $=o(0);function E(q,F){if(F===0){q.write($);return}let N=0;for(let Q=F;Q!==0;Q=Q>>>7)N++;const V=s.$Fd.alloc(N);for(let Q=0;F!==0;Q++)V.buffer[Q]=F&127,F=F>>>7,F>0&&(V.buffer[Q]|=128);q.write(V)}class u{constructor(F){this.b=F,this.a=0}read(F){const N=this.b.slice(this.a,this.a+F);return this.a+=N.byteLength,N}}e.$_g=u;class t{constructor(){this.a=[]}get buffer(){return s.$Fd.concat(this.a)}write(F){this.a.push(F)}}e.$ah=t;var l;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(l||(l={}));function o(q){const F=s.$Fd.alloc(1);return F.writeUInt8(q,0),F}const i={Undefined:o(l.Undefined),String:o(l.String),Buffer:o(l.Buffer),VSBuffer:o(l.VSBuffer),Array:o(l.Array),Object:o(l.Object),Uint:o(l.Int)},n=typeof Buffer<"u";function a(q,F){if(typeof F>"u")q.write(i.Undefined);else if(typeof F=="string"){const N=s.$Fd.fromString(F);q.write(i.String),E(q,N.byteLength),q.write(N)}else if(n&&Buffer.isBuffer(F)){const N=s.$Fd.wrap(F);q.write(i.Buffer),E(q,N.byteLength),q.write(N)}else if(F instanceof s.$Fd)q.write(i.VSBuffer),E(q,F.byteLength),q.write(F);else if(Array.isArray(F)){q.write(i.Array),E(q,F.length);for(const N of F)a(q,N)}else if(typeof F=="number"&&(F|0)===F)q.write(i.Uint),E(q,F);else{const N=s.$Fd.fromString(JSON.stringify(F));q.write(i.Object),E(q,N.byteLength),q.write(N)}}e.$bh=a;function k(q){switch(q.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return q.read(r(q)).toString();case l.Buffer:return q.read(r(q)).buffer;case l.VSBuffer:return q.read(r(q));case l.Array:{const N=r(q),V=[];for(let Q=0;Q<N;Q++)V.push(k(q));return V}case l.Object:return JSON.parse(q.read(r(q)).toString());case l.Int:return r(q)}}e.$ch=k;class I{constructor(F,N,V=null,Q=1e3){this.h=F,this.j=N,this.k=V,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(F,N){this.b.set(F,N),setTimeout(()=>this.w(F),0)}m(F){switch(F.type){case 200:{const N=this.o([F.type]);this.k?.logOutgoing(N,0,1,d(F.type));return}case 201:case 202:case 204:case 203:{const N=this.o([F.type,F.id],F.data);this.k?.logOutgoing(N,F.id,1,d(F.type),F.data);return}}}o(F,N=void 0){const V=new t;return a(V,F),a(V,N),this.p(V.buffer)}p(F){try{return this.h.send(F),F.byteLength}catch{return 0}}q(F){const N=new u(F),V=k(N),Q=k(N),x=V[0];switch(x){case 100:return this.k?.logIncoming(F.byteLength,V[1],1,`${v(x)}: ${V[2]}.${V[3]}`,Q),this.s({type:x,id:V[1],channelName:V[2],name:V[3],arg:Q});case 102:return this.k?.logIncoming(F.byteLength,V[1],1,`${v(x)}: ${V[2]}.${V[3]}`,Q),this.t({type:x,id:V[1],channelName:V[2],name:V[3],arg:Q});case 101:return this.k?.logIncoming(F.byteLength,V[1],1,`${v(x)}`),this.u({type:x,id:V[1]});case 103:return this.k?.logIncoming(F.byteLength,V[1],1,`${v(x)}`),this.u({type:x,id:V[1]})}}s(F){const N=this.b.get(F.channelName);if(!N){this.v(F);return}const V=new M.$pd;let Q;try{Q=N.call(this.j,F.name,F.arg,V.token)}catch(Y){Q=Promise.reject(Y)}const x=F.id;Q.then(Y=>{this.m({id:x,data:Y,type:201})},Y=>{Y instanceof Error?this.m({id:x,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.m({id:x,data:Y,type:203})}).finally(()=>{ce.dispose(),this.d.delete(F.id)});const ce=(0,c.$ic)(()=>V.cancel());this.d.set(F.id,ce)}t(F){const N=this.b.get(F.channelName);if(!N){this.v(F);return}const V=F.id,x=N.listen(this.j,F.name,F.arg)(ce=>this.m({id:V,data:ce,type:204}));this.d.set(F.id,x)}u(F){const N=this.d.get(F.id);N&&(N.dispose(),this.d.delete(F.id))}v(F){let N=this.g.get(F.channelName);N||(N=[],this.g.set(F.channelName,N));const V=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.m({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);N.push({request:F,timeoutTimer:V})}w(F){const N=this.g.get(F);if(N){for(const V of N)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.s(V.request);break;case 102:this.t(V.request);break}this.g.delete(F)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$fc)(this.d.values()),this.d.clear()}}e.$dh=I;var C;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(C||(e.RequestInitiator=C={}));class p{constructor(F,N=null){this.l=F,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$fd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=N}getChannel(F){const N=this;return{call(V,Q,x){return N.a?Promise.reject(new S.$3):N.m(F,V,Q,x)},listen(V,Q){return N.a?h.Event.None:N.o(F,V,Q)}}}m(F,N,V,Q=M.CancellationToken.None){const x=this.g++,Y={id:x,type:100,channelName:F,name:N,arg:V};if(Q.isCancellationRequested)return Promise.reject(new S.$3);let R;return new Promise((W,T)=>{if(Q.isCancellationRequested)return T(new S.$3);const H=()=>{const ge=ue=>{switch(ue.type){case 201:this.f.delete(x),W(ue.data);break;case 202:{this.f.delete(x);const we=new Error(ue.data.message);we.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,we.name=ue.data.name,T(we);break}case 203:this.f.delete(x),T(ue.data);break}};this.f.set(x,ge),this.p(Y)};let B=null;this.b===g.Idle?H():(B=(0,O.$ug)(ge=>this.u()),B.then(()=>{B=null,H()}));const ne=()=>{B?(B.cancel(),B=null):this.p({id:x,type:101}),T(new S.$3)},fe=Q.onCancellationRequested(ne);R=(0,c.$hc)((0,c.$ic)(ne),fe),this.d.add(R)}).finally(()=>{R.dispose(),this.d.delete(R)})}o(F,N,V){const Q=this.g++,ce={id:Q,type:102,channelName:F,name:N,arg:V};let Y=null;const R=new h.$fd({onWillAddFirstListener:()=>{Y=(0,O.$ug)(W=>this.u()),Y.then(()=>{Y=null,this.d.add(R),this.p(ce)})},onDidRemoveLastListener:()=>{Y?(Y.cancel(),Y=null):(this.d.delete(R),this.p({id:Q,type:103}))}}),j=W=>R.fire(W.data);return this.f.set(Q,j),R.event}p(F){switch(F.type){case 100:case 102:{const N=this.q([F.type,F.id,F.channelName,F.name],F.arg);this.j?.logOutgoing(N,F.id,0,`${v(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const N=this.q([F.type,F.id]);this.j?.logOutgoing(N,F.id,0,v(F.type));return}}}q(F,N=void 0){const V=new t;return a(V,F),a(V,N),this.r(V.buffer)}r(F){try{return this.l.send(F),F.byteLength}catch{return 0}}s(F){const N=new u(F),V=k(N),Q=k(N),x=V[0];switch(x){case 200:return this.j?.logIncoming(F.byteLength,0,0,d(x)),this.t({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(F.byteLength,V[1],0,d(x),Q),this.t({type:V[0],id:V[1],data:Q})}}t(F){if(F.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(F.id)?.(F)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$fc)(this.d.values()),this.d.clear()}}e.$eh=p,ke([D.$6g],p.prototype,"onDidInitializePromise",null);class A{get connections(){const F=[];return this.f.forEach(N=>F.push(N)),F}constructor(F){this.a=new Map,this.f=new Set,this.g=new h.$fd,this.onDidAddConnection=this.g.event,this.h=new h.$fd,this.onDidRemoveConnection=this.h.event,this.j=new c.$jc,this.j.add(F(({protocol:N,onDidClientDisconnect:V})=>{const Q=h.Event.once(N.onMessage);this.j.add(Q(x=>{const ce=new u(x),Y=k(ce),R=new I(N,Y),j=new p(N);this.a.forEach((T,H)=>R.registerChannel(H,T));const W={channelServer:R,channelClient:j,ctx:Y};this.f.add(W),this.g.fire(W),this.j.add(V(()=>{R.dispose(),j.dispose(),this.f.delete(W),this.h.fire(W)}))}))}))}getChannel(F,N){const V=this;return{call(Q,x,ce){let Y;if((0,y.$xf)(N)){const j=(0,P.$2b)(V.connections.filter(N));Y=j?Promise.resolve(j):h.Event.toPromise(h.Event.filter(V.onDidAddConnection,N))}else Y=N.routeCall(V,Q,x);const R=Y.then(j=>j.channelClient.getChannel(F));return U(R).call(Q,x,ce)},listen(Q,x){if((0,y.$xf)(N))return V.k(F,N,Q,x);const ce=N.routeEvent(V,Q,x).then(Y=>Y.channelClient.getChannel(F));return U(ce).listen(Q,x)}}}k(F,N,V,Q){const x=this;let ce;const Y=new h.$fd({onWillAddFirstListener:()=>{ce=new c.$jc;const R=new h.$ld,j=new Map,W=H=>{const ne=H.channelClient.getChannel(F).listen(V,Q),fe=R.add(ne);j.set(H,fe)},T=H=>{const B=j.get(H);B&&(B.dispose(),j.delete(H))};x.connections.filter(N).forEach(W),h.Event.filter(x.onDidAddConnection,N)(W,void 0,ce),x.onDidRemoveConnection(T,void 0,ce),R.event(Y.fire,Y,ce),ce.add(R)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return Y.event}registerChannel(F,N){this.a.set(F,N);for(const V of this.f)V.channelServer.registerChannel(F,N)}dispose(){this.j.dispose();for(const F of this.f)F.channelClient.dispose(),F.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$fh=A;class L{constructor(F,N,V=null){const Q=new t;a(Q,N),F.send(Q.buffer),this.a=new p(F,V),this.d=new I(F,N,V)}getChannel(F){return this.a.getChannel(F)}registerChannel(F,N){this.d.registerChannel(F,N)}dispose(){this.a.dispose(),this.d.dispose()}}e.$gh=L;function U(q){return{call(F,N,V){return q.then(Q=>Q.call(F,N,V))},listen(F,N){const V=new h.$od;return q.then(Q=>V.input=Q.listen(F,N)),V.event}}}e.$hh=U;function z(q){let F=!1;return{call(N,V,Q){return F?q.call(N,V,Q):(0,O.$Hg)(0).then(()=>F=!0).then(()=>q.call(N,V,Q))},listen(N,V){if(F)return q.listen(N,V);const Q=new h.$od;return(0,O.$Hg)(0).then(()=>F=!0).then(()=>Q.input=q.listen(N,V)),Q.event}}}e.$ih=z;class re{constructor(F){this.a=F}routeCall(F){return this.b(F)}routeEvent(F){return this.b(F)}async b(F){for(const N of F.connections)if(await Promise.resolve(this.a(N.ctx)))return Promise.resolve(N);return await h.Event.toPromise(F.onDidAddConnection),await this.b(F)}}e.$jh=re;var ee;(function(q){function F(x,ce,Y){const R=x,j=Y&&Y.disableMarshalling,W=new Map;for(const T in R)V(T)&&W.set(T,h.Event.buffer(R[T],!0,void 0,ce));return new class{listen(T,H,B){const ne=W.get(H);if(ne)return ne;if(Q(H)){const fe=R[H];if(typeof fe=="function")return fe.call(R,B)}throw new S.$_(`Event not found: ${H}`)}call(T,H,B){const ne=R[H];if(typeof ne=="function"){if(!j&&Array.isArray(B))for(let fe=0;fe<B.length;fe++)B[fe]=(0,m.$$g)(B[fe]);return ne.apply(R,B)}throw new S.$_(`Method not found: ${H}`)}}}q.fromService=F;function N(x,ce){const Y=ce&&ce.disableMarshalling;return new Proxy({},{get(R,j){if(typeof j=="string")return ce?.properties?.has(j)?ce.properties.get(j):Q(j)?function(W){return x.listen(j,W)}:V(j)?x.listen(j):async function(...W){let T;ce&&!(0,y.$sf)(ce.context)?T=[ce.context,...W]:T=W;const H=await x.call(j,T);return Y?H:(0,m.$$g)(H)};throw new S.$_(`Property not found: ${String(j)}`)}})}q.toService=N;function V(x){return x[0]==="o"&&x[1]==="n"&&w.$Le(x.charCodeAt(2))}function Q(x){return/^onDynamic/.test(x)&&w.$Le(x.charCodeAt(9))}})(ee||(e.ProxyChannel=ee={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function se(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const F=q.toString();if(F!=="[object Object]")return F}return q}function oe(q){return Array.isArray(q)?q.map(se):se(q)}function G(q,F,N,V,Q,x,ce){ce=oe(ce);const Y=ae[Q],R=Y[V%Y.length];let j=[`%c[${q}]%c[${String(F).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${R}`];/\($/.test(x)?(j=j.concat(ce),j.push(")")):j.push(ce),console.log.apply(console,j)}class J{constructor(F,N){this.d=F,this.f=N,this.a=0,this.b=0}logOutgoing(F,N,V,Q,x){this.b+=F,G(this.d,this.b,F,N,V,Q,x)}logIncoming(F,N,V,Q,x){this.a+=F,G(this.f,this.a,F,N,V,Q,x)}}e.$kh=J}),define(te[156],ie([0,1,17,3,42]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YS=e.$XS=void 0;class M{constructor(h){this.a=h,this.onMessage=O.Event.fromDOMEventEmitter(this.a,"message",c=>P.$Fd.wrap(c.data)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.$XS=M;class D extends s.$gh{constructor(h,c){const m=new M(h);super(m,c),this.b=m}dispose(){this.b.disconnect(),super.dispose()}}e.$YS=D}),define(te[109],ie([0,1,17,3,2,42]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ph=e.$oh=e.$nh=e.$mh=e.ProtocolConstants=e.$lh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let a=0;function k(C,p){if(!n.has(C)){const A=String(++a);n.set(C,A)}return n.get(C)}function I(C,p,A,L){if(!i.enableDiagnostics)return;const U=k(C,p);if(L instanceof P.$Fd||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const z=P.$Fd.alloc(L.byteLength);z.set(L),i.records.push({timestamp:Date.now(),id:U,label:p,type:A,buff:z})}else i.records.push({timestamp:Date.now(),id:U,label:p,type:A,data:L})}i.traceSocketEvent=I})(S||(e.SocketDiagnostics=S={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let c=null;function m(){return c||(c=P.$Fd.alloc(0)),c}class w{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,a){if(n===0)return m();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const p=this.a[0];return a&&(this.a.shift(),this.b-=n),p}if(this.a[0].byteLength>n){const p=this.a[0].slice(0,n);return a&&(this.a[0]=this.a[0].slice(n),this.b-=n),p}const k=P.$Fd.alloc(n);let I=0,C=0;for(;n>0;){const p=this.a[C];if(p.byteLength>n){const A=p.slice(0,n);k.set(A,I),I+=n,a&&(this.a[C]=p.slice(n),this.b-=n),n-=n}else k.set(p,I),I+=p.byteLength,a?(this.a.shift(),this.b-=p.byteLength):C++,n-=p.byteLength}return k}}e.$lh=w;var y;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(y||(y={}));function f(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class b{constructor(n,a,k,I){this.type=n,this.id=a,this.ack=k,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends s.$kc{constructor(n){super(),this.f=this.B(new O.$fd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new w,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:f(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,I=this.g.id,C=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new b(k,I,C,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=P.$Fd.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:f(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(a,n.data)}g(n,a){const k=this.f===0;return this.d.push(n,a),this.f+=n.byteLength+a.byteLength,k}h(){const n=P.$Fd.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,a){this.g(n,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class r extends s.$kc{constructor(n){super(),this.f=new O.$fd,this.onMessage=this.f.event,this.g=new O.$fd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new g(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new b(1,0,0,n))}}e.$mh=r;class $ extends M.$gh{static fromSocket(n,a){return new $(new r(n),a)}get onDidDispose(){return this.b.onDidDispose}constructor(n,a,k=null){super(n,a,k),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$nh=$;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new O.$fd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$oh=E;class u{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,a=this.a;for(;a;)a=a.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let a=0,k=this.a;for(;k;)n[a++]=k.data,k=k.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const a=new u(n);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class l{static{this.a=10}static{this.b=null}static getInstance(){return l.b||(l.b=new l),l.b}constructor(){this.c=[];const n=Date.now();for(let a=0;a<l.a;a++)this.c[a]=n-1e3*a;setInterval(()=>{for(let a=l.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),a=(1+l.a)*1e3;let k=0;for(let I=0;I<l.a;I++)n-this.c[I]<=a&&k++;return 1-k/l.a}hasHighLoad(){return this.d()>=.5}}class o{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??l.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$jc,this.o=n.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new b(5,0,0,m());this.p.write(n),this.p.flush()}sendPause(){const n=new b(7,0,0,m());this.p.write(n)}sendResume(){const n=new b(8,0,0,m());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,a){this.a=!0,this.r.dispose(),this.r=new s.$jc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new b(3,0,this.h,m());this.p.write(n);const a=this.b.toArray();for(let k=0,I=a.length;k<I;k++)this.p.write(a[k]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const a=this.b.peek();if(a&&a.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new b(6,0,0,m())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let k=0,I=a.length;k<I;k++)this.p.write(a[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const a=++this.c;this.h=this.g;const k=new b(1,a,this.h,n);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(n){const a=new b(2,0,0,n);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),a=Date.now()-n.writtenTime,k=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(a>=2e4&&k>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:k});return}const C=Math.max(2e4-a,2e4-k,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},C)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new b(3,0,this.h,m());this.p.write(n)}D(){this.h=this.g;const n=new b(9,0,this.h,m());this.p.write(n)}}e.$ph=o}),define(te[157],ie([0,1,38,17,3,2,42,145]),function(K,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2S=void 0;function h(m,w){const y=s.Event.fromNodeEventEmitter(P.$US,w,(v,b)=>({event:v,message:b})),f=s.Event.filter(y,({event:v})=>v.sender.id===m);return s.Event.map(f,({message:v})=>v&&O.$Fd.wrap(v))}class c extends D.$fh{static{this.b=new Map}static d(){const w=s.Event.fromNodeEventEmitter(P.$US,"vscode:hello",({sender:y})=>y);return s.Event.map(w,y=>{const f=y.id;c.b.get(f)?.dispose();const b=new s.$fd;c.b.set(f,(0,M.$ic)(()=>b.fire()));const d=h(f,"vscode:message"),g=s.Event.any(s.Event.signal(h(f,"vscode:disconnect")),b.event);return{protocol:new S.$1S(y,d),onDidClientDisconnect:g}})}constructor(){super(c.d())}}e.$2S=c}),define(te[110],ie([0,1,38,3,31,156]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4S=e.$3S=void 0;class D extends M.$YS{constructor(c,m){super({addEventListener:(w,y)=>c.addListener(w,y),removeEventListener:(w,y)=>c.removeListener(w,y),postMessage:w=>c.postMessage(w),start:()=>c.start(),close:()=>c.close()},m)}}e.$3S=D;async function S(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,s.$4f)();h.webContents.send("vscode:createMessageChannel",c);const m=O.Event.fromNodeEventEmitter(P.$US,"vscode:createMessageChannelResult",(y,f)=>({nonce:f,port:y.ports[0]})),{port:w}=await O.Event.toPromise(O.Event.once(O.Event.filter(m,y=>y.nonce===c)));return w}e.$4S=S}),define(te[158],ie([0,1,47,8,17,22,153,14,3,2,37,88,73,42]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0;class v extends f.$dh{constructor(g){super({send:r=>{try{process.send?.(r.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",r=>s.$Fd.wrap(Buffer.from(r,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$Rp=v;class b{constructor(g,r){this.i=g,this.j=r,this.c=new Set,this.g=new Map,this.h=new h.$fd,this.onDidProcessExit=this.h.event;const $=r&&r.timeout?r.timeout:6e4;this.b=new O.$Dg($),this.d=null,this.f=null}getChannel(g){const r=this;return{call($,E,u){return r.k(g,$,E,u)},listen($,E){return r.l(g,$,E)}}}k(g,r,$,E=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(S.$4());this.b.cancel();const u=this.n(g),t=(0,O.$ug)(i=>u.call(r,$,i)),l=E.onCancellationRequested(()=>t.cancel()),o=(0,c.$ic)(()=>t.cancel());return this.c.add(o),t.finally(()=>{l.dispose(),this.c.delete(o),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,r,$){if(!this.b)return h.Event.None;this.b.cancel();let E;const u=new h.$fd({onWillAddFirstListener:()=>{E=this.n(g).listen(r,$)(u.fire,u),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return u.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],r=Object.create(null);r.env={...(0,m.$Vm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(r.env={...r.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(r.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(r.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(r.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),r.execArgv===void 0&&(r.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,y.$tl)(r.env),this.d=(0,P.fork)(this.i,g,r);const $=new h.$fd;h.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$Np)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}$.fire(s.$Fd.wrap(Buffer.from(n,"base64")))});const u=this.j.useQueue?(0,w.$vl)(this.d):this.d,t=n=>this.d&&this.d.connected&&u.send(n.buffer.toString("base64")),l=$.event,o={send:t,onMessage:l};this.f=new f.$eh(o);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,a)=>{process.removeListener("exit",i),this.c.forEach(k=>(0,c.$fc)(k)),this.c.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:a})})}return this.f}n(g){let r=this.g.get(g);return r||(r=this.m.getChannel(g),this.g.set(g,r)),r}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Sp=b}),define(te[111],ie([0,1,8,3,2,74,12]),function(K,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.StorageState=e.$Qo=e.StorageHint=void 0;var S;(function(y){y[y.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",y[y.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function h(y){const f=y;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$Qo=h;var c;(function(y){y[y.None=0]="None",y[y.Initialized=1]="Initialized",y[y.Closed=2]="Closed"})(c||(e.StorageState=c={}));class m extends s.$kc{static{this.a=100}constructor(f,v=Object.create(null)){super(),this.r=f,this.s=v,this.b=this.B(new O.$id),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new P.$Eg(m.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((v,b)=>this.w(b,v)),f.deleted?.forEach(v=>this.w(v,void 0))}finally{this.b.resume()}}w(f,v){if(this.c===c.Closed)return;let b=!1;(0,D.$sf)(v)?b=this.f.delete(f):this.f.get(f)!==v&&(this.f.set(f,v),b=!0),b&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,v){const b=this.f.get(f);return(0,D.$sf)(b)?v:b}getBoolean(f,v){const b=this.get(f);return(0,D.$sf)(b)?v:b==="true"}getNumber(f,v){const b=this.get(f);return(0,D.$sf)(b)?v:parseInt(b,10)}getObject(f,v){const b=this.get(f);return(0,D.$sf)(b)?v:(0,M.$0g)(b)}async set(f,v,b=!1){if(this.c===c.Closed)return;if((0,D.$sf)(v))return this.delete(f,b);const d=(0,D.$lf)(v)||Array.isArray(v)?(0,M.$9g)(v):String(v);if(this.f.get(f)!==d)return this.f.set(f,d),this.j.set(f,d),this.h.delete(f),this.b.fire({key:f,external:b}),this.D()}async delete(f,v=!1){if(!(this.c===c.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:v}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$Ro=m;class w{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((v,b)=>this.a.set(b,v)),f.delete?.forEach(v=>this.a.delete(v))}async optimize(){}async close(){}}e.$So=w}),define(te[159],ie([0,1,8,3,33,9,21]),function(K,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nT=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return O.Event.None}static{this.a=2e3}static{this.b=256}constructor(m,w=Object.create(null)){this.g=m,this.h=w,this.c=(0,M.$ae)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const m=await this.f,w=new Map;return(await this.s(m,"SELECT * FROM ItemTable")).forEach(f=>w.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${w.size} rows`),w}async updateItems(m){const w=await this.f;return this.j(w,m)}j(m,w){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${w.insert?(0,s.$xi)(w.insert):"0"}), delete(${w.delete?(0,s.$yi)(w.delete):"0"})`),this.t(m,()=>{const y=w.insert,f=w.delete;if(y&&y.size>0){const v=[];v.push([]);let b=0;y.forEach((d,g)=>{let r=v[b];r.length>S.b&&(b++,r=[],v.push(r)),r.push(g,d)}),v.forEach(d=>{this.u(m,`INSERT INTO ItemTable VALUES ${new Array(d.length/2).fill("(?,?)").join(",")}`,g=>g.run(d),()=>{const g=[];let r=0;return y.forEach(($,E)=>{g.push(E),r+=$.length}),`Keys: ${g.join(", ")} Length: ${r}`})})}if(f&&f.size){const v=[];v.push([]);let b=0;f.forEach(d=>{let g=v[b];g.length>S.b&&(b++,g=[],v.push(g)),g.push(d)}),v.forEach(d=>{this.u(m,`DELETE FROM ItemTable WHERE key IN (${new Array(d.length).fill("?").join(",")})`,g=>g.run(d),()=>{const g=[];return f.forEach(r=>{g.push(r)}),`Keys: ${g.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const m=await this.f;return this.q(m,"VACUUM")}async close(m){this.d.trace(`[storage ${this.c}] close()`);const w=await this.f;return this.k(w,m)}k(m,w){return new Promise((y,f)=>{m.db.close(v=>(v&&this.o(m,`[storage ${this.c}] close(): ${v}`),this.g===S.IN_MEMORY_PATH?y():!m.isErroneous&&!m.isInMemory?this.l().then(y,b=>(this.d.error(`[storage ${this.c}] backup(): ${b}`),y())):typeof w=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(b=>{const d=()=>this.k(b,void 0);return this.j(b,{insert:w()}).then(()=>d(),g=>(d(),Promise.reject(g)))})).then(y,f):f(v||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const m=this.m(this.g);return D.Promises.copy(this.g,m,{preserveSymlinks:!1})}m(m){return`${m}.backup`}async checkIntegrity(m){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${m})`);const w=await this.f,y=await this.r(w,m?"PRAGMA integrity_check":"PRAGMA quick_check"),f=m?y.integrity_check:y.quick_check;return w.isErroneous?`${f} (last error: ${w.lastError})`:w.isInMemory?`${f} (in-memory!)`:f}async n(m,w=!0){this.d.trace(`[storage ${this.c}] open(${m}, retryOnBusy: ${w})`);try{return await this.p(m)}catch(y){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${y}`),y.code==="SQLITE_BUSY"&&w)return await(0,P.$Hg)(S.a),this.n(m,!1);try{await D.Promises.unlink(m);try{await D.Promises.rename(this.m(m),m,!1)}catch{}return await this.p(m)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(S.IN_MEMORY_PATH)}}}o(m,w){m.isErroneous=!0,m.lastError=w,this.d.error(w)}p(m){return new Promise((w,y)=>{new Promise((f,v)=>{K(["@vscode/sqlite3"],f,v)}).then(f=>{const v={db:new(this.d.isTracing?f.verbose().Database:f.Database)(m,b=>b?v.db&&b.code!=="SQLITE_CANTOPEN"?v.db.close(()=>y(b)):y(b):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>w(v),d=>v.db.close(()=>y(d)))),isInMemory:m===S.IN_MEMORY_PATH};v.db.on("error",b=>this.o(v,`[storage ${this.c}] Error (event): ${b}`)),this.d.isTracing&&v.db.on("trace",b=>this.d.trace(`[storage ${this.c}] Trace (event): ${b}`))},y)})}q(m,w){return new Promise((y,f)=>{m.db.exec(w,v=>v?(this.o(m,`[storage ${this.c}] exec(): ${v}`),f(v)):y())})}r(m,w){return new Promise((y,f)=>{m.db.get(w,(v,b)=>v?(this.o(m,`[storage ${this.c}] get(): ${v}`),f(v)):y(b))})}s(m,w){return new Promise((y,f)=>{m.db.all(w,(v,b)=>v?(this.o(m,`[storage ${this.c}] all(): ${v}`),f(v)):y(b))})}t(m,w){return new Promise((y,f)=>{m.db.serialize(()=>{m.db.run("BEGIN TRANSACTION"),w(),m.db.run("END TRANSACTION",v=>v?(this.o(m,`[storage ${this.c}] transaction(): ${v}`),f(v)):y())})})}u(m,w,y,f){const v=m.db.prepare(w),b=d=>{this.o(m,`[storage ${this.c}] prepare(): ${d} (${w}). Details: ${f()}`)};v.on("error",b),y(v),v.finalize(d=>{d&&b(d),v.removeListener("error",b)})}}e.$nT=S;class h{static{this.a="VSCODE_TRACE_STORAGE"}constructor(m){m&&typeof m.logTrace=="function"&&process.env[h.a]&&(this.b=m.logTrace),m&&typeof m.logError=="function"&&(this.c=m.logError)}get isTracing(){return!!this.b}trace(m){this.b?.(m)}error(m){this.c?.(m)}}}),define(te[160],ie([11,10]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(te[161],ie([11,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[162],ie([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/contextkey",e)}),define(te[163],ie([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/scanner",e)}),define(te[164],ie([11,10]),function(K,e){return K.create("vs/platform/dialogs/common/dialogs",e)}),define(te[165],ie([11,10]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[166],ie([11,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(te[167],ie([11,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(te[168],ie([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[169],ie([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[170],ie([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[171],ie([11,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[172],ie([11,10]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[173],ie([11,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(te[174],ie([11,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(te[175],ie([11,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(te[176],ie([11,10]),function(K,e){return K.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[177],ie([11,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[178],ie([11,10]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[179],ie([11,10]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[180],ie([11,10]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[181],ie([11,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(te[182],ie([11,10]),function(K,e){return K.create("vs/platform/shell/node/shellEnv",e)}),define(te[183],ie([11,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[184],ie([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[185],ie([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[186],ie([11,10]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(te[187],ie([11,10]),function(K,e){return K.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[188],ie([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[189],ie([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[190],ie([11,10]),function(K,e){return K.create("vs/platform/workspace/common/workspace",e)}),define(te[191],ie([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[192],ie([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[193],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eU=e.$dU=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.$dU=P;function O(s){return s&&s.hasOwnProperty("workspace")}e.$eU=O}),define(te[194],ie([0,1,7]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L5b=e.$K5b=e.$J5b=void 0;function O(D){return typeof D?.backupFolder=="string"}e.$J5b=O;function s(D){let S=[];try{Array.isArray(D.workspaces)&&(S=D.workspaces.map(h=>({workspace:{id:h.id,configPath:P.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return S}e.$K5b=s;function M(D){let S=[];try{Array.isArray(D.folders)&&(S=D.folders.map(h=>({folderUri:P.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return S}e.$L5b=M}),define(te[195],ie([0,1,14,163]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fi=e.TokenType=void 0;var s;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(s||(e.TokenType=s={}));function M(...c){switch(c.length){case 1:return(0,O.localize)(0,null,c[0]);case 2:return(0,O.localize)(1,null,c[0],c[1]);case 3:return(0,O.localize)(2,null,c[0],c[1],c[2]);default:return}}const D=(0,O.localize)(3,null),S=(0,O.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(m){switch(m.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return m.isTripleEq?"===":"==";case 4:return m.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return m.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return m.lexeme;case 18:return m.lexeme;case 19:return m.lexeme;case 20:return"EOF";default:throw(0,P.$6)(`unhandled token type: ${JSON.stringify(m)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(m=>m.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(m){return this.c=m,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const w=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:w})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const w=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:w})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(m){return this.r()||this.c.charCodeAt(this.e)!==m?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(m){this.f.push({type:m,offset:this.d})}l(m){const w=this.d,y=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:y};this.g.push({offset:w,lexeme:y,additionalInfo:m}),this.f.push(f)}n(){this.m.lastIndex=this.d;const m=this.m.exec(this.c);if(m){this.e=this.d+m[0].length;const w=this.c.substring(this.d,this.e),y=h.b.get(w);y?this.k(y):this.f.push({type:17,lexeme:w,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let m=this.e,w=!1,y=!1;for(;;){if(m>=this.c.length){this.e=m,this.l(S);return}const v=this.c.charCodeAt(m);if(w)w=!1;else if(v===47&&!y){m++;break}else v===91?y=!0:v===92?w=!0:v===93&&(y=!1);m++}for(;m<this.c.length&&h.a.has(this.c.charCodeAt(m));)m++;this.e=m;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$Fi=h}),define(te[196],ie([0,1,3,2]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=e.$Bn=void 0;class s{constructor(){this.a=new P.$fd,this.b=new P.$fd,this.c=new P.$fd,this.d=new P.$fd}static{this.ChannelName="extensionhostdebugservice"}call(S,h,c){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(S,h,c){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Bn=s;class M extends O.$kc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,h,c){this.b.call("attach",[S,h,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,h){this.b.call("terminate",[S,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,h){return this.b.call("openExtensionDevelopmentHostWindow",[S,h])}}e.$Cn=M}),define(te[197],ie([0,1,148,55,13,9,35,19,7]),function(K,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.$8l=void 0,e.$8l=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,M.$_d)(s.$2f.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,M.$9d)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,S.$ig)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$ig)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,P.$7l)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$9d)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$ig)(h.URI.file((0,M.$9d)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$ig)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$ig)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$ig)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=D.env.VSCODE_PORTABLE;return f?h.URI.file((0,M.$9d)(f,"argv.json")):(0,S.$ig)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,M.$9d)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,M.$0d)(f):(0,M.$7d)((0,M.$9d)(s.$2f.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,M.$0d)(f)):h.URI.file((0,M.$9d)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,M.$0d)(f);const v=D.env.VSCODE_EXTENSIONS;if(v)return v;const b=D.env.VSCODE_PORTABLE;return b?(0,M.$9d)(b,"extensions"):(0,S.$ig)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(v=>/^[^:/?#]+?:\/\//.test(v)?h.URI.parse(v):h.URI.file((0,M.$7d)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,M.$7d)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return m(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$8l.test(f))}get extensionLogLevel(){const f=[];for(const v of this.args.log||[]){const b=e.$8l.exec(v);b&&b[1]&&b[2]&&f.push([b[1],b[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,S.$ig)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=D.env.VSCODE_PORTABLE;return f?h.URI.file((0,M.$9d)(f,"policy.json")):(0,S.$ig)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,v,b){this.a=f,this.b=v,this.c=b,this.editSessionId=this.args.editSessionId}}e.$9l=c,ke([O.$6g],c.prototype,"appRoot",null),ke([O.$6g],c.prototype,"userHome",null),ke([O.$6g],c.prototype,"userDataPath",null),ke([O.$6g],c.prototype,"appSettingsHome",null),ke([O.$6g],c.prototype,"tmpDir",null),ke([O.$6g],c.prototype,"cacheHome",null),ke([O.$6g],c.prototype,"stateResource",null),ke([O.$6g],c.prototype,"userRoamingDataHome",null),ke([O.$6g],c.prototype,"userDataSyncHome",null),ke([O.$6g],c.prototype,"sync",null),ke([O.$6g],c.prototype,"machineSettingsResource",null),ke([O.$6g],c.prototype,"workspaceStorageHome",null),ke([O.$6g],c.prototype,"localHistoryHome",null),ke([O.$6g],c.prototype,"keyboardLayoutResource",null),ke([O.$6g],c.prototype,"argvResource",null),ke([O.$6g],c.prototype,"isExtensionDevelopment",null),ke([O.$6g],c.prototype,"untitledWorkspacesHome",null),ke([O.$6g],c.prototype,"builtinExtensionsPath",null),ke([O.$6g],c.prototype,"extensionsPath",null),ke([O.$6g],c.prototype,"extensionDevelopmentLocationURI",null),ke([O.$6g],c.prototype,"extensionDevelopmentKind",null),ke([O.$6g],c.prototype,"extensionTestsLocationURI",null),ke([O.$6g],c.prototype,"debugExtensionHost",null),ke([O.$6g],c.prototype,"logLevel",null),ke([O.$6g],c.prototype,"extensionLogLevel",null),ke([O.$6g],c.prototype,"serviceMachineIdResource",null),ke([O.$6g],c.prototype,"disableTelemetry",null),ke([O.$6g],c.prototype,"disableWorkspaceTrust",null),ke([O.$6g],c.prototype,"useInMemorySecretStorage",null),ke([O.$6g],c.prototype,"policyFile",null);function m(y,f){return w(y["inspect-extensions"],y["inspect-brk-extensions"],5870,f,y.debugId,y.extensionEnvironment)}e.$0l=m;function w(y,f,v,b,d,g){const $=Number(f||y)||(b?null:v),E=$?!!f:!1;let u;if(g)try{u=JSON.parse(g)}catch{}return{port:$,break:E,debugId:d,env:u}}e.$$l=w}),define(te[112],ie([0,1,308,4,166]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=void 0;const M={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$xl=["tunnel","serve-web"],e.$yl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(23,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(24,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(25,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(26,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(27,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(28,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(29,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(30,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(31,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(b,d,g=D){const r=b.find(a=>a.length>0&&a[0]!=="-"),$={},E=["_"],u=[],t={};let l;for(const a in d){const k=d[a];k.type==="subcommand"?a===r&&(l=k):(k.alias&&($[a]=k.alias),k.type==="string"||k.type==="string[]"?(E.push(a),k.deprecates&&E.push(...k.deprecates)):k.type==="boolean"&&(u.push(a),k.deprecates&&u.push(...k.deprecates)),k.global&&(t[a]=k))}if(l&&r){const a=t;for(const p in l.options)a[p]=l.options[p];const k=b.filter(p=>p!==r),I=g.getSubcommandReporter?g.getSubcommandReporter(r):void 0,C=S(k,a,I);return{[r]:C,_:[]}}const o=P(b,{string:E,boolean:u,alias:$}),i={},n=o;i._=o._.map(a=>String(a)).filter(a=>a.length>0),delete n._;for(const a in d){const k=d[a];if(k.type==="subcommand")continue;k.alias&&delete n[k.alias];let I=n[a];if(k.deprecates)for(const C of k.deprecates)n.hasOwnProperty(C)&&(I||(I=n[C],I&&g.onDeprecatedOption(C,k.deprecationMessage||(0,s.localize)(37,null,a))),delete n[C]);if(typeof I<"u"){if(k.type==="string[]"){if(Array.isArray(I)||(I=[I]),!k.allowEmptyValue){const C=I.filter(p=>p.length>0);C.length!==I.length&&(g.onEmptyValue(a),I=C.length>0?C:void 0)}}else k.type==="string"&&(Array.isArray(I)?(I=I.pop(),g.onMultipleValues(a,I)):!I&&!k.allowEmptyValue&&(g.onEmptyValue(a),I=void 0));i[a]=I,k.deprecationMessage&&g.onDeprecatedOption(a,k.deprecationMessage)}delete n[a]}for(const a in n)g.onUnknownOption(a);return i}e.$zl=S;function h(b,d){let g="";return d.args&&(Array.isArray(d.args)?g=` <${d.args.join("> <")}>`:g=` <${d.args}>`),d.alias?`-${d.alias} --${b}${g}`:`--${b}${g}`}function c(b,d){const g=[];for(const r in b){const $=b[r],E=h(r,$);g.push([E,$.description])}return m(g,d)}e.$Al=c;function m(b,d){const r=b.reduce((u,t)=>Math.max(u,t[0].length),12)+2+1;if(d-r<25)return b.reduce((u,t)=>u.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const $=d-r-1,E=[];for(const u of b){const t=u[0],l=y(u[1],$),o=w(r-t.length-2);E.push("  "+t+o+l[0]);for(let i=1;i<l.length;i++)E.push(w(r)+l[i])}return E}function w(b){return" ".repeat(b)}function y(b,d){const g=[];for(;b.length;){const r=b.length<d?b.length:b.lastIndexOf(" ",d),$=b.slice(0,r).trim();b=b.slice(r),g.push($)}return g}function f(b,d,g,r,$){const E=process.stdout.isTTY&&process.stdout.columns||80,u=$?.noInputFiles!==!0?`[${(0,s.localize)(38,null)}...]`:"",t=[`${b} ${g}`];t.push(""),t.push(`${(0,s.localize)(39,null)}: ${d} [${(0,s.localize)(40,null)}]${u}`),t.push(""),$?.noPipe!==!0&&(O.$i?t.push((0,s.localize)(41,null,d)):t.push((0,s.localize)(42,null,d)),t.push(""));const l={},o=[];for(const i in r){const n=r[i];if(n.type==="subcommand")n.description&&o.push({command:i,description:n.description});else if(n.description&&n.cat){let a=l[n.cat];a||(l[n.cat]=a={}),a[i]=n}}for(const i in l){const n=i,a=l[n];a&&(t.push(M[n]),t.push(...c(a,E)),t.push(""))}return o.length&&(t.push((0,s.localize)(43,null)),t.push(...m(o.map(i=>[i.command,i.description]),E)),t.push("")),t.join(`
`)}e.$Bl=f;function v(b,d){return`${b||(0,s.localize)(44,null)}
${d||(0,s.localize)(45,null)}
${process.arch}`}e.$Cl=v}),define(te[198],ie([0,1,87,196,112]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S5b=void 0;class M extends O.$Bn{constructor(S){super(),this.f=S}call(S,h,c){return h==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(S,h,c)}async g(S,h){const c=(0,s.$zl)(S,s.$yl);c.debugRenderer=h;const m=c.extensionDevelopmentPath;if(!m)return{success:!1};const[w]=await this.f.openExtensionDevelopmentHostWindow(m,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!h)return{success:!0};const y=w.win;if(!y)return{success:!0};const f=y.webContents.debugger;let v=f.isAttached()?1/0:0;const b=(0,P.createServer)(d=>{v++===0&&f.attach();let g=!1;const r=u=>{g||d.write(JSON.stringify(u)+"\0")},$=(u,t,l,o)=>r({method:t,params:l,sessionId:o});y.on("close",()=>{f.removeListener("message",$),d.end(),g=!0}),f.addListener("message",$);let E=Buffer.alloc(0);d.on("data",u=>{E=Buffer.concat([E,u]);for(let t=E.indexOf(0);t!==-1;t=E.indexOf(0)){let l;try{const o=E.slice(0,t).toString("utf8");E=E.slice(t+1),l=JSON.parse(o)}catch(o){console.error("error reading cdp line",o)}f.sendCommand(l.method,l.params,l.sessionId).then(o=>r({id:l.id,sessionId:l.sessionId,result:o})).catch(o=>r({id:l.id,sessionId:l.sessionId,error:{code:0,message:o.message}}))}}),d.on("error",u=>{console.error("error on cdp pipe:",u)}),d.on("close",()=>{g=!0,--v===0&&f.detach()})});return await new Promise(d=>b.listen(0,d)),y.on("close",()=>b.close()),{rendererDebugPort:b.address().port,success:!0}}}e.$S5b=M}),define(te[63],ie([0,1,309,167,112]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$El=e.$Dl=void 0;function M(w,y){const f=($,E)=>{console.warn((0,O.localize)(0,null,$,E))},v=$=>{console.warn((0,O.localize)(1,null,$))},b=($,E)=>{console.warn((0,O.localize)(2,null,$,E))},d=$=>({onUnknownOption:E=>{s.$xl.includes($)||console.warn((0,O.localize)(3,null,E,$))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:b,getSubcommandReporter:s.$xl.includes($)?d:void 0}),g={onUnknownOption:$=>{console.warn((0,O.localize)(4,null,$))},onMultipleValues:f,onEmptyValue:v,onDeprecatedOption:b,getSubcommandReporter:d},r=(0,s.$zl)(w,s.$yl,y?g:void 0);return r.goto&&r._.forEach($=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test($),(0,O.localize)(5,null))),r}function D(w){const y=w.findIndex(f=>!/^-/.test(f));if(y>-1)return[...w.slice(0,y),...w.slice(y+1)]}function S(w){let[,...y]=w;process.env.VSCODE_DEV&&(y=D(y)||[]);const f=!m(process.env);return M(y,f)}e.$Dl=S;function h(w){let[,,...y]=w;return process.env.VSCODE_DEV&&(y=D(y)||[]),M(y,!0)}e.$El=h;function c(w,...y){const f=w.indexOf("--");return f===-1?w.push(...y):w.splice(f,0,...y),w}e.$Fl=c;function m(w){return w.VSCODE_CLI==="1"}e.$Gl=m}),function(){"use strict";function K(e,P,O){function s(D,S){const h=M(D,S),c=[h];return e.isAbsolute(h)||c.unshift(O),e.resolve(...c)}function M(D,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,S);const m=D["user-data-dir"];if(m)return m;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(w,"AppData","Roaming")}break;case"darwin":c=e.join(P.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,S)}return{getUserDataPath:s}}if(typeof define=="function")define(te[199],ie([113,27,35]),function(e,P,O){return K(e,P,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=K(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[89],ie([0,1,27,197,199]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=void 0;class M extends O.$9l{constructor(c,m){super(c,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(c,m.nameShort)},m)}}e.$_l=M;function D(h,c){return(0,O.$$l)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,c,h.extensionEnvironment)}e.$am=D;function S(h,c){return(0,O.$$l)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,c,h.extensionEnvironment)}e.$bm=S}),define(te[200],ie([0,1,45,27,32]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j7b=void 0;function M(D){const S=(0,s.$Qf)((0,O.tmpdir)());try{return(0,P.writeFileSync)(S,""),D&&console.log(`Marker file for --wait created: ${S}`),S}catch(h){D&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.$j7b=M}),define(te[201],ie([0,1,12,169]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$np=void 0;function s(D,S,h,c){try{M(D,S,h,c)}catch(m){D.error(m?.message??m)}return S}e.$np=s;function M(D,S,h,c){const m=(w,y,f)=>{const v=w[y];if((0,P.$jf)(v)){const b=v,d=b.length;if(d>1&&b[0]==="%"&&b[d-1]==="%"){const g=b.substr(1,d-2);let r=h[g];r===void 0&&c&&(r=c[g]);const $=typeof r=="string"?r:r?.message,E=c?.[g],u=typeof E=="string"?E:E?.message;if(!$){u||D.warn(`[${S.name}]: ${(0,O.localize)(0,null,g)}`);return}if(f&&(y==="title"||y==="category")&&u&&u!==$){const t={value:$,original:u};w[y]=t}else w[y]=$}}else if((0,P.$lf)(v))for(const b in v)v.hasOwnProperty(b)&&(b==="commands"?m(v,b,!0):m(v,b,f));else if(Array.isArray(v))for(let b=0;b<v.length;b++)m(v,b,f)};for(const w in S)S.hasOwnProperty(w)&&m(S,w)}}),define(te[202],ie([0,1,19,70,171,203]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function h(g){return g=g.trim(),g==="*"||D.test(g)}e.$Bo=h;function c(g){if(!h(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const r=g.match(D);return r?{hasCaret:r[1]==="^",hasGreaterEquals:r[1]===">=",majorBase:r[2]==="x"?0:parseInt(r[2],10),majorMustEqual:r[2]!=="x",minorBase:r[4]==="x"?0:parseInt(r[4],10),minorMustEqual:r[4]!=="x",patchBase:r[6]==="x"?0:parseInt(r[6],10),patchMustEqual:r[6]!=="x",preRelease:r[8]||null}:null}e.$Co=c;function m(g){if(!g)return null;const r=g.majorBase,$=g.majorMustEqual,E=g.minorBase;let u=g.minorMustEqual;const t=g.patchBase;let l=g.patchMustEqual;g.hasCaret&&(r===0||(u=!1),l=!1);let o=0;if(g.preRelease){const i=S.exec(g.preRelease);if(i){const[,n,a,k]=i;o=Date.UTC(Number(n),Number(a)-1,Number(k))}}return{majorBase:r,majorMustEqual:$,minorBase:E,minorMustEqual:u,patchBase:t,patchMustEqual:l,isMinimum:g.hasGreaterEquals,notBefore:o}}e.$Do=m;function w(g,r,$){let E;typeof g=="string"?E=m(c(g)):E=g;let u;r instanceof Date?u=r.getTime():typeof r=="string"&&(u=new Date(r).getTime());let t;if(typeof $=="string"?t=m(c($)):t=$,!E||!t)return!1;const l=E.majorBase,o=E.minorBase,i=E.patchBase;let n=t.majorBase,a=t.minorBase,k=t.patchBase;const I=t.notBefore;let C=t.majorMustEqual,p=t.minorMustEqual,A=t.patchMustEqual;return t.isMinimum?l>n?!0:l<n?!1:o>a?!0:o<a||u&&u<I?!1:i>=k:(l===1&&n===0&&(!C||!p||!A)&&(n=1,a=0,k=0,C=!0,p=!1,A=!1),l<n?!1:l>n?!C:o<a?!1:o>a?!p:i<k?!1:i>k?!A:!(u&&u<I))}e.$Eo=w;function y(g,r,$,E,u){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([O.default.Error,s.localize(0,null)]),t;if(typeof E.name!="string")return t.push([O.default.Error,s.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([O.default.Error,s.localize(2,null,"version")]),t;if(!E.engines)return t.push([O.default.Error,s.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([O.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!d(E.extensionDependencies))return t.push([O.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!d(E.activationEvents))return t.push([O.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([O.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([O.default.Warning,s.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([O.default.Error,s.localize(9,null,"main")]),t;{const i=(0,P.$ig)($,E.main);(0,P.$cg)(i,$)||t.push([O.default.Warning,s.localize(10,null,i.path,$.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([O.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,P.$ig)($,E.browser);(0,P.$cg)(i,$)||t.push([O.default.Warning,s.localize(12,null,i.path,$.path)])}}if(!M.valid(E.version))return t.push([O.default.Error,s.localize(13,null)]),t;const l=[];if(!f(g,r,E,u,l))for(const i of l)t.push([O.default.Error,i]);return t}e.$Fo=y;function f(g,r,$,E,u){return E||typeof $.main>"u"&&typeof $.browser>"u"?!0:b(g,r,$.engines.vscode,u)}e.$Go=f;function v(g,r,$){return g==="*"||b(r,$,g)}e.$Ho=v;function b(g,r,$,E=[]){const u=m(c($));if(!u)return E.push(s.localize(14,null,$)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return E.push(s.localize(15,null,$)),!1}else if(!u.majorMustEqual)return E.push(s.localize(16,null,$)),!1;return w(g,r,u)?!0:(E.push(s.localize(17,null,g,$)),!1)}function d(g){if(!Array.isArray(g))return!1;for(let r=0,$=g.length;r<$;r++)if(typeof g[r]!="string")return!1;return!0}}),define(te[204],ie([0,1,17,31]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=void 0;async function s(M,D,S){let h=S&&S.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const m=(await D.readFile(M.serviceMachineIdResource)).value.toString();h=(0,O.$3f)(m)?m:null}catch{h=null}if(!h){h=(0,O.$4f)();try{await D.writeFile(M.serviceMachineIdResource,P.$Fd.fromString(h))}catch{}}return S?.store("storage.serviceMachineId",h,-1,1),h}e.$2o=s}),define(te[75],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=void 0;class P{constructor(s,M=[],D=!1){this.ctor=s,this.staticArguments=M,this.supportsDelayedInstantiation=D}}e.$yh=P}),define(te[205],ie([0,1,75]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nr=e.$mr=e.InstantiationType=void 0;const O=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function M(S,h,c){h instanceof P.$yh||(h=new P.$yh(h,[],!!c)),O.push([S,h])}e.$mr=M;function D(){return O}e.$nr=D}),define(te[206],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$4p=void 0;class P{constructor(M,D){this.key=M,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$4p=P;class O{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const D of this.a.values())D.outgoing.size===0&&M.push(D);return M}insertEdge(M,D){const S=this.lookupOrInsertNode(M),h=this.lookupOrInsertNode(D);S.outgoing.set(h.key,h),h.incoming.set(S.key,S)}removeNode(M){const D=this.b(M);this.a.delete(D);for(const S of this.a.values())S.outgoing.delete(D),S.incoming.delete(D)}lookupOrInsertNode(M){const D=this.b(M);let S=this.a.get(D);return S||(S=new P(D,M),this.a.set(D,S)),S}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[D,S]of this.a)M.push(`${D}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,D]of this.a){const S=new Set([M]),h=this.c(D,S);if(h)return h}}c(M,D){for(const[S,h]of M.outgoing){if(D.has(S))return[...D,S].join(" -> ");D.add(S);const c=this.c(h,D);if(c)return c;D.delete(S)}}}e.$5p=O}),define(te[6],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=e._util=void 0;var P;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(h){return h[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(P||(e._util=P={})),e.$Ah=s("instantiationService");function O(D,S,h){S[P.DI_TARGET]===S?S[P.DI_DEPENDENCIES].push({id:D,index:h}):(S[P.DI_DEPENDENCIES]=[{id:D,index:h}],S[P.DI_TARGET]=S)}function s(D){if(P.serviceIds.has(D))return P.serviceIds.get(D);const S=function(h,c,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");O(S,h,m)};return S.toString=()=>D,P.serviceIds.set(D,S),S}e.$Bh=s;function M(D){return D}e.$Ch=M}),define(te[64],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M5b=void 0,e.$M5b=(0,P.$Bh)("backupMainService")}),define(te[18],ie([0,1,12,7,6]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.$ei=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.ConfigurationTarget=e.$0h=e.$9h=e.$8h=void 0,e.$8h=(0,s.$Bh)("configurationService");function M(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof O.URI)}e.$9h=M;function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof O.URI)}e.$0h=D;var S;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function h(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$$h=h;function c(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.$_h=c;function m(g,r){const $=Object.create(null);for(const E in g)w($,E,g[E],r);return $}e.$ai=m;function w(g,r,$,E){const u=r.split("."),t=u.pop();let l=g;for(let o=0;o<u.length;o++){const i=u[o];let n=l[i];switch(typeof n){case"undefined":n=l[i]=Object.create(null);break;case"object":break;default:E(`Ignoring ${r} as ${u.slice(0,o+1).join(".")} is ${JSON.stringify(n)}`);return}l=n}if(typeof l=="object"&&l!==null)try{l[t]=$}catch{E(`Ignoring ${r} as ${u.join(".")} is ${JSON.stringify(l)}`)}else E(`Ignoring ${r} as ${u.join(".")} is ${JSON.stringify(l)}`)}e.$bi=w;function y(g,r){const $=r.split(".");f(g,$)}e.$ci=y;function f(g,r){const $=r.shift();if(r.length===0){delete g[$];return}if(Object.keys(g).indexOf($)!==-1){const E=g[$];typeof E=="object"&&!Array.isArray(E)&&(f(E,r),Object.keys(E).length===0&&delete g[$])}}function v(g,r,$){function E(l,o){let i=l;for(const n of o){if(typeof i!="object"||i===null)return;i=i[n]}return i}const u=r.split("."),t=E(g,u);return typeof t>"u"?$:t}e.$di=v;function b(g,r,$){Object.keys(r).forEach(E=>{E!=="__proto__"&&(E in g?P.$lf(g[E])&&P.$lf(r[E])?b(g[E],r[E],$):$&&(g[E]=r[E]):g[E]=r[E])})}e.$ei=b;function d(g){return g.replace(/[\[\]]/g,"")}e.$fi=d}),define(te[114],ie([0,1,4,26,195,6,162,14]),function(K,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.ContextKeyExprType=e.$Gi=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",P.$j),h.set("isLinux",P.$k),h.set("isWindows",P.$i),h.set("isWeb",P.$o),h.set("isMacNative",P.$j&&!P.$o),h.set("isEdge",P.$G),h.set("isFirefox",P.$E),h.set("isChrome",P.$D),h.set("isSafari",P.$F);function c(Y,R){if(h.get(Y)!==void 0)throw(0,S.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(Y,R)}e.$Gi=c;const m=Object.prototype.hasOwnProperty;var w;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const y={regexParsingWithErrorRecovery:!0},f=(0,D.localize)(0,null),v=(0,D.localize)(1,null),b=(0,D.localize)(2,null),d=(0,D.localize)(3,null),g=(0,D.localize)(4,null),r=(0,D.localize)(5,null),$=(0,D.localize)(6,null),E=(0,D.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(R=y){this.k=R,this.d=new s.$Fi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(R){if(R===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(R).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const W=this.D(),T=W.type===17?r:void 0;throw this.h.push({message:g,offset:W.offset,lexeme:s.$Fi.getLexeme(W),additionalInfo:T}),u.c}return j}catch(j){if(j!==u.c)throw j;return}}l(){return this.m()}m(){const R=[this.o()];for(;this.y(16);){const j=this.o();R.push(j)}return R.length===1?R[0]:t.or(...R)}o(){const R=[this.s()];for(;this.y(15);){const j=this.s();R.push(j)}return R.length===1?R[0]:t.and(...R)}s(){if(this.y(2)){const R=this.D();switch(R.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const j=this.l();return this.A(1,d),j?.negate()}case 17:return this.z(),L.create(R.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",R)}}return this.t()}t(){const R=this.D();switch(R.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const j=this.l();return this.A(1,d),j}case 17:{const j=R.lexeme;if(this.z(),this.y(9)){const T=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),T.type!==10)throw this.B("REGEX",T);const H=T.lexeme,B=H.lastIndexOf("/"),ne=B===H.length-1?void 0:this.w(H.substring(B+1));let fe;try{fe=new RegExp(H.substring(1,B),ne)}catch{throw this.B("REGEX",T)}return se.create(j,fe)}switch(T.type){case 10:case 19:{const H=[T.lexeme];this.z();let B=this.D(),ne=0;for(let me=0;me<T.lexeme.length;me++)T.lexeme.charCodeAt(me)===40?ne++:T.lexeme.charCodeAt(me)===41&&ne--;for(;!this.E()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:ne++;break;case 1:ne--;break;case 10:case 18:for(let me=0;me<B.lexeme.length;me++)B.lexeme.charCodeAt(me)===40?ne++:T.lexeme.charCodeAt(me)===41&&ne--}if(ne<0)break;H.push(s.$Fi.getLexeme(B)),this.z(),B=this.D()}const fe=H.join(""),ge=fe.lastIndexOf("/"),ue=ge===fe.length-1?void 0:this.w(fe.substring(ge+1));let we;try{we=new RegExp(fe.substring(1,ge),ue)}catch{throw this.B("REGEX",T)}return t.regex(j,we)}case 18:{const H=T.lexeme;this.z();let B=null;if(!(0,O.$me)(H)){const ne=H.indexOf("/"),fe=H.lastIndexOf("/");if(ne!==fe&&ne>=0){const ge=H.slice(ne+1,fe),ue=H[fe+1]==="i"?"i":"";try{B=new RegExp(ge,ue)}catch{throw this.B("REGEX",T)}}}if(B===null)throw this.B("REGEX",T);return se.create(j,B)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const T=this.u();return t.notIn(j,T)}switch(this.D().type){case 3:{this.z();const T=this.u();if(this.x().type===18)return t.equals(j,T);switch(T){case"true":return t.has(j);case"false":return t.not(j);default:return t.equals(j,T)}}case 4:{this.z();const T=this.u();if(this.x().type===18)return t.notEquals(j,T);switch(T){case"true":return t.not(j);case"false":return t.has(j);default:return t.notEquals(j,T)}}case 5:return this.z(),ee.create(j,this.u());case 6:return this.z(),ae.create(j,this.u());case 7:return this.z(),z.create(j,this.u());case 8:return this.z(),re.create(j,this.u());case 13:return this.z(),t.in(j,this.u());default:return t.has(j)}}case 20:throw this.h.push({message:$,offset:R.offset,lexeme:"",additionalInfo:E}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const R=this.D();switch(R.type){case 17:case 18:return this.z(),R.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(R){return R.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(R){return this.C(R)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(R,j){if(this.C(R))return this.z();throw this.B(j,this.D())}B(R,j,W){const T=(0,D.localize)(8,null,R,s.$Fi.getLexeme(j)),H=j.offset,B=s.$Fi.getLexeme(j);return this.h.push({message:T,offset:H,lexeme:B,additionalInfo:W}),u.c}C(R){return this.D().type===R}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Hi=u;class t{static false(){return n.INSTANCE}static true(){return a.INSTANCE}static has(R){return k.create(R)}static equals(R,j){return I.create(R,j)}static notEquals(R,j){return A.create(R,j)}static regex(R,j){return se.create(R,j)}static in(R,j){return C.create(R,j)}static notIn(R,j){return p.create(R,j)}static not(R){return L.create(R)}static and(...R){return J.create(R,null,!0)}static or(...R){return q.create(R,null,!0)}static greater(R,j){return z.create(R,j)}static greaterEquals(R,j){return re.create(R,j)}static smaller(R,j){return ee.create(R,j)}static smallerEquals(R,j){return ae.create(R,j)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(R){return R==null?void 0:this.c.parse(R)}}e.$Ii=t;function l(Y){const R=new u({regexParsingWithErrorRecovery:!1});return Y.map(j=>(R.parse(j),R.lexingErrors.length>0?R.lexingErrors.map(W=>({errorMessage:W.additionalInfo?(0,D.localize)(9,null,W.additionalInfo):(0,D.localize)(10,null),offset:W.offset,length:W.lexeme.length})):R.parsingErrors.length>0?R.parsingErrors.map(W=>({errorMessage:W.additionalInfo?`${W.message}. ${W.additionalInfo}`:W.message,offset:W.offset,length:W.lexeme.length})):[]))}e.$Ji=l;function o(Y,R){const j=Y?Y.substituteConstants():void 0,W=R?R.substituteConstants():void 0;return!j&&!W?!0:!j||!W?!1:j.equals(W)}e.$Ki=o;function i(Y,R){return Y.cmp(R)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!1}serialize(){return"false"}keys(){return[]}map(R){return this}negate(){return a.INSTANCE}}e.$Li=n;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(R){return this.type-R.type}equals(R){return R.type===this.type}substituteConstants(){return this}evaluate(R){return!0}serialize(){return"true"}keys(){return[]}map(R){return this}negate(){return n.INSTANCE}}e.$Mi=a;class k{static create(R,j=null){const W=h.get(R);return typeof W=="boolean"?W?a.INSTANCE:n.INSTANCE:new k(R,j)}constructor(R,j){this.key=R,this.c=j,this.type=2}cmp(R){return R.type!==this.type?this.type-R.type:N(this.key,R.key)}equals(R){return R.type===this.type?this.key===R.key:!1}substituteConstants(){const R=h.get(this.key);return typeof R=="boolean"?R?a.INSTANCE:n.INSTANCE:this}evaluate(R){return!!R.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(R){return R.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$Ni=k;class I{static create(R,j,W=null){if(typeof j=="boolean")return j?k.create(R,W):L.create(R,W);const T=h.get(R);return typeof T=="boolean"?j===(T?"true":"false")?a.INSTANCE:n.INSTANCE:new I(R,j,W)}constructor(R,j,W){this.c=R,this.d=j,this.f=W,this.type=4}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=h.get(this.c);if(typeof R=="boolean"){const j=R?"true":"false";return this.d===j?a.INSTANCE:n.INSTANCE}return this}evaluate(R){return R.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(R){return R.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Oi=I;class C{static create(R,j){return new C(R,j)}constructor(R,j){this.d=R,this.f=j,this.type=10,this.c=null}cmp(R){return R.type!==this.type?this.type-R.type:V(this.d,this.f,R.d,R.f)}equals(R){return R.type===this.type?this.d===R.d&&this.f===R.f:!1}substituteConstants(){return this}evaluate(R){const j=R.getValue(this.f),W=R.getValue(this.d);return Array.isArray(j)?j.includes(W):typeof W=="string"&&typeof j=="object"&&j!==null?m.call(j,W):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(R){return R.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$Pi=C;class p{static create(R,j){return new p(R,j)}constructor(R,j){this.d=R,this.f=j,this.type=11,this.c=C.create(R,j)}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(R){return R.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Qi=p;class A{static create(R,j,W=null){if(typeof j=="boolean")return j?L.create(R,W):k.create(R,W);const T=h.get(R);return typeof T=="boolean"?j===(T?"true":"false")?n.INSTANCE:a.INSTANCE:new A(R,j,W)}constructor(R,j,W){this.c=R,this.d=j,this.f=W,this.type=5}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){const R=h.get(this.c);if(typeof R=="boolean"){const j=R?"true":"false";return this.d===j?n.INSTANCE:a.INSTANCE}return this}evaluate(R){return R.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(R){return R.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$Ri=A;class L{static create(R,j=null){const W=h.get(R);return typeof W=="boolean"?W?n.INSTANCE:a.INSTANCE:new L(R,j)}constructor(R,j){this.c=R,this.d=j,this.type=3}cmp(R){return R.type!==this.type?this.type-R.type:N(this.c,R.c)}equals(R){return R.type===this.type?this.c===R.c:!1}substituteConstants(){const R=h.get(this.c);return typeof R=="boolean"?R?n.INSTANCE:a.INSTANCE:this}evaluate(R){return!R.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(R){return R.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$Si=L;function U(Y,R){if(typeof Y=="string"){const j=parseFloat(Y);isNaN(j)||(Y=j)}return typeof Y=="string"||typeof Y=="number"?R(Y):n.INSTANCE}class z{static create(R,j,W=null){return U(j,T=>new z(R,T,W))}constructor(R,j,W){this.c=R,this.d=j,this.f=W,this.type=12}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Ti=z;class re{static create(R,j,W=null){return U(j,T=>new re(R,T,W))}constructor(R,j,W){this.c=R,this.d=j,this.f=W,this.type=13}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(R){return R.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$Ui=re;class ee{static create(R,j,W=null){return U(j,T=>new ee(R,T,W))}constructor(R,j,W){this.c=R,this.d=j,this.f=W,this.type=14}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Vi=ee;class ae{static create(R,j,W=null){return U(j,T=>new ae(R,T,W))}constructor(R,j,W){this.c=R,this.d=j,this.f=W,this.type=15}cmp(R){return R.type!==this.type?this.type-R.type:V(this.c,this.d,R.c,R.d)}equals(R){return R.type===this.type?this.c===R.c&&this.d===R.d:!1}substituteConstants(){return this}evaluate(R){return typeof this.d=="string"?!1:parseFloat(R.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(R){return R.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Wi=ae;class se{static create(R,j){return new se(R,j)}constructor(R,j){this.d=R,this.f=j,this.type=7,this.c=null}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.d<R.d)return-1;if(this.d>R.d)return 1;const j=this.f?this.f.source:"",W=R.f?R.f.source:"";return j<W?-1:j>W?1:0}equals(R){if(R.type===this.type){const j=this.f?this.f.source:"",W=R.f?R.f.source:"";return this.d===R.d&&j===W}return!1}substituteConstants(){return this}evaluate(R){const j=R.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const R=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${R}`}keys(){return[this.d]}map(R){return R.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=oe.create(this)),this.c}}e.$Xi=se;class oe{static create(R){return new oe(R)}constructor(R){this.c=R,this.type=8}cmp(R){return R.type!==this.type?this.type-R.type:this.c.cmp(R.c)}equals(R){return R.type===this.type?this.c.equals(R.c):!1}substituteConstants(){return this}evaluate(R){return!this.c.evaluate(R)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(R){return new oe(this.c.map(R))}negate(){return this.c}}e.$Yi=oe;function G(Y){let R=null;for(let j=0,W=Y.length;j<W;j++){const T=Y[j].substituteConstants();if(Y[j]!==T&&R===null){R=[];for(let H=0;H<j;H++)R[H]=Y[H]}R!==null&&(R[j]=T)}return R===null?Y:R}class J{static create(R,j,W){return J.d(R,j,W)}constructor(R,j){this.expr=R,this.c=j,this.type=6}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let j=0,W=this.expr.length;j<W;j++){const T=i(this.expr[j],R.expr[j]);if(T!==0)return T}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let j=0,W=this.expr.length;j<W;j++)if(!this.expr[j].equals(R.expr[j]))return!1;return!0}return!1}substituteConstants(){const R=G(this.expr);return R===this.expr?this:J.create(R,this.c,!1)}evaluate(R){for(let j=0,W=this.expr.length;j<W;j++)if(!this.expr[j].evaluate(R))return!1;return!0}static d(R,j,W){const T=[];let H=!1;for(const B of R)if(B){if(B.type===1){H=!0;continue}if(B.type===0)return n.INSTANCE;if(B.type===6){T.push(...B.expr);continue}T.push(B)}if(T.length===0&&H)return a.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];T.sort(i);for(let B=1;B<T.length;B++)T[B-1].equals(T[B])&&(T.splice(B,1),B--);if(T.length===1)return T[0];for(;T.length>1;){const B=T[T.length-1];if(B.type!==9)break;T.pop();const ne=T.pop(),fe=T.length===0,ge=q.create(B.expr.map(ue=>J.create([ue,ne],null,W)),null,fe);ge&&(T.push(ge),T.sort(i))}if(T.length===1)return T[0];if(W){for(let B=0;B<T.length;B++)for(let ne=B+1;ne<T.length;ne++)if(T[B].negate().equals(T[ne]))return n.INSTANCE;if(T.length===1)return T[0]}return new J(T,j)}}serialize(){return this.expr.map(R=>R.serialize()).join(" && ")}keys(){const R=[];for(const j of this.expr)R.push(...j.keys());return R}map(R){return new J(this.expr.map(j=>j.map(R)),null)}negate(){if(!this.c){const R=[];for(const j of this.expr)R.push(j.negate());this.c=q.create(R,this,!0)}return this.c}}e.$Zi=J;class q{static create(R,j,W){return q.d(R,j,W)}constructor(R,j){this.expr=R,this.c=j,this.type=9}cmp(R){if(R.type!==this.type)return this.type-R.type;if(this.expr.length<R.expr.length)return-1;if(this.expr.length>R.expr.length)return 1;for(let j=0,W=this.expr.length;j<W;j++){const T=i(this.expr[j],R.expr[j]);if(T!==0)return T}return 0}equals(R){if(R.type===this.type){if(this.expr.length!==R.expr.length)return!1;for(let j=0,W=this.expr.length;j<W;j++)if(!this.expr[j].equals(R.expr[j]))return!1;return!0}return!1}substituteConstants(){const R=G(this.expr);return R===this.expr?this:q.create(R,this.c,!1)}evaluate(R){for(let j=0,W=this.expr.length;j<W;j++)if(this.expr[j].evaluate(R))return!0;return!1}static d(R,j,W){let T=[],H=!1;if(R){for(let B=0,ne=R.length;B<ne;B++){const fe=R[B];if(fe){if(fe.type===0){H=!0;continue}if(fe.type===1)return a.INSTANCE;if(fe.type===9){T=T.concat(fe.expr);continue}T.push(fe)}}if(T.length===0&&H)return n.INSTANCE;T.sort(i)}if(T.length!==0){if(T.length===1)return T[0];for(let B=1;B<T.length;B++)T[B-1].equals(T[B])&&(T.splice(B,1),B--);if(T.length===1)return T[0];if(W){for(let B=0;B<T.length;B++)for(let ne=B+1;ne<T.length;ne++)if(T[B].negate().equals(T[ne]))return a.INSTANCE;if(T.length===1)return T[0]}return new q(T,j)}}serialize(){return this.expr.map(R=>R.serialize()).join(" || ")}keys(){const R=[];for(const j of this.expr)R.push(...j.keys());return R}map(R){return new q(this.expr.map(j=>j.map(R)),null)}negate(){if(!this.c){const R=[];for(const j of this.expr)R.push(j.negate());for(;R.length>1;){const j=R.shift(),W=R.shift(),T=[];for(const H of ce(j))for(const B of ce(W))T.push(J.create([H,B],null,!1));R.unshift(q.create(T,null,!1))}this.c=q.create(R,this,!0)}return this.c}}e.$1i=q;class F extends k{static{this.d=[]}static all(){return F.d.values()}constructor(R,j,W){super(R,null),this.f=j,typeof W=="object"?F.d.push({...W,key:R}):W!==!0&&F.d.push({key:R,description:W,type:j!=null?typeof j:void 0})}bindTo(R){return R.createKey(this.key,this.f)}getValue(R){return R.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(R){return I.create(this.key,R)}notEqualsTo(R){return A.create(this.key,R)}}e.$2i=F,e.$3i=(0,M.$Bh)("contextKeyService");function N(Y,R){return Y<R?-1:Y>R?1:0}function V(Y,R,j,W){return Y<j?-1:Y>j?1:R<W?-1:R>W?1:0}function Q(Y,R){if(Y.type===0||R.type===1)return!0;if(Y.type===9)return R.type===9?x(Y.expr,R.expr):!1;if(R.type===9){for(const j of R.expr)if(Q(Y,j))return!0;return!1}if(Y.type===6){if(R.type===6)return x(R.expr,Y.expr);for(const j of Y.expr)if(Q(j,R))return!0;return!1}return Y.equals(R)}e.$4i=Q;function x(Y,R){let j=0,W=0;for(;j<Y.length&&W<R.length;){const T=Y[j].cmp(R[W]);if(T<0)return!1;T===0&&j++,W++}return j===Y.length}function ce(Y){return Y.type===9?Y.expr:[Y]}}),define(te[90],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$im=e.$hm=e.$gm=e.ID=void 0,e.ID="diagnosticsService",e.$gm=(0,P.$Bh)(e.ID);function O(M){return!!M.hostName&&!!M.errorMessage}e.$hm=O;class s{async getPerformanceInfo(D,S){return{}}async getSystemInfo(D,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,S){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$im=s}),define(te[91],ie([0,1,19,70,164,6,46,4,37]),function(K,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vv=e.$uv=e.ConfirmResult=e.$tv=e.$sv=e.$rv=void 0,e.$rv=(0,M.$Bh)("dialogService");var c;(function(b){b[b.Confirmation=1]="Confirmation",b[b.Prompt=2]="Prompt",b[b.Input=3]="Input"})(c||(c={}));class m{a(d){return this.d(d,c.Confirmation)}b(d){return this.d(d,c.Prompt)}c(d){return this.d(d,c.Input)}d(d,g){const r=[];switch(g){case c.Confirmation:{const $=d;$.primaryButton?r.push($.primaryButton):r.push((0,s.localize)(0,null)),$.cancelButton?r.push($.cancelButton):r.push((0,s.localize)(1,null));break}case c.Prompt:{const $=d;Array.isArray($.buttons)&&$.buttons.length>0&&r.push(...$.buttons.map(E=>E.label)),$.cancelButton&&($.cancelButton===!0?r.push((0,s.localize)(2,null)):typeof $.cancelButton=="string"?r.push($.cancelButton):$.cancelButton.label?r.push($.cancelButton.label):r.push((0,s.localize)(3,null))),r.length===0&&r.push((0,s.localize)(4,null));break}case c.Input:{const $=d;$.primaryButton?r.push($.primaryButton):r.push((0,s.localize)(5,null)),$.cancelButton?r.push($.cancelButton):r.push((0,s.localize)(6,null));break}}return r}e(d){if(typeof d=="string")return d;if(typeof d=="number")return d===O.default.Info?"info":d===O.default.Error?"error":d===O.default.Warning?"warning":"none"}async f(d,g,r){const $=[...d.buttons??[]];return d.cancelButton&&typeof d.cancelButton!="string"&&typeof d.cancelButton!="boolean"&&$.push(d.cancelButton),{result:await $[g]?.run({checkboxChecked:r}),checkboxChecked:r}}}e.$sv=m,e.$tv=(0,M.$Bh)("fileDialogService");var w;(function(b){b[b.SAVE=0]="SAVE",b[b.DONT_SAVE=1]="DONT_SAVE",b[b.CANCEL=2]="CANCEL"})(w||(e.ConfirmResult=w={}));const y=10;function f(b){const d=[];return d.push(...b.slice(0,y).map(g=>typeof g=="string"?g:(0,P.$fg)(g))),b.length>y&&(b.length-y===1?d.push((0,s.localize)(7,null)):d.push((0,s.localize)(8,null,b.length-y))),d.push(""),d.join(`
`)}e.$uv=f;function v(b,d){const g=(0,h.$Vm)(b);let r=(g.buttons??[]).map(t=>(0,D.$ov)(t)),$=(b.buttons||[]).map((t,l)=>l),E=0,u=g.cancelId??r.length-1;if(r.length>1){const t=typeof u=="number"?r[u]:void 0;if(S.$k||S.$j){if(typeof t=="string"&&r.length>1&&u!==1){r.splice(u,1),r.splice(1,0,t);const l=$[u];$.splice(u,1),$.splice(1,0,l),u=1}S.$k&&r.length>1&&(r=r.reverse(),$=$.reverse(),E=r.length-1,typeof t=="string"&&(u=E-1))}else if(S.$i&&typeof t=="string"&&r.length>1&&u!==r.length-1){r.splice(u,1),r.push(t);const l=$[u];$.splice(u,1),$.push(l),u=r.length-1}}return g.buttons=r,g.defaultId=E,g.cancelId=u,g.noLink=!0,g.title=g.title||d.nameLong,{options:g,buttonIndeces:$}}e.$vv=v}),define(te[115],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ET=e.$DT=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$CT=e.$BT=void 0,e.$BT=(0,P.$Bh)("encryptionService"),e.$CT=(0,P.$Bh)("encryptionMainService");var O;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(O||(e.PasswordStoreCLIOption=O={}));var s;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function M(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$DT=M;function D(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$ET=D}),define(te[36],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jh=e.$Ih=void 0,e.$Ih=(0,P.$Bh)("environmentService"),e.$Jh=(0,P.$Ch)(e.$Ih)}),define(te[116],ie([0,1,168,6]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Zn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=void 0,e.$Mn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Nn=new RegExp(e.$Mn),e.$On="__web_extension",e.$Pn="skipWalkthrough",e.$Qn="extensionsSync",e.$Rn="dependecyOrPackExtensionInstall";function s(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Sn=s;function M(r){switch(r){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Tn=M;function D(r,$){switch(r){case 3:return $==="x64"?"win32-x64":$==="ia32"?"win32-ia32":$==="arm64"?"win32-arm64":"unknown";case 2:return $==="x64"?"linux-x64":$==="arm64"?"linux-arm64":$==="arm"?"linux-armhf":"unknown";case"alpine":return $==="x64"?"alpine-x64":$==="arm64"?"alpine-arm64":"unknown";case 1:return $==="x64"?"darwin-x64":$==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$Un=D;function S(r,$){return $==="web"&&!r.includes("web")}e.$Vn=S;function h(r,$,E){return S($,E)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===E?!0:c(E).includes(r)}e.$Wn=h;function c(r){switch(r){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Xn=c;function m(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$Yn=m;var w;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var y;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var f;(function(r){r.Install="install",r.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var v;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$Zn=(0,O.$Bh)("extensionGalleryService");var b;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.Extract="Extract",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var d;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(d||(e.ExtensionSignaturetErrorCode=d={}));class g extends Error{constructor($,E){super($),this.code=E,this.name=E}}e.$1n=g,e.$2n=(0,O.$Bh)("extensionManagementService"),e.$3n="extensionsIdentifiers/disabled",e.$4n="extensionsIdentifiers/enabled",e.$5n=(0,O.$Bh)("IGlobalExtensionEnablementService"),e.$6n=(0,O.$Bh)("IExtensionTipsService"),e.$7n=(0,P.localize)(0,null),e.$8n={value:e.$7n,original:"Extensions"},e.$9n={value:(0,P.localize)(1,null),original:"Preferences"}}),define(te[207],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9kb=void 0,e.$9kb=(0,P.$Bh)("extensionUrlTrustService")}),define(te[208],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$95b=e.$85b=void 0,e.$85b=(0,P.$Bh)("extensionHostStarter"),e.$95b="extensionHostStarter"}),define(te[209],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qXb=e.$pXb=void 0,e.$pXb=(0,P.$Bh)("externalTerminal"),e.$qXb="Terminal.app"}),define(te[210],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$5b=void 0,e.$$5b=(0,P.$Bh)("externalTerminal")}),define(te[211],ie([0,1,47,13,9,4,73,21,88,172,209]),function(K,e,P,O,s,M,D,S,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b6b=e.$a6b=e.$_5b=void 0;const w=c.localize(0,null);class y{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await b.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends y{static{this.b="cmd.exe"}openTerminal(E,u){return this.spawnTerminal(P,E,h.$ul(),u)}spawnTerminal(E,u,t,l){const o=u.windowsExec||f.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=s.$ae(o,".exe").toLowerCase();if(i==="cmder")return E.spawn(o,l?[l]:void 0),Promise.resolve(void 0);const n=["/c","start","/wait"];return o.indexOf(" ")>=0&&n.push('""'),n.push(o),i==="wt"&&n.push("-d ."),new Promise((a,k)=>{const I=d(process),C=E.spawn(t,n,{cwd:l,env:I});C.on("error",k),C.on("exit",()=>a())})}runInTerminal(E,u,t,l,o){const i="windowsExec"in o&&o.windowsExec?o.windowsExec:f.getDefaultTerminalWindows();return new Promise((n,a)=>{const k=`"${u} - ${w}"`,I=`""${t.join('" "')}" & pause"`,C=Object.assign({},d(process),l);Object.keys(C).filter(z=>C[z]===null).forEach(z=>delete C[z]);const p={cwd:u,env:C,windowsVerbatimArguments:!0};let A,L;s.$ae(i,".exe")==="wt"?(A=i,L=["-d",".",f.b,"/c",I]):(A=f.b,L=["/c","start",k,"/wait",i,"/c",I]),P.spawn(A,L,p).on("error",z=>{a(g(z))}),n(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const E=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${E?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.$_5b=f;class v extends y{static{this.b="/usr/bin/osascript"}openTerminal(E,u){return this.spawnTerminal(P,E,u)}runInTerminal(E,u,t,l,o){const i=o.osxExec||m.$qXb;return new Promise((n,a)=>{if(i===m.$qXb||i==="iTerm.app"){const k=i===m.$qXb?"TerminalHelper":"iTermHelper",C=[O.$2f.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",E||w,"-w",u];for(const L of t)C.push("-a"),C.push(L);if(l){const L=Object.assign({},d(process),l);for(const U in L){const z=L[U];z===null?(C.push("-u"),C.push(U)):(C.push("-e"),C.push(`${U}=${z}`))}}let p="";const A=P.spawn(v.b,C);A.on("error",L=>{a(g(L))}),A.stderr.on("data",L=>{p+=L.toString()}),A.on("exit",L=>{if(L===0)n(void 0);else if(p){const U=p.split(`
`,1);a(new Error(U[0]))}else a(new Error(c.localize(1,null,k,L)))})}else a(new Error(c.localize(2,null,i)))})}spawnTerminal(E,u,t){const l=u.osxExec||m.$qXb;return new Promise((o,i)=>{const n=["-a",l];t&&n.push(t);const a=d(process),k=E.spawn("/usr/bin/open",n,{cwd:t,env:a});k.on("error",i),k.on("exit",()=>o())})}}e.$a6b=v;class b extends y{static{this.b=c.localize(3,null)}openTerminal(E,u){return this.spawnTerminal(P,E,u)}runInTerminal(E,u,t,l,o){const i=o.linuxExec?Promise.resolve(o.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((n,a)=>{const k=[];i.then(I=>{I.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const C=`${r(t)}; echo; read -p "${b.b}" -n1;`;k.push(`''${C}''`);const p=Object.assign({},d(process),l);Object.keys(p).filter(z=>p[z]===null).forEach(z=>delete p[z]);const A={cwd:u,env:p};let L="";const U=P.spawn(I,k,A);U.on("error",z=>{a(g(z))}),U.stderr.on("data",z=>{L+=z.toString()}),U.on("exit",z=>{if(z===0)n(void 0);else if(L){const re=L.split(`
`,1);a(new Error(re[0]))}else a(new Error(c.localize(4,null,I,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!b.d)if(!M.$k)b.d=Promise.resolve("xterm");else{const E=await S.Promises.exists("/etc/debian_version");b.d=new Promise(u=>{E?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return b.d}spawnTerminal(E,u,t){const l=u.linuxExec?Promise.resolve(u.linuxExec):b.getDefaultTerminalLinuxReady();return new Promise((o,i)=>{l.then(n=>{const a=d(process),k=E.spawn(n,[],{cwd:t,env:a});k.on("error",i),k.on("exit",()=>o())})})}}e.$b6b=b;function d($){const E={...$.env};return(0,D.$sl)(E),E}function g($){return"errno"in $&&$.errno==="ENOENT"&&"path"in $&&typeof $.path=="string"?new Error(c.localize(5,null,$.path)):$}function r($){let E="";for(const u of $)u.indexOf(" ")>=0?E+='"'+u+'"':E+=u,E+=" ";return E}}),define(te[16],ie([0,1,57,9,26,12,7,174,6,4,13]),function(K,e,P,O,s,M,D,S,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.FileKind=e.$wk=e.$vk=e.$uk=e.$tk=e.$sk=e.$rk=e.$qk=e.FileOperationResult=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileChangeType=e.$kk=e.FileOperation=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.FileSystemProviderErrorCode=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$7j=e.$6j=void 0,e.$6j=(0,h.$Bh)("fileService");function w(N){return N.create===!0}e.$7j=w;var y;(function(N){N[N.Unknown=0]="Unknown",N[N.File=1]="File",N[N.Directory=2]="Directory",N[N.SymbolicLink=64]="SymbolicLink"})(y||(e.FileType=y={}));var f;(function(N){N[N.Readonly=1]="Readonly",N[N.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var v;(function(N){N[N.None=0]="None",N[N.FileReadWrite=2]="FileReadWrite",N[N.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",N[N.FileReadStream=16]="FileReadStream",N[N.FileFolderCopy=8]="FileFolderCopy",N[N.PathCaseSensitive=1024]="PathCaseSensitive",N[N.Readonly=2048]="Readonly",N[N.Trash=4096]="Trash",N[N.FileWriteUnlock=8192]="FileWriteUnlock",N[N.FileAtomicRead=16384]="FileAtomicRead",N[N.FileAtomicWrite=32768]="FileAtomicWrite",N[N.FileAtomicDelete=65536]="FileAtomicDelete",N[N.FileClone=131072]="FileClone"})(v||(e.FileSystemProviderCapabilities=v={}));function b(N){return!!(N.capabilities&2)}e.$8j=b;function d(N){return!!(N.capabilities&8)}e.$9j=d;function g(N){return!!(N.capabilities&131072)}e.$0j=g;function r(N){return!!(N.capabilities&4)}e.$$j=r;function $(N){return!!(N.capabilities&16)}e.$_j=$;function E(N){return b(N)?!!(N.capabilities&16384):!1}e.$ak=E;function u(N){return b(N)?!!(N.capabilities&32768):!1}e.$bk=u;function t(N){return!!(N.capabilities&65536)}e.$ck=t;function l(N){return!!(N.capabilities&2048)}e.$dk=l;var o;(function(N){N.FileExists="EntryExists",N.FileNotFound="EntryNotFound",N.FileNotADirectory="EntryNotADirectory",N.FileIsADirectory="EntryIsADirectory",N.FileExceedsStorageQuota="EntryExceedsStorageQuota",N.FileTooLarge="EntryTooLarge",N.FileWriteLocked="EntryWriteLocked",N.NoPermissions="NoPermissions",N.Unavailable="Unavailable",N.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class i extends Error{static create(V,Q){const x=new i(V.toString(),Q);return k(x,Q),x}constructor(V,Q){super(V),this.code=Q}}e.$ek=i;function n(N,V){return i.create(N,V)}e.$fk=n;function a(N){return N||n((0,S.localize)(0,null),o.Unknown)}e.$gk=a;function k(N,V){return N.name=V?`${V} (FileSystemError)`:"FileSystemError",N}e.$hk=k;function I(N){if(!N)return o.Unknown;if(N instanceof i)return N.code;const V=/^(.+) \(FileSystemError\)$/.exec(N.name);if(!V)return o.Unknown;switch(V[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}e.$ik=I;function C(N){if(N instanceof re)return N.fileOperationResult;switch(I(N)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}e.$jk=C;var p;(function(N){N[N.CREATE=0]="CREATE",N[N.DELETE=1]="DELETE",N[N.MOVE=2]="MOVE",N[N.COPY=3]="COPY",N[N.WRITE=4]="WRITE"})(p||(e.FileOperation=p={}));class A{constructor(V,Q,x){this.resource=V,this.operation=Q,this.target=x}isOperation(V){return this.operation===V}}e.$kk=A;var L;(function(N){N[N.UPDATED=0]="UPDATED",N[N.ADDED=1]="ADDED",N[N.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class U{constructor(V,Q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const x=new Map;for(const ce of V){const Y=x.get(ce.type);switch(Y?Y.push([ce.resource,ce]):x.set(ce.type,[[ce.resource,ce]]),ce.type){case 1:this.rawAdded.push(ce.resource);break;case 0:this.rawUpdated.push(ce.resource);break;case 2:this.rawDeleted.push(ce.resource);break}}for(const[ce,Y]of x)switch(ce){case 1:this.a=P.$Hh.forUris(()=>Q),this.a.fill(Y);break;case 0:this.b=P.$Hh.forUris(()=>Q),this.b.fill(Y);break;case 2:this.c=P.$Hh.forUris(()=>Q),this.c.fill(Y);break}}contains(V,...Q){return this.d(V,{includeChildren:!1},...Q)}affects(V,...Q){return this.d(V,{includeChildren:!0},...Q)}d(V,Q,...x){if(!V)return!1;const ce=x.length>0;return!!((!ce||x.includes(1))&&(this.a?.get(V)||Q.includeChildren&&this.a?.findSuperstr(V))||(!ce||x.includes(0))&&(this.b?.get(V)||Q.includeChildren&&this.b?.findSuperstr(V))||(!ce||x.includes(2))&&(this.c?.findSubstr(V)||Q.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$lk=U;function z(N,V,Q){return!N||!V||N===V||V.length>N.length?!1:(V.charAt(V.length-1)!==O.sep&&(V+=O.sep),Q?(0,s.$Ne)(N,V):N.indexOf(V)===0)}e.$mk=z;class re extends Error{constructor(V,Q,x){super(V),this.fileOperationResult=Q,this.options=x}}e.$nk=re;class ee extends re{constructor(V,Q,x,ce){super(V,Q,ce),this.fileOperationResult=Q,this.size=x}}e.$ok=ee;class ae extends re{constructor(V,Q,x){super(V,2,x),this.stat=Q}}e.$pk=ae;var se;(function(N){N[N.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",N[N.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",N[N.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",N[N.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",N[N.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",N[N.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",N[N.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",N[N.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",N[N.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",N[N.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",N[N.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(se||(e.FileOperationResult=se={})),e.$qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sk="files.associations",e.$tk="files.exclude",e.$uk="files.readonlyInclude",e.$vk="files.readonlyExclude",e.$wk="files.readonlyFromPermissions";var oe;(function(N){N[N.FILE=0]="FILE",N[N.FOLDER=1]="FOLDER",N[N.ROOT_FOLDER=2]="ROOT_FOLDER"})(oe||(e.FileKind=oe={})),e.$xk="";function G(N){if(!(typeof N.size!="number"||typeof N.mtime!="number"))return N.mtime.toString(29)+N.size.toString(31)}e.$yk=G;async function J(N,V){if(!V.hasProvider(D.URI.from({scheme:N.scheme})))return new Promise(Q=>{const x=V.onDidChangeFileSystemProviderRegistrations(ce=>{ce.scheme===N.scheme&&ce.added&&(x.dispose(),Q())})})}e.$zk=J;class q{static{this.KB=1024}static{this.MB=q.KB*q.KB}static{this.GB=q.MB*q.KB}static{this.TB=q.GB*q.KB}static formatSize(V){return(0,M.$nf)(V)||(V=0),V<q.KB?(0,S.localize)(1,null,V.toFixed(0)):V<q.MB?(0,S.localize)(2,null,(V/q.KB).toFixed(2)):V<q.GB?(0,S.localize)(3,null,(V/q.MB).toFixed(2)):V<q.TB?(0,S.localize)(4,null,(V/q.GB).toFixed(2)):(0,S.localize)(5,null,(V/q.TB).toFixed(2))}}e.$Ak=q;function F(N){const V=typeof N=="string"||N?.scheme===m.Schemas.vscodeRemote;return typeof N!="string"&&N?.scheme===m.Schemas.file?1024*q.MB:V?10*q.MB:c.$o?50*q.MB:1024*q.MB}e.$Bk=F}),define(te[212],ie([0,1,17,50,14,3,2,62,7,31,16]),function(K,e,P,O,s,M,D,S,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=void 0,e.$7M="localFilesystem";class w extends D.$kc{constructor(f,v){super(),this.a=f,this.b=v,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$fd),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$fd),this.onDidWatchError=this.g.event,this.h=(0,c.$4f)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,v){const{buffer:b}=await this.a.call("readFile",[f,v]);return b}readFileStream(f,v,b){const d=(0,S.$td)(r=>P.$Fd.concat(r.map($=>P.$Fd.wrap($))).buffer),g=new D.$jc;return g.add(this.a.listen("readFileStream",[f,v])(r=>{if(r instanceof P.$Fd)d.write(r.buffer);else{if(r==="end")d.end();else{let $;if(r instanceof Error)$=r;else{const E=r;$=(0,m.$fk)(E.message??(0,O.$mi)(E),E.code??m.FileSystemProviderErrorCode.Unknown)}d.error($),d.end()}g.dispose()}})),g.add(b.onCancellationRequested(()=>{d.error((0,s.$4)()),d.end(),g.dispose()})),d}writeFile(f,v,b){return this.a.call("writeFile",[f,P.$Fd.wrap(v),b])}open(f,v){return this.a.call("open",[f,v])}close(f){return this.a.call("close",[f])}async read(f,v,b,d,g){const[r,$]=await this.a.call("read",[f,v,g]);return b.set(r.buffer.slice(0,$),d),$}write(f,v,b,d,g){return this.a.call("write",[f,v,P.$Fd.wrap(b),d,g])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,v){return this.a.call("delete",[f,v])}rename(f,v,b){return this.a.call("rename",[f,v,b])}copy(f,v,b){return this.a.call("copy",[f,v,b])}cloneFile(f,v){return this.a.call("cloneFile",[f,v])}j(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const v=f;this.f.fire(v.map(b=>({resource:h.URI.revive(b.resource),type:b.type})))}else{const v=f;this.g.fire(v)}}))}watch(f,v){const b=(0,c.$4f)();return this.a.call("watch",[this.h,b,f,v]),(0,D.$ic)(()=>this.a.call("unwatch",[this.h,b]))}}e.$8M=w}),define(te[117],ie([0,1,17,14,175,16]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=void 0;async function D(m,w,y,f,v,b){let d;try{await S(m,w,y,f,v,b)}catch(g){d=g}finally{d&&v.errorTransformer&&(d=v.errorTransformer(d)),typeof d<"u"&&y.error(d),y.end()}}e.$Cp=D;async function S(m,w,y,f,v,b){h(b);const d=await m.open(w,{create:!1});try{h(b);let g=0,r=0,$=v&&typeof v.length=="number"?v.length:void 0,E=P.$Fd.alloc(Math.min(v.bufferSize,typeof $=="number"?$:v.bufferSize)),u=v&&typeof v.position=="number"?v.position:0,t=0;do r=await m.read(d,u,E.buffer,t,E.byteLength-t),u+=r,t+=r,g+=r,typeof $=="number"&&($-=r),t===E.byteLength&&(await y.write(f(E)),E=P.$Fd.alloc(Math.min(v.bufferSize,typeof $=="number"?$:v.bufferSize)),t=0);while(r>0&&(typeof $!="number"||$>0)&&h(b)&&c(g,v));if(t>0){let l=t;typeof $=="number"&&(l=Math.min(t,$)),y.write(f(E.slice(0,l)))}}catch(g){throw(0,M.$gk)(g)}finally{await m.close(d)}}function h(m){if(m.isCancellationRequested)throw(0,O.$4)();return!0}function c(m,w){if(typeof w?.limits?.size=="number"&&m>w.limits.size)throw(0,M.$fk)((0,s.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[76],ie([0,1,104,2,9,4,7,16]),function(K,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lp=e.$Kp=e.$Jp=e.$Ip=e.$Hp=e.$Gp=e.$Fp=e.$Ep=void 0;function h(g){return g.recursive===!0}e.$Ep=h;class c extends O.$kc{static{this.a=5}constructor(r,$,E,u){super(),this.h=r,this.j=$,this.m=E,this.n=u,this.c=this.B(new O.$lc),this.f=void 0,this.g=0}s(){const r=new O.$jc;this.c.value=r,this.b=this.r(r),this.b.setVerboseLogging(this.m),r.add(this.b.onDidChangeFile($=>this.h($))),r.add(this.b.onDidLogMessage($=>this.j($))),r.add(this.b.onDidError($=>this.t($)))}t(r){this.n.restartOnError?this.g<c.a&&this.f?(this.w(`restarting watcher after error: ${r}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${r}`):this.w(r)}u(r){this.g++,this.s(),this.watch(r)}async watch(r){this.f=r,await this.b?.watch(r)}async setVerboseLogging(r){this.m=r,await this.b?.setVerboseLogging(r)}w(r){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${r}`})}y(r){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${r}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Fp=c;class m extends c{constructor(r,$,E){super(r,$,E,{type:"node.js",restartOnError:!1})}}e.$Gp=m;class w extends c{constructor(r,$,E){super(r,$,E,{type:"universal",restartOnError:!0})}}e.$Hp=w;function y(g){return g.map(r=>({type:r.type,resource:D.URI.file(r.path)}))}e.$Ip=y;function f(g){const r=new d;for(const $ of g)r.processEvent($);return r.coalesce()}e.$Jp=f;function v(g,r){return typeof r=="string"&&!r.startsWith(P.$nj)&&!(0,s.$8d)(r)?{base:g,pattern:r}:r}e.$Kp=v;function b(g,r){const $=[];for(const E of r)$.push((0,P.$rj)(v(g,E)));return $}e.$Lp=b;class d{constructor(){this.a=new Set,this.b=new Map}c(r){return M.$k?r.path:r.path.toLowerCase()}processEvent(r){const $=this.b.get(this.c(r));let E=!1;if($){const u=$.type,t=r.type;$.path!==r.path&&(r.type===2||r.type===1)?E=!0:u===1&&t===2?(this.b.delete(this.c(r)),this.a.delete($)):u===2&&t===1?$.type=0:u===1&&t===0||($.type=t)}else E=!0;E&&(this.a.add(r),this.b.set(this.c(r),r))}coalesce(){const r=[],$=[];return Array.from(this.a).filter(E=>E.type!==2?(r.push(E),!1):!0).sort((E,u)=>E.path.length-u.path.length).filter(E=>$.some(u=>(0,S.$mk)(E.path,u,!M.$k))?!1:($.push(E.path),!0)).concat(r)}}}),define(te[213],ie([0,1,45,8,22,32,2,85,9,4,105,21,76]),function(K,e,P,O,s,M,D,S,h,c,m,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zp=e.$Yp=void 0;class f extends D.$kc{static{this.a=100}static{this.b=75}constructor(d,g,r,$){super(),this.m=d,this.n=g,this.r=r,this.s=$,this.c=this.B(new O.$Vg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},E=>this.n(E))),this.f=this.B(new O.$Ug(E=>this.z(E),f.b)),this.g=(0,y.$Lp)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,y.$Lp)(this.m.path,this.m.includes):void 0,this.j=new s.$pd,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const g=await w.Promises.stat(d);this.B(await this.w(d,g.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let g=d.path;try{g=await w.Promises.realpath(d.path),d.path===g&&(g=await(0,m.$Vp)(d.path)??d.path),d.path!==g&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${g})`)}catch{}return g}async w(d,g){if(c.$j&&(0,M.$If)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$kc.None;const r=new s.$pd(this.j.token),$=new D.$jc;try{const E=(0,h.$ae)(d),u=(0,P.watch)(d);$.add((0,D.$ic)(()=>{u.removeAllListeners(),u.close()})),this.G(`Started watching: '${d}'`);const t=new Set;if(g)try{for(const o of await w.Promises.readdir(d))t.add(o)}catch(o){this.D(o)}const l=new Map;$.add((0,D.$ic)(()=>{for(const[,o]of l)o.dispose();l.clear()})),u.on("error",(o,i)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${o}, ${i})`),this.dispose()}),u.on("change",(o,i)=>{if(r.token.isCancellationRequested)return;this.G(`[raw] ["${o}"] ${i}`);let n="";if(i&&(n=i.toString(),c.$j&&(n=(0,S.$hl)(n))),!(!n||o!=="change"&&o!=="rename"))if(g)if(o==="rename"){l.get(n)?.dispose();const a=setTimeout(async()=>{if(l.delete(n),n===E&&!await w.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const k=await this.C((0,h.$9d)(d,n));if(r.token.isCancellationRequested)return;let I;k?t.has(n)?I=0:(I=1,t.add(n)):(t.delete(n),I=2),this.y({path:(0,h.$9d)(this.m.path,n),type:I})},f.a);l.set(n,(0,D.$ic)(()=>clearTimeout(a)))}else{let a;t.has(n)?a=0:(a=1,t.add(n)),this.y({path:(0,h.$9d)(this.m.path,n),type:a})}else if(o==="rename"||n!==E){const a=setTimeout(async()=>{const k=await w.Promises.exists(d);r.token.isCancellationRequested||(k?(this.y({path:this.m.path,type:0},!0),$.add(await this.w(d,!1))):(this.y({path:this.m.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);$.clear(),$.add((0,D.$ic)(()=>clearTimeout(a)))}else this.y({path:this.m.path,type:0},!0)})}catch(E){await w.Promises.exists(d)&&!r.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${E.toString()})`)}return(0,D.$ic)(()=>{r.dispose(!0),$.dispose()})}y(d,g=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`),!g&&this.g.some(r=>r(d.path))?this.s&&this.G(` >> ignored (excluded) ${d.path}`):!g&&this.h&&this.h.length>0&&!this.h.some(r=>r(d.path))?this.s&&this.G(` >> ignored (not included) ${d.path}`):this.f.work(d))}z(d){const g=(0,y.$Jp)(d);if(g.length>0){if(this.s)for(const $ of g)this.G(`>> normalized ${$.type===1?"[ADDED]":$.type===2?"[DELETED]":"[CHANGED]"} ${$.path}`);this.c.work(g)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(c.$k)return w.Promises.exists(d);try{const g=(0,h.$ae)(d);return(await w.Promises.readdir((0,h.$_d)(d))).some($=>$===g)}catch(g){return this.G(g),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$Yp=f;async function v(b,d,g,r,$=512){const E=await w.Promises.open(b,"r"),u=Buffer.allocUnsafe($),t=new s.$pd(r);let l,o=!1;const i={path:b,excludes:[],recursive:!1},n=new f(i,a=>{(async()=>{for(const{type:k}of a)if(k===0){if(o)return;o=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:I}=await w.Promises.read(E,u,0,$,null);if(!I||t.token.isCancellationRequested)break;d(u.slice(0,I))}}catch(I){l=new Error(I),t.dispose(!0)}finally{o=!1}}})()});return await n.ready,g(),new Promise((a,k)=>{t.token.onCancellationRequested(async()=>{n.dispose();try{await w.Promises.close(E)}catch(I){l=new Error(I)}l?k(l):a()})})}e.$Zp=v}),define(te[214],ie([0,1,3,104,2,4,213]),function(K,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1p=void 0;class S extends s.$kc{constructor(){super(...arguments),this.a=this.B(new P.$fd),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$fd),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(c){const m=this.j(c),w=m.filter(f=>{const v=this.c.get(f.path);return v?!(0,O.$vj)(v.request.excludes,f.excludes)||!(0,O.$vj)(v.request.includes,f.includes):!0}),y=Array.from(this.c.values()).filter(({request:f})=>!m.find(v=>v.path===f.path&&(0,O.$vj)(v.excludes,f.excludes)&&(0,O.$vj)(v.includes,f.includes))).map(({request:f})=>f.path);w.length&&this.m(`Request to start watching: ${w.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),y.length&&this.m(`Request to stop watching: ${y.join(",")}`);for(const f of y)this.h(f);for(const f of w)this.g(f)}g(c){const m=new D.$Yp(c,y=>this.a.fire(y),y=>this.b.fire(y),this.f),w={request:c,instance:m};this.c.set(c.path,w)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const m=this.c.get(c);m&&(this.c.delete(c),m.instance.dispose())}j(c){const m=new Map;for(const w of c){const y=M.$k?w.path:w.path.toLowerCase();m.set(y,w)}return Array.from(m.values())}async setVerboseLogging(c){this.f=c;for(const[,m]of this.c)m.instance.setVerboseLogging(c)}m(c){this.f&&this.b.fire({type:"trace",message:this.n(c)})}n(c,m){return m?`[File Watcher (node.js)] ${c} (path: ${m.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$1p=S}),define(te[215],ie([0,1,76,214]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=void 0;class s extends P.$Gp{constructor(D,S,h){super(D,S,h),this.s()}r(D){return D.add(new O.$1p)}}e.$2p=s}),define(te[216],ie([0,1,13,42,158,76]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=void 0;class D extends M.$Hp{constructor(h,c,m){super(h,c,m),this.s()}r(h){const c=h.add(new s.$Sp(P.$2f.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(c.onDidProcessExit(({code:m,signal:w})=>this.t(`terminated by itself with code ${m}, signal: ${w}`))),O.ProxyChannel.toService((0,O.$ih)(c.getChannel("watcher")))}}e.$Tp=D}),define(te[92],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=void 0;class P{constructor(...s){this.a=new Map;for(const[M,D]of s)this.set(M,D)}set(s,M){const D=this.a.get(s);return this.a.set(s,M),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$zh=P}),define(te[217],ie([0,1,8,14,2,75,206,6,92,101]),function(K,e,P,O,s,M,D,S,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=void 0;const m=!1;class w extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class y{constructor(d=new h.$zh,g=!1,r,$=m){this.f=d,this.g=g,this.h=r,this.i=$,this.o=new Set,this.f.set(S.$Ah,this),this._globalGraph=$?r?._globalGraph??new D.$5p(E=>E):void 0}createChild(d){return new y(d,this.g,this,this.i)}invokeFunction(d,...g){const r=v.traceInvocation(this.i,d);let $=!1;try{return d({get:u=>{if($)throw(0,O.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(u,r);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...g)}finally{$=!0,r.stop()}}createInstance(d,...g){let r,$;return d instanceof M.$yh?(r=v.traceCreation(this.i,d.ctor),$=this.j(d.ctor,d.staticArguments.concat(g),r)):(r=v.traceCreation(this.i,d),$=this.j(d,g,r)),r.stop(),$}j(d,g=[],r){const $=S._util.getServiceDependencies(d).sort((t,l)=>t.index-l.index),E=[];for(const t of $){const l=this.m(t.id,r);l||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(l)}const u=$.length>0?$[0].index:g.length;if(g.length!==u){console.trace(`[createInstance] First service dependency of ${d.name} at position ${u+1} conflicts with ${g.length} static arguments`);const t=u-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,u)}return Reflect.construct(d,g.concat(E))}k(d,g){if(this.f.get(d)instanceof M.$yh)this.f.set(d,g);else if(this.h)this.h.k(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const g=this.f.get(d);return!g&&this.h?this.h.l(d):g}m(d,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const r=this.l(d);return r instanceof M.$yh?this.q(d,r,g.branch(d,!0)):(g.branch(d,!1),r)}q(d,g,r){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,g,r)}finally{this.o.delete(d)}}r(d,g,r){const $=new D.$5p(t=>t.id.toString());let E=0;const u=[{id:d,desc:g,_trace:r}];for(;u.length;){const t=u.pop();if($.lookupOrInsertNode(t),E++>1e3)throw new w($);for(const l of S._util.getServiceDependencies(t.desc.ctor)){const o=this.l(l.id);if(o||this.u(`[createInstance] ${d} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),o instanceof M.$yh){const i={id:l.id,desc:o,_trace:t._trace.branch(l.id,!0)};$.insertEdge(t,i),u.push(i)}}}for(;;){const t=$.roots();if(t.length===0){if(!$.isEmpty())throw new w($);break}for(const{data:l}of t){if(this.l(l.id)instanceof M.$yh){const i=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,i)}$.removeNode(l)}}return this.l(d)}s(d,g,r=[],$,E){if(this.f.get(d)instanceof M.$yh)return this.t(d,g,r,$,E);if(this.h)return this.h.s(d,g,r,$,E);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(d,g,r=[],$,E){if($){const u=new y(void 0,this.g,this,this.i);u.c=String(d);const t=new Map,l=new P.$Xg(()=>{const o=u.j(g,r,E);for(const[i,n]of t){const a=o[i];if(typeof a=="function")for(const k of n)a.apply(o,k)}return t.clear(),o});return new Proxy(Object.create(null),{get(o,i){if(!l.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let k=t.get(i);return k||(k=new c.$tc,t.set(i,k)),(C,p,A)=>{const L=k.push([C,p,A]);return(0,s.$ic)(L)}}if(i in o)return o[i];const n=l.value;let a=n[i];return typeof a!="function"||(a=a.bind(n),o[i]=a),a},set(o,i,n){return l.value[i]=n,!0},getPrototypeOf(o){return g.prototype}})}else return this.j(g,r,E)}u(d,g){if(g&&console.warn(d),this.g)throw new Error(d)}}e.$6p=y;var f;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(f||(f={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,g){return d?new v(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(d,g){return d?new v(1,g.name):v.c}static{this.f=0}constructor(d,g){this.type=d,this.name=g,this.g=Date.now(),this.h=[]}branch(d,g){const r=new v(3,d.toString());return this.h.push([d,g,r]),r}stop(){const d=Date.now()-this.g;v.f+=d;let g=!1;function r(E,u){const t=[],l=new Array(E+1).join("	");for(const[o,i,n]of u.h)if(i&&n){g=!0,t.push(`${l}CREATES -> ${o}`);const a=r(E+1,n);a&&t.push(a)}else t.push(`${l}uses -> ${o}`);return t.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${r(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(d>2||g)&&v.all.add($.join(`
`))}}e.$7p=v}),define(te[218],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qtb=e.IssueType=void 0;var O;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(O||(e.IssueType=O={})),e.$qtb=(0,P.$Bh)("issueService")}),define(te[5],ie([0,1,50,3,56,2,33,4,19,12,7,114,6]),function(K,e,P,O,s,M,D,S,h,c,m,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.log=e.$8i=e.LogLevel=e.$7i=e.$6i=e.$5i=void 0,e.$5i=(0,y.$Bh)("logService"),e.$6i=(0,y.$Bh)("loggerService");function f(){return new Date().toISOString()}function v(C){return(0,c.$nf)(C)}e.$7i=v;var b;(function(C){C[C.Off=0]="Off",C[C.Trace=1]="Trace",C[C.Debug=2]="Debug",C[C.Info=3]="Info",C[C.Warning=4]="Warning",C[C.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$8i=b.Info;function d(C,p,A){switch(p){case b.Trace:C.trace(A);break;case b.Debug:C.debug(A);break;case b.Info:C.info(A);break;case b.Warning:C.warn(A);break;case b.Error:C.error(A);break;case b.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=d;function g(C,p=!1){let A="";for(let L=0;L<C.length;L++){let U=C[L];if(U instanceof Error&&(U=(0,P.$mi)(U,p)),typeof U=="object")try{U=JSON.stringify(U)}catch{}A+=(L>0?" ":"")+U}return A}class r extends M.$kc{constructor(){super(...arguments),this.b=e.$8i,this.c=this.B(new O.$fd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==b.Off&&this.b<=p}}e.$0i=r;class $ extends r{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...A){this.f(b.Trace)&&this.g(b.Trace,g([p,...A],!0))}debug(p,...A){this.f(b.Debug)&&this.g(b.Debug,g([p,...A]))}info(p,...A){this.f(b.Info)&&this.g(b.Info,g([p,...A]))}warn(p,...A){this.f(b.Warning)&&this.g(b.Warning,g([p,...A]))}error(p,...A){if(this.f(b.Error))if(p instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=p.stack,this.g(b.Error,g(L))}else this.g(b.Error,g([p,...A]))}flush(){}}e.$$i=$;class E extends r{constructor(p=e.$8i){super(),this.setLevel(p),this.g=!S.$i}trace(p,...A){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...A):console.log(`[main ${f()}]`,p,...A))}debug(p,...A){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...A):console.log(`[main ${f()}]`,p,...A))}info(p,...A){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,p,...A):console.log(`[main ${f()}]`,p,...A))}warn(p,...A){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,p,...A):console.warn(`[main ${f()}]`,p,...A))}error(p,...A){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,p,...A):console.error(`[main ${f()}]`,p,...A))}dispose(){}flush(){}}e.$_i=E;class u extends r{constructor(p=e.$8i,A=!0){super(),this.g=A,this.setLevel(p)}trace(p,...A){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...A):console.log(p,...A))}debug(p,...A){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...A):console.log(p,...A))}info(p,...A){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...A):console.log(p,...A))}warn(p,...A){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...A):console.log(p,...A))}error(p,...A){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...A):console.error(p,...A))}dispose(){}flush(){}}e.$aj=u;class t extends r{constructor(p,A=e.$8i){super(),this.g=p,this.setLevel(A)}trace(p,...A){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(p),...A])}debug(p,...A){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(p),...A])}info(p,...A){this.f(b.Info)&&this.g.log(b.Info,[this.h(p),...A])}warn(p,...A){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(p),...A])}error(p,...A){this.f(b.Error)&&this.g.log(b.Error,[this.h(p),...A])}h(p){return typeof p=="string"?p:(0,P.$mi)(p,this.f(b.Trace))}dispose(){}flush(){}}e.$bj=t;class l extends r{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const A of this.g)A.setLevel(p);super.setLevel(p)}trace(p,...A){for(const L of this.g)L.trace(p,...A)}debug(p,...A){for(const L of this.g)L.debug(p,...A)}info(p,...A){for(const L of this.g)L.info(p,...A)}warn(p,...A){for(const L of this.g)L.warn(p,...A)}error(p,...A){for(const L of this.g)L.error(p,...A)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose()}}e.$cj=l;class o extends M.$kc{constructor(p,A,L){if(super(),this.h=p,this.j=A,this.b=new D.$zi,this.c=this.B(new O.$fd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new O.$fd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new O.$fd),this.onDidChangeVisibility=this.g.event,L)for(const U of L)this.b.set(U.resource,{logger:void 0,info:U})}m(p){return(0,c.$jf)(p)?[...this.b.values()].find(A=>A.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,A){const L=this.n(p),U=(0,c.$jf)(p)?p:A?.id??(0,s.$pi)(L.toString()).toString(16);let z=this.b.get(L)?.logger;const re=A?.logLevel==="always"?b.Trace:A?.logLevel;z||(z=this.s(L,re??this.getLogLevel(L)??this.h,{...A,id:U}));const ee={logger:z,info:{resource:L,id:U,logLevel:re,name:A?.name,hidden:A?.hidden,extensionId:A?.extensionId,when:A?.when}};return this.registerLogger(ee.info),this.b.set(L,ee),z}n(p){return(0,c.$jf)(p)?(0,h.$ig)(this.j,`${p}.log`):p}setLogLevel(p,A){if(m.URI.isUri(p)){const L=p,U=A,z=this.b.get(L);z&&U!==z.info.logLevel&&(z.info.logLevel=U===this.h?void 0:U,z.logger?.setLevel(U),this.b.set(z.info.resource,z),this.f.fire([L,U]))}else{this.h=p;for(const[L,U]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&U.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,A){const L=this.m(p);L&&A!==!L.info.hidden&&(L.info.hidden=!A,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,A]))}getLogLevel(p){let A;return p&&(A=this.b.get(p)?.info.logLevel),A??this.h}registerLogger(p){const A=this.b.get(p.resource);A?A.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const A=this.b.get(p);A&&(A.logger&&A.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[A.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dj=o;class i{constructor(){this.onDidChangeLogLevel=new O.$fd().event}setLevel(p){}getLevel(){return b.Info}trace(p,...A){}debug(p,...A){}info(p,...A){}warn(p,...A){}error(p,...A){}critical(p,...A){}dispose(){}flush(){}}e.$ej=i;class n extends i{}e.$fj=n;function a(C){if(C.verbose)return b.Trace;if(typeof C.logLevel=="string"){const p=I(C.logLevel.toLowerCase());if(p!==void 0)return p}return e.$8i}e.$gj=a;function k(C){switch(C){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.$hj=k;function I(C){switch(C){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$ij=I,e.$jj=new w.$2i("logLevel",k(b.Info))});var _=this&&this.__param||function(K,e){return function(P,O){e(P,O,K)}};define(te[219],ie([0,1,15,4,5]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$65b=void 0;const M=P.safeStorage;let D=class{constructor(h){this.a=h,P.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(M.encryptString(h));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(h){let c;try{if(c=JSON.parse(h),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const m=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const w=M.decryptString(m);return this.a.trace("[EncryptionMainService] Decrypted value."),w}catch(m){throw this.a.error(m),m}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(O.$i)return Promise.resolve("dpapi");if(O.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const h=M.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.a.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(O.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(O.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}};e.$65b=D,e.$65b=D=ke([_(0,s.$5i)],D)}),define(te[220],ie([0,1,23,8,14,3,2,9,76,5]),function(K,e,P,O,s,M,D,S,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=void 0;class m extends D.$kc{constructor(y,f){super(),this.a=y,this.b=f,this.c=this.B(new M.$fd),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$fd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$Eg(0)),this.w=[],this.y=this.B(new O.$Eg(0))}watch(y,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(y,f):this.z(y,f)}n(y,f){const v={path:this.H(y),excludes:f.excludes,includes:f.includes,recursive:f.recursive},b=(0,P.$Sb)(this.j,v);return this.r(),(0,D.$ic)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,s.$Y)(y))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,h.$Ip)(f)),f=>this.G(f),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const f of this.j)(0,h.$Ep)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const f of this.j)(0,h.$Ep)(f)&&y.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,f){const v={path:this.H(y),excludes:f.excludes,includes:f.includes,recursive:!1},b=(0,P.$Sb)(this.w,v);return this.C(),(0,D.$ic)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,s.$Y)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,h.$Ip)(y)),y=>this.G(y),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.a[y.type](y.message)}H(y){return(0,S.$7d)(y.fsPath)}}e.$Mp=m}),define(te[221],ie([0,1,23,8,17,22,3,56,68,2,57,13,65,19,62,173,16,117,5,14]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=void 0;let E=class extends c.$kc{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new D.$fd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$fd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$fd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$fd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$fd),this.onDidFilesChange=this.X.event,this.Y=this.B(new D.$fd),this.onDidWatchError=this.Y.event,this.Z=new Map,this.ab=this.B(new O.$Pg)}registerProvider(t,l){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,y.mark)(`code/registerFilesystem/${t}`);const o=new c.$jc;return this.h.set(t,l),this.c.fire({added:!0,scheme:t,provider:l}),o.add(l.onDidChangeFile(i=>this.X.fire(new d.$lk(i,!this.S(l))))),typeof l.onDidWatchError=="function"&&o.add(l.onDidWatchError(i=>this.Y.fire(new Error(i)))),o.add(l.onDidChangeCapabilities(()=>this.g.fire({provider:l,scheme:t}))),(0,c.$ic)(()=>{this.c.fire({added:!1,scheme:t,provider:l}),this.h.delete(t),(0,c.$fc)(o)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const l=[];this.f.fire({scheme:t,join(o){l.push(o)}}),!this.h.has(t)&&await O.Promises.settled(l)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,l){const o=this.h.get(t.scheme);return!!(o&&o.capabilities&l)}listCapabilities(){return h.Iterable.map(this.h,([t,l])=>({scheme:t,capabilities:l.capabilities}))}async j(t){if(!(0,f.$mg)(t))throw new d.$nk((0,b.localize)(0,null,this.rb(t)),8);await this.activateProvider(t.scheme);const l=this.h.get(t.scheme);if(!l){const o=new $.$_;throw o.message=(0,b.localize)(1,null,t.toString()),o}return l}async m(t){const l=await this.j(t);if((0,d.$$j)(l)||(0,d.$8j)(l)||(0,d.$_j)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(t){const l=await this.j(t);if((0,d.$$j)(l)||(0,d.$8j)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,l){try{return await this.s(t,l)}catch(o){throw(0,d.$ik)(o)===d.FileSystemProviderErrorCode.FileNotFound?new d.$nk((0,b.localize)(2,null,this.rb(t)),1):(0,d.$gk)(o)}}async s(t,l){const o=await this.j(t),i=this.S(o),n=l?.resolveTo,a=l?.resolveSingleChildDescendants,k=l?.resolveMetadata,I=await o.stat(t);let C;return this.t(o,t,I,void 0,!!k,(p,A)=>(C||(C=m.$Hh.forUris(()=>!i),C.set(t,!0),n&&C.fill(!0,n)),C.get(p.resource)||C.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&a?A===1:!1))}async t(t,l,o,i,n,a){const{providerExtUri:k}=this.R(t),I={resource:l,name:k.basename(l),isFile:(o.type&d.FileType.File)!==0,isDirectory:(o.type&d.FileType.Directory)!==0,isSymbolicLink:(o.type&d.FileType.SymbolicLink)!==0,mtime:o.mtime,ctime:o.ctime,size:o.size,readonly:!!((o.permissions??0)&d.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((o.permissions??0)&d.FilePermission.Locked),etag:(0,d.$yk)({mtime:o.mtime,size:o.size}),children:void 0};if(I.isDirectory&&a(I,i)){try{const C=await t.readdir(l),p=await O.Promises.settled(C.map(async([A,L])=>{try{const U=k.joinPath(l,A),z=n?await t.stat(U):{type:L};return await this.t(t,U,z,C.length,n,a)}catch(U){return this.b.trace(U),null}}));I.children=(0,P.$Fb)(p)}catch(C){this.b.trace(C),I.children=[]}return I}return I}async resolveAll(t){return O.Promises.settled(t.map(async l=>{try{return{stat:await this.s(l.resource,l.options),success:!0}}catch(o){return this.b.trace(o),{stat:void 0,success:!1}}}))}async stat(t){const l=await this.j(t),o=await l.stat(t);return this.t(l,t,o,void 0,!0,()=>!1)}async exists(t){const l=await this.j(t);try{return!!await l.stat(t)}catch{return!1}}async canCreateFile(t,l){try{await this.u(t,l)}catch(o){return o}return!0}async u(t,l){if(!l?.overwrite&&await this.exists(t))throw new d.$nk((0,b.localize)(3,null,this.rb(t)),3,l)}async createFile(t,l=s.$Fd.fromString(""),o){await this.u(t,o);const i=await this.writeFile(t,l);return this.r.fire(new d.$kk(t,0,i)),i}async writeFile(t,l,o){const i=this.pb(await this.n(t),t),{providerExtUri:n}=this.R(i);let a=o;if((0,d.$bk)(i)&&!a?.atomic){const k=i.enforceAtomicWriteFile?.(t);k&&(a={...o,atomic:k})}try{await this.w(i,t,a)||await this.U(i,n.dirname(t));let I;if((0,d.$8j)(i)&&!(l instanceof s.$Fd))if((0,v.$rd)(l)){const C=await(0,v.$yd)(l,3);C.ended?I=s.$Fd.concat(C.buffer):I=C}else I=(0,v.$vd)(l,C=>s.$Fd.concat(C),3);else I=l;if(!(0,d.$$j)(i)||(0,d.$8j)(i)&&I instanceof s.$Fd||(0,d.$8j)(i)&&(0,d.$bk)(i)&&a?.atomic)await this.gb(i,t,a,I);else{const C=I instanceof s.$Fd?(0,s.$Qd)(I):I;a?.atomic!==!1&&a?.atomic?.postfix?await this.bb(i,t,(0,f.$ig)((0,f.$hg)(t),`${(0,f.$fg)(t)}${a.atomic.postfix}`),a,C):await this.cb(i,t,a,C)}this.r.fire(new d.$kk(t,4))}catch(k){throw new d.$nk((0,b.localize)(4,null,this.rb(t),(0,d.$gk)(k).toString()),(0,d.$jk)(k),a)}return this.resolve(t,{resolveMetadata:!0})}async w(t,l,o){const i=!!o?.unlock;if(i&&!(t.capabilities&8192))throw new Error((0,b.localize)(5,null,this.rb(l)));if(!!o?.atomic){if(!(t.capabilities&32768))throw new Error((0,b.localize)(6,null,this.rb(l)));if(i)throw new Error((0,b.localize)(7,null,this.rb(l)))}let a;try{a=await t.stat(l)}catch{return}if(a.type&d.FileType.Directory)throw new d.$nk((0,b.localize)(8,null,this.rb(l)),0,o);if(this.qb(l,a),typeof o?.mtime=="number"&&typeof o.etag=="string"&&o.etag!==d.$xk&&typeof a.mtime=="number"&&typeof a.size=="number"&&o.mtime<a.mtime&&o.etag!==(0,d.$yk)({mtime:o.mtime,size:a.size}))throw new d.$nk((0,b.localize)(9,null),3,o);return a}async readFile(t,l,o){const i=await this.m(t);return l?.atomic?this.z(i,t,l,o):this.C(i,t,l,o)}async z(t,l,o,i){return new Promise((n,a)=>{this.ab.queueFor(l,this.R(t).providerExtUri).queue(async()=>{try{const k=await this.C(t,l,o,i);n(k)}catch(k){a(k)}})})}async C(t,l,o,i){const n=await this.D(t,l,{...o,preferUnbuffered:!0},i);return{...n,value:await(0,s.$Rd)(n.value)}}async readFileStream(t,l,o){const i=await this.m(t);return this.D(i,t,l,o)}async D(t,l,o,i){const n=new M.$pd(i);let a=o;(0,d.$ak)(t)&&t.enforceAtomicReadFile?.(l)&&(a={...o,atomic:!0});const k=this.J(l,a).then(C=>C,C=>{throw n.dispose(!0),C});let I;try{return typeof a?.etag=="string"&&a.etag!==d.$xk&&await k,a?.atomic&&(0,d.$ak)(t)||!((0,d.$$j)(t)||(0,d.$_j)(t))||(0,d.$8j)(t)&&a?.preferUnbuffered?I=this.I(t,l,a):(0,d.$_j)(t)?I=this.G(t,l,n.token,a):I=this.H(t,l,n.token,a),I.on("end",()=>n.dispose()),I.on("error",()=>n.dispose()),{...await k,value:I}}catch(C){throw I&&await(0,v.$wd)(I),this.F(C,l,a)}}F(t,l,o){const i=(0,b.localize)(10,null,this.rb(l),(0,d.$gk)(t).toString());return t instanceof d.$pk?new d.$pk(i,t.stat,o):t instanceof d.$ok?new d.$ok(i,t.fileOperationResult,t.size,t.options):new d.$nk(i,(0,d.$jk)(t),o)}G(t,l,o,i=Object.create(null)){const n=t.readFileStream(l,i,o);return(0,v.$Cd)(n,{data:a=>a instanceof s.$Fd?a:s.$Fd.wrap(a),error:a=>this.F(a,l,i)},a=>s.$Fd.concat(a))}H(t,l,o,i=Object.create(null)){const n=(0,s.$Vd)();return(0,g.$Cp)(t,l,n,a=>a,{...i,bufferSize:this.a,errorTransformer:a=>this.F(a,l,i)},o),n}I(t,l,o){const i=(0,v.$td)(n=>s.$Fd.concat(n));return(async()=>{try{let n;o?.atomic&&(0,d.$ak)(t)?n=await t.readFile(l,{atomic:!0}):n=await t.readFile(l),typeof o?.position=="number"&&(n=n.slice(o.position)),typeof o?.length=="number"&&(n=n.slice(0,o.length)),this.L(l,n.byteLength,o),i.end(s.$Fd.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async J(t,l){const o=await this.resolve(t,{resolveMetadata:!0});if(o.isDirectory)throw new d.$nk((0,b.localize)(11,null,this.rb(t)),0,l);if(typeof l?.etag=="string"&&l.etag!==d.$xk&&l.etag===o.etag)throw new d.$pk((0,b.localize)(12,null),o,l);return this.L(t,o.size,l),o}L(t,l,o){if(typeof o?.limits?.size=="number"&&l>o.limits.size)throw new d.$ok((0,b.localize)(13,null,this.rb(t)),7,l,o)}async canMove(t,l,o){return this.M(t,l,"move",o)}async canCopy(t,l,o){return this.M(t,l,"copy",o)}async M(t,l,o,i){if(t.toString()!==l.toString())try{const n=o==="move"?this.pb(await this.n(t),t):await this.m(t),a=this.pb(await this.n(l),l);await this.Q(n,t,a,l,o,i)}catch(n){return n}return!0}async move(t,l,o){const i=this.pb(await this.n(t),t),n=this.pb(await this.n(l),l),a=await this.N(i,t,n,l,"move",!!o),k=await this.resolve(l,{resolveMetadata:!0});return this.r.fire(new d.$kk(t,a==="move"?2:3,k)),k}async copy(t,l,o){const i=await this.m(t),n=this.pb(await this.n(l),l),a=await this.N(i,t,n,l,"copy",!!o),k=await this.resolve(l,{resolveMetadata:!0});return this.r.fire(new d.$kk(t,a==="copy"?3:2,k)),k}async N(t,l,o,i,n,a){if(l.toString()===i.toString())return n;const{exists:k,isSameResourceWithDifferentPathCase:I}=await this.Q(t,l,o,i,n,a);if(k&&!I&&a&&await this.del(i,{recursive:!0}),await this.U(o,this.R(o).providerExtUri.dirname(i)),n==="copy"){if(t===o&&(0,d.$9j)(t))await t.copy(l,i,{overwrite:a});else{const C=await this.resolve(l);C.isDirectory?await this.P(t,C,o,i):await this.O(t,l,o,i)}return n}else return t===o?(await t.rename(l,i,{overwrite:a}),n):(await this.N(t,l,o,i,"copy",a),await this.del(l,{recursive:!0}),"copy")}async O(t,l,o,i){if((0,d.$$j)(t)&&(0,d.$$j)(o))return this.ib(t,l,o,i);if((0,d.$$j)(t)&&(0,d.$8j)(o))return this.ob(t,l,o,i);if((0,d.$8j)(t)&&(0,d.$$j)(o))return this.mb(t,l,o,i);if((0,d.$8j)(t)&&(0,d.$8j)(o))return this.kb(t,l,o,i)}async P(t,l,o,i){await o.mkdir(i),Array.isArray(l.children)&&await O.Promises.settled(l.children.map(async n=>{const a=this.R(o).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.P(t,await this.resolve(n.resource),o,a):this.O(t,n.resource,o,a)}))}async Q(t,l,o,i,n,a){let k=!1;if(t===o){const{providerExtUri:C,isPathCaseSensitive:p}=this.R(t);if(p||(k=C.isEqual(l,i)),k&&n==="copy")throw new Error((0,b.localize)(14,null,this.rb(l),this.rb(i)));if(!k&&C.isEqualOrParent(i,l))throw new Error((0,b.localize)(15,null,this.rb(l),this.rb(i)))}const I=await this.exists(i);if(I&&!k){if(!a)throw new d.$nk((0,b.localize)(16,null,this.rb(l),this.rb(i)),4);if(t===o){const{providerExtUri:C}=this.R(t);if(C.isEqualOrParent(l,i))throw new Error((0,b.localize)(17,null,this.rb(l),this.rb(i)))}}return{exists:I,isSameResourceWithDifferentPathCase:k}}R(t){const l=this.S(t);return{providerExtUri:l?f.$$f:f.$ag,isPathCaseSensitive:l}}S(t){return!!(t.capabilities&1024)}async createFolder(t){const l=this.pb(await this.j(t),t);await this.U(l,t);const o=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$kk(t,0,o)),o}async U(t,l){const o=[],{providerExtUri:i}=this.R(t);for(;!i.isEqual(l,i.dirname(l));)try{if(!((await t.stat(l)).type&d.FileType.Directory))throw new Error((0,b.localize)(18,null,this.rb(l)));break}catch(n){if((0,d.$ik)(n)!==d.FileSystemProviderErrorCode.FileNotFound)throw n;o.push(i.basename(l)),l=i.dirname(l)}for(let n=o.length-1;n>=0;n--){l=i.joinPath(l,o[n]);try{await t.mkdir(l)}catch(a){if((0,d.$ik)(a)!==d.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,l){try{await this.W(t,l)}catch(o){return o}return!0}async W(t,l){const o=this.pb(await this.j(t),t),i=!!l?.useTrash;if(i&&!(o.capabilities&4096))throw new Error((0,b.localize)(19,null,this.rb(t)));const n=l?.atomic;if(n&&!(o.capabilities&65536))throw new Error((0,b.localize)(20,null,this.rb(t)));if(i&&n)throw new Error((0,b.localize)(21,null,this.rb(t)));let a;try{a=await o.stat(t)}catch{}if(a)this.qb(t,a);else throw new d.$nk((0,b.localize)(22,null,this.rb(t)),1);if(!!!l?.recursive){const I=await this.resolve(t);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,b.localize)(23,null,this.rb(t)))}return o}async del(t,l){const o=await this.W(t,l);let i=l;if((0,d.$ck)(o)&&!i?.atomic){const I=o.enforceAtomicDelete?.(t);I&&(i={...l,atomic:I})}const n=!!i?.useTrash,a=!!i?.recursive,k=i?.atomic??!1;await o.delete(t,{recursive:a,useTrash:n,atomic:k}),this.r.fire(new d.$kk(t,1))}async cloneFile(t,l){const o=await this.j(t),i=this.pb(await this.n(l),l);if(o===i&&this.R(o).providerExtUri.isEqual(t,l))return;if(o===i&&(0,d.$0j)(o))return o.cloneFile(t,l);await this.U(i,this.R(i).providerExtUri.dirname(l));const n=this.ab.queueFor(t,this.R(o).providerExtUri);return o===i&&(0,d.$9j)(o)?n.queue(()=>o.copy(t,l,{overwrite:!0})):n.queue(()=>this.O(o,t,i,l))}watch(t,l={recursive:!1,excludes:[]}){const o=new c.$jc;let i=!1,n=()=>{i=!0};return o.add((0,c.$ic)(()=>n())),(async()=>{try{const a=await this.$(t,l);i?(0,c.$fc)(a):n=()=>(0,c.$fc)(a)}catch(a){this.b.error(a)}})(),o}async $(t,l){const o=await this.j(t),i=(0,S.$pi)([this.R(o).providerExtUri.getComparisonKey(t),l]);let n=this.Z.get(i);return n||(n={count:0,disposable:o.watch(t,l)},this.Z.set(i,n)),n.count+=1,(0,c.$ic)(()=>{n&&(n.count--,n.count===0&&((0,c.$fc)(n.disposable),this.Z.delete(i)))})}dispose(){super.dispose();for(const[,t]of this.Z)(0,c.$fc)(t.disposable);this.Z.clear()}async bb(t,l,o,i,n){await this.cb(t,o,i,n);try{await t.rename(o,l,{overwrite:!0})}catch(a){try{await t.delete(o,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async cb(t,l,o,i){return this.ab.queueFor(l,this.R(t).providerExtUri).queue(async()=>{const n=await t.open(l,{create:!0,unlock:o?.unlock??!1});try{(0,v.$rd)(i)||(0,v.$sd)(i)?await this.db(t,n,i):await this.eb(t,n,i)}catch(a){throw(0,d.$gk)(a)}finally{await t.close(n)}})}async db(t,l,o){let i=0,n;if((0,v.$sd)(o)){if(o.buffer.length>0){const a=s.$Fd.concat(o.buffer);await this.fb(t,l,a,a.byteLength,i,0),i+=a.byteLength}if(o.ended)return;n=o.stream}else n=o;return new Promise((a,k)=>{(0,v.$xd)(n,{onData:async I=>{n.pause();try{await this.fb(t,l,I,I.byteLength,i,0)}catch(C){return k(C)}i+=I.byteLength,setTimeout(()=>n.resume())},onError:I=>k(I),onEnd:()=>a()})})}async eb(t,l,o){let i=0,n;for(;(n=o.read())!==null;)await this.fb(t,l,n,n.byteLength,i,0),i+=n.byteLength}async fb(t,l,o,i,n,a){let k=0;for(;k<i;){const I=await t.write(l,n+k,o.buffer,a+k,i-k);k+=I}}async gb(t,l,o,i){return this.ab.queueFor(l,this.R(t).providerExtUri).queue(()=>this.hb(t,l,o,i))}async hb(t,l,o,i){let n;i instanceof s.$Fd?n=i:(0,v.$rd)(i)?n=await(0,s.$Rd)(i):(0,v.$sd)(i)?n=await(0,s.$Sd)(i):n=(0,s.$Pd)(i),await t.writeFile(l,n.buffer,{create:!0,overwrite:!0,unlock:o?.unlock??!1,atomic:o?.atomic??!1})}async ib(t,l,o,i){return this.ab.queueFor(i,this.R(o).providerExtUri).queue(()=>this.jb(t,l,o,i))}async jb(t,l,o,i){let n,a;try{n=await t.open(l,{create:!1}),a=await o.open(i,{create:!0,unlock:!1});const k=s.$Fd.alloc(this.a);let I=0,C=0,p=0;do p=await t.read(n,I,k.buffer,C,k.byteLength-C),await this.fb(o,a,k,p,I,C),I+=p,C+=p,C===k.byteLength&&(C=0);while(p>0)}catch(k){throw(0,d.$gk)(k)}finally{await O.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof a=="number"?o.close(a):Promise.resolve()])}}async kb(t,l,o,i){return this.ab.queueFor(i,this.R(o).providerExtUri).queue(()=>this.lb(t,l,o,i))}async lb(t,l,o,i){return o.writeFile(i,await t.readFile(l),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async mb(t,l,o,i){return this.ab.queueFor(i,this.R(o).providerExtUri).queue(()=>this.nb(t,l,o,i))}async nb(t,l,o,i){const n=await o.open(i,{create:!0,unlock:!1});try{const a=await t.readFile(l);await this.fb(o,n,s.$Fd.wrap(a),a.byteLength,0,0)}catch(a){throw(0,d.$gk)(a)}finally{await o.close(n)}}async ob(t,l,o,i){const n=await(0,s.$Rd)(this.H(t,l,M.CancellationToken.None));await this.gb(o,i,void 0,n)}pb(t,l){if(t.capabilities&2048)throw new d.$nk((0,b.localize)(24,null,this.rb(l)),6);return t}qb(t,l){if((l.permissions??0)&d.FilePermission.Readonly)throw new d.$nk((0,b.localize)(25,null,this.rb(t)),6)}rb(t){return t.scheme===w.Schemas.file?t.fsPath:t.toString(!0)}};e.$Dp=E,e.$Dp=E=ke([_(0,r.$5i)],E)}),define(te[93],ie([0,1,45,310,8,33,17,3,32,2,9,4,19,62,21,177,16,117,220,50,216,215]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r,$,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3p=void 0,(()=>{try{(0,O.gracefulify)(P)}catch(l){console.error(`Error enabling graceful-fs: ${(0,$.$mi)(l)}`)}})();class t extends r.$Mp{static{this.I=!1}constructor(o,i){super(o,i),this.onDidChangeCapabilities=S.Event.None,this.N=new M.$zi(n=>y.$_f.getComparisonKey(n)),this.S=new Map,this.U=new Map,this.W=new Map}get capabilities(){return this.J||(this.J=253982,w.$k&&(this.J|=1024)),this.J}async stat(o){try{const{stat:i,symbolicLink:n}=await v.SymlinkSupport.stat(this.H(o));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.eb(i)}}async L(o){try{return await this.stat(o)}catch{return}}async readdir(o){try{const i=await v.Promises.readdir(this.H(o),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async a=>{try{let k;a.isSymbolicLink()?k=(await this.stat((0,y.$ig)(o,a.name))).type:k=this.M(a),n.push([a.name,k])}catch(k){this.a.trace(k)}})),n}catch(i){throw this.eb(i)}}M(o,i){let n;return i?.dangling?n=d.FileType.Unknown:o.isFile()?n=d.FileType.File:o.isDirectory()?n=d.FileType.Directory:n=d.FileType.Unknown,i&&(n|=d.FileType.SymbolicLink),n}async O(o){const i=this.H(o);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(o);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const a=new s.$Fg;return this.N.set(o,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$ic)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(o)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(o)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(o,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(o)})`),n=await this.O(o));const a=this.H(o);return await v.Promises.readFile(a)}catch(a){throw this.eb(a)}finally{n?.dispose()}}P(o){t.I&&this.a.trace(o)}readFileStream(o,i,n){const a=(0,f.$td)(k=>D.$Fd.concat(k.map(I=>D.$Fd.wrap(I))).buffer);return(0,g.$Cp)(this,o,a,k=>k.buffer,{...i,bufferSize:256*1024},n),a}async writeFile(o,i,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.Q(o,(0,y.$ig)((0,y.$hg)(o),`${(0,y.$fg)(o)}${n.atomic.postfix}`),i,n):this.R(o,i,n)}async Q(o,i,n,a){await this.R(i,n,a);try{await this.rename(i,o,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}async R(o,i,n){let a;try{const k=this.H(o);if(!n.create||!n.overwrite){if(await v.Promises.exists(k)){if(!n.overwrite)throw(0,d.$fk)((0,b.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,d.$fk)((0,b.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(o,{create:!0,unlock:n.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(k){throw await this.fb(o,k)}finally{typeof a=="number"&&await this.close(a)}}static{this.X=!0}static configureFlushOnWrite(o){t.X=o}async open(o,i){const n=this.H(o);let a;(0,d.$7j)(i)&&(a=await this.O(o));let k;try{if((0,d.$7j)(i)&&i.unlock)try{const{stat:C}=await v.SymlinkSupport.stat(n);C.mode&128||await v.Promises.chmod(n,C.mode|128)}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}let I;if((0,d.$7j)(i)){if(w.$i)try{await v.Promises.truncate(n,0),I="r+"}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}I||(I="w")}else I="r";k=await v.Promises.open(n,I)}catch(I){throw a?.dispose(),(0,d.$7j)(i)?await this.fb(o,I):this.eb(I)}if(this.S.set(k,0),(0,d.$7j)(i)&&this.W.set(k,o),a){const I=this.U.get(k);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${n})`),this.U.set(k,a),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${n})`),I.dispose())}return k}async close(o){const i=this.U.get(o);try{if(this.S.delete(o),this.W.delete(o)&&t.X)try{await v.Promises.fdatasync(o)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await v.Promises.close(o)}catch(n){throw this.eb(n)}finally{i&&(this.U.get(o)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${o}`),this.U.delete(o)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${o}`),i.dispose())}}async read(o,i,n,a,k){const I=this.Y(o,i);let C=null;try{C=(await v.Promises.read(o,n,a,k,I)).bytesRead}catch(p){throw this.eb(p)}finally{this.Z(o,I,C)}return C}Y(o,i){return i===this.S.get(o)?null:i}Z(o,i,n){const a=this.S.get(o);typeof a=="number"&&(typeof i=="number"||(typeof n=="number"?this.S.set(o,a+n):this.S.delete(o)))}async write(o,i,n,a,k){return(0,s.$Yg)(()=>this.$(o,i,n,a,k),100,3)}async $(o,i,n,a,k){const I=this.Y(o,i);let C=null;try{C=(await v.Promises.write(o,n,a,k,I)).bytesWritten}catch(p){throw await this.fb(this.W.get(o),p)}finally{this.Z(o,I,C)}return C}async mkdir(o){try{await v.Promises.mkdir(this.H(o))}catch(i){throw this.eb(i)}}async delete(o,i){try{const n=this.H(o);if(i.recursive){let a;i?.atomic!==!1&&i.atomic.postfix&&(a=(0,m.$9d)((0,m.$_d)(n),`${(0,m.$ae)(n)}${i.atomic.postfix}`)),await v.Promises.rm(n,v.RimRafMode.MOVE,a)}else try{await v.Promises.unlink(n)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let k=!1;try{const{stat:I,symbolicLink:C}=await v.SymlinkSupport.stat(n);k=I.isDirectory()&&!C}catch{}if(k)await v.Promises.rmdir(n);else throw a}else throw a}}catch(n){throw this.eb(n)}}async rename(o,i,n){const a=this.H(o),k=this.H(i);if(a!==k)try{await this.ab(o,i,"move",n.overwrite),await v.Promises.rename(a,k)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,b.localize)(2,null,(0,m.$ae)(a),(0,m.$ae)((0,m.$_d)(k)),I.toString()))),this.eb(I)}}async copy(o,i,n){const a=this.H(o),k=this.H(i);if(a!==k)try{await this.ab(o,i,"copy",n.overwrite),await v.Promises.copy(a,k,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,b.localize)(3,null,(0,m.$ae)(a),(0,m.$ae)((0,m.$_d)(k)),I.toString()))),this.eb(I)}}async ab(o,i,n,a){const k=this.H(o),I=this.H(i);let C=!1;if(!!(this.capabilities&1024)||(C=(0,h.$Hf)(k,I,!0)),C){if(n==="copy")throw(0,d.$fk)((0,b.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const A=await this.L(o);if(!A)throw(0,d.$fk)((0,b.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(i);if(L){if(!a)throw(0,d.$fk)((0,b.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);A.type&d.FileType.File&&L.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(o,i){return this.bb(o,i,!1)}async bb(o,i,n){const a=this.H(o),k=this.H(i),I=!!(this.capabilities&1024);if((0,h.$Hf)(a,k,!I))return;const C=new c.$jc;try{const[p,A]=await Promise.all([this.O(o),this.O(i)]);C.add(p),C.add(A),n&&await v.Promises.mkdir((0,m.$_d)(k),{recursive:!0}),await v.Promises.copyFile(a,k)}catch(p){if(p.code==="ENOENT"&&!n)return this.bb(o,i,!0);throw this.eb(p)}finally{C.dispose()}}t(o,i,n){return new E.$Tp(a=>o(a),a=>i(a),n)}F(o,i,n){return new u.$2p(a=>o(a),a=>i(a),n)}eb(o){if(o instanceof d.$ek)return o;let i=o,n;switch(o.code){case"ENOENT":n=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${o.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=d.FileSystemProviderErrorCode.Unknown;break;default:n=d.FileSystemProviderErrorCode.Unknown}return(0,d.$fk)(i,n)}async fb(o,i){let n=this.eb(i);if(o&&n.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await v.SymlinkSupport.stat(this.H(o));a.mode&128||(n=(0,d.$fk)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return n}}e.$3p=t}),define(te[222],ie([0,1,3,93,2,17,62,22]),function(K,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=void 0;class h extends s.$kc{constructor(w,y){super(),this.a=w,this.b=y,this.F=new Map,this.G=new Map}call(w,y,f){const v=this.c(w);switch(y){case"stat":return this.g(v,f[0]);case"readdir":return this.h(v,f[0]);case"open":return this.r(v,f[0],f[1]);case"close":return this.s(f[0]);case"read":return this.t(f[0],f[1],f[2]);case"readFile":return this.j(v,f[0],f[1]);case"write":return this.u(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.n(v,f[0],f[1],f[2]);case"rename":return this.z(v,f[0],f[1],f[2]);case"copy":return this.C(v,f[0],f[1],f[2]);case"cloneFile":return this.D(v,f[0],f[1]);case"mkdir":return this.w(v,f[0]);case"delete":return this.y(v,f[0],f[1]);case"watch":return this.I(v,f[0],f[1],f[2],f[3]);case"unwatch":return this.J(f[0],f[1])}throw new Error(`IPC Command ${y} not found`)}listen(w,y,f){const v=this.c(w);switch(y){case"fileChange":return this.H(v,f[0]);case"readFileStream":return this.m(v,f[0],f[1])}throw new Error(`Unknown event ${y}`)}g(w,y){const f=this.f(w,y,!0);return this.a.stat(f)}h(w,y){const f=this.f(w,y);return this.a.readdir(f)}async j(w,y,f){const v=this.f(w,y,!0),b=await this.a.readFile(v,f);return M.$Fd.wrap(b)}m(w,y,f){const v=this.f(w,y,!0),b=new S.$pd,d=new P.$fd({onDidRemoveLastListener:()=>{b.cancel()}}),g=this.a.readFileStream(v,f,b.token);return(0,D.$xd)(g,{onData:r=>d.fire(M.$Fd.wrap(r)),onError:r=>d.fire(r),onEnd:()=>{d.fire("end"),d.dispose(),b.dispose()}}),d.event}n(w,y,f,v){const b=this.f(w,y);return this.a.writeFile(b,f.buffer,v)}r(w,y,f){const v=this.f(w,y,!0);return this.a.open(v,f)}s(w){return this.a.close(w)}async t(w,y,f){const v=M.$Fd.alloc(f),b=0,d=await this.a.read(w,y,v.buffer,b,f);return[v,d]}u(w,y,f,v,b){return this.a.write(w,y,f.buffer,v,b)}w(w,y){const f=this.f(w,y);return this.a.mkdir(f)}y(w,y,f){const v=this.f(w,y);return this.a.delete(v,f)}z(w,y,f,v){const b=this.f(w,y),d=this.f(w,f);return this.a.rename(b,d,v)}C(w,y,f,v){const b=this.f(w,y),d=this.f(w,f);return this.a.copy(b,d,v)}D(w,y,f){const v=this.f(w,y),b=this.f(w,f);return this.a.cloneFile(v,b)}H(w,y){const f=new P.$fd({onWillAddFirstListener:()=>{this.F.set(y,this.L(w,f))},onDidRemoveLastListener:()=>{(0,s.$fc)(this.F.get(y)),this.F.delete(y)}});return f.event}async I(w,y,f,v,b){const d=this.F.get(y);if(d){const g=this.f(w,v),r=d.watch(f,g,b);this.G.set(y+f,r)}}async J(w,y){const f=w+y,v=this.G.get(f);v&&((0,s.$fc)(v),this.G.delete(f))}dispose(){super.dispose();for(const[,w]of this.G)w.dispose();this.G.clear();for(const[,w]of this.F)w.dispose();this.F.clear()}}e.$yr=h;class c extends s.$kc{constructor(w,y,f,v){super(),this.c=w,this.f=f,this.g=v,this.a=new Map,this.b=this.B(new O.$3p(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(y)}h(w){const y=this.B(new P.$fd);this.B(y.event(f=>{w.fire(f.map(v=>({resource:this.c.transformOutgoingURI(v.resource),type:v.type})))})),this.B(this.b.onDidChangeFile(f=>y.fire(f))),this.B(this.b.onDidWatchError(f=>w.fire(f)))}j(w){}m(w){}watch(w,y,f){const v=this.m(this.g);return Array.isArray(v)&&(f.excludes=[...f.excludes,...v]),this.a.set(w,this.b.watch(y,f)),(0,s.$ic)(()=>{(0,s.$fc)(this.a.get(w)),this.a.delete(w)})}dispose(){for(const[,w]of this.a)w.dispose();this.a.clear(),super.dispose()}}e.$zr=c}),define(te[223],ie([0,1,15,176,4,7,16,9,222,154]),function(K,e,P,O,s,M,D,S,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c6b=void 0;class m extends h.$yr{constructor(f,v,b){super(f,v),this.M=b}c(f){return c.$Cm}f(f,v){return M.URI.revive(v)}async y(f,v,b){if(!b.useTrash)return super.y(f,v,b);const d=this.f(f,v),g=(0,S.$7d)(d.fsPath);try{await P.shell.trashItem(g)}catch{throw(0,D.$fk)(s.$i?(0,O.localize)(0,null,(0,S.$ae)(g)):(0,O.localize)(1,null,(0,S.$ae)(g)),D.FileSystemProviderErrorCode.Unknown)}}L(f,v){return new w(f,v,this.b,this.M)}}e.$c6b=m;class w extends h.$zr{watch(f,v,b){if(b.recursive)throw(0,D.$fk)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(f,v,b)}}}),define(te[224],ie([0,1,5]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$c3b=void 0;class O extends P.$$i{constructor(M=P.$8i){super(),this.m=[],this.n=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(D=>{this.n?.setLevel(D)}))}set logger(M){this.n=M;for(const{level:D,message:S}of this.m)(0,P.log)(M,D,S);this.m=[]}g(M,D){this.n?(0,P.log)(this.n,M,D):this.getLevel()<=M&&this.m.push({level:M,message:D})}dispose(){this.n?.dispose()}flush(){this.n?.flush()}}e.$c3b=O}),define(te[225],ie([0,1,7,3,5,2]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=e.$1q=void 0;class D extends s.$dj{constructor(w,y,f,v,b){super(y,f,v),this.r=w,this.t=b,this.B(b.listen("onDidChangeLogLevel",w)(d=>{(0,s.$7i)(d)?super.setLogLevel(d):super.setLogLevel(P.URI.revive(d[0]),d[1])})),this.B(b.listen("onDidChangeVisibility",w)(([d,g])=>super.setVisibility(P.URI.revive(d),g))),this.B(b.listen("onDidChangeLoggers",w)(({added:d,removed:g})=>{for(const r of d)super.registerLogger({...r,resource:P.URI.revive(r.resource)});for(const r of g)super.deregisterLogger(r.resource)}))}createConsoleMainLogger(){return new s.$bj({log:(w,y)=>{this.t.call("consoleLog",[w,y])}})}registerLogger(w){super.registerLogger(w),this.t.call("registerLogger",[w,this.r])}deregisterLogger(w){super.deregisterLogger(w),this.t.call("deregisterLogger",[w,this.r])}setLogLevel(w,y){super.setLogLevel(w,y),this.t.call("setLogLevel",[w,y])}setVisibility(w,y){super.setVisibility(w,y),this.t.call("setVisibility",[this.n(w),y])}s(w,y,f){return new S(this.t,w,y,f,this.r)}static setLogLevel(w,y,f){return w.call("setLogLevel",[y,f])}}e.$1q=D;class S extends s.$$i{constructor(w,y,f,v,b){super(v?.logLevel==="always"),this.r=w,this.s=y,this.m=!1,this.n=[],this.setLevel(f),this.r.call("createLogger",[y,v,b]).then(()=>{this.u(this.n),this.m=!0})}g(w,y){const f=[[w,y]];this.m?this.u(f):this.n.push(...f)}u(w){this.r.call("log",[this.s,w])}}class h{constructor(w,y){this.a=w,this.b=y}listen(w,y){const f=this.b(w);switch(y){case"onDidChangeLoggers":return O.Event.map(this.a.onDidChangeLoggers,v=>({added:[...v.added].map(b=>this.c(b,f)),removed:[...v.removed].map(b=>this.c(b,f))}));case"onDidChangeVisibility":return O.Event.map(this.a.onDidChangeVisibility,v=>[f.transformOutgoingURI(v[0]),v[1]]);case"onDidChangeLogLevel":return O.Event.map(this.a.onDidChangeLogLevel,v=>(0,s.$7i)(v)?v:[f.transformOutgoingURI(v[0]),v[1]])}throw new Error(`Event not found: ${y}`)}async call(w,y,f){const v=this.b(w);switch(y){case"setLogLevel":return(0,s.$7i)(f[0])?this.a.setLogLevel(f[0]):this.a.setLogLevel(P.URI.revive(v.transformIncoming(f[0][0])),f[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,v)))}throw new Error(`Call not found: ${y}`)}c(w,y){return{...w,resource:y.transformOutgoingURI(w.resource)}}}e.$2q=h;class c extends M.$kc{constructor(w,y){super(),y.call("setLogLevel",[w.getLogLevel()]),this.B(w.onDidChangeLogLevel(f=>y.call("setLogLevel",[f]))),y.call("getRegisteredLoggers").then(f=>{for(const v of f)w.registerLogger({...v,resource:P.URI.revive(v.resource)})}),this.B(y.listen("onDidChangeVisibility")(([f,v])=>w.setVisibility(P.URI.revive(f),v))),this.B(y.listen("onDidChangeLoggers")(({added:f,removed:v})=>{for(const b of f)w.registerLogger({...b,resource:P.URI.revive(b.resource)});for(const b of v)w.deregisterLogger(b.resource)}))}}e.$3q=c}),define(te[226],ie([0,1,2,5]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=void 0;class s extends P.$kc{constructor(D,S=[]){super(),this.a=new O.$cj([D,...S]),this.B(D.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...S){this.a.trace(D,...S)}debug(D,...S){this.a.debug(D,...S)}info(D,...S){this.a.info(D,...S)}warn(D,...S){this.a.warn(D,...S)}error(D,...S){this.a.error(D,...S)}flush(){this.a.flush()}}e.$mN=s}),define(te[227],ie([0,1,33,7,5]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a7b=void 0;class M{constructor(S){this.b=S,this.a=new P.$zi}listen(S,h,c){switch(h){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(S,h,c){switch(h){case"createLogger":this.c(O.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(O.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,s.$7i)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(O.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(O.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:O.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(O.URI.revive(c[0]))}throw new Error(`Call not found: ${h}`)}c(S,h,c){this.a.set(S,this.b.createLogger(S,h,c))}d(S,h){let c=console.log;switch(S){case s.LogLevel.Error:c=console.error;break;case s.LogLevel.Warning:c=console.warn;break;case s.LogLevel.Info:c=console.info;break}c.call(console,...h)}e(S,h){const c=this.a.get(S);if(!c)throw new Error("Create the logger before logging");for(const[m,w]of h)(0,s.log)(c,m,w)}}e.$a7b=M}),define(te[228],ie([0,1,16,5]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=void 0;var s;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(s||(s={}));async function M(c,m,w,y,f){try{const v=await new Promise((d,g)=>{K(["@vscode/spdlog"],d,g)});v.setFlushOn(s.Trace);const b=await v.createAsyncRotatingLogger(c,m,w,y);return f?b.clearFormatters():b.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),b}catch(v){console.error(v)}return null}function D(c,m,w){switch(m){case O.LogLevel.Trace:c.trace(w);break;case O.LogLevel.Debug:c.debug(w);break;case O.LogLevel.Info:c.info(w);break;case O.LogLevel.Warning:c.warn(w);break;case O.LogLevel.Error:c.error(w);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function S(c,m){switch(m){case O.LogLevel.Trace:c.setLevel(s.Trace);break;case O.LogLevel.Debug:c.setLevel(s.Debug);break;case O.LogLevel.Info:c.setLevel(s.Info);break;case O.LogLevel.Warning:c.setLevel(s.Warning);break;case O.LogLevel.Error:c.setLevel(s.Error);break;case O.LogLevel.Off:c.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${m}`)}}class h extends O.$$i{constructor(m,w,y,f,v){super(),this.m=[],this.setLevel(v),this.n=this.s(m,w,y,f),this.B(this.onDidChangeLogLevel(b=>{this.r&&S(this.r,b)}))}async s(m,w,y,f){const v=y?6:1,b=30/v*P.$Ak.MB,d=await M(m,w,b,v,f);if(d){this.r=d,S(this.r,this.getLevel());for(const{level:g,message:r}of this.m)D(this.r,g,r);this.m=[]}}g(m,w){this.r?D(this.r,m,w):this.getLevel()<=m&&this.m.push({level:m,message:w})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$bN=h}),define(te[229],ie([0,1,31,5,228]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cN=void 0;class M extends O.$dj{s(S,h,c){return new s.$bN((0,P.$4f)(),S.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,h)}}e.$cN=M}),define(te[66],ie([0,1,33,3,6,5,229]),function(K,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B6b=e.$A6b=void 0,e.$A6b=(0,s.$Ch)(M.$6i);class S extends D.$cN{constructor(){super(...arguments),this.u=new P.$zi}createLogger(c,m,w){w!==void 0&&this.u.set(this.n(c),w);try{return super.createLogger(c,m)}catch(y){throw this.u.delete(this.n(c)),y}}registerLogger(c,m){m!==void 0&&this.u.set(c.resource,m),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const m=[];for(const w of super.getRegisteredLoggers())c===this.u.get(w.resource)&&m.push(w);return m}getOnDidChangeLogLevelEvent(c){return O.Event.filter(this.onDidChangeLogLevel,m=>(0,M.$7i)(m)||this.w(m[0],c))}getOnDidChangeVisibilityEvent(c){return O.Event.filter(this.onDidChangeVisibility,([m])=>this.w(m,c))}getOnDidChangeLoggersEvent(c){return O.Event.filter(O.Event.map(this.onDidChangeLoggers,m=>({added:[...m.added].filter(y=>this.w(y.resource,c)),removed:[...m.removed].filter(y=>this.w(y.resource,c))})),m=>m.added.length>0||m.removed.length>0)}deregisterLoggers(c){for(const[m,w]of this.u)w===c&&this.deregisterLogger(m)}w(c,m){const w=this.u.get(c);return w===void 0||w===m}dispose(){super.dispose(),this.u.clear()}}e.$B6b=S}),define(te[230],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u6b=e.$t6b=e.$s6b=e.$r6b=void 0;function P(D){return D.submenu!==void 0}e.$r6b=P;function O(D){return D.id==="vscode.menubar.separator"}e.$s6b=O;function s(D){return D.uri!==void 0}e.$t6b=s;function M(D){return!P(D)&&!O(D)&&!s(D)}e.$u6b=M}),define(te[39],ie([0,1,3,68,2,6]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=void 0,e.$0m=(0,M.$Bh)("policy");class D extends s.$kc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$fd),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const m=Object.keys(this.f).length;return this.f={...c,...this.f},m!==Object.keys(this.f).length&&await this.j(c),O.Iterable.reduce(this.g.entries(),(w,[y,f])=>({...w,[y]:f}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(c,[m,w])=>({...c,[m]:{definition:w,value:this.g.get(m)}}),{})}}e.$$m=D;class S{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$_m=S}),define(te[231],ie([0,1,8,3,68,12,16,5,39]),function(K,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s7b=void 0;function c(w,y){const f=[];for(const v of new Set(s.Iterable.concat(w.keys(),y.keys())))w.get(v)!==y.get(v)&&f.push(v);return f}let m=class extends h.$$m{constructor(y,f,v){super(),this.m=y,this.n=f,this.s=v,this.c=this.B(new P.$Eg(500));const b=O.Event.filter(f.onDidFilesChange,d=>d.affects(y));this.B(f.watch(y)),this.B(b(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const y=new Map;try{const f=await this.n.readFile(this.m),v=JSON.parse(f.value.toString());if(!(0,M.$lf)(v))throw new Error("Policy file isn't a JSON object");for(const b of Object.keys(v))this.f[b]&&y.set(b,v[b])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return y}async w(){const y=await this.u(),f=c(this.g,y);this.g=y,f.length>0&&this.h.fire(f)}};e.$s7b=m,e.$s7b=m=ke([_(1,D.$6j),_(2,S.$5i)],m)}),define(te[232],ie([0,1,3,2,39]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$76b=e.$66b=void 0;class M{constructor(h){this.b=h,this.a=new O.$jc}listen(h,c){switch(c){case"onDidChange":return P.Event.map(this.b.onDidChange,m=>m.reduce((w,y)=>({...w,[y]:this.b.getPolicyValue(y)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(h,c,m){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(m)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$66b=M;class D extends s.$$m{constructor(h,c){super(),this.a=c;for(const m in h){const{definition:w,value:y}=h[m];this.f[m]=w,y!==void 0&&this.g.set(m,y)}this.a.listen("onDidChange")(m=>{for(const w in m){const y=m[w];y===null?this.g.delete(w):this.g.set(w,y)}this.h.fire(Object.keys(m))})}async j(h){const c=await this.a.call("updatePolicyDefinitions",h);for(const m in c)this.g.set(m,c[m])}}e.$76b=D}),define(te[233],ie([0,1,39,8,311,2,5]),function(K,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r7b=void 0;let S=class extends P.$$m{constructor(c,m){super(),this.m=c,this.n=m,this.a=new O.$Ag,this.b=this.B(new M.$lc)}async j(c){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((m,w)=>{try{this.b.value=(0,s.createWatcher)(this.n,c,y=>{this.t(y),m()})}catch(y){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",y),w(y)}}))}t(c){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const m in c){const w=c[m];w===void 0?this.g.delete(m):this.g.set(m,w)}this.h.fire(Object.keys(c))}};e.$r7b=S,e.$r7b=S=ke([_(0,D.$5i)],S)}),define(te[77],ie([0,1,4,35]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof P.$g.vscode<"u"&&typeof P.$g.vscode.context<"u"){const M=P.$g.vscode.context.configuration();if(M)s=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:M.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(te[24],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=e.$kj=void 0,e.$kj=(0,P.$Bh)("productService"),e.$lj="vscode://schemas/vscode-product"}),define(te[234],ie([0,1,72,5,24]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$75b=void 0;let M=class{constructor(S,h){this.b=S,this.c=h,this.a=new Map}async isExtensionUrlTrusted(S,h){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const c=/^(.*)#([^#]+)$/.exec(h);if(!c)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,m,w]=c;let y=this.a.get(S);if(!y){if(y=this.b.trustedExtensionUrlPublicKeys[S],!y||y.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",S),!1;this.a.set(S,[...y])}const f=Buffer.from(decodeURIComponent(w),"base64");if(f.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const v=f.slice(0,6),b=f.readUIntBE(0,6),d=Date.now()-b;if(d<0||d>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const g=f.slice(6),r=P.createVerify("SHA256");r.write(v),r.write(Buffer.from(m)),r.end();for(let $=0;$<y.length;$++){let E=y[$];if(E!==null){if(typeof E=="string")try{E=P.createPublicKey({key:Buffer.from(E,"base64"),format:"der",type:"spki"}),y[$]=E}catch(u){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${$+1} for ${S}:`,u),y[$]=null;continue}if(r.verify(E,g))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};e.$75b=M,e.$75b=M=ke([_(0,s.$kj),_(1,O.$5i)],M)}),define(te[235],ie([0,1,8,5]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h6b=void 0;let s=class{constructor(D,S,h){this.a=D,this.b=S,this.c=h}async inspect(D){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.$Hg)(D);const h=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$h6b=s,e.$h6b=s=ke([_(2,O.$5i)],s)}),define(te[78],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k6b=void 0,e.$k6b=(0,P.$Bh)("protocolMainService")}),define(te[43],ie([0,1,135,12]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0;class s{constructor(){this.a=new Map}add(D,S){P.ok(O.$jf(D)),P.ok(O.$lf(S)),P.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$8m=new s}),define(te[236],ie([0,1,3,43]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$9m={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class M{constructor(){this.b=new P.$fd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,c){this.a[s(h)]=c,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const D=new M;O.$8m.add(e.$9m.JSONContribution,D)}),define(te[58],ie([0,1,23,3,12,161,18,236,43]),function(K,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.ConfigurationScope=e.$an=e.EditPresentationTypes=void 0;var c;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$an={Configuration:"base.contributions.configuration"};var m;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(m||(e.ConfigurationScope=m={})),e.$bn={properties:{},patternProperties:{}},e.$cn={properties:{},patternProperties:{}},e.$dn={properties:{},patternProperties:{}},e.$en={properties:{},patternProperties:{}},e.$fn={properties:{},patternProperties:{}},e.$gn={properties:{},patternProperties:{}},e.$hn="vscode://schemas/settings/resourceLanguage",e.$in="vscode://schemas/settings/configurationDefaults";const w=h.$8m.as(S.$9m.JSONContribution);class y{constructor(){this.h=new Set,this.i=new O.$fd,this.onDidSchemaChange=this.i.event,this.j=new O.$fd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.$hn,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const o=new Set;this.n(t,l,o),w.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:o})}deregisterConfigurations(t){const l=new Set;this.o(t,l),w.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const o=new Set;this.o(l,o),this.n(t,!1,o),w.registerSchema(e.$hn,this.g),this.i.fire(),this.j.fire({properties:o})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const o=[];for(const{overrides:i,source:n}of t)for(const a in i)if(l.add(a),e.$kn.test(a)){const k=this.a.get(a),I=k?.valuesSources??new Map;if(n)for(const L of Object.keys(i[a]))I.set(L,n);const C={...k?.value||{},...i[a]};this.a.set(a,{source:n,value:C,valuesSources:I});const p=(0,D.$fi)(a),A={type:"object",default:C,description:M.localize(1,null,p),$ref:e.$hn,defaultDefaultValue:C,source:s.$jf(n)?void 0:n,defaultValueSource:n};o.push(...b(a)),this.d[a]=A,this.b.properties[a]=A}else{this.a.set(a,{value:i[a],source:n});const k=this.d[a];k&&(this.w(a,k),this.r(a,k))}this.m(o)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:o,source:i}of t)for(const n in o){const a=this.a.get(n),k=s.$jf(i)?i:i?.id,I=s.$jf(a?.source)?a?.source:a?.source?.id;if(k===I)if(l.add(n),this.a.delete(n),e.$kn.test(n))delete this.d[n],delete this.b.properties[n];else{const C=this.d[n];C&&(this.w(n,C),this.r(n,C))}}this.u()}deltaConfiguration(t){let l=!1;const o=new Set;t.removedDefaults&&(this.l(t.removedDefaults,o),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,o),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,o),t.addedConfigurations&&this.n(t.addedConfigurations,!1,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,o){t.forEach(i=>{this.p(i,l,i.extensionInfo,i.restrictedProperties,void 0,o),this.c.push(i),this.q(i)})}o(t,l){const o=i=>{if(i.properties)for(const n in i.properties){l.add(n);const a=this.d[n];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>o(n))};for(const i of t){o(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,l=!0,o,i,n=3,a){n=s.$sf(t.scope)?n:t.scope;const k=t.properties;if(k)for(const C in k){const p=k[C];if(l&&$(C,p)){delete k[C];continue}if(p.source=o,p.defaultDefaultValue=k[C].default,this.w(C,p),e.$kn.test(C)?p.scope=void 0:(p.scope=s.$sf(p.scope)?n:p.scope,p.restricted=s.$sf(p.restricted)?!!i?.includes(C):p.restricted),k[C].hasOwnProperty("included")&&!k[C].included){this.f[C]=k[C],delete k[C];continue}else this.d[C]=k[C],k[C].policy?.name&&this.e.set(k[C].policy.name,C);!k[C].deprecationMessage&&k[C].markdownDeprecationMessage&&(k[C].deprecationMessage=k[C].markdownDeprecationMessage),a.add(C)}const I=t.allOf;if(I)for(const C of I)this.p(C,l,o,i,n,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=o=>{const i=o.properties;if(i)for(const a in i)this.r(a,i[a]);o.allOf?.forEach(l)};l(t)}r(t,l){switch(e.$bn.properties[t]=l,l.scope){case 1:e.$cn.properties[t]=l;break;case 2:e.$dn.properties[t]=l;break;case 6:e.$en.properties[t]=l;break;case 3:e.$fn.properties[t]=l;break;case 4:e.$gn.properties[t]=l;break;case 5:e.$gn.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.$bn.properties[t],l.scope){case 1:delete e.$cn.properties[t];break;case 2:delete e.$dn.properties[t];break;case 6:delete e.$en.properties[t];break;case 3:delete e.$fn.properties[t];break;case 4:case 5:delete e.$gn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,o={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$hn};this.w(l,o),e.$bn.properties[l]=o,e.$cn.properties[l]=o,e.$dn.properties[l]=o,e.$en.properties[l]=o,e.$fn.properties[l]=o,e.$gn.properties[l]=o}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$hn};e.$bn.patternProperties[e.$jn]=t,e.$cn.patternProperties[e.$jn]=t,e.$dn.patternProperties[e.$jn]=t,e.$en.patternProperties[e.$jn]=t,e.$fn.patternProperties[e.$jn]=t,e.$gn.patternProperties[e.$jn]=t,this.i.fire()}w(t,l){const o=this.a.get(t);let i=o?.value,n=o?.source;s.$qf(i)&&(i=l.defaultDefaultValue,n=void 0),s.$qf(i)&&(i=g(l.type)),l.default=i,l.defaultValueSource=n}}const f="\\[([^\\]]+)\\]",v=new RegExp(f,"g");e.$jn=`^(${f})+$`,e.$kn=new RegExp(e.$jn);function b(u){const t=[];if(e.$kn.test(u)){let l=v.exec(u);for(;l?.length;){const o=l[1].trim();o&&t.push(o),l=v.exec(u)}}return(0,P.$Kb)(t)}e.$ln=b;function d(u){return u.reduce((t,l)=>`${t}[${l}]`,"")}e.$mn=d;function g(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$nn=g;const r=new y;h.$8m.add(e.$an.Configuration,r);function $(u,t){return u.trim()?e.$kn.test(u)?M.localize(7,null,u):r.getConfigurationProperties()[u]!==void 0?M.localize(8,null,u):t.policy?.name&&r.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,u,t.policy?.name,r.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$on=$;function E(){const u=[],t=r.getConfigurationProperties();for(const l of Object.keys(t))u.push([l,t[l].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$pn=E}),define(te[118],ie([0,1,23,3,44,2,33,37,12,7,18,58,43]),function(K,e,P,O,s,M,D,S,h,c,m,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vn=e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function f(l){return Object.isFrozen(l)?l:S.$Wm(l)}class v{constructor(o={},i=[],n=[],a){this.b=o,this.c=i,this.d=n,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const o=this.raw.map(i=>{if(i instanceof v)return i;const n=new b("");return n.parseRaw(i),n.configurationModel});this.f=o.reduce((i,n)=>n===i?n:i.merge(n),o[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(o){return o?(0,m.$di)(this.contents,o):this.contents}inspect(o,i){const n=this.rawConfiguration.getValue(o),a=i?this.rawConfiguration.getOverrideValue(o,i):void 0,k=i?this.rawConfiguration.override(i).getValue(o):n;return{value:n,override:a,merged:k}}getOverrideValue(o,i){const n=this.i(i);return n?o?(0,m.$di)(n,o):n:void 0}getKeysForOverrideIdentifier(o){const i=[];for(const n of this.overrides)n.identifiers.includes(o)&&i.push(...n.keys);return P.$Kb(i)}getAllOverrideIdentifiers(){const o=[];for(const i of this.overrides)o.push(...i.identifiers);return P.$Kb(o)}override(o){let i=this.a.get(o);return i||(i=this.g(o),this.a.set(o,i)),i}merge(...o){const i=S.$Vm(this.contents),n=S.$Vm(this.overrides),a=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const I of o)if(k.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(i,I.contents);for(const C of I.overrides){const[p]=n.filter(A=>P.$sb(A.identifiers,C.identifiers));p?(this.h(p.contents,C.contents),p.keys.push(...C.keys),p.keys=P.$Kb(p.keys)):n.push(S.$Vm(C))}for(const C of I.keys)a.indexOf(C)===-1&&a.push(C)}return new v(i,a,n,k.every(I=>I instanceof v)?void 0:k)}g(o){const i=this.i(o);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const a of P.$Kb([...Object.keys(this.contents),...Object.keys(i)])){let k=this.contents[a];const I=i[a];I&&(typeof k=="object"&&typeof I=="object"?(k=S.$Vm(k),this.h(k,I)):k=I),n[a]=k}return new v(n,this.keys,this.overrides)}h(o,i){for(const n of Object.keys(i)){if(n in o&&h.$lf(o[n])&&h.$lf(i[n])){this.h(o[n],i[n]);continue}o[n]=S.$Vm(i[n])}}i(o){let i=null,n=null;const a=k=>{k&&(n?this.h(n,k):n=S.$Vm(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===o?i=k.contents:k.identifiers.includes(o)&&a(k.contents);return a(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(o,i){this.j(o,i,!0)}setValue(o,i){this.j(o,i,!1)}removeValue(o){const i=this.keys.indexOf(o);i!==-1&&(this.keys.splice(i,1),(0,m.$ci)(this.contents,o),w.$kn.test(o)&&this.overrides.splice(this.overrides.findIndex(n=>P.$sb(n.identifiers,(0,w.$ln)(o))),1))}j(o,i,n){(0,m.$bi)(this.contents,o,i,a=>console.error(a)),n=n||this.keys.indexOf(o)===-1,n&&this.keys.push(o),w.$kn.test(o)&&this.overrides.push({identifiers:(0,w.$ln)(o),keys:Object.keys(this.contents[o]),contents:(0,m.$ai)(this.contents[o],a=>console.error(a))})}}e.$qn=v;class b{constructor(o){this.f=o,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(o,i){if(!h.$sf(o)){const n=this.g(o);this.parseRaw(n,i)}}reparse(o){this.a&&this.parseRaw(this.a,o)}parseRaw(o,i){this.a=o;const{contents:n,keys:a,overrides:k,restricted:I,hasExcludedProperties:C}=this.h(o,i);this.b=new v(n,a,k,C?[o]:void 0),this.c=I||[]}g(o){let i={},n=null,a=[];const k=[],I=[];function C(A){Array.isArray(a)?a.push(A):n!==null&&(a[n]=A)}const p={onObjectBegin:()=>{const A={};C(A),k.push(a),a=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{a=k.pop()},onArrayBegin:()=>{const A=[];C(A),k.push(a),a=A,n=null},onArrayEnd:()=>{a=k.pop()},onLiteralValue:C,onError:(A,L,U)=>{I.push({error:A,offset:L,length:U})}};if(o)try{s.$Sm(o,p),i=a[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return i}h(o,i){const n=y.$8m.as(w.$an.Configuration).getConfigurationProperties(),a=this.i(o,n,!0,i);o=a.raw;const k=(0,m.$ai)(o,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),I=Object.keys(o),C=this.j(o,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:k,keys:I,overrides:C,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(o,i,n,a){let k=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:o,restricted:[],hasExcludedProperties:k};const I={},C=[];for(const p in o)if(w.$kn.test(p)&&n){const A=this.i(o[p],i,!1,a);I[p]=A.raw,k=k||A.hasExcludedProperties,C.push(...A.restricted)}else{const A=i[p],L=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&C.push(p),!a.exclude?.includes(p)&&(a.include?.includes(p)||(L===void 0||a.scopes===void 0||a.scopes.includes(L))&&!(a.skipRestricted&&A?.restricted))?I[p]=o[p]:k=!0}return{raw:I,restricted:C,hasExcludedProperties:k}}j(o,i){const n=[];for(const a of Object.keys(o))if(w.$kn.test(a)){const k={};for(const I in o[a])k[I]=o[a][I];n.push({identifiers:(0,w.$ln)(a),keys:Object.keys(k),contents:(0,m.$ai)(k,i)})}return n}}e.$rn=b;class d extends M.$kc{constructor(o,i,n,a){super(),this.c=o,this.f=i,this.g=a,this.b=this.B(new O.$fd),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&n.isEqual(k.resource,o)))(()=>this.b.fire()))}async loadConfiguration(){try{const o=await this.g.readFile(this.c);return this.a.parse(o.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(o){return o&&(this.f=o),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$sn=d;class g{constructor(o,i,n,a,k,I,C,p,A,L,U,z,re){this.a=o,this.b=i,this.c=n,this.overrideIdentifiers=a,this.d=k,this.f=I,this.g=C,this.h=p,this.i=A,this.j=L,this.k=U,this.l=z,this.m=re}get value(){return f(this.c)}n(o,i,n){const a=o.inspect(i,n);return{get value(){return f(a.value)},get override(){return f(a.override)},get merged(){return f(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class r{constructor(o,i,n,a,k=new v,I=new v,C=new D.$zi,p=new v,A=new D.$zi){this.c=o,this.d=i,this.f=n,this.g=a,this.h=k,this.i=I,this.j=C,this.l=p,this.m=A,this.a=null,this.b=new D.$zi,this.n=null}getValue(o,i,n){return this.q(o,i,n).getValue(o)}updateValue(o,i,n={}){let a;n.resource?(a=this.m.get(n.resource),a||(a=new v,this.m.set(n.resource,a))):a=this.l,i===void 0?a.removeValue(o):a.setValue(o,i),n.resource||(this.a=null)}inspect(o,i,n){const a=this.q(o,i,n),k=this.u(i.resource,n),I=i.resource?this.m.get(i.resource)||this.l:this.l,C=new Set;for(const p of a.overrides)for(const A of p.identifiers)a.getOverrideValue(o,A)!==void 0&&C.add(A);return new g(o,i,a.getValue(o),C.size?[...C]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,k||void 0,I)}keys(o){const i=this.u(void 0,o);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(o){this.c=o,this.a=null,this.b.clear()}updatePolicyConfiguration(o){this.d=o}updateApplicationConfiguration(o){this.f=o,this.a=null,this.b.clear()}updateLocalUserConfiguration(o){this.g=o,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(o){this.h=o,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(o){this.i=o,this.a=null,this.b.clear()}updateFolderConfiguration(o,i){this.j.set(o,i),this.b.delete(o)}deleteFolderConfiguration(o){this.p.delete(o),this.b.delete(o)}compareAndUpdateDefaultConfiguration(o,i){const n=[];if(!i){const{added:a,updated:k,removed:I}=u(this.c,o);i=[...a,...k,...I]}for(const a of i)for(const k of(0,w.$ln)(a)){const I=this.c.getKeysForOverrideIdentifier(k),C=o.getKeysForOverrideIdentifier(k),p=[...C.filter(A=>I.indexOf(A)===-1),...I.filter(A=>C.indexOf(A)===-1),...I.filter(A=>!S.$Zm(this.c.override(k).getValue(A),o.override(k).getValue(A)))];n.push([k,p])}return this.updateDefaultConfiguration(o),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(o){const{added:i,updated:n,removed:a}=u(this.d,o),k=[...i,...n,...a];return k.length&&this.updatePolicyConfiguration(o),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(o){const{added:i,updated:n,removed:a,overrides:k}=u(this.applicationConfiguration,o),I=[...i,...n,...a];return I.length&&this.updateApplicationConfiguration(o),{keys:I,overrides:k}}compareAndUpdateLocalUserConfiguration(o){const{added:i,updated:n,removed:a,overrides:k}=u(this.localUserConfiguration,o),I=[...i,...n,...a];return I.length&&this.updateLocalUserConfiguration(o),{keys:I,overrides:k}}compareAndUpdateRemoteUserConfiguration(o){const{added:i,updated:n,removed:a,overrides:k}=u(this.remoteUserConfiguration,o),I=[...i,...n,...a];return I.length&&this.updateRemoteUserConfiguration(o),{keys:I,overrides:k}}compareAndUpdateWorkspaceConfiguration(o){const{added:i,updated:n,removed:a,overrides:k}=u(this.workspaceConfiguration,o),I=[...i,...n,...a];return I.length&&this.updateWorkspaceConfiguration(o),{keys:I,overrides:k}}compareAndUpdateFolderConfiguration(o,i){const n=this.p.get(o),{added:a,updated:k,removed:I,overrides:C}=u(n,i),p=[...a,...k,...I];return(p.length||!n)&&this.updateFolderConfiguration(o,i),{keys:p,overrides:C}}compareAndDeleteFolderConfiguration(o){const i=this.p.get(o);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(o);const{added:n,updated:a,removed:k,overrides:I}=u(i,void 0);return{keys:[...n,...a,...k],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(o,i,n){let a=this.r(i,n);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(o)!==void 0&&(a=a.merge(this.d)),a}r({resource:o},i){let n=this.s();if(i&&o){const a=i.getFolder(o);a&&(n=this.t(a.uri)||n);const k=this.m.get(o);k&&(n=n.merge(k))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(o){let i=this.b.get(o);if(!i){const n=this.s(),a=this.j.get(o);a?(i=n.merge(a),this.b.set(o,i)):i=n}return i}u(o,i){if(i&&o){const n=i.getFolder(o);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((o,i)=>{const{contents:n,overrides:a,keys:k}=this.j.get(i);return o.push([i,{contents:n,overrides:a,keys:k}]),o},[])}}allKeys(){const o=new Set;return this.c.keys.forEach(i=>o.add(i)),this.userConfiguration.keys.forEach(i=>o.add(i)),this.i.keys.forEach(i=>o.add(i)),this.j.forEach(i=>i.keys.forEach(n=>o.add(n))),[...o.values()]}v(){const o=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>o.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>o.add(n))),[...o.values()]}w(o){const i=new Set;return this.c.getKeysForOverrideIdentifier(o).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(o).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(o).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(o).forEach(a=>i.add(a))),[...i.values()]}static parse(o){const i=this.x(o.defaults),n=this.x(o.policy),a=this.x(o.application),k=this.x(o.user),I=this.x(o.workspace),C=o.folders.reduce((p,A)=>(p.set(c.URI.revive(A[0]),this.x(A[1])),p),new D.$zi);return new r(i,n,a,k,new v,I,C,new v,new D.$zi)}static x(o){return new v(o.contents,o.keys,o.overrides)}}e.$tn=r;function $(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const o=new Set,i=new Map;for(const a of l)a.keys.forEach(k=>o.add(k)),a.overrides.forEach(([k,I])=>{const C=(0,D.$wi)(i,k,new Set);I.forEach(p=>C.add(p))});const n=[];return i.forEach((a,k)=>n.push([k,[...a.values()]])),{keys:[...o.values()],overrides:n}}e.$un=$;class E{constructor(o,i,n,a){this.change=o,this.f=i,this.g=n,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of o.keys)this.affectedKeys.add(k);for(const[,k]of o.overrides)for(const I of k)this.affectedKeys.add(I);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=r.parse(this.f.data)),this.i}affectsConfiguration(o,i){const n=this.a+o,a=this.d.indexOf(n);if(a<0)return!1;const k=a+n.length;if(k>=this.d.length)return!1;const I=this.d.charCodeAt(k);if(I!==this.b&&I!==this.c)return!1;if(i){const C=this.previousConfiguration?this.previousConfiguration.getValue(o,i,this.f?.workspace):void 0,p=this.g.getValue(o,i,this.h);return!S.$Zm(C,p)}return!0}}e.$vn=E;function u(l,o){const{added:i,removed:n,updated:a}=t(o?.rawConfiguration,l?.rawConfiguration),k=[],I=l?.getAllOverrideIdentifiers()||[],C=o?.getAllOverrideIdentifiers()||[];if(o){const p=C.filter(A=>!I.includes(A));for(const A of p)k.push([A,o.getKeysForOverrideIdentifier(A)])}if(l){const p=I.filter(A=>!C.includes(A));for(const A of p)k.push([A,l.getKeysForOverrideIdentifier(A)])}if(o&&l){for(const p of I)if(C.includes(p)){const A=t({contents:l.getOverrideValue(void 0,p)||{},keys:l.getKeysForOverrideIdentifier(p)},{contents:o.getOverrideValue(void 0,p)||{},keys:o.getKeysForOverrideIdentifier(p)});k.push([p,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:n,updated:a,overrides:k}}function t(l,o){const i=l?o?l.keys.filter(k=>o.keys.indexOf(k)===-1):[...l.keys]:[],n=o?l?o.keys.filter(k=>l.keys.indexOf(k)===-1):[...o.keys]:[],a=[];if(l&&o){for(const k of o.keys)if(l.keys.indexOf(k)!==-1){const I=(0,m.$di)(o.contents,k),C=(0,m.$di)(l.contents,k);S.$Zm(I,C)||a.push(k)}}return{added:i,removed:n,updated:a}}}),define(te[237],ie([0,1,23,3,2,37,12,118,58,5,39,43]),function(K,e,P,O,s,M,D,S,h,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=e.$wn=void 0;class y extends s.$kc{constructor(){super(...arguments),this.a=this.B(new O.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$qn}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(w.$8m.as(h.$an.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:g})=>this.c(Array.from(d),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(d,g){this.h(d,w.$8m.as(h.$an.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}f(){return{}}g(){this.b=new S.$qn;const d=w.$8m.as(h.$an.Configuration).getConfigurationProperties();this.h(Object.keys(d),d)}h(d,g){const r=this.f();for(const $ of d){const E=r[$],u=g[$];E!==void 0?this.b.addValue($,E):u?this.b.addValue($,u.default):this.b.removeValue($)}}}e.$wn=y;class f{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=new S.$qn}async initialize(){return this.configurationModel}}e.$xn=f;let v=class extends s.$kc{get configurationModel(){return this.b}constructor(d,g,r){super(),this.c=d,this.f=g,this.g=r,this.a=this.B(new O.$fd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$qn}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const g={},r=[],$=w.$8m.as(h.$an.Configuration).getConfigurationProperties();for(const E of d){const u=$[E];if(!u){r.push(E);continue}if(u.policy){if(u.type!=="string"&&u.type!=="number"){this.g.warn(`Policy ${u.policy.name} has unsupported type ${u.type}`);continue}r.push(E),g[u.policy.name]={type:u.type}}}return(0,D.$wf)(g)||await this.f.updatePolicyDefinitions(g),r}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const g=w.$8m.as(h.$an.Configuration).getPolicyConfigurations(),r=(0,P.$Fb)(d.map($=>g.get($)));this.m(r,!0)}m(d,g){this.g.trace("PolicyConfiguration#update",d);const r=w.$8m.as(h.$an.Configuration).getConfigurationProperties(),$=[],E=this.b.isEmpty();for(const u of d){const t=r[u]?.policy?.name;if(t){const l=this.f.getPolicyValue(t);(E?l!==void 0:!(0,M.$Zm)(this.b.getValue(u),l))&&$.push([u,l])}else this.b.getValue(u)!==void 0&&$.push([u,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const u=this.b;this.b=new S.$qn;for(const t of u.keys)this.b.setValue(t,u.getValue(t));for(const[t,l]of $)l===void 0?this.b.removeValue(t):this.b.setValue(t,l);g&&this.a.fire(this.b)}}};e.$yn=v,e.$yn=v=ke([_(1,m.$0m),_(2,c.$5i)],v)}),define(te[238],ie([0,1,8,3,2,19,18,118,237,39]),function(K,e,P,O,s,M,D,S,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=void 0;class m extends s.$kc{constructor(y,f,v,b){super(),this.j=y,this.h=this.B(new O.$fd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.$wn),this.c=v instanceof c.$_m?new h.$xn:this.B(new h.$yn(this.b,v,b)),this.f=this.B(new S.$sn(this.j,{},M.$_f,f)),this.a=new S.$tn(this.b.configurationModel,this.c.configurationModel,new S.$qn,new S.$qn),this.g=this.B(new P.$Sg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:d,properties:g})=>this.n(d,g))),this.B(this.c.onDidChangeConfiguration(d=>this.r(d))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[y,f,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$tn(y,f,new S.$qn,v)}getConfigurationData(){return this.a.toData()}getValue(y,f){const v=typeof y=="string"?y:void 0,b=(0,D.$9h)(y)?y:(0,D.$9h)(f)?f:{};return this.a.getValue(v,b,void 0)}updateValue(y,f,v,b){return Promise.reject(new Error("not supported"))}inspect(y){return this.a.inspect(y,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const y=await this.f.loadConfiguration();this.m(y)}m(y){const f=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(y);this.s(v,f,2)}n(y,f){const v=this.a.toData(),b=this.a.compareAndUpdateDefaultConfiguration(y,f);this.s(b,v,7)}r(y){const f=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(y);this.s(v,f,7)}s(y,f,v){const b=new S.$vn(y,{data:f},this.a);b.source=v,b.sourceConfig=this.t(v),this.h.fire(b)}t(y){switch(y){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$zn=m}),define(te[239],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h7b=e.$g7b=e.$f7b=void 0,e.$f7b="request",e.$g7b="remoteResourceHandler";class P{async routeCall(s,M,D){if(M!==e.$f7b)throw new Error(`Call not found: ${M}`);const S=D[0];if(S?.authority){const h=s.connections.find(c=>c.ctx===S.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(s,M){throw new Error(`Event not found: ${M}`)}}e.$h7b=P}),define(te[240],ie([0,1,14,6]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.$Mk=e.RemoteAuthorityResolverErrorCode=e.$Lk=e.$Kk=e.RemoteConnectionType=e.$Jk=void 0,e.$Jk=(0,O.$Bh)("remoteAuthorityResolverService");var s;(function(m){m[m.WebSocket=0]="WebSocket",m[m.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class M{constructor(w){this.id=w,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kk=M;class D{constructor(w,y){this.host=w,this.port=y,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Lk=D;var S;(function(m){m.Unknown="Unknown",m.NotAvailable="NotAvailable",m.TemporarilyNotAvailable="TemporarilyNotAvailable",m.NoResolverFound="NoResolverFound",m.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class h extends P.$_{static isNotAvailable(w){return w instanceof h&&w._code===S.NotAvailable}static isTemporarilyNotAvailable(w){return w instanceof h&&w._code===S.TemporarilyNotAvailable}static isNoResolverFound(w){return w instanceof h&&w._code===S.NoResolverFound}static isInvalidAuthority(w){return w instanceof h&&w._code===S.InvalidAuthority}static isHandled(w){return w instanceof h&&w.isHandled}constructor(w,y=S.Unknown,f){super(w),this._message=w,this._code=y,this._detail=f,this.isHandled=y===S.NotAvailable&&f===!0,Object.setPrototypeOf(this,h.prototype)}}e.$Mk=h;function c(m){const w=m.indexOf("+");return w===-1?m:m.substring(0,w)}e.$Nk=c}),define(te[59],ie([0,1,13]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=void 0;function O(c){return c.scheme===P.Schemas.vscodeRemote?c.authority:void 0}e.$Ok=O;function s(c){if(!c)return;const m=c.indexOf("+");return m<0?c:c.substr(0,m)}e.$Pk=s;function M(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Qk=M;function D(c){const{host:m,port:w}=h(c);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:m,port:w}}e.$Rk=D;function S(c,m){let{host:w,port:y}=h(c);return typeof y>"u"&&(y=m),{host:w,port:y}}e.$Sk=S;function h(c){const m=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(m)return{host:m[1],port:parseInt(m[2],10)};const w=c.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const y=c.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:c,port:void 0}}}),define(te[119],ie([0,1,26,6,59]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.TargetPlatform=e.ExtensionType=e.$Ul=e.$Tl=e.$Sl=e.$Rl=e.$Ql=e.$Pl=void 0,e.$Pl="extensions.user.cache",e.$Ql="extensions.builtin.cache",e.$Rl="undefined_publisher",e.$Sl=["ui","workspace","web"];function M(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$Tl=M,e.$Ul=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(D||(e.ExtensionType=D={}));var S;(function(b){b.WIN32_X64="win32-x64",b.WIN32_IA32="win32-ia32",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class h{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,g){if(typeof d>"u"||d===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof d=="string"||typeof g=="string"){const r=typeof d=="string"?d:d.value,$=typeof g=="string"?g:g.value;return P.$Me(r,$)}return d._lower===g._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Vl=h;class c{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const g of d)this.add(g)}add(d){this.c.add(h.toKey(d))}delete(d){return this.c.delete(h.toKey(d))}has(d){return this.c.has(h.toKey(d))}}e.$Wl=c;class m{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(h.toKey(d))}get(d){return this.c.get(h.toKey(d))}has(d){return this.c.has(h.toKey(d))}set(d,g){this.c.set(h.toKey(d),g)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Xl=m;function w(b){return y(b)}e.$Yl=w;function y(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.$Zl=y;function f(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.$1l=f;function v(b,d){if(d){const g=`onResolveRemoteAuthority:${(0,s.$Pk)(d)}`;return!!b.activationEvents?.includes(g)}return!1}e.$2l=v,e.$3l=(0,O.$Bh)("IBuiltinExtensionsScannerService")}),define(te[241],ie([0,1,8,17,22,14,3,2,65,69,31,109,240,59]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8k=e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.$1k=e.PersistentConnectionEventType=e.$Zk=e.$Yk=e.$Xk=e.ConnectionType=void 0;const v=30*1e3;var b;(function(Y){Y[Y.Management=1]="Management",Y[Y.ExtensionHost=2]="ExtensionHost",Y[Y.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function d(Y){switch(Y){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(Y){const R=new s.$pd;return setTimeout(()=>R.cancel(),Y),R.token}function r(Y,R){if(Y.isCancellationRequested||R.isCancellationRequested)return s.CancellationToken.Cancelled;const j=new s.$pd;return Y.onCancellationRequested(()=>j.cancel()),R.onCancellationRequested(()=>j.cancel()),j.token}class ${get didTimeout(){return this.c==="timedout"}constructor(R){this.c="pending",this.d=new S.$jc,this.promise=new Promise((j,W)=>{this.f=j,this.g=W}),R.isCancellationRequested?this.h():this.d.add(R.onCancellationRequested(()=>this.h()))}registerDisposable(R){this.c==="pending"?this.d.add(R):R.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const R=new Error("Time limit reached");return R.code="ETIMEDOUT",R.syscall="connect",R}resolve(R){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(R))}reject(R){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(R))}}function E(Y,R){const j=new $(R);return j.registerDisposable(Y.onControlMessage(W=>{const T=JSON.parse(W.toString()),H=F(T);H?j.reject(H):j.resolve(T)})),j.promise}function u(Y,R,j,W,T,H,B,ne){const fe=new $(ne),ge=c.$bd.create(!1);return Y.info(`Creating a socket (${B})...`),h.mark(`code/willCreateSocket/${H}`),R.connect(j,W,T,B).then(ue=>{fe.didTimeout?(h.mark(`code/didCreateSocketError/${H}`),Y.info(`Creating a socket (${B}) finished after ${ge.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(h.mark(`code/didCreateSocketOK/${H}`),Y.info(`Creating a socket (${B}) was successful after ${ge.elapsed()} ms.`),fe.resolve(ue))},ue=>{h.mark(`code/didCreateSocketError/${H}`),Y.info(`Creating a socket (${B}) returned an error after ${ge.elapsed()} ms.`),Y.error(ue),fe.reject(ue)}),fe.promise}function t(Y,R){const j=new $(R);return Y.then(W=>{j.didTimeout||j.resolve(W)},W=>{j.didTimeout||j.reject(W)}),j.promise}async function l(Y,R,j,W){const T=x(Y,R);Y.logService.trace(`${T} 1/6. invoking socketFactory.connect().`);let H;try{H=await u(Y.logService,Y.remoteSocketFactoryService,Y.connectTo,(0,f.$Qk)(Y),`reconnectionToken=${Y.reconnectionToken}&reconnection=${Y.reconnectionProtocol?"true":"false"}`,d(R),`renderer-${d(R)}-${Y.reconnectionToken}`,W)}catch(ue){throw Y.logService.error(`${T} socketFactory.connect() failed or timed out. Error:`),Y.logService.error(ue),ue}Y.logService.trace(`${T} 2/6. socketFactory.connect() was successful.`);let B,ne;Y.reconnectionProtocol?(Y.reconnectionProtocol.beginAcceptReconnection(H,null),B=Y.reconnectionProtocol,ne=!1):(B=new w.$ph({socket:H}),ne=!0),Y.logService.trace(`${T} 3/6. sending AuthRequest control message.`);const fe=await t(Y.signService.createNewMessage((0,m.$4f)()),W),ge={type:"auth",auth:Y.connectionToken||"00000000000000000000",data:fe.data};B.sendControl(O.$Fd.fromString(JSON.stringify(ge)));try{const ue=await E(B,r(W,g(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(Y.logService.trace(`${T} 4/6. received SignRequest control message.`),!await t(Y.signService.validate(fe,ue.signedData),W)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const me=await t(Y.signService.sign(ue.data),W),Se={type:"connectionType",commit:Y.commit,signedData:me,desiredConnectionType:R};return j&&(Se.args=j),Y.logService.trace(`${T} 5/6. sending ConnectionTypeRequest control message.`),B.sendControl(O.$Fd.fromString(JSON.stringify(Se))),{protocol:B,ownsProtocol:ne}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(Y.logService.error(`${T} the handshake timed out. Error:`),Y.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(Y.logService.error(`${T} received error control message when negotiating connection. Error:`),Y.logService.error(ue)),ne&&q(B),ue}}async function o(Y,R,j,W){const T=Date.now(),H=x(Y,R),{protocol:B,ownsProtocol:ne}=await l(Y,R,j,W),fe=new $(W);return fe.registerDisposable(B.onControlMessage(ge=>{const ue=JSON.parse(ge.toString()),we=F(ue);we?(Y.logService.error(`${H} received error control message when negotiating connection. Error:`),Y.logService.error(we),ne&&q(B),fe.reject(we)):(Y.reconnectionProtocol?.endAcceptReconnection(),Y.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${ce(T)}!`),fe.resolve({protocol:B,firstMessage:ue}))})),fe.promise}async function i(Y,R){const{protocol:j}=await o(Y,1,void 0,R);return{protocol:j}}async function n(Y,R,j){const{protocol:W,firstMessage:T}=await o(Y,2,R,j),H=T&&T.debugPort;return{protocol:W,debugPort:H}}async function a(Y,R,j){const W=Date.now(),T=x(Y,3),{protocol:H}=await l(Y,3,R,j);return Y.logService.trace(`${T} 6/6. handshake finished, connection is up and running after ${ce(W)}!`),H}async function k(Y,R,j){const{connectTo:W,connectionToken:T}=await Y.addressProvider.getAddress();return{commit:Y.commit,quality:Y.quality,connectTo:W,connectionToken:T,reconnectionToken:R,reconnectionProtocol:j,remoteSocketFactoryService:Y.remoteSocketFactoryService,signService:Y.signService,logService:Y.logService}}async function I(Y,R,j){return p(Y,async W=>{const{protocol:T}=await i(W,s.CancellationToken.None);return new G(Y,R,j,W.reconnectionToken,T)})}e.$Xk=I;async function C(Y,R){return p(Y,async j=>{const{protocol:W,debugPort:T}=await n(j,R,s.CancellationToken.None);return new J(Y,R,j.reconnectionToken,W,T)})}e.$Yk=C;async function p(Y,R){for(let W=1;;W++)try{const T=(0,m.$4f)(),H=await k(Y,T,null);return await R(H)}catch(T){if(W<5)Y.logService.error(`[remote-connection][attempt ${W}] An error occurred in initial connection! Will retry... Error:`),Y.logService.error(T);else throw Y.logService.error(`[remote-connection][attempt ${W}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Y.logService.error(T),oe.triggerPermanentFailure(0,0,y.$Mk.isHandled(T)),T}}async function A(Y,R,j){const W=await k(Y,(0,m.$4f)(),null);return await a(W,{host:R,port:j},s.CancellationToken.None)}e.$Zk=A;function L(Y){return(0,P.$ug)(R=>new Promise((j,W)=>{const T=setTimeout(j,Y*1e3);R.onCancellationRequested(()=>{clearTimeout(T),j()})}))}var U;(function(Y){Y[Y.ConnectionLost=0]="ConnectionLost",Y[Y.ReconnectionWait=1]="ReconnectionWait",Y[Y.ReconnectionRunning=2]="ReconnectionRunning",Y[Y.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Y[Y.ConnectionGain=4]="ConnectionGain"})(U||(e.PersistentConnectionEventType=U={}));class z{constructor(R,j){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.type=0}}e.$1k=z;class re{constructor(R,j,W,T){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.durationSeconds=W,this.c=T,this.type=1}skipWait(){this.c.cancel()}}e.$2k=re;class ee{constructor(R,j,W){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.attempt=W,this.type=2}}e.$3k=ee;class ae{constructor(R,j,W){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.attempt=W,this.type=4}}e.$4k=ae;class se{constructor(R,j,W,T){this.reconnectionToken=R,this.millisSinceLastIncomingData=j,this.attempt=W,this.handled=T,this.type=3}}e.$5k=se;class oe extends S.$kc{static triggerPermanentFailure(R,j,W){this._permanentFailure=!0,this.f=R,this.g=j,this.h=W,this.j.forEach(T=>T.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(R=>R.y())}static debugPauseSocketWriting(){this.j.forEach(R=>R.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||oe._permanentFailure}constructor(R,j,W,T,H){super(),this.t=R,this.u=j,this.reconnectionToken=W,this.protocol=T,this.w=H,this.m=this.B(new D.$fd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(T.onSocketClose(B=>{const ne=Q(this.t,this.reconnectionToken,!0);B?B.type===0?(this.u.logService.info(`${ne} received socket close event (hadError: ${B.hadError}).`),B.error&&this.u.logService.error(B.error)):(this.u.logService.info(`${ne} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this.u.logService.error(B.event)):this.u.logService.info(`${ne} received socket close event.`),this.y()})),this.B(T.onSocketTimeout(B=>{const ne=Q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ne} received socket timeout event (unacknowledgedMsgCount: ${B.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${B.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${B.timeSinceLastReceivedSomeData}).`),this.y()})),oe.j.push(this),this.B((0,S.$ic)(()=>{const B=oe.j.indexOf(this);B>=0&&oe.j.splice(B,1)})),this.n&&this.D(oe.f,oe.g,oe.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const R=Q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${R} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const j=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const T=W<j.length?j[W]:j[j.length-1];try{if(T>0){const B=L(T);this.m.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),T,B)),this.u.logService.info(`${R} waiting for ${T} seconds before reconnecting...`);try{await B}catch{}}if(this.n){this.u.logService.error(`${R} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this.u.logService.info(`${R} resolving connection...`);const H=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${R} connecting to ${H.connectTo}...`),await this.G(H,g(v)),this.u.logService.info(`${R} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(H){if(H.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${R} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this.u.logService.error(`${R} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(y.$Mk.isTemporarilyNotAvailable(H)){this.u.logService.info(`${R} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((H.code==="ETIMEDOUT"||H.code==="ENETUNREACH"||H.code==="ECONNREFUSED"||H.code==="ECONNRESET")&&H.syscall==="connect"){this.u.logService.info(`${R} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if((0,M.$2)(H)){this.u.logService.info(`${R} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(H);continue}if(H instanceof y.$Mk){this.u.logService.error(`${R} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,y.$Mk.isHandled(H));break}this.u.logService.error(`${R} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(H),this.C(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this.n&&!this.s)}C(R,j,W){this.w?oe.triggerPermanentFailure(R,j,W):this.D(R,j,W)}D(R,j,W){this.m.fire(new se(this.reconnectionToken,R,j,W)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$6k=oe;class G extends oe{constructor(R,j,W,T,H){super(1,R,T,H,!0),this.client=this.B(new w.$nh(H,{remoteAuthority:j,clientId:W},R.ipcLogger))}async G(R,j){await i(R,j)}}e.$7k=G;class J extends oe{constructor(R,j,W,T,H){super(2,R,W,T,!1),this.H=j,this.debugPort=H}async G(R,j){await n(R,this.H,j)}}e.$8k=J;function q(Y){try{Y.acceptDisconnect();const R=Y.getSocket();Y.dispose(),R.dispose()}catch(R){(0,M.$Y)(R)}}function F(Y){if(Y&&Y.type==="error"){const R=new Error(`Connection error: ${Y.reason}`);return R.code="VSCODE_CONNECTION_ERROR",R}return null}function N(Y,R){for(;Y.length<R;)Y+=" ";return Y}function V(Y,R){return`[remote-connection][${N(d(Y),13)}][${R.substr(0,5)}\u2026]`}function Q(Y,R,j){return`${V(Y,R)}[${j?"reconnect":"initial"}]`}function x(Y,R){return`${Q(R,Y.reconnectionToken,!!Y.reconnectionProtocol)}[${Y.connectTo}]`}function ce(Y){return`${Date.now()-Y} ms`}}),define(te[242],ie([0,1,2,6]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uk=e.$Tk=void 0,e.$Tk=(0,O.$Bh)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,S){return this.a[D]??=[],this.a[D].push(S),(0,P.$ic)(()=>{const h=this.a[D]?.indexOf(S);typeof h=="number"&&h>=0&&this.a[D]?.splice(h,1)})}b(D){return(this.a[D.type]||[]).find(h=>h.supports(D))}connect(D,S,h,c){const m=this.b(D);if(!m)throw new Error(`No socket factory found for ${D}`);return m.connect(D,S,h,c)}}e.$Uk=s}),define(te[243],ie([0,1,27,47,21,113]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g6b=void 0;let D;async function S(f=!1){return(D===void 0||f)&&(D=h()),D}e.$g6b=S;async function h(){const f=c();if(f===void 0)return!1;if(f>=22e3){const v=w();if(v)return new Promise(b=>{O.execFile(v,["--status"],d=>b(!d))})}else{const v=y();if(v)try{if((await s.Promises.stat(v)).isFile())return!0}catch{}}return!1}function c(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(f)return parseInt(f[3])}function m(f){const v=process.env.SystemRoot;if(v){const b=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(v,b?"Sysnative":"System32",f)}}function w(){return m("wsl.exe")}function y(){return m("lxss\\LxssManager.dll")}}),define(te[51],ie([0,1,17,14,2,181,58,6,5,43]),function(K,e,P,O,s,M,D,S,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.$Io=void 0,e.$Io=(0,S.$Bh)("requestService");class m{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?u[t]="*****":u[t]=this.b[t];this.a=u}return this.a}}class w extends s.$kc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,M.localize)(0,null),when:h.$jj.isEqualTo((0,h.$hj)(h.LogLevel.Trace)).serialize()})}async c(u,t,l){const o=`${u} #${++this.b}: ${t.url}`;this.a.trace(`${o} - begin`,t.type,new m(t.headers??{}));try{const i=await l();return this.a.trace(`${o} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${o} - error`,t.type,(0,O.$8)(i)),i}}}e.$Jo=w;function y(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}e.$Ko=y;function f(E){return E.res.statusCode===204}e.$Lo=f;async function v(E){return f(E)?null:(await(0,P.$Rd)(E.stream)).toString()}e.$Mo=v;async function b(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);return v(E)}e.$No=b;async function d(E){if(!y(E))throw new Error("Server returned "+E.res.statusCode);if(f(E))return null;const t=(await(0,P.$Rd)(E.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}e.$Oo=d;function g(E){$(E)}e.$Po=g;let r;function $(E){const u=c.$8m.as(D.$an.Configuration),t=r;r={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0}}},u.updateConfigurations({add:[r],remove:t?[t]:[]})}$(1)}),define(te[244],ie([0,1,17,22]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=void 0;class s{constructor(S){this.a=S}listen(S,h){throw new Error("Invalid listen")}call(S,h,c,m=O.CancellationToken.None){switch(h){case"request":return this.a.request(c[0],m).then(async({res:w,stream:y})=>{const f=await(0,P.$Rd)(y);return[{statusCode:w.statusCode,headers:w.headers},f]});case"resolveProxy":return this.a.resolveProxy(c[0])}throw new Error("Invalid call")}}e.$Lq=s;class M{constructor(S){this.a=S}async request(S,h){const[c,m]=await this.a.call("request",[S],h);return{res:c,stream:(0,P.$Td)(m)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}}e.$Mq=M}),define(te[245],ie([0,1,246,12]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;function s(D,S){return D.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:D.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function M(D,S,h={}){const c=(0,P.parse)(D),m=h.proxyUrl||s(c,S);if(!m)return null;const w=(0,P.parse)(m);if(!/^https?:$/.test(w.protocol||""))return null;const y={host:w.hostname||"",port:w.port||(w.protocol==="https"?"443":"80"),auth:w.auth,rejectUnauthorized:(0,O.$pf)(h.strictSSL)?h.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((f,v)=>{K(["http-proxy-agent"],f,v)}))(y):new(await new Promise((f,v)=>{K(["https-proxy-agent"],f,v)}))(y)}e.$Nq=M}),define(te[247],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E6b=e.$D6b=e.$C6b=void 0,e.$C6b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$D6b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$E6b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(te[94],ie([0,1,47,9,182,22,50,14,4,31,108,63,8,138]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=void 0;let v;async function b(g,r,$,E){return $["force-disable-user-env"]?(r.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(r.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.$Gl)(E)&&!$["force-user-env"]?(r.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.$Gl)(E)?r.trace("resolveShellEnv(): running (--force-user-env)"):r.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=y.Promises.withAsyncBody(async(u,t)=>{const l=new M.$pd;let o=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(o=(0,f.$Hl)(i,1,120)*1e3);const n=setTimeout(()=>{l.dispose(!0),t(new Error((0,s.localize)(0,null)))},o);try{u(await d(r,l.token))}catch(a){!(0,S.$2)(a)&&!l.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,D.$mi)(a)))):u({})}finally{clearTimeout(n),l.dispose()}})),v)}e.$Ml=b;async function d(g,r){const $=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",$);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",E);const u=(0,c.$4f)().replace(/-/g,"").substr(0,12),t=new RegExp(u+"({.*})"+u),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",l);const o=await(0,m.$wl)(h.OS,l);return g.trace("getUnixShellEnvironment#shell",o),new Promise((i,n)=>{if(r.isCancellationRequested)return n(new S.$3);const a=(0,O.$ae)(o);let k,I;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(k=`& '${process.execPath}' ${C} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,I=["-Login","-Command"]):a==="nu"?(k=`^'${process.execPath}' ${C} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,I=["-i","-l","-c"]):(k=`'${process.execPath}' ${C} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,a==="tcsh"||a==="csh"?I=["-ic"]:I=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),k);const p=(0,P.spawn)(o,[...I,k],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});r.onCancellationRequested(()=>(p.kill(),n(new S.$3))),p.on("error",U=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,D.$mi)(U)),n(U)});const A=[];p.stdout.on("data",U=>A.push(U));const L=[];p.stderr.on("data",U=>L.push(U)),p.on("close",(U,z)=>{const re=Buffer.concat(A).toString("utf8");g.trace("getUnixShellEnvironment#raw",re);const ee=Buffer.concat(L).toString("utf8");if(ee.trim()&&g.trace("getUnixShellEnvironment#stderr",ee),U||z)return n(new Error((0,s.localize)(2,null,U,z)));const ae=t.exec(re),se=ae?ae[1]:"{}";try{const oe=JSON.parse(se);$?oe.ELECTRON_RUN_AS_NODE=$:delete oe.ELECTRON_RUN_AS_NODE,E?oe.ELECTRON_NO_ATTACH_CONSOLE=E:delete oe.ELECTRON_NO_ATTACH_CONSOLE,delete oe.VSCODE_RESOLVING_ENVIRONMENT,delete oe.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",oe),i(oe)}catch(oe){g.error("getUnixShellEnvironment#errorCaught",(0,D.$mi)(oe)),n(oe)}})})}}),define(te[248],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D2b=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const M=await this.c();if(M){const D=String(P.a++);return this.b.set(D,M),{id:D,data:M.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,M){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(M)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$D2b=P}),define(te[95],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=e.$Vk=void 0,e.$Vk="signService",e.$Wk=(0,P.$Bh)(e.$Vk)}),define(te[249],ie([0,1,248]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q7b=void 0;class O extends P.$D2b{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(D=>new D.signer().sign(M))}h(){return new Promise((M,D)=>K(["vsda"],M,D))}}e.$q7b=O}),define(te[34],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eN=e.$dN=void 0,e.$dN=(0,P.$Bh)("stateReadService"),e.$eN=(0,P.$Bh)("stateService")}),define(te[120],ie([0,1,8,17,2,12,36,16,5]),function(K,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hN=e.$gN=e.$fN=e.SaveStrategy=void 0;var c;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class m extends s.$kc{constructor(v,b,d,g){super(),this.h=v,this.j=d,this.m=g,this.a=Object.create(null),this.b="",this.f=void 0,this.g=void 0,this.c=b===0?void 0:this.B(new P.$Eg(100))}init(){return this.f||(this.f=this.n()),this.f}async n(){try{this.b=(await this.m.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(v){v.fileOperationResult!==1&&this.j.error(v)}}getItem(v,b){const d=this.a[v];return(0,M.$sf)(d)?b:d}setItem(v,b){this.setItems([{key:v,data:b}])}setItems(v){let b=!1;for(const{key:d,data:g}of v)this.a[d]!==g&&((0,M.$sf)(g)?(0,M.$qf)(this.a[d])||(this.a[d]=void 0,b=!0):(this.a[d]=g,b=!0));b&&this.r()}removeItem(v){(0,M.$qf)(this.a[v])||(this.a[v]=void 0,this.r())}async r(){if(!this.g)return this.c?this.c.trigger(()=>this.s()):this.s()}async s(){if(!this.f)return;await this.f;const v=JSON.stringify(this.a,null,4);if(v!==this.b)try{await this.m.writeFile(this.h,O.$Fd.fromString(v),{atomic:{postfix:".vsctmp"}}),this.b=v}catch(b){this.j.error(b)}}async close(){return this.g||(this.g=this.c?this.c.trigger(()=>this.s(),0):this.s()),this.g}}e.$fN=m;let w=class extends s.$kc{constructor(v,b,d,g){super(),this.a=this.B(new m(b.stateResource,v,d,g))}async init(){await this.a.init()}getItem(v,b){return this.a.getItem(v,b)}};e.$gN=w,e.$gN=w=ke([_(1,D.$Ih),_(2,h.$5i),_(3,S.$6j)],w);class y extends w{setItem(v,b){this.a.setItem(v,b)}setItems(v){this.a.setItems(v)}removeItem(v){this.a.removeItem(v)}close(){return this.a.close()}}e.$hN=y}),define(te[121],ie([0,1,4,35,31]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=void 0;function M(h){if(P.$t===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function D(h,c,m,w,y,f,v,b){const d=Object.create(null);d["common.machineId"]=f,d.sessionID=(0,s.$4f)()+Date.now(),d.commitHash=w,d.version=y,d["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),d["common.platform"]=(0,P.$h)(P.$t),d["common.nodePlatform"]=O.$3d,d["common.nodeArch"]=m,d["common.product"]=b||"desktop",v&&(d["common.msftInternal"]=v);let g=0;const r=Date.now();Object.defineProperties(d,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),P.$l&&(d["common.snap"]="true");const $=M(c);return $&&(d["common.platformDetail"]=$),d}e.$0n=D;function S(h){const c=O.env.USERDNSDOMAIN;if(!c)return!1;const m=c.toLowerCase();return h.some(w=>m===w)}e.$$n=S}),define(te[25],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$fl=e.$el=e.$dl=e.$cl=e.$bl=e.$al=e.$_k=e.$$k=e.$0k=e.$9k=void 0,e.$9k=(0,P.$Bh)("telemetryService"),e.$0k=(0,P.$Bh)("customEndpointTelemetryService"),e.$$k="telemetry.currentSessionDate",e.$_k="telemetry.firstSessionDate",e.$al="telemetry.lastSessionDate",e.$bl="telemetry.machineId",e.$cl="telemetry",e.$dl="telemetry.telemetryLevel",e.$el="telemetry.enableCrashReporter",e.$fl="telemetry.enableTelemetry";var O;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var s;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(te[250],ie([0,1,27,8,44,13,9,4,7,86,21,107,90,16,24,25]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=e.$tr=void 0;const d=new Map;async function g(t,l){const o=`${t}::${l.join(":")}`,i=d.get(o);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,k=new Map,I=2e4;function C(A,L,U,z){const re=L.substring(A.length+1);return O.Promises.withAsyncBody(async ee=>{let ae;try{ae=await m.Promises.readdir(L,{withFileTypes:!0})}catch{ee();return}if(z.count>=I){z.count+=ae.length,z.maxReached=!0,ee();return}let se=ae.length;if(se===0){ee();return}let oe=ae;z.count+ae.length>I&&(z.maxReached=!0,se=I-z.count,oe=ae.slice(0,se)),z.count+=ae.length;for(const G of oe)if(G.isDirectory()){if(U.includes(G.name)||await C(A,(0,D.$9d)(L,G.name),U,z),--se===0){ee();return}}else{const J=G.name.lastIndexOf(".");if(J>=0){const q=G.name.substring(J+1);q&&a.set(q,(a.get(q)??0)+1)}for(const q of n)q.relativePathPattern?.test(re)!==!1&&q.filePattern.test(G.name)&&k.set(q.tag,(k.get(q.tag)??0)+1);if(--se===0){ee();return}}})}const p=O.Promises.withAsyncBody(async A=>{const L={count:0,maxReached:!1};await C(t,t,l,L);const U=await E(t);A({configFiles:r(k),fileTypes:r(a),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:U})});return d.set(o,p),p}e.$tr=g;function r(t){return Array.from(t.entries(),([l,o])=>({name:l,count:o})).sort((l,o)=>o.count-l.count)}function $(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/f.$Ak.GB).toFixed(2)}GB (${(P.freemem()/f.$Ak.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$Hm.value()*100)}%`},l=P.cpus();return l&&l.length>0&&(t.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),t}e.$ur=$;async function E(t){try{const l=new Map,o=(0,D.$9d)(t,".vscode","launch.json"),i=await m.Promises.readFile(o),n=[],a=(0,s.$Lm)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${o}`),[];if((0,s.$Um)(a)==="object"&&a.configurations)for(const k of a.configurations){const I=k.type;I&&(l.has(I)?l.set(I,l.get(I)+1):l.set(I,1))}return r(l)}catch{return[]}}e.$vr=E;let u=class{constructor(l,o){this.c=l,this.d=o}f(l){const o=[];return o.push(`OS Version:       ${l.os}`),o.push(`CPUs:             ${l.cpus}`),o.push(`Memory (System):  ${l.memory}`),o.push(`VM:               ${l.vmHint}`),o.join(`
`)}g(l){const o=[];o.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),o.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const i=P.cpus();return i&&i.length>0&&o.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),o.push(`Memory (System):  ${(P.totalmem()/f.$Ak.GB).toFixed(2)}GB (${(P.freemem()/f.$Ak.GB).toFixed(2)}GB free)`),S.$i||o.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),o.push(`VM:               ${Math.round(c.$Hm.value()*100)}%`),o.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${l.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.j(l.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(l,o){return Promise.all([(0,w.$sr)(l.mainPID),this.k(l)]).then(async i=>{let[n,a]=i,k=this.m(l,n);return o.forEach(I=>{if((0,y.$hm)(I))k+=`
${I.errorMessage}`,a+=`
${I.errorMessage}`;else if(k+=`

Remote: ${I.hostName}`,I.processes&&(k+=`
${this.m(l,I.processes)}`),I.workspaceMetadata){a+=`
|  Remote: ${I.hostName}`;for(const C of Object.keys(I.workspaceMetadata)){const p=I.workspaceMetadata[C];let A=`${p.fileCount} files`;p.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${C}): ${A}`,a+=this.h(p)}}}),{processInfo:k,workspaceInfo:a}})}async getSystemInfo(l,o){const{memory:i,vmHint:n,os:a,cpus:k}=$(),I={os:a,memory:i,cpus:k,vmHint:n,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:o};return S.$i||(I.load=`${P.loadavg().map(C=>Math.round(C)).join(", ")}`),S.$k&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(l,o){const i=[];return(0,w.$sr)(l.mainPID).then(async n=>(i.push(""),i.push(this.g(l)),i.push(""),i.push(this.m(l,n)),l.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(l))),o.forEach(a=>{if((0,y.$hm)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.f(a.machineInfo)),a.processes&&i.push(this.m(l,a.processes)),a.workspaceMetadata)for(const k of Object.keys(a.workspaceMetadata)){const I=a.workspaceMetadata[k];let C=`${I.fileCount} files`;I.maxFilesReached&&(C=`more than ${C}`),i.push(`Folder (${k}): ${C}`),i.push(this.h(I))}}),i.push(""),i.push(""),i.join(`
`)))}h(l){const o=[];let n=0;const a=(p,A)=>{const L=` ${p}(${A})`;n+L.length>60?(o.push(k),k="|                 ",n=k.length):n+=L.length,k+=L};let k="|      File types:";const I=10,C=l.fileTypes.length>I?I:l.fileTypes.length;for(let p=0;p<C;p++){const A=l.fileTypes[p];a(A.name,A.count)}if(o.push(k),l.configFiles.length>=0&&(k="|      Conf files:",n=0,l.configFiles.forEach(p=>{a(p.name,p.count)}),o.push(k)),l.launchConfigFiles.length>0){let p="|      Launch Configs:";l.launchConfigFiles.forEach(A=>{const L=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;p+=L}),o.push(p)}return o.join(`
`)}j(l){const o=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(o-i.length)}  ${l[i]}`).join(`
                  `)}k(l){const o=[],i=[];return l.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(o.push(`|  Window (${n.title})`),n.folderURIs.forEach(a=>{const k=h.URI.revive(a);if(k.scheme===M.Schemas.file){const I=k.fsPath;i.push(g(I,["node_modules",".git"]).then(C=>{let p=`${C.fileCount} files`;C.maxFilesReached&&(p=`more than ${p}`),o.push(`|    Folder (${(0,D.$ae)(I)}): ${p}`),o.push(this.h(C))}).catch(C=>{o.push(`|      Error: Unable to collect workspace stats for folder ${I} (${C.toString()})`)}))}else o.push(`|    Folder (${k.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>o.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(l,o){const i=new Map;l.windows.forEach(a=>i.set(a.pid,`window [${a.id}] (${a.title})`)),l.pidToNames.forEach(({pid:a,name:k})=>i.set(a,k));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),o&&this.n(l.mainPID,i,n,o,0),n.join(`
`)}n(l,o,i,n,a){const k=a===0;let I;k?I=n.pid===l?`${this.d.applicationName} main`:"remote agent":o.has(n.pid)?I=o.get(n.pid):I=`${"  ".repeat(a)} ${n.name}`;const C=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(C/f.$Ak.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(n.children)&&n.children.forEach(p=>this.n(l,o,i,p,a+1))}async getWorkspaceFileExtensions(l){const o=new Set;for(const{uri:i}of l.folders){const n=h.URI.revive(i);if(n.scheme!==M.Schemas.file)continue;const a=n.fsPath;try{(await g(a,["node_modules",".git"])).fileTypes.forEach(I=>o.add(I.name))}catch{}}return{extensions:[...o]}}async reportWorkspaceStats(l){for(const{uri:o}of l.folders){const i=h.URI.revive(o);if(i.scheme!==M.Schemas.file)continue;const n=i.fsPath;try{const a=await g(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),a.fileTypes.forEach(k=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:k.name,count:k.count})}),a.launchConfigFiles.forEach(k=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:k.name,count:k.count})}),a.configFiles.forEach(k=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:k.name,count:k.count})})}catch{}}}};e.$wr=u,e.$wr=u=ke([_(0,b.$9k),_(1,v.$kj)],u)}),define(te[251],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I6b=e.$H6b=void 0;class P{constructor(M){this.b=M}listen(M,D){throw new Error(`Event not found: ${D}`)}call(M,D,{eventName:S,data:h}){return this.b.forEach(c=>c.log(S,h)),Promise.resolve(null)}}e.$H6b=P;class O{constructor(M){this.b=M}log(M,D){return this.b.call("log",{eventName:M,data:D}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$I6b=O}),define(te[52],ie([0,1,37,12,3,18,59,121,25]),function(K,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$_n=c;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$ao=m,e.$bo=new m;class w{async publicLog(n,a,k){}async publicLogError(n,a,k){}}e.$co=w,e.$do="telemetry",e.$eo="extensionTelemetryLog",e.$fo={log:()=>null,flush:()=>Promise.resolve(null)};function y(i,n){return s.Event.debounce(n.onDidChangeConfiguration,(k,I)=>{const C=k?new Set([...k.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:C}},1e3,!0)(k=>{k.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,M.$$h)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$go=y;function f(i,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!i.enableTelemetry||n.extensionTestsLocationURI)}e.$ho=f;function v(i,n){return!(n.isBuilt||n.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$io=v;function b(i){const n=i.getValue(h.$dl),a=i.getValue(h.$el);if(i.getValue(h.$fl)===!1||a===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$jo=b;function d(i){const n={},a={},k={};$(i,k);for(let I in k){I=I.length>150?I.substr(I.length-149):I;const C=k[I];typeof C=="number"?a[I]=C:typeof C=="boolean"?a[I]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${C.length}`),n[I]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(n[I]=C)}return{properties:n,measurements:a}}e.$ko=d;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(i){if(!i)return"none";const n=(0,D.$Pk)(i);return g.has(n)?n:"other"}e.$lo=r;function $(i,n,a=0,k){if(i)for(const I of Object.getOwnPropertyNames(i)){const C=i[I],p=k?k+I:I;Array.isArray(C)?n[p]=(0,P.$1m)(C):C instanceof Date?n[p]=C.toISOString():(0,O.$lf)(C)?a<2?$(C,n,a+1,p+"."):n[p]=(0,P.$1m)(C):n[p]=C}}function E(i,n){const a=i.msftInternalDomains||[],k=n.getValue("telemetry.internalTesting");return(0,S.$$n)(a)||k}e.$mo=E;function u(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$no=u;function t(i,n){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const k=[];for(const A of n)for(;;){const L=A.exec(i);if(!L)break;k.push([L.index,A.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(a="";;){const A=C.exec(i);if(!A)break;const L=k.some(([U,z])=>A.index<z&&U<C.lastIndex);!I.test(A[0])&&!L&&(a+=i.substring(p,A.index)+"<REDACTED: user-file-path>",p=C.lastIndex)}return p<i.length&&(a+=i.substr(p)),a}function l(i){if(!i)return i;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of n)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function o(i,n){return(0,P.$Xm)(i,a=>{if(a instanceof c||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let k=a.replaceAll("%20"," ");k=t(k,n);for(const I of n)k=k.replace(I,"");return k=l(k),k}})}e.$oo=o}),define(te[122],ie([0,1,26,116,119,4,7,14,35,52]),function(K,e,P,O,s,M,D,S,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;function m(o,i){return o.uuid&&i.uuid?o.uuid===i.uuid:o.id===i.id?!0:(0,P.$He)(o.id,i.id)===0}e.$po=m;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{static create(i){const n=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new y(i.identifier,n,a)}static parse(i){const n=w.exec(i);return n&&n[1]&&n[2]?new y({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,a="undefined"){this.version=n,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof y?m(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$qo=y;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(o){const i=f.exec(o);return i&&i[1]?[d(i[1]),i[2]]:[d(o),void 0]}e.$ro=v;function b(o,i){return`${o}.${i}`}e.$so=b;function d(o){return o.toLowerCase()}e.$to=d;function g(o,i){return d(b(o??s.$Rl,i))}e.$uo=g;function r(o,i){const n=[],a=k=>{for(const I of n)if(I.some(C=>m(i(C),i(k))))return I;return null};for(const k of o){const I=a(k);I?I.push(k):n.push([k])}return n}e.$vo=r;function $(o){return{id:o.identifier.id,name:o.manifest.name,galleryId:null,publisherId:o.publisherId,publisherName:o.manifest.publisher,publisherDisplayName:o.publisherDisplayName,dependencies:o.manifest.extensionDependencies&&o.manifest.extensionDependencies.length>0}}e.$wo=$;function E(o){return{id:new c.$_n(o.identifier.id),name:new c.$_n(o.name),galleryId:o.identifier.uuid,publisherId:o.publisherId,publisherName:o.publisher,publisherDisplayName:o.publisherDisplayName,isPreReleaseVersion:o.properties.isPreReleaseVersion,dependencies:!!(o.properties.dependencies&&o.properties.dependencies.length>0),isSigned:o.isSigned,...o.telemetryData}}e.$xo=E,e.$yo=new s.$Vl("pprice.better-merge");function u(o,i){const n=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const k=a.shift();if(k&&n.every(I=>!m(I.identifier,{id:k}))){const I=o.filter(C=>m(C.identifier,{id:k}));I.length===1&&(n.push(I[0]),a.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$zo=u;async function t(o,i){if(!M.$k)return!1;let n;try{n=(await o.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await o.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){i.debug("Error while getting the os-release file.",(0,S.$8)(k))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(o,i){const n=await t(o,i),a=(0,O.$Un)(n?"alpine":M.$t,h.$4d);return i.debug("ComputeTargetPlatform:",a),a}e.$Ao=l}),define(te[252],ie([0,1,204,52]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3o=void 0;async function s(M,D,S,h,c,m,w){const y={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${D.nameShort})`};if((0,O.$ho)(D,S)&&(0,O.$jo)(h)===3){const f=await(0,P.$2o)(S,c,m);y["X-Market-User-Id"]=f,y["VSCode-SessionId"]=w.machineId||f}return y}e.$3o=s}),define(te[253],ie([0,1,2,37,4,26,183,18,58,77,24,43,25,52]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,r,$){this.k=r,this.l=$,this.d={},this.i=new P.$jc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,M.$qe)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$qe)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(y.$dl)||E.affectsConfiguration(y.$fl)||E.affectsConfiguration(y.$el))&&this.m()}))}setExperimentProperty(g,r){this.d[g]=r}m(){let g=(0,f.$jo)(this.k);const r=this.l.enabledTelemetryLevels;if(r){this.h=this.sendErrorTelemetry?r.error:!1;const $=r.usage?3:r.error?2:0;g=Math.min(g,$)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,r,$){this.g<r||($=(0,O.$Ym)($,this.d),$=(0,f.$oo)($,this.j),$=(0,O.$Ym)($,this.c),this.b.forEach(E=>E.log(g,$)))}publicLog(g,r){this.n(g,3,r)}publicLog2(g,r){this.publicLog(g,r)}publicLogError(g,r){this.h&&this.n(g,2,r)}publicLogError2(g,r){this.publicLogError(g,r)}};e.$Qq=v,e.$Qq=v=ke([_(1,S.$8h),_(2,m.$kj)],v);function b(){const d=(0,D.localize)(0,null,c.default.nameLong),g=c.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),r=s.$o?"":(0,D.localize)(3,null),$=(0,D.localize)(4,null),E=(0,D.localize)(5,null),u=(0,D.localize)(6,null),t=(0,D.localize)(7,null),l=`
|       | ${$} | ${E} | ${u} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,D.localize)(8,null);return`
${d} ${g} ${r}

&nbsp;

${t}
${l}

&nbsp;

${o}
`}w.$8m.as(h.$an.Configuration).registerConfiguration({id:y.$cl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[y.$dl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),w.$8m.as(h.$an.Configuration).registerConfiguration({id:y.$cl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[y.$fl]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,D.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,D.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${y.$dl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[254],ie([0,1,4,86,25]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$6b=void 0;async function M(D,S){let h=D.getItem(s.$bl);return(typeof h!="string"||P.$j&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,O.$Im)(S.error.bind(S))),h}e.$$6b=M}),define(te[255],ie([0,1,25,254]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_6b=void 0;async function s(M,D){const S=await(0,O.$$6b)(M,D);return M.setItem(P.$bl,S),S}e.$_6b=s}),define(te[123],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(O){O[O.Replace=1]="Replace",O[O.Append=2]="Append",O[O.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(te[256],ie([0,1,4,123]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;const s=new Map([[O.EnvironmentVariableMutatorType.Append,"APPEND"],[O.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[O.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(m){this.collections=m,this.a=new Map,this.b=new Map,m.forEach((w,y)=>{this.d(w,y);const f=w.map.entries();let v=f.next();for(;!v.done;){const b=v.value[1],d=v.value[0];let g=this.a.get(d);if(g||(g=[],this.a.set(d,g)),g.length>0&&g[0].type===O.EnvironmentVariableMutatorType.Replace){v=f.next();continue}const r={extensionIdentifier:y,value:b.value,type:b.type,scope:b.scope,variable:b.variable,options:b.options};r.scope||delete r.scope,g.unshift(r),v=f.next()}})}async applyToProcessEnvironment(m,w,y){let f;P.$i&&(f={},Object.keys(m).forEach(v=>f[v.toLowerCase()]=v));for(const[v,b]of this.getVariableMap(w)){const d=P.$i&&f[v.toLowerCase()]||v;for(const g of b){const r=y?await y(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case O.EnvironmentVariableMutatorType.Append:m[d]=(m[d]||"")+r;break;case O.EnvironmentVariableMutatorType.Prepend:m[d]=r+(m[d]||"");break;case O.EnvironmentVariableMutatorType.Replace:m[d]=r;break}if(g.options?.applyAtShellIntegration??!1){const $=`VSCODE_ENV_${s.get(g.type)}`;m[$]=(m[$]?m[$]+":":"")+v+"="+this.c(r)}}}}c(m){return m.replaceAll(":","\\x3a")}diff(m,w){const y=new Map,f=new Map,v=new Map;if(m.getVariableMap(w).forEach((b,d)=>{const g=this.getVariableMap(w).get(d),r=S(b,g);r&&y.set(d,r)}),this.getVariableMap(w).forEach((b,d)=>{const g=m.getVariableMap(w).get(d),r=S(b,g);r&&v.set(d,r)}),this.getVariableMap(w).forEach((b,d)=>{const g=m.getVariableMap(w).get(d),r=h(b,g);r&&f.set(d,r)}),!(y.size===0&&f.size===0&&v.size===0))return{added:y,changed:f,removed:v}}getVariableMap(m){const w=new Map;for(const y of this.a.values()){const f=y.filter(v=>D(v,m));f.length>0&&w.set(f[0].variable,f)}return w}getDescriptionMap(m){const w=new Map;for(const y of this.b.values()){const f=y.filter(v=>D(v,m,!0));for(const v of f)w.set(v.extensionIdentifier,v.description)}return w}d(m,w){if(!m.descriptionMap)return;const y=m.descriptionMap.entries();let f=y.next();for(;!f.done;){const v=f.value[1],b=f.value[0];let d=this.b.get(b);d||(d=[],this.b.set(b,d));const g={extensionIdentifier:w,scope:v.scope,description:v.description};g.scope||delete g.scope,d.push(g),f=y.next()}}}e.$gr=M;function D(c,m,w=!1){return c.scope?!!(c.scope.workspaceFolder&&m?.workspaceFolder&&c.scope.workspaceFolder.index===m.workspaceFolder.index):w?m===c.scope:!0}function S(c,m){if(!m)return c;const w=new Set;m.forEach(f=>w.add(f.extensionIdentifier));const y=[];return c.forEach(f=>{w.has(f.extensionIdentifier)||y.push(f)}),y.length===0?void 0:y}function h(c,m){if(!m)return;const w=new Map;m.forEach(f=>w.set(f.extensionIdentifier,f));const y=[];return c.forEach(f=>{const v=w.get(f.extensionIdentifier);v&&(f.type!==v.type||f.value!==v.value||f.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index)&&y.push(v)}),y.length===0?void 0:y}}),define(te[257],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=e.$dr=e.$cr=e.$br=e.$ar=void 0;function P(h){return[...h.entries()]}e.$ar=P;function O(h){return h?[...h.entries()]:[]}e.$br=O;function s(h){return new Map(h)}e.$cr=s;function M(h){return new Map(h??[])}e.$dr=M;function D(h){return Array.from(h.entries()).map(c=>[c[0],P(c[1].map),O(c[1].descriptionMap)])}e.$er=D;function S(h){return new Map(h.map(c=>[c[0],{map:s(c[1]),descriptionMap:M(c[2])}]))}e.$fr=S}),define(te[258],ie([0,1,8,22,3,2,5]),function(K,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;let S=class extends M.$kc{constructor(c,m){super(),this.h=m,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$fd),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,M.$ic)(()=>{for(const w of this.f.values())(0,M.$fc)(w)}))}createRequest(c){return new Promise((m,w)=>{const y=++this.a;this.c.set(y,m),this.g.fire({requestId:y,...c});const f=new O.$pd;(0,P.$Hg)(this.b,f.token).then(()=>w(`Request ${y} timed out (${this.b}ms)`)),this.f.set(y,[(0,M.$ic)(()=>f.cancel())])})}acceptReply(c,m){const w=this.c.get(c);w?(this.c.delete(c),(0,M.$fc)(this.f.get(c)||[]),this.f.delete(c),w(m)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$4q=S,e.$4q=S=ke([_(1,D.$5i)],S)}),define(te[124],ie([0,1,6,114,43]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=e.$Xq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Wq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Vq=void 0,e.$Vq=new O.$2i("terminalTabFocusMode",!1,!0);var M;(function(u){u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var D;(function(u){u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.TabStopWidth="terminal.integrated.tabStopWidth",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorStyleInactive="terminal.integrated.cursorStyleInactive",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.TabFocusMode="terminal.integrated.tabFocusMode",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.HideOnStartup="terminal.integrated.hideOnStartup",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",u.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",u.EnableImages="terminal.integrated.enableImages",u.SmoothScrolling="terminal.integrated.smoothScrolling",u.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",u.FocusAfterRun="terminal.integrated.focusAfterRun",u.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",u.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",u.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var S;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(S||(e.PosixShellType=S={}));var h;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(h||(e.WindowsShellType=h={}));var c;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var m;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.PtyHostWindow="ptyHostWindow",u.Logger="logger",u.Heartbeat="heartbeat"})(m||(e.TerminalIpcChannels=m={}));var w;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(w||(e.ProcessPropertyType=w={})),e.$Wq=(0,P.$Bh)("ptyService");var y;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(y||(e.HeartbeatConstants=y={}));var f;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(f||(e.TerminalLocation=f={}));var v;(function(u){u.TerminalView="view",u.Editor="editor"})(v||(e.TerminalLocationString=v={}));var b;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(b||(e.LocalReconnectConstants=b={}));var d;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(d||(e.FlowControlConstants=d={}));var g;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var r;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(r||(e.ShellIntegrationStatus=r={}));var $;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})($||(e.TerminalExitReason=$={})),e.$Xq={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const l=this.b(t.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$8m.add(e.$Xq.Backend,new E),e.$Yq=(0,P.$Bh)("localPtyService"),e.$Zq=(0,P.$Bh)("terminalLogService")}),define(te[259],ie([0,1,71,7,185,102]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=e.$7q=e.$6q=e.$5q=void 0;function D(y,f){const v=[{name:null,description:(0,s.localize)(0,null)}];return v.push(...y.map(b=>({name:b.profileName,description:S(b)}))),f&&v.push(...f.map(b=>({name:b.title,description:h(b)}))),{values:v.map(b=>b.name),markdownDescriptions:v.map(b=>b.description)}}e.$5q=D;function S(y){let f=`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:P.$Pj.terminal.id}) ${y.profileName}
- path: ${y.path}`;return y.args&&(typeof y.args=="string"?f+=`
- args: "${y.args}"`:f+=`
- args: [${y.args.length===0?"":`'${y.args.join("','")}'`}]`),y.overrideName!==void 0&&(f+=`
- overrideName: ${y.overrideName}`),y.color&&(f+=`
- color: ${y.color}`),y.env&&(f+=`
- env: ${JSON.stringify(y.env)}`),f}function h(y){return`$(${M.ThemeIcon.isThemeIcon(y.icon)?y.icon.id:y.icon?y.icon:P.$Pj.terminal.id}) ${y.title}
- extensionIdentifier: ${y.extensionIdentifier}`}function c(y,f){if(!y&&!f)return!0;if(typeof y=="string"&&typeof f=="string")return y===f;if(Array.isArray(y)&&Array.isArray(f)){if(y.length!==f.length)return!1;for(let v=0;v<y.length;v++)if(y[v]!==f[v])return!1;return!0}return!1}e.$6q=c;function m(y,f){if(!y&&!f)return!0;if(!y||!f)return!1;if(M.ThemeIcon.isThemeIcon(y)&&M.ThemeIcon.isThemeIcon(f))return y.id===f.id&&y.color===f.color;if(typeof y=="object"&&"light"in y&&"dark"in y&&typeof f=="object"&&"light"in f&&"dark"in f){const v=y,b=f;if((O.URI.isUri(v.light)||w(v.light))&&(O.URI.isUri(v.dark)||w(v.dark))&&(O.URI.isUri(b.light)||w(b.light))&&(O.URI.isUri(b.dark)||w(b.dark)))return v.light.path===b.light.path&&v.dark.path===b.dark.path}if(O.URI.isUri(y)&&O.URI.isUri(f)||w(y)||w(f)){const v=y,b=f;return v.path===b.path&&v.scheme===b.scheme}return!1}e.$7q=m;function w(y){return y?typeof y.path=="string"&&typeof y.scheme=="string":!1}e.$8q=w}),define(te[260],ie([0,1,71,4,184,58,43,259]),function(K,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=e.$$q=e.$0q=e.$9q=void 0,e.$9q={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$0q={type:"string",enum:Array.from((0,P.$Oj)(),d=>d.id),markdownEnumDescriptions:Array.from((0,P.$Oj)(),d=>`$(${d.id})`)};const h={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$0q},color:{description:(0,s.localize)(3,null),...e.$9q},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},m={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function w(d){const g=d===2?"linux":d===1?"osx":"windows";return(0,s.localize)(7,null,(0,O.$h)(d),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const y={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},m],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:w(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...h}},{type:"null"},c]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:w(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...h}},{type:"null"},c]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:w(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...h}},{type:"null"},c]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function f(){D.$8m.as(M.$an.Configuration).registerConfiguration(y),b()}e.$$q=f;let v;function b(d,g){const r=D.$8m.as(M.$an.Configuration);let $;d&&($=(0,S.$5q)(d?.profiles,g));const E=v;v={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:d?.os===3?$?.values:void 0,markdownEnumDescriptions:d?.os===3?$?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:d?.os===2?$?.values:void 0,markdownEnumDescriptions:d?.os===2?$?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:d?.os===1?$?.values:void 0,markdownEnumDescriptions:d?.os===1?$?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[v],remove:E?[E]:[]})}e.$_q=b}),define(te[261],ie([0,1,27,13,37,9,4,35,26,12,21,123,257,256]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=e.$ir=e.$hr=void 0;function v(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$hr=v;async function b(i,n,a,k=S.env,I=m.Promises.exists){if(M.$8d(i))return await I(i)?i:void 0;if(n===void 0&&(n=S.cwd()),M.$_d(i)!=="."){const L=M.$9d(n,i);return await I(L)?L:void 0}const p=(0,s.$3m)(k,"PATH");if(a===void 0&&(0,c.$jf)(p)&&(a=p.split(M.$ge)),a===void 0||a.length===0){const L=M.$9d(n,i);return await I(L)?L:void 0}for(const L of a){let U;if(M.$8d(L)?U=M.$9d(L,i):U=M.$9d(n,L,i),await I(U))return U;if(D.$i){let z=U+".com";if(await I(z)||(z=U+".exe",await I(z)))return z}}const A=M.$9d(n,i);return await I(A)?A:void 0}e.$ir=b;function d(i,n,a,k,I){const C=D.$i&&(!n.windowsEnableConpty||v()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||C)return;const p=i.args,A=S.$3d==="win32"?M.$ae(i.executable).toLowerCase():M.$ae(i.executable),L=M.$_d(O.$2f.asFileUri("").fsPath);let U;const z={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(z.VSCODE_NONCE=n.shellIntegration.nonce),D.$i){if(A==="pwsh.exe"||A==="powershell.exe")return!p||l(p)?U=$.get(r.WindowsPwsh):t(p)&&(U=$.get(r.WindowsPwshLogin)),U?(U=[...U],U[U.length-1]=(0,h.$ne)(U[U.length-1],L,""),{newArgs:U,envMixin:z}):void 0;k.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(A){case"bash":return!p||p.length===0?U=$.get(r.Bash):o(p)&&(z.VSCODE_SHELL_LOGIN="1",g(n,z),U=$.get(r.Bash)),U?(U=[...U],U[U.length-1]=(0,h.$ne)(U[U.length-1],L),{newArgs:U,envMixin:z}):void 0;case"fish":{const re=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return z.XDG_DATA_DIRS=`${re}:${ee}`,g(n,z),{newArgs:void 0,envMixin:z}}case"pwsh":return!p||l(p)?U=$.get(r.Pwsh):t(p)&&(U=$.get(r.PwshLogin)),U?(U=[...U],U[U.length-1]=(0,h.$ne)(U[U.length-1],L,""),{newArgs:U,envMixin:z}):void 0;case"zsh":{if(!p||p.length===0?U=$.get(r.Zsh):o(p)?(U=$.get(r.ZshLogin),g(n,z)):(p===$.get(r.Zsh)||p===$.get(r.ZshLogin))&&(U=p),!U)return;U=[...U],U[U.length-1]=(0,h.$ne)(U[U.length-1],L);let re;try{re=P.userInfo().username}catch{re="unknown"}const ee=M.$9d(P.tmpdir(),`${re}-${I.applicationName}-zsh`);z.ZDOTDIR=ee;const ae=a?.ZDOTDIR??P.homedir()??"~";z.USER_ZDOTDIR=ae;const se=[];return se.push({source:M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$9d(ee,".zshrc")}),se.push({source:M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$9d(ee,".zprofile")}),se.push({source:M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$9d(ee,".zshenv")}),se.push({source:M.$9d(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$9d(ee,".zlogin")}),{newArgs:U,envMixin:z,filesToCopy:se}}}k.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$jr=d;function g(i,n){if(D.$j&&i.environmentVariableCollections){const a=(0,y.$fr)(i.environmentVariableCollections),I=new f.$gr(a).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),C=[];if(I)for(const p of I)p.type===w.EnvironmentVariableMutatorType.Prepend&&C.push(p.value);C.length>0&&(n.VSCODE_PATH_PREFIX=C.join(""))}}var r;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(r||(r={}));const $=new Map;$.set(r.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),$.set(r.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),$.set(r.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),$.set(r.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),$.set(r.Zsh,["-i"]),$.set(r.ZshLogin,["-il"]),$.set(r.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],u=["-nol","-nologo"];function t(i){return typeof i=="string"?E.includes(i.toLowerCase()):i.length===1&&E.includes(i[0].toLowerCase())||i.length===2&&(E.includes(i[0].toLowerCase())||E.includes(i[1].toLowerCase()))&&(u.includes(i[0].toLowerCase())||u.includes(i[1].toLowerCase()))}function l(i){return typeof i=="string"?u.includes(i.toLowerCase()):i.length===0||i?.length===1&&u.includes(i[0].toLowerCase())}function o(i){return i==="string"&&E.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&E.includes(i[0].toLowerCase())}}),define(te[262],ie([0,1,47,71,9,4,12,21,106,261,113]),function(K,e,P,O,s,M,D,S,h,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=void 0;let w,y=!0;function f(n,a,k,I,C=process.env,p,A,L,U){return p=p||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},M.$i?v(k,p,C,A,I.getValue("terminal.integrated.useWslProfiles")!==!1,n&&typeof n=="object"?{...n}:I.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:I.getValue("terminal.integrated.defaultProfile.windows"),U,L):l(p,A,k,n&&typeof n=="object"?{...n}:I.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:I.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),U,L,C)}e.$kr=f;async function v(n,a,k,I,C,p,A,L,U){const z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${z?"Sysnative":"System32"}`;let ee=!1;(0,c.$hr)()>=16299&&(ee=!0),await r(L);const ae=new Map;if(n){ae.set("PowerShell",{source:"PowerShell",icon:O.$Pj.terminalPowershell,isAutoDetected:!0}),ae.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:O.$Pj.terminalPowershell,isAutoDetected:!0}),ae.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ae.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:O.$Pj.terminalCmd,isAutoDetected:!0}),ae.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ae.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:O.$Pj.terminalBash,isAutoDetected:!0});const oe=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ae.set("Cmder",{path:`${re}\\cmd.exe`,args:["/K",oe],requiresPath:process.env.CMDER_ROOT?oe:{path:oe,isUnsafe:!0},isAutoDetected:!0})}o(p,ae);const se=await b(ae.entries(),A,a,k,I,U);if(n&&C)try{const oe=await u(`${re}\\${ee?"wsl":"bash"}.exe`,A);for(const G of oe)(!p||!(G.profileName in p))&&se.push(G)}catch{y&&(I?.info("WSL is not installed, so could not detect WSL profiles"),y=!1)}return se}async function b(n,a,k,I=process.env,C,p){const A=[];for(const[L,U]of n)A.push(d(L,U,a,k,I,C,p));return(await Promise.all(A)).filter(L=>!!L)}async function d(n,a,k,I,C=process.env,p,A){if(a===null)return;let L,U,z;if("source"in a&&!("path"in a)){const se=w?.get(a.source);if(!se)return;L=se.paths,U=a.args||se.args,a.icon?z=g(a.icon):se.icon&&(z=se.icon)}else L=Array.isArray(a.path)?a.path:[a.path],U=M.$i||Array.isArray(a.args)?a.args:void 0,z=g(a.icon);let re;if(A){const se=L.map(G=>typeof G=="string"?G:G.path),oe=await A(se);re=new Array(L.length);for(let G=0;G<L.length;G++)typeof L[G]=="string"?re[G]=oe[G]:re[G]={path:oe[G],isUnsafe:!0}}else re=L.slice();let ee;if(a.requiresPath){let se;if((0,D.$jf)(a.requiresPath)?se=a.requiresPath:(se=a.requiresPath.path,a.requiresPath.isUnsafe&&(ee=se)),!await I.existsFile(se))return}const ae=await i(n,k,re,I,C,U,a.env,a.overrideName,a.isAutoDetected,ee);if(!ae){p?.debug("Terminal profile not validated",n,L);return}return ae.isAutoDetected=a.isAutoDetected,ae.icon=z,ae.color=a.color,ae}function g(n){return typeof n=="string"?{id:n}:n}async function r(n){if(w&&!n)return;const[a,k]=await Promise.all([$(),n||E()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:k,icon:O.$Pj.terminalPowershell})}async function $(){const n=new Set,a=await(0,c.$ir)("git.exe");if(a){const C=(0,m.dirname)(a);n.add((0,m.resolve)(C,"../.."))}function k(C,p){p&&C.add(p)}k(n,process.env.ProgramW6432),k(n,process.env.ProgramFiles),k(n,process.env["ProgramFiles(X86)"]),k(n,`${process.env.LocalAppData}\\Program`);const I=[];for(const C of n)I.push(`${C}\\Git\\bin\\bash.exe`,`${C}\\Git\\usr\\bin\\bash.exe`,`${C}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function E(){const n=[];for await(const a of(0,h.$ql)())n.push(a.exePath);return n}async function u(n,a){const k=[],I=await new Promise((A,L)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(U,z)=>{if(U)return L("Problem occurred when getting wsl distros");A(z)})});if(!I)return[];const C=new RegExp(/[\r?\n]/),p=I.split(C).filter(A=>A.trim().length>0&&A!=="");for(const A of p){if(A===""||A.startsWith("docker-desktop"))continue;const L=`${A} (WSL)`,U={profileName:L,path:n,args:["-d",`${A}`],isDefault:L===a,icon:t(A),isAutoDetected:!1};k.push(U)}return k}function t(n){return n.includes("Ubuntu")?O.$Pj.terminalUbuntu:n.includes("Debian")?O.$Pj.terminalDebian:O.$Pj.terminalLinux}async function l(n,a,k,I,C,p,A,L){const U=new Map;if(k){const z=(await n.readFile("/etc/shells")).toString(),re=(p||z.split(`
`)).map(ae=>{const se=ae.indexOf("#");return se===-1?ae:ae.substring(0,se)}).filter(ae=>ae.trim().length>0),ee=new Map;for(const ae of re){let se=(0,s.$ae)(ae),oe=ee.get(se)||0;oe++,oe>1&&(se=`${se} (${oe})`),ee.set(se,oe),U.set(se,{path:ae,isAutoDetected:!0})}}return o(I,U),await b(U.entries(),C,n,L,a,A)}function o(n,a){if(n)for(const[k,I]of Object.entries(n))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?a.delete(k):(I.icon=I.icon||a.get(k)?.icon,a.set(k,I))}async function i(n,a,k,I,C,p,A,L,U,z){if(k.length===0)return Promise.resolve(void 0);const re=k.shift();if(re==="")return i(n,a,k,I,C,p,A,L,U);const ee=typeof re!="string"&&re.isUnsafe,ae=typeof re=="string"?re:re.path,se={profileName:n,path:ae,args:p,env:A,overrideName:L,isAutoDetected:U,isDefault:n===a,isUnsafePath:ee,requiresUnsafePath:z};if((0,s.$ae)(ae)===ae){const G=C.PATH?C.PATH.split(s.$ge):void 0,J=await(0,c.$ir)(ae,void 0,G,void 0,I.existsFile);return J?(se.path=J,se.isFromPath=!0,se):i(n,a,k,I,C,p)}return await I.existsFile((0,s.$7d)(ae))?se:i(n,a,k,I,C,p,A,L,U)}}),define(te[263],ie([0,1,3,2,4,42,18,5,225,94,258,124,260,262,108,69]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=void 0;var d;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let g=class extends O.$kc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor($,E,u,t){super(),this.M=$,this.N=E,this.O=u,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new P.$fd),this.onPtyHostExit=this.u.event,this.w=this.B(new P.$fd),this.onPtyHostStart=this.w.event,this.y=this.B(new P.$fd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new P.$fd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new P.$fd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new P.$fd),this.onProcessData=this.D.event,this.F=this.B(new P.$fd),this.onProcessReady=this.F.event,this.G=this.B(new P.$fd),this.onProcessReplay=this.G.event,this.H=this.B(new P.$fd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new P.$fd),this.onDidRequestDetach=this.I.event,this.J=this.B(new P.$fd),this.onDidChangeProperty=this.J.event,this.L=this.B(new P.$fd),this.onProcessExit=this.L.event,(0,y.$$q)(),this.B(this.M),this.B((0,O.$ic)(()=>this.W())),this.j=this.B(new m.$4q(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&P.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,c.$Ml)(this.N,this.O,{_:[]},process.env)}catch($){return this.O.error("ptyHost was unable to resolve shell environment",$),{}}}U(){const $=this.M.start(),E=$.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B($.onDidProcessExit(l=>{this.u.fire(l.code),!this.m&&!this.q.isDisposed&&(this.n<=d.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${l.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))}));const t=M.ProxyChannel.toService(E.getChannel(w.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(l=>this.D.fire(l))),this.B(t.onProcessReady(l=>this.F.fire(l))),this.B(t.onProcessExit(l=>this.L.fire(l))),this.B(t.onDidChangeProperty(l=>this.J.fire(l))),this.B(t.onProcessReplay(l=>this.G.fire(l))),this.B(t.onProcessOrphanQuestion(l=>this.H.fire(l))),this.B(t.onDidRequestDetach(l=>this.I.fire(l))),this.B(new h.$3q(this.P,E.getChannel(w.TerminalIpcChannels.Logger))),this.a=$,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[$,t]}async createProcess($,E,u,t,l,o,i,n,a,k,I){const C=setTimeout(()=>this.$(),w.HeartbeatConstants.CreateProcessTimeout),p=await this.f.createProcess($,E,u,t,l,o,i,n,a,k,I);return clearTimeout(C),p}updateTitle($,E,u){return this.f.updateTitle($,E,u)}updateIcon($,E,u,t){return this.f.updateIcon($,E,u,t)}attachToProcess($){return this.f.attachToProcess($)}detachFromProcess($,E){return this.f.detachFromProcess($,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start($){return this.f.start($)}shutdown($,E){return this.f.shutdown($,E)}input($,E){return this.f.input($,E)}processBinary($,E){return this.f.processBinary($,E)}resize($,E,u){return this.f.resize($,E,u)}clearBuffer($){return this.f.clearBuffer($)}acknowledgeDataEvent($,E){return this.f.acknowledgeDataEvent($,E)}setUnicodeVersion($,E){return this.f.setUnicodeVersion($,E)}getInitialCwd($){return this.f.getInitialCwd($)}getCwd($){return this.f.getCwd($)}async getLatency(){const $=new b.$bd,E=await this.f.getLatency();return $.stop(),[{label:"ptyhostservice<->ptyhost",latency:$.elapsed()},...E]}orphanQuestionReply($){return this.f.orphanQuestionReply($)}installAutoReply($,E){return this.f.installAutoReply($,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply($){return this.f.uninstallAutoReply($)}getDefaultSystemShell($){return this.g?.getDefaultSystemShell($)??(0,v.$wl)($??s.OS,process.env)}async getProfiles($,E,u,t=!1){const l=await this.S();return(0,f.$kr)(E,u,t,this.N,l,void 0,this.O,this.bb.bind(this,$))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath($,E){return this.f.getWslPath($,E)}getRevivedPtyNewId($,E){return this.f.getRevivedPtyNewId($,E)}setTerminalLayoutInfo($){return this.f.setTerminalLayoutInfo($)}async getTerminalLayoutInfo($){return this.g?.getTerminalLayoutInfo($)}async requestDetachInstance($,E){return this.f.requestDetachInstance($,E)}async acceptDetachInstanceReply($,E){return this.f.acceptDetachInstanceReply($,E)}async freePortKillProcess($){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess($)}async serializeTerminalState($){return this.f.serializeTerminalState($)}async reviveTerminalProcesses($,E,u){return this.f.reviveTerminalProcesses($,E,u)}async refreshProperty($,E){return this.f.refreshProperty($,E)}async updateProperty($,E,u){return this.f.updateProperty($,E,u)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X($){this.ab(),this.s=setTimeout(()=>this.Y(),$?w.HeartbeatConstants.ConnectingBeatInterval:w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier+w.HeartbeatConstants.BeatInterval*w.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${w.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb($,E){return this.j.createRequest({workspaceId:$,originalText:E})}async acceptPtyHostResolvedVariables($,E){this.j.acceptReply($,E)}};e.$lr=g,e.$lr=g=ke([_(1,D.$8h),_(2,S.$5i),_(3,S.$6i)],g)}),define(te[79],ie([0,1,15,3,2,4,18,6,34]),function(K,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f6b=e.$e6b=void 0;const c="#FFFFFF",m="#1E1E1E",w="#000000",y="#FFFFFF",f="theme",v="themeBackground",b="windowSplash";e.$e6b=(0,S.$Bh)("themeMainService");let d=class extends s.$kc{constructor(r,$){super(),this.b=r,this.c=$,this.a=this.B(new O.$fd),this.onDidChangeColorScheme=this.a.event,P.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$i){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const r=this.getColorScheme();if(r.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return r.dark?w:y;let $=this.b.getItem(v,null);if(!$)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":$=c;break;case"hc-black":$=w;break;case"hc-light":$=y;break;default:$=m}return M.$j&&$.toUpperCase()===m&&($="#171717"),$}saveWindowSplash(r,$){this.b.setItems([{key:f,data:$.baseTheme},{key:v,data:$.colorInfo.background},{key:b,data:$}]),typeof r=="number"&&this.f(r,$)}f(r,$){for(const E of P.BrowserWindow.getAllWindows())if(E.id===r){E.setBackgroundColor($.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(b)}};e.$f6b=d,e.$f6b=d=ke([_(0,h.$eN),_(1,D.$8h)],d)}),define(te[125],ie([0,1,3,18,6,5]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0u=e.$9u=e.$8u=e.$7u=e.$6u=e.$5u=e.$4u=e.$3u=e.ProvidedOnAutoForward=e.$2u=e.TunnelPrivacyId=e.TunnelProtocol=e.$1u=e.$Zu=void 0,e.$Zu=(0,s.$Bh)("tunnelService"),e.$1u=(0,s.$Bh)("sharedTunnelsService");var D;(function(d){d.Http="http",d.Https="https"})(D||(e.TunnelProtocol=D={}));var S;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(S||(e.TunnelPrivacyId=S={}));function h(d){return!!d.forwardPort}e.$2u=h;var c;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(c||(e.ProvidedOnAutoForward=c={}));function m(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(g)return{address:g[1],port:+g[2]}}e.$3u=m,e.$4u=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(d){return e.$4u.indexOf(d)>=0}e.$5u=w,e.$6u=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(d){return e.$6u.indexOf(d)>=0}e.$7u=y;function f(d,g,r,$){if(r===1)return!1;if(r===2&&y(g)){const E=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(E?.length===4&&parseInt(E[1])>=18)return!1}return d<1024}e.$8u=f;class v{constructor(g,r,$){this.remoteAddress=g,this.localAddress=r,this.b=$,this.a=new P.$fd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$9u=v;let b=class{constructor(g,r){this.j=g,this.k=r,this.a=new P.$fd,this.onTunnelOpened=this.a.event,this.b=new P.$fd,this.onTunnelClosed=this.b.event,this.c=new P.$fd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const g=this.k.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.f=g,g?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.g=g.elevation,this.h=g.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const g=[],r=Array.from(this.e.values());for(const $ of r){const E=Array.from($.values());for(const u of E){const t=await u.value;t&&typeof t!="string"&&g.push(t)}}return g}async dispose(){for(const g of this.e.values()){for(const{value:r}of g.values())await r.then($=>typeof $!="string"?$?.dispose():void 0);g.clear()}this.e.clear()}setEnvironmentTunnel(g,r,$,E,u){this.p(g,r,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:r,localAddress:$,privacy:E,protocol:u,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,r){(y(g)||w(g))&&(g=e.$4u[0]);const $=this.r(g,r);if($)return++$.refcount,$.value}openTunnel(g,r,$,E,u,t=!1,l,o){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${r}:${$} on local port ${u}.`);const i=this.f??g;if(!i)return;if(r||(r="localhost"),E||(E=this.l),this.f&&this.i.has($)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.s(i,r,$,E,u,t,l,o);return n?n.then(a=>{if(a){if(typeof a=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(r,$),a}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(r,$);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(a);return(a.tunnelRemoteHost!==r||a.tunnelRemotePort!==$)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&a.privacy!==l&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}n(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const r=this.e.get(g.tunnelRemoteHost);if(r){const $=r.get(g.tunnelRemotePort);$&&($.refcount--,await this.o(g.tunnelRemoteHost,g.tunnelRemotePort,$))}}}}async o(g,r,$){if($.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${r}.`);const E=$.value.then(async u=>{u&&typeof u!="string"&&(await u.dispose(!0),this.b.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this.e.has(g)&&this.e.get(g).delete(r),E}}async closeTunnel(g,r){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${r} `);const $=this.e.get(g);if($&&$.has(r)){const E=$.get(r);E.refcount=0,await this.o(g,r,E)}}p(g,r,$){this.e.has(g)||this.e.set(g,new Map),this.e.get(g).set(r,{refcount:1,value:$})}async q(g,r){const $=this.e.get(g);if($){const E=$.get(r),u=E?await E.value:void 0;(!u||typeof u=="string")&&$.delete(r),$.size===0&&this.e.delete(g)}}r(g,r){const $=[g];w(g)?($.push(...e.$4u),$.push(...e.$6u)):y(g)&&$.push(...e.$6u);const E=$.map(u=>this.e.get(u));for(const u of E){const t=u?.get(r);if(t)return t}}canTunnel(g){return!!m(g)}t(g,r,$,E,u,t,l){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${r}:${$} on local port ${E}.`);const o=$;this.i.add(o);const i=E===void 0?$:E,n={elevationRequired:u?this.isPortPrivileged(i):!1},a={remoteAddress:{host:r,port:$},localAddressPort:E,privacy:t,public:t?t!==S.Private:void 0,protocol:l},k=g.forwardPort(a,n);return k?(this.p(r,$,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(o)})):this.i.delete(o),k}};e.$0u=b,e.$0u=b=ke([_(0,M.$5i),_(1,O.$8h)],b)}),define(te[48],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UT=e.$TT=e.DisablementReason=e.UpdateType=e.StateType=void 0;var O;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(O||(e.StateType=O={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var M;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$TT={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,S)=>({type:"idle",updateType:D,error:S}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$UT=(0,P.$Bh)("updateService")}),define(te[264],ie([0,1,4,186,58,43]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$8m.as(s.$an.Configuration).registerConfiguration({id:"update",order:15,title:(0,O.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,O.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,O.localize)(2,null),(0,O.localize)(3,null),(0,O.localize)(4,null),(0,O.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,O.localize)(6,null),deprecationMessage:(0,O.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,O.localize)(8,null),description:(0,O.localize)(9,null),included:P.$i&&!P.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,O.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[265],ie([0,1,3,48]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K6b=e.$J6b=void 0;class s{constructor(S){this.a=S}listen(S,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(S,h,c){switch(h){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${h}`)}}e.$J6b=s;class M{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new P.$fd,this.onStateChange=this.a.event,this.b=O.$TT.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$K6b=M}),define(te[40],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ck=void 0,e.$Ck=(0,P.$Bh)("IUriIdentityService")}),define(te[266],ie([0,1,40,205,16,19,139,3,2]),function(K,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;class c{static{this._clock=0}constructor(y){this.uri=y,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let m=class{constructor(y){this.g=y,this.c=new h.$jc,this.f=2**16;const f=new Map,v=b=>{let d=f.get(b.scheme);return d===void 0&&(d=y.hasProvider(b)&&!this.g.hasCapability(b,1024),f.set(b.scheme,d)),d};this.c.add(S.Event.any(y.onDidChangeFileSystemProviderRegistrations,y.onDidChangeFileSystemProviderCapabilities)(b=>{f.delete(b.scheme)})),this.extUri=new M.$0f(v),this.d=new D.$or((b,d)=>this.extUri.compare(b,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(y){this.g.hasProvider(y)&&(y=(0,M.$jg)(y));const f=this.d.get(y);return f?f.touch().uri.with({fragment:y.fragment}):(this.d.set(y,new c(y)),this.h(),y)}h(){if(this.d.size<this.f)return;const y=[...this.d.entries()].sort((v,b)=>v[1].time<b[1].time?1:v[1].time>b[1].time?-1:0);c._clock=0,this.d.clear();const f=this.f*.5;for(let v=0;v<f;v++)this.d.set(y[v][0],y[v][1].touch())}};e.$pr=m,e.$pr=m=ke([_(0,s.$6j)],m),(0,O.$mr)(P.$Ck,m,1)}),define(te[126],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IT=void 0,e.$IT=(0,P.$Bh)("urlService")}),define(te[267],ie([0,1,7]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T6b=e.$S6b=e.$R6b=void 0;class O{constructor(S){this.a=S}listen(S,h){throw new Error(`Event not found: ${h}`)}call(S,h,c){switch(h){case"handleURL":return this.a.handleURL(P.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${h}`)}}e.$R6b=O;class s{constructor(S){this.a=S}handleURL(S,h){return this.a.call("handleURL",[S.toJSON(),h])}}e.$S6b=s;class M{constructor(S,h){this.a=S,this.b=h}async routeCall(S,h,c,m){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(c)&&c.length>0){const w=P.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",w.toString(!0)),w.query){const y=/\bwindowId=(\d+)/.exec(w.query);if(y){const f=y[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,w.toString(!0));const v=new RegExp(`window:${f}`),b=S.connections.find(d=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",d.ctx),v.test(d.ctx)));if(b)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",w.toString(!0)),b;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",w.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",w.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,h,c,m)}routeEvent(S,h){throw new Error(`Event not found: ${h}`)}}e.$T6b=M}),define(te[268],ie([0,1,8,2,7,24]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KT=e.$JT=void 0;class D extends O.$kc{constructor(){super(...arguments),this.a=new Set}open(c,m){const w=[...this.a.values()];return(0,P.$Kg)(w.map(y=>()=>y.handleURL(c,m)),void 0,!1).then(y=>y||!1)}registerHandler(c){return this.a.add(c),(0,O.$ic)(()=>this.a.delete(c))}}e.$JT=D;let S=class extends D{constructor(c){super(),this.b=c}create(c){let{authority:m,path:w,query:y,fragment:f}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return m&&w&&w.indexOf("/")!==0&&(w=`/${w}`),s.URI.from({scheme:this.b.urlProtocol,authority:m,path:w,query:y,fragment:f})}};e.$KT=S,e.$KT=S=ke([_(0,M.$kj)],S)}),define(te[269],ie([0,1,15,8,3,2,4,7]),function(K,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U6b=void 0;class h{constructor(m,w,y,f,v,b){if(this.f=w,this.g=b,this.a=[],this.b=0,this.c=M.$kc.None,this.d=new M.$jc,m&&(b.trace("ElectronURLListener initialUrisToHandle:",m.map(r=>r.originalUrl)),this.a=m),D.$i){const r=f.isBuilt?[]:[`"${f.appRoot}"`];r.push("--open-url","--"),P.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,r)}const d=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(r,$)=>({event:r,url:$})),({event:r,url:$})=>(r.preventDefault(),$));this.d.add(d(r=>{const $=this.h(r);$&&this.f.open($,{originalUrl:r})})),y.getWindows().filter(r=>r.isReady).length>0?(b.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(b.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),s.Event.once(y.onDidSignalReadyWindow)(this.i,this,this.d))}h(m){try{return S.URI.parse(m)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const m=[];for(const w of this.a)await this.f.open(w.uri,{originalUrl:w.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",w.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",w.originalUrl),m.push(w));m.length!==0&&(this.a=m,this.c=(0,O.$Ig)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.$U6b=h}),define(te[270],ie([0,1,3,2,16,57,33]),function(K,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t7b=void 0;class S extends O.$kc{constructor(c,m,w,y,f,v){super(),this.f=c,this.g=m,this.h=w,this.j=y,this.m=f,this.n=v,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$fd),this.onDidChangeFile=this.a.event,this.b=M.$Hh.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Ai(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(y.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,m){return this.g.open(this.t(c),m)}close(c){return this.g.close(c)}read(c,m,w,y,f){return this.g.read(c,m,w,y,f)}write(c,m,w,y,f){return this.g.write(c,m,w,y,f)}watch(c,m){this.b.set(c,c);const w=this.g.watch(this.t(c),m);return(0,O.$ic)(()=>{this.b.delete(c),w.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,m,w){return this.g.rename(this.t(c),this.t(m),w)}readFile(c,m){return this.g.readFile(this.t(c),m)}readFileStream(c,m,w){return this.g.readFileStream(this.t(c),m,w)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,m,w){return this.g.writeFile(this.t(c),m,w)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,m){return this.g.delete(this.t(c),m)}copy(c,m,w){if((0,s.$9j)(this.g))return this.g.copy(this.t(c),this.t(m),w);throw new Error("copy not supported")}cloneFile(c,m){if((0,s.$0j)(this.g))return this.g.cloneFile(this.t(c),this.t(m));throw new Error("clone not supported")}s(c){const m=[];for(const w of c){if(w.resource.scheme!==this.f)continue;const y=this.u(w.resource);this.b.findSubstr(y)&&m.push({resource:y,type:w.type})}m.length&&(this.n.debug("User data changed"),this.a.fire(m))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$t7b=S}),define(te[271],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b7b=void 0,e.$b7b="utilityProcessWorker"}),define(te[272],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V6b=void 0,e.$V6b=(0,P.$Bh)("webviewManagerService")}),define(te[273],ie([0,1,15,2,13,7]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W6b=void 0;class D extends O.$kc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,h)}b(h,c){try{const m=M.URI.parse(h.url),w=D.a.get(m.path);if(typeof w=="string"){const y=`vs/workbench/contrib/webview/browser/pre/${w}`,f=s.$2f.asFileUri(y);return c({path:f.fsPath,headers:{...s.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$W6b=D}),define(te[80],ie([0,1,4]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YC=e.$XC=e.$WC=e.$VC=e.$UC=e.$TC=e.$SC=e.$RC=void 0,e.$RC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function O(m){return!!m.workspaceUri}e.$SC=O;function s(m){return!!m.folderUri}e.$TC=s;function M(m){return!!m.fileUri}e.$UC=M;function D(m){const w=S(m),y=m.getValue("window.menuBarVisibility");return y==="default"||w==="native"&&y==="compact"||P.$j&&P.$m?"classic":y}e.$VC=D;function S(m){if(P.$o)return"custom";const w=m.getValue("window");if(w){if(P.$j&&w.nativeTabs===!0||P.$j&&w.nativeFullScreen===!1)return"native";const v=w.titleBarStyle;if(v==="native"||v==="custom")return v}return P.$k?"native":"custom"}e.$WC=S;function h(m){return!(!P.$i||P.$o||S(m)==="native")}e.$XC=h;function c(m=0){return Math.pow(1.2,m)}e.$YC=c}),define(te[127],ie([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$s5b=e.UnloadReason=e.LoadReason=void 0;var P;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var O;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(O||(e.UnloadReason=O={}));const s=function(S=1){return{width:1024,height:768,mode:S}};e.$s5b=s;var M;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var D;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(te[30],ie([0,1,6]),function(K,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.$H5b=void 0,e.$H5b=(0,P.$Bh)("windowsMainService");var O;(function(s){s[s.CLI=0]="CLI",s[s.DOCK=1]="DOCK",s[s.MENU=2]="MENU",s[s.DIALOG=3]="DIALOG",s[s.DESKTOP=4]="DESKTOP",s[s.API=5]="API"})(O||(e.OpenContext=O={}))}),define(te[274],ie([0,1,15,23,4,7,21,18,63,6,5,126,30]),function(K,e,P,O,s,M,D,S,h,c,m,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q6b=e.$p6b=e.ID=void 0,e.ID="launchMainService",e.$p6b=(0,c.$Bh)(e.ID);let f=class{constructor(b,d,g,r){this.a=b,this.b=d,this.c=g,this.d=r}async start(b,d){this.a.trace("Received data from other instance: ",b,d),s.$j&&P.app.focus({steal:!0});const g=this.e(b);if(g.length){let r=Promise.resolve();if(this.b.getWindowCount()===0){const $=(0,O.$Mb)(await this.b.openEmptyWindow({context:4}));$&&(r=$.ready())}r.then(()=>{for(const{uri:$,originalUrl:E}of g)this.c.open($,{originalUrl:E})})}else return this.f(b,d)}e(b){return b["open-url"]&&b._urls&&b._urls.length>0?(0,O.$Fb)(b._urls.map(d=>{try{return{uri:M.URI.parse(d),originalUrl:d}}catch{return null}})):[]}async f(b,d){const g=(0,h.$Gl)(d)?0:4;let r=[];const $=b.wait&&b.waitMarkerFilePath?M.URI.file(b.waitMarkerFilePath):void 0,E=b.remote||void 0,u={context:g,cli:b,userEnv:d,waitMarkerFileURI:$,remoteAuthority:E,forceProfile:b.profile,forceTempProfile:b["profile-temp"]};if(b.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(b.extensionDevelopmentPath,u);else if(!b._.length&&!b["folder-uri"]&&!b["file-uri"]){let t=!1;if(b["new-window"]||b["unity-launch"]||u.forceProfile||u.forceTempProfile)t=!0;else if(b["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)r=await this.b.open({...u,forceNewWindow:!0,forceEmpty:!0});else{const l=this.b.getLastActiveWindow();l?(this.b.openExistingWindow(l,u),r=[l]):r=await this.b.open({...u,forceEmpty:!0})}}else r=await this.b.open({...u,forceNewWindow:b["new-window"],preferNewWindow:!b["reuse-window"]&&!b.wait,forceReuseWindow:b["reuse-window"],diffMode:b.diff,mergeMode:b.merge,addMode:b.add,noRecentEntry:!!b["skip-add-to-recently-opened"],gotoLineMode:b.goto});if($&&r.length===1&&r[0])return Promise.race([r[0].whenClosedOrLoaded,(0,D.whenDeleted)($.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$q6b=f,e.$q6b=f=ke([_(0,m.$5i),_(1,y.$H5b),_(2,w.$IT),_(3,S.$8h)],f)}),define(te[275],ie([0,1,15,3,2,273,30]),function(K,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X6b=void 0;let S=class extends s.$kc{constructor(c){super(),this.b=c,this.a=this.B(new O.$fd),this.onFoundInFrame=this.a.event,this.B(new M.$W6b)}async setIgnoreMenuShortcuts(c,m){let w;if(typeof c.windowId=="number"){const{windowId:y}=c,f=this.b.getWindowById(y);if(!f?.win)throw new Error(`Invalid windowId: ${y}`);w=f.win.webContents}else{const{webContentsId:y}=c;if(w=P.webContents.fromId(y),!w)throw new Error(`Invalid webContentsId: ${y}`)}w.isDestroyed()||w.setIgnoreMenuShortcuts(m)}async findInFrame(c,m,w,y){const v=this.c(c,m);if(typeof v.findInFrame=="function"){v.findInFrame(w,{findNext:y.findNext,forward:y.forward});const b=(d,g)=>{g.finalUpdate&&(this.a.fire(g),v.removeListener("found-in-frame",b))};v.on("found-in-frame",b)}}async stopFindInFrame(c,m,w){const f=this.c(c,m);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(w.keepSelection?"keepSelection":"clearSelection")}c(c,m){const w=this.b.getWindowById(c.windowId);if(!w?.win)throw new Error(`Invalid windowId: ${c}`);const y=w.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===m);if(!y)throw new Error(`Unknown frame: ${m}`);return y}};e.$X6b=S,e.$X6b=S=ke([_(0,D.$H5b)],S)}),define(te[276],ie([0,1,8,3,2]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$46b=void 0;class M extends s.$kc{constructor({onDidOpenWindow:S,onDidFocusWindow:h,getActiveWindowId:c}){super(),this.a=this.B(new s.$jc),O.Event.latch(O.Event.any(S,h))(this.f,this,this.a),this.b=(0,P.$ug)(()=>c()),(async()=>{try{const w=await this.b;this.c=typeof this.c=="number"?this.c:w}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$46b=M}),define(te[29],ie([0,1,190,9,57,19,7,6,13]),function(K,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.WorkbenchState=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=void 0,e.$Kh=(0,S.$Bh)("contextService");function c(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$Lh=c;function m(i){return typeof i?.id=="string"&&!c(i)&&!y(i)}e.$Mh=m,e.$Nh={id:"ext-dev"},e.$Oh={id:"empty-window"};function w(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,O.$ae)(i)}:n?e.$Nh:e.$Oh;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$Ph=w;function y(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$Qh=y;function f(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:D.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.$Rh=f;var v;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Sh=b;function d(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Th=d;class g{constructor(n,a,k,I,C){this.h=n,this.j=k,this.k=I,this.l=C,this.c=s.$Hh.forUris(this.l,()=>!0),this.folders=a}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=s.$Hh.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Uh=g;class r{constructor(n,a){this.raw=a,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,M.$ig)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Vh=r;function $(i){return new r({uri:i,index:0,name:(0,M.$eg)(i)},{uri:i.toString()})}e.$Wh=$,e.$Xh="code-workspace",e.$Yh=`.${e.$Xh}`,e.$Zh=[{name:(0,P.localize)(0,null),extensions:[e.$Xh]}],e.$1h="workspace.json";function E(i,n){return M.$_f.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$2h=E;function u(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===h.Schemas.tmp}e.$3h=u,e.$4h="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$4h}e.$5h=t;function l(i,n){return!E(i,n)&&!u(i)}e.$6h=l;function o(i){return(typeof i=="string"?(0,O.$be)(i):(0,M.$gg)(i))===e.$Yh}e.$7h=o}),define(te[60],ie([0,1,15,8,56,46,2,85,4,21,165,91,6,5,24,29]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U5b=e.$T5b=void 0,e.$T5b=(0,y.$Bh)("dialogMainService");let d=class{constructor(r,$){this.d=r,this.e=$,this.a=new Map,this.b=new Map,this.c=new O.$Ng}pickFileFolder(r,$){return this.f({...r,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},$)}pickFolder(r,$){return this.f({...r,pickFolders:!0,title:(0,m.localize)(1,null)},$)}pickFile(r,$){return this.f({...r,pickFiles:!0,title:(0,m.localize)(2,null)},$)}pickWorkspace(r,$){const E=(0,m.localize)(3,null),u=(0,M.$ov)((0,m.localize)(4,null)),t=b.$Zh;return this.f({...r,pickFiles:!0,title:E,filters:t,buttonLabel:u},$)}async f(r,$){const E={title:r.title,buttonLabel:r.buttonLabel,filters:r.filters,defaultPath:r.defaultPath};(typeof r.pickFiles=="boolean"||typeof r.pickFolders=="boolean")&&(E.properties=void 0,r.pickFiles&&r.pickFolders&&(E.properties=["multiSelections","openDirectory","openFile","createDirectory"])),E.properties||(E.properties=["multiSelections",r.pickFolders?"openDirectory":"openFile","createDirectory"]),h.$j&&E.properties.push("treatPackageAsDirectory");const u=await this.showOpenDialog(E,($||P.BrowserWindow.getFocusedWindow())??void 0);if(u&&u.filePaths&&u.filePaths.length>0)return u.filePaths}g(r){if(r){let $=this.b.get(r.id);return $||($=new O.$Ng,this.b.set(r.id,$)),$}else return this.c}showMessageBox(r,$){return this.g($).queue(async()=>{const{options:E,buttonIndeces:u}=(0,w.$vv)(r,this.e);let t;return $?t=await P.dialog.showMessageBox($,E):t=await P.dialog.showMessageBox(E),{response:u[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(r,$){const E=this.j(r,$);if(!E)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g($).queue(async()=>{let u;return $?u=await P.dialog.showSaveDialog($,r):u=await P.dialog.showSaveDialog(r),u.filePath=this.h(u.filePath),u})}finally{(0,D.$fc)(E)}}h(r){return r&&h.$j&&(r=(0,S.$hl)(r)),r}i(r){return r.map($=>this.h($))}async showOpenDialog(r,$){r.defaultPath&&(await c.Promises.exists(r.defaultPath)||(r.defaultPath=void 0));const E=this.j(r,$);if(!E)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g($).queue(async()=>{let u;return $?u=await P.dialog.showOpenDialog($,r):u=await P.dialog.showOpenDialog(r),u.filePaths=this.i(u.filePaths),u})}finally{(0,D.$fc)(E)}}j(r,$){if(!$)return D.$kc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",r);let E=this.a.get($.id);E||(E=new Set,this.a.set($.id,E));const u=(0,s.$pi)(r);if(!E.has(u))return this.d.trace("[DialogMainService]: new file dialog lock created",r),E.add(u),(0,D.$ic)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",r),E?.delete(u),E?.size===0&&this.a.delete($.id)})}};e.$U5b=d,e.$U5b=d=ke([_(0,f.$5i),_(1,v.$kj)],d)}),define(te[277],ie([0,1,3,2,74,29]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G6b=void 0;class D extends O.$kc{static{this.a=100}constructor(h,c){super(),this.f=h,this.g=c,this.b=this.B(new P.$fd),this.c=new Map,this.h(c.applicationStorage,this.b)}h(h,c){this.B(P.Event.debounce(h.onDidChangeStorage,(m,w)=>(m?m.push(w):m=[w],m),D.a)(m=>{m.length&&c.fire(this.j(m,h))}))}j(h,c){const m=new Map,w=new Set;return h.forEach(y=>{const f=c.get(y.key);typeof f=="string"?m.set(y.key,f):w.add(y.key)}),{changed:Array.from(m.entries()),deleted:Array.from(w.values())}}listen(h,c,m){switch(c){case"onDidChangeStorage":{const w=m.profile?(0,s.$$g)(m.profile):void 0;if(!w)return this.b.event;let y=this.c.get(w.id);return y||(y=this.B(new P.$fd),this.h(this.g.profileStorage(w),y),this.c.set(w.id,y)),y.event}}throw new Error(`Event not found: ${c}`)}async call(h,c,m){const w=m.profile?(0,s.$$g)(m.profile):void 0,y=(0,M.$Rh)(m.workspace),f=await this.m(w,y);switch(c){case"getItems":return Array.from(f.items.entries());case"updateItems":{const v=m;if(v.insert)for(const[b,d]of v.insert)f.set(b,d);v.delete?.forEach(b=>f.delete(b));break}case"optimize":return f.optimize();case"isUsed":{const v=m.payload;if(typeof v=="string")return this.g.isUsed(v)}default:throw new Error(`Call not found: ${c}`)}}async m(h,c){let m;c?m=this.g.workspaceStorage(c):h?m=this.g.profileStorage(h):m=this.g.applicationStorage;try{await m.init()}catch(w){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":h?"profile":"application"} storage due to ${w}`)}return m}}e.$G6b=D}),define(te[41],ie([0,1,56,3,2,19,7,187,36,16,6,5,29,33,40,8,31,26,12]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.ProfileResourceType=void 0;var $;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$Dk=E,e.$Ek=(0,m.$Bh)("IUserDataProfilesService");function u(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$Fk=u;function t(i,n,a,k,I,C){return{id:i,name:n,location:a,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:C&&I?.useDefaultFlags?.globalState?C.globalStorageHome:(0,M.$ig)(a,"globalStorage"),settingsResource:C&&I?.useDefaultFlags?.settings?C.settingsResource:(0,M.$ig)(a,"settings.json"),keybindingsResource:C&&I?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,M.$ig)(a,"keybindings.json"),tasksResource:C&&I?.useDefaultFlags?.tasks?C.tasksResource:(0,M.$ig)(a,"tasks.json"),snippetsHome:C&&I?.useDefaultFlags?.snippets?C.snippetsHome:(0,M.$ig)(a,"snippets"),extensionsResource:C&&I?.useDefaultFlags?.extensions?C.extensionsResource:(0,M.$ig)(a,"extensions.json"),cacheHome:(0,M.$ig)(k,i),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$Gk=t;let l=class extends s.$kc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,a,k,I){super(),this.t=n,this.u=a,this.w=k,this.y=I,this.f=!0,this.h=this.B(new O.$fd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$fd),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$fd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$fd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$zi,emptyWindows:new Map},this.profilesHome=(0,M.$ig)(this.t.userRoamingDataHome,"profiles"),this.g=(0,M.$ig)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),a=[n];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,r.$jf)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}a.push(t((0,M.$fg)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},n))}}catch(C){this.y.error(C)}const k=new f.$zi,I=new Map;if(a.length)try{const C=this.Q();if(C.workspaces)for(const[p,A]of Object.entries(C.workspaces)){const L=D.URI.parse(p),U=a.find(z=>z.id===A);U&&k.set(L,U)}if(C.emptyWindows)for(const[p,A]of Object.entries(C.emptyWindows)){const L=a.find(U=>U.id===A);L&&I.set(p,L)}}catch(C){this.y.error(C)}this.z={profiles:a,workspaces:k,emptyWindows:I}}return this.z}D(){const n=t("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const a="Temp",k=new RegExp(`${(0,g.$qe)(a)}\\s(\\d+)`);let I=0;for(const p of this.profiles){const A=k.exec(p.name),L=A?parseInt(A[1]):0;I=L>I?L:I}const C=`${a} ${I+1}`;return this.createProfile((0,P.$pi)((0,d.$4f)()).toString(16),C,{transient:!0},n)}async createNamedProfile(n,a,k){return this.createProfile((0,P.$pi)((0,d.$4f)()).toString(16),n,a,k)}async createProfile(n,a,k,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(n,a,k);return I&&await this.setProfileForWorkspace(I,C),C}async F(n,a,k){if(!(0,r.$jf)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(a);return I||(I=(async()=>{try{const C=this.profiles.find(L=>L.name===a||L.id===n);if(C)return C;const p=t(n,a,(0,M.$ig)(this.profilesHome,n),this.g,k,this.defaultProfile);await this.u.createFolder(p.location);const A=[];return this.j.fire({profile:p,join(L){A.push(L)}}),await b.Promises.settled(A),this.I([p],[],[]),p}finally{this.r.delete(a)}})(),this.r.set(a,I)),I}async updateProfile(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(I=>I.id===n.id);if(!k)throw new Error(`Profile '${n.name}' does not exist`);return k=t(k.id,a.name??k.name,k.location,this.g,{shortName:a.shortName??k.shortName,icon:a.icon===null?void 0:a.icon??k.icon,transient:a.transient??k.isTransient,useDefaultFlags:a.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(I=>I.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);const k=[];this.m.fire({profile:a,join(I){k.push(I)}});try{await Promise.allSettled(k)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(I){(0,c.$jk)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(I=>I.id===a.id);if(!k)throw new Error(`Profile '${a.name}' does not exist`);this.L(n,k)}unsetWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(a=>a.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(n.map(a=>this.removeProfile(a)))}getProfileForWorkspace(n){const a=this.G(n);return D.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(n){return(0,y.$Lh)(n)?n.uri:(0,y.$Qh)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location)))}I(n,a,k){const I=[...this.profiles,...n],C=[];this.s.profiles=[];for(let p of I)p.isDefault||a.some(A=>p.id===A.id)||(p=k.find(A=>p.id===A.id)??p,p.isTransient?this.s.profiles.push(p):C.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(C),this.z=void 0,this.J(n,a,k)}J(n,a,k){this.h.fire({added:n,removed:a,updated:k,all:this.profiles})}L(n,a,k){k=a?.isTransient?!0:k,k||this.L(n,void 0,!0);const I=this.G(n),C=k?this.s:this.C;D.URI.isUri(I)?(C.workspaces.delete(I),a&&C.workspaces.set(I,a)):(C.emptyWindows.delete(I),a&&C.emptyWindows.set(I,a)),k||this.M()}M(){const n={};for(const[k,I]of this.C.workspaces.entries())n[k.toString()]=I.id;const a={};for(const[k,I]of this.C.emptyWindows.entries())a[k.toString()]=I.id;this.R({workspaces:n,emptyWindows:a}),this.z=void 0}N(n){const a={},k=this.D();if(n.workspaces)for(const[C,p]of Object.entries(n.workspaces)){const A=D.URI.parse(p);a[C]=this.w.extUri.isEqual(A,k.location)?k.id:this.w.extUri.basename(A)}const I={};if(n.emptyWindows)for(const[C,p]of Object.entries(n.emptyWindows)){const A=D.URI.parse(p);I[C]=this.w.extUri.isEqual(A,k.location)?k.id:this.w.extUri.basename(A)}return{workspaces:a,emptyWindows:I}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Hk=l,e.$Hk=l=ke([_(0,h.$Ih),_(1,c.$6j),_(2,v.$Ck),_(3,w.$5i)],l);class o extends l{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Ik=o}),define(te[81],ie([0,1,8,17,2,3,33,7,116,122,16,6,5,41,40,12,14,25]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.ExtensionsProfileScanningErrorCode=void 0;var r;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(r||(e.ExtensionsProfileScanningErrorCode=r={}));class $ extends Error{constructor(o,i){super(o),this.code=i}}e.$jp=$,e.$kp=(0,w.$Bh)("IExtensionsProfileScannerService");let E=class extends s.$kc{constructor(o,i,n,a,k,I){super(),this.j=o,this.m=i,this.n=n,this.r=a,this.s=k,this.t=I,this.b=this.B(new M.$fd),this.onAddExtensions=this.b.event,this.c=this.B(new M.$fd),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$fd),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$fd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$zi}scanProfileExtensions(o,i){return this.u(o,void 0,i)}async addExtensionsToProfile(o,i){const n=[],a=[];try{return await this.u(i,k=>{const I=[];for(const C of k)o.some(([p])=>(0,c.$po)(p.identifier,C.identifier)&&p.manifest.version!==C.version)?n.push(C):I.push(C);for(const[C,p]of o){const A=I.findIndex(U=>(0,c.$po)(U.identifier,C.identifier)&&U.version===C.manifest.version),L={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:p};A===-1?(a.push(L),I.push(L)):I.splice(A,1,L)}return a.length&&this.b.fire({extensions:a,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),I}),a.length&&this.c.fire({extensions:a,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),a}catch(k){throw a.length&&this.c.fire({extensions:a,error:k,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:k,profileLocation:i}),k}}async updateMetadata(o,i){const n=[];return await this.u(i,a=>{const k=[];for(const I of a){const C=o.find(([p])=>(0,c.$po)(p.identifier,I.identifier)&&p.manifest.version===I.version);C&&(I.metadata={...I.metadata,...C[1]},n.push(I)),k.push(I)}return k}),n}async removeExtensionFromProfile(o,i){const n=[];try{await this.u(i,a=>{const k=[];for(const I of a)(0,c.$po)(I.identifier,o.identifier)?n.push(I):k.push(I);return n.length&&this.f.fire({extensions:n,profileLocation:i}),k}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(a){throw n.length&&this.g.fire({extensions:n,error:a,profileLocation:i}),a}}async u(o,i,n){return this.F(o).queue(async()=>{let a=[],k;try{const I=await this.m.readFile(o);k=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,m.$jk)(I)!==1)throw I;if(this.r.extUri.isEqual(o,this.n.defaultProfile.extensionsResource)&&(k=await this.D()),!k&&n?.bailOutWhenFileNotFound)throw new $((0,d.$8)(I),"ERROR_PROFILE_NOT_FOUND")}if(k){Array.isArray(k)||this.w(o);let I=!1;for(const C of k){u(C)||this.w(o);let p;if((0,b.$jf)(C.relativeLocation)&&C.relativeLocation)p=this.z(C.relativeLocation);else if((0,b.$jf)(C.location))p=this.z(C.location),I=!0,C.relativeLocation=C.location,C.location=p.toJSON();else{p=S.URI.revive(C.location);const A=this.y(p);A&&(I=!0,C.relativeLocation=A)}a.push({identifier:C.identifier,location:p,version:C.version,metadata:C.metadata})}I&&await this.m.writeFile(o,O.$Fd.fromString(JSON.stringify(k)))}if(i){a=i(a);const I=a.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.y(C.location),metadata:C.metadata}));await this.m.writeFile(o,O.$Fd.fromString(JSON.stringify(I)))}return a})}w(o){const i=new $(`Invalid extensions content in ${o.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(o){return this.r.extUri.isEqual(this.r.extUri.dirname(o),this.j)?this.r.extUri.basename(o):void 0}z(o){return this.r.extUri.joinPath(this.j,o)}async D(){return this.C||(this.C=(async()=>{const o=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(o)).value.toString()}catch(k){if((0,m.$jk)(k)===1)return;throw k}this.t.info("Migrating extensions from old default profile location",o.toString());let a;try{const k=JSON.parse(n);Array.isArray(k)&&k.every(I=>u(I))?a=k:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",k)}catch(k){this.t.error(k)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,O.$Fd.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",o.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(k){if((0,m.$jk)(k)===3)this.t.info("Migration from old default profile location to new location is done by another window",o.toString(),this.n.defaultProfile.extensionsResource.toString());else throw k}try{await this.m.del(o)}catch(k){(0,m.$jk)(k)!==1&&this.t.error(k)}try{await this.m.del(i)}catch(k){(0,m.$jk)(k)!==1&&this.t.error(k)}return a})()),this.C}F(o){let i=this.h.get(o);return i||(i=new P.$Ng,this.h.set(o,i)),i}};e.$lp=E,e.$lp=E=ke([_(1,m.$6j),_(2,f.$Ek),_(3,v.$Ck),_(4,g.$9k),_(5,y.$5i)],E);function u(l){return(0,b.$lf)(l)&&(0,h.$Yn)(l.identifier)&&(t(l.location)||(0,b.$jf)(l.location)&&l.location)&&((0,b.$qf)(l.relativeLocation)||(0,b.$jf)(l.relativeLocation))&&l.version&&(0,b.$jf)(l.version)}function t(l){return l?(0,b.$jf)(l.path)&&(0,b.$jf)(l.scheme):!1}}),define(te[128],ie([0,1,23,8,37,17,14,44,151,2,13,9,4,19,203,70,12,7,170,36,122,119,202,16,6,5,24,3,74,81,41,40,201]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r,$,E,u,t,l,o,i,n,a,k,I,C,p,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.Translations=void 0;var L;(function(oe){function G(J,q){if(J===q)return!0;const F=Object.keys(J),N=new Set;for(const V of Object.keys(q))N.add(V);if(F.length!==N.size)return!1;for(const V of F){if(J[V]!==q[V])return!1;N.delete(V)}return N.size===0}oe.equals=G})(L||(e.Translations=L={})),e.$op=(0,o.$Bh)("IExtensionsScannerService");let U=class extends c.$kc{constructor(G,J,q,F,N,V,Q,x,ce,Y,R,j){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=J,this.r=q,this.s=F,this.t=N,this.u=V,this.w=Q,this.y=x,this.z=ce,this.C=Y,this.D=R,this.F=j,this.g=this.B(new a.$fd),this.onDidChangeCache=this.g.event,this.h=(0,f.$ig)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ee,this.s,this.h)),this.m=this.B(this.F.createInstance(ee,this.s,this.h)),this.n=this.B(this.F.createInstance(re,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Ao)(this.w,this.y)),this.G}async scanAllExtensions(G,J,q){const[F,N]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(J)]),V=q?await this.scanExtensionsUnderDevelopment(G,[...F,...N]):[];return this.L(F,N,V,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const J=[];J.push(this.M(!!G.useCache,G.language)),J.push(this.N(G.language,!!G.checkControlFile));const[q,F]=await Promise.all(J);return this.J([...q,...F],0,G,!1)}async scanUserExtensions(G){const J=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const q=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,F=await this.P(J,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,q),N=G.useCache&&!F.devMode&&F.excludeObsolete?this.m:this.n;let V;try{V=await N.scanExtensions(F)}catch(Q){if(Q instanceof I.$jp&&Q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),V=await N.scanExtensions(F);else throw Q}return V=await this.J(V,1,G,!0),this.y.trace("Scanned user extensions:",V.length),V}async scanExtensionsUnderDevelopment(G,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(F=>F.scheme===m.Schemas.file).map(async F=>{const N=await this.P(F,!1,1,!0,G.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(N)).map(Q=>(Q.type=J.find(x=>(0,E.$po)(x.identifier,Q.identifier))?.type??Q.type,this.n.validate(Q,N)))}))).flat();return this.J(q,"development",G,!0)}return[]}async scanExistingExtension(G,J,q){const F=await this.P(G,!1,J,!0,q.language,!0,void 0),N=await this.n.scanExtension(F);return!N||!q.includeInvalid&&!N.isValid?null:N}async scanOneOrMultipleExtensions(G,J,q){const F=await this.P(G,!1,J,!0,q.language,!0,void 0),N=await this.n.scanOneOrMultipleExtensions(F);return this.J(N,J,q,!0)}async scanMetadata(G){const J=(0,f.$ig)(G,"package.json"),q=(await this.w.readFile(J)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(G,J){const q=(0,f.$ig)(G,"package.json"),F=(await this.w.readFile(q)).value.toString(),N=JSON.parse(F);J.isMachineScoped=J.isMachineScoped||void 0,J.isBuiltin=J.isBuiltin||void 0,N.__metadata={...N.__metadata,...J},await this.w.writeFile((0,f.$ig)(G,"package.json"),M.$Fd.fromString(JSON.stringify(N,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof I.$jp&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,M.$Fd.fromString(JSON.stringify([])))}catch(J){(0,l.$jk)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$8)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,J,q,F){return q.includeAllVersions||(G=this.L(J===0?G:void 0,J===1?G:void 0,J==="development"?G:void 0,await this.getTargetPlatform(),F)),q.includeInvalid||(G=G.filter(N=>N.isValid)),G.sort((N,V)=>{const Q=w.$ae(N.location.fsPath),x=w.$ae(V.location.fsPath);return Q<x?-1:Q>x?1:0})}L(G,J,q,F,N){const V=(x,ce,Y)=>{if(x.isValid&&!ce.isValid)return!1;if(x.isValid===ce.isValid){if(N&&v.gt(x.manifest.version,ce.manifest.version))return this.y.debug(`Skipping extension ${ce.location.path} with lower version ${ce.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(v.eq(x.manifest.version,ce.manifest.version)){if(x.type===0)return this.y.debug(`Skipping extension ${ce.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===F)return this.y.debug(`Skipping extension ${ce.location.path} from different target platform ${ce.targetPlatform}`),!1}}return Y?this.y.warn(`Overwriting user extension ${x.location.path} with ${ce.location.path}.`):this.y.debug(`Overwriting user extension ${x.location.path} with ${ce.location.path}.`),!0},Q=new u.$Xl;return G?.forEach(x=>{const ce=Q.get(x.identifier.id);(!ce||V(ce,x,!1))&&Q.set(x.identifier.id,x)}),J?.forEach(x=>{const ce=Q.get(x.identifier.id);if(!ce&&G&&x.type===0){this.y.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!ce||V(ce,x,!1))&&Q.set(x.identifier.id,x)}),q?.forEach(x=>{const ce=Q.get(x.identifier.id);(!ce||V(ce,x,!0))&&Q.set(x.identifier.id,x),Q.set(x.identifier.id,x)}),[...Q.values()]}async M(G,J){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0),N=await(G&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",N.length),N}async N(G,J){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const F=J?await this.O():{},N=[],V=g.URI.file(w.$7d(w.$9d(m.$2f.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of q){const ce=F[x.name]||"marketplace";switch(ce){case"disabled":break;case"marketplace":N.push((0,f.$ig)(V,x.name));break;default:N.push(g.URI.file(ce));break}}const Q=await Promise.all(N.map(async x=>this.n.scanExtension(await this.P(x,!1,0,!0,G,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Q.length),(0,P.$Fb)(Q)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,J,q,F,N,V,Q){const x=await this.f(N??y.$v),ce=await this.Q(G),Y=J&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,R=Y?await this.Q(Y):void 0;return new z(G,ce,Y,R,J,Q,q,F,V,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,N,x)}async Q(G){try{const J=await this.w.stat(G);if(typeof J.mtime=="number")return J.mtime}catch{}}};e.$pp=U,e.$pp=U=ke([_(4,C.$Ek),_(5,I.$kp),_(6,l.$6j),_(7,i.$5i),_(8,$.$Ih),_(9,n.$kj),_(10,p.$Ck),_(11,o.$Ah)],U);class z{constructor(G,J,q,F,N,V,Q,x,ce,Y,R,j,W,T,H){this.location=G,this.mtime=J,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=F,this.profile=N,this.profileScanOptions=V,this.type=Q,this.excludeObsolete=x,this.validate=ce,this.productVersion=Y,this.productDate=R,this.productCommit=j,this.devMode=W,this.language=T,this.translations=H}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,J){return(0,f.$bg)(G.location,J.location)&&G.mtime===J.mtime&&(0,f.$bg)(G.applicationExtensionslocation,J.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&G.profile===J.profile&&s.$Zm(G.profileScanOptions,J.profileScanOptions)&&G.type===J.type&&G.excludeObsolete===J.excludeObsolete&&G.validate===J.validate&&G.productVersion===J.productVersion&&G.productDate===J.productDate&&G.productCommit===J.productCommit&&G.devMode===J.devMode&&G.language===J.language&&L.equals(G.translations,J.translations)}}e.$qp=z;let re=class extends c.$kc{constructor(G,J,q,F,N){super(),this.f=G,this.g=J,this.h=q,this.j=F,this.m=N}async scanExtensions(G){const J=G.profile?await this.r(G):await this.n(G);let q={};if(G.excludeObsolete&&G.type===1)try{const F=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(F)}catch{}return(0,d.$wf)(q)?J:J.filter(F=>!q[E.$qo.create(F).toString()])}async n(G){const J=await this.j.resolve(G.location);if(!J.children?.length)return[];const q=await Promise.all(J.children.map(async F=>{if(!F.isDirectory||G.type===1&&(0,f.$fg)(F.resource).indexOf(".")===0)return null;const N=new z(F.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(N)}));return(0,P.$Fb)(q).sort((F,N)=>F.location.path<N.location.path?-1:1)}async r(G){let J=await this.s(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){J=J.filter(F=>!F.metadata?.isApplicationScoped);const q=await this.s(G.applicationExtensionslocation,F=>!!F.metadata?.isBuiltin||!!F.metadata?.isApplicationScoped,G);J.push(...q)}return J}async s(G,J,q){const F=await this.g.scanProfileExtensions(G,q.profileScanOptions);if(!F.length)return[];const N=await Promise.all(F.map(async V=>{if(J(V)){const Q=new z(V.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(Q,V.metadata)}return null}));return(0,P.$Fb)(N)}async scanOneOrMultipleExtensions(G){try{if(await this.j.exists((0,f.$ig)(G.location,"package.json"))){const J=await this.scanExtension(G);return J?[J]:[]}else return await this.scanExtensions(G)}catch(J){return this.m.error(`Error scanning extensions at ${G.location.path}:`,(0,D.$8)(J)),[]}}async scanExtension(G,J){try{let q=await this.scanExtensionManifest(G.location);if(q){q.publisher||(q.publisher=u.$Rl),J=J??q.__metadata,delete q.__metadata;const F=(0,E.$uo)(q.publisher,q.name),N=J?.id?{id:F,uuid:J.id}:{id:F},V=J?.isSystem?0:G.type,Q=V===0||!!J?.isBuiltin;q=await this.t(G.location,q,z.createNlsConfiguration(G));const x={type:V,identifier:N,manifest:q,location:G.location,isBuiltin:Q,targetPlatform:J?.targetPlatform??"undefined",metadata:J,isValid:!0,validations:[]};return G.validate?this.validate(x,G):x}}catch(q){G.type!==0&&this.m.error(q)}return null}validate(G,J){let q=!0;const F=(0,t.$Fo)(J.productVersion,J.productDate,J.location,G.manifest,G.isBuiltin);for(const[N,V]of F)N===b.default.Error&&(q=!1,this.m.error(this.z(J.location,V)));return G.isValid=q,G.validations=F,G}async scanExtensionManifest(G){const J=(0,f.$ig)(G,"package.json");let q;try{q=(await this.j.readFile(J)).value.toString()}catch(N){return(0,l.$jk)(N)!==1&&this.m.error(this.z(G,(0,r.localize)(0,null,J.path,N.message))),null}let F;try{F=JSON.parse(q)}catch{const V=[];(0,S.$Lm)(q,V);for(const Q of V)this.m.error(this.z(G,(0,r.localize)(1,null,J.path,Q.offset,Q.length,(0,h.$mp)(Q.error))));return null}return(0,S.$Um)(F)!=="object"?(this.m.error(this.z(G,(0,r.localize)(2,null,J.path))),null):F}async t(G,J,q){const F=await this.u(G,J,q);if(F)try{const N=[],V=await this.w(F.default,N);if(N.length>0)return N.forEach(x=>{this.m.error(this.z(G,(0,r.localize)(3,null,F.default?.path,(0,h.$mp)(x.error))))}),J;if((0,S.$Um)(F)!=="object")return this.m.error(this.z(G,(0,r.localize)(4,null,F.default?.path))),J;const Q=F.values||Object.create(null);return(0,A.$np)(this.m,J,Q,V)}catch{}return J}async u(G,J,q){const F=(0,f.$ig)(G,"package.nls.json"),N=(ce,Y)=>{Y.forEach(R=>{this.m.error(this.z(G,(0,r.localize)(5,null,ce?.path,(0,h.$mp)(R.error))))})},V=ce=>{this.m.error(this.z(G,(0,r.localize)(6,null,ce?.path)))},Q=`${J.publisher}.${J.name}`,x=q.translations[Q];if(x)try{const ce=g.URI.file(x),Y=(await this.j.readFile(ce)).value.toString(),R=[],j=(0,S.$Lm)(Y,R);return R.length>0?(N(ce,R),{values:void 0,default:F}):(0,S.$Um)(j)!=="object"?(V(ce),{values:void 0,default:F}):{values:j.contents?j.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.j.exists(F))return;let Y;try{Y=await this.y(G,q)}catch{return}if(!Y.localized)return{values:void 0,default:Y.original};try{const R=(await this.j.readFile(Y.localized)).value.toString(),j=[],W=(0,S.$Lm)(R,j);return j.length>0?(N(Y.localized,j),{values:void 0,default:Y.original}):(0,S.$Um)(W)!=="object"?(V(Y.localized),{values:void 0,default:Y.original}):{values:W,default:Y.original}}catch{return{values:void 0,default:Y.original}}}}async w(G,J){if(G)try{const q=(await this.j.readFile(G)).value.toString();return(0,S.$Lm)(q,J)}catch{}}y(G,J){return new Promise((q,F)=>{const N=V=>{const Q=(0,f.$ig)(G,`package.nls.${V}.json`);this.j.exists(Q).then(x=>{x&&q({localized:Q,original:(0,f.$ig)(G,"package.nls.json")});const ce=V.lastIndexOf("-");ce===-1?q({localized:(0,f.$ig)(G,"package.nls.json"),original:null}):(V=V.substring(0,ce),N(V))})};if(J.devMode||J.pseudo||!J.language)return q({localized:(0,f.$ig)(G,"package.nls.json"),original:null});N(J.language)})}z(G,J){return`[${G.path}]: ${J}`}};re=ke([_(1,I.$kp),_(2,p.$Ck),_(3,l.$6j),_(4,i.$5i)],re);let ee=class extends re{constructor(G,J,q,F,N,V,Q){super(J,F,N,V,Q),this.G=G,this.H=q,this.D=this.B(new O.$Eg(3e3)),this.F=this.B(new a.$fd),this.onDidChangeCache=this.F.event}async scanExtensions(G){const J=this.M(G),q=await this.I(J);if(this.C=G,q&&q.input&&z.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",G.location.toString()),this.D.trigger(()=>this.L()),q.result.map(N=>(N.location=g.URI.revive(N.location),N));const F=await super.scanExtensions(G);return await this.J(J,{input:G,result:F}),F}async I(G){try{const J=await this.j.readFile(G),q=JSON.parse(J.value.toString());return{result:q.result,input:(0,k.$$g)(q.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",G.path,(0,D.$8)(J))}return null}async J(G,J){try{await this.j.writeFile(G,M.$Fd.fromString(JSON.stringify(J)))}catch(q){this.m.debug("Error while writing the extension cache file:",G.path,(0,D.$8)(q))}}async L(){if(!this.C)return;const G=this.M(this.C),J=await this.I(G);if(!J)return;const q=J.result,F=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$Zm(F,q))try{this.m.info("Invalidating Cache",q,F),await this.j.del(G),this.F.fire()}catch(N){this.m.error(N)}}M(G){const J=this.N(G);return this.h.extUri.joinPath(J.cacheHome,G.type===0?u.$Ql:u.$Pl)}N(G){return G.type===0?this.H.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(G.location,J.extensionsResource))??this.G:this.H.defaultProfile}};ee=ke([_(2,C.$Ek),_(3,I.$kp),_(4,p.$Ck),_(5,l.$6j),_(6,i.$5i)],ee);function ae(oe,G){const J=(0,E.$so)(oe.manifest.publisher,oe.manifest.name);return{id:J,identifier:new u.$Vl(J),isBuiltin:oe.type===0,isUserBuiltin:oe.type===1&&oe.isBuiltin,isUnderDevelopment:G,extensionLocation:oe.location,uuid:oe.identifier.uuid,targetPlatform:oe.targetPlatform,...oe.manifest}}e.$rp=ae;class se extends U{constructor(G,J,q,F,N,V,Q,x,ce,Y,R,j){super(G,J,(0,f.$ig)(q,".vscode-oss-dev","extensions","control.json"),F,N,V,Q,x,ce,Y,R,j),this.R=(async()=>{if(y.$y)try{const W=await this.w.readFile(g.URI.file(y.$y));return JSON.parse(W.value.toString())}catch{}return Object.create(null)})()}f(G){return this.R}}e.$sp=se}),define(te[278],ie([0,1,5,41,40,25,81,16,36,7]),function(K,e,P,O,s,M,D,S,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=void 0;let m=class extends D.$lp{constructor(y,f,v,b,d,g){super(c.URI.file(y.extensionsPath),f,v,b,d,g)}};e.$lN=m,e.$lN=m=ke([_(0,h.$Jh),_(1,S.$6j),_(2,O.$Ek),_(3,s.$Ck),_(4,M.$9k),_(5,P.$5i)],m)}),define(te[279],ie([0,1,7,36,81,128,16,6,5,24,40,41]),function(K,e,P,O,s,M,D,S,h,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$86b=void 0;let y=class extends M.$sp{constructor(v,b,d,g,r,$,E,u){super(P.URI.file(r.builtinExtensionsPath),P.URI.file(r.extensionsPath),r.userHome,v.defaultProfile,v,b,d,g,r,$,E,u)}};e.$86b=y,e.$86b=y=ke([_(0,w.$Ek),_(1,s.$kp),_(2,D.$6j),_(3,h.$5i),_(4,O.$Jh),_(5,c.$kj),_(6,m.$Ck),_(7,S.$Ah)],y)}),define(te[280],ie([0,1,15,2,13,9,4,57,7,31,38,36,5,41]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k7b=void 0;let v=class extends O.$kc{constructor(d,g,r){super(),this.c=d,this.f=r,this.a=S.$Hh.forPaths(!D.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(d.appRoot),this.addValidFileRoot(d.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(d.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:d}=P.session;d.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(g,r)=>this.j(g,r)),d.protocol.interceptFileProtocol(s.Schemas.file,(g,r)=>this.h(g,r)),this.B((0,O.$ic)(()=>{d.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(d){const g=(0,M.$7d)(d);return this.a.get(g)?O.$kc.None:(this.a.set(g,!0),(0,O.$ic)(()=>this.a.delete(g)))}h(d,g){const r=h.URI.parse(d.url);return this.f.error(`Refused to load resource ${r.fsPath} from ${s.Schemas.file}: protocol (original URL: ${d.url})`),g({error:-3})}j(d,g){const r=this.m(d);let $;return this.c.crossOriginIsolated&&((0,M.$ae)(r)==="workbench.html"||(0,M.$ae)(r)==="workbench-dev.html"?$=s.COI.CoopAndCoep:$=s.COI.getHeadersFromQuery(d.url)),this.a.findSubstr(r)?g({path:r,headers:$}):this.b.has((0,M.$be)(r).toLowerCase())?g({path:r}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${r} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),g({error:-3}))}m(d){const g=h.URI.parse(d.url),r=s.$2f.uriToFileUri(g);return(0,M.$7d)(r.fsPath)}createIPCObjectUrl(){let d;const g=h.URI.from({scheme:"vscode",path:(0,c.$4f)()}),r=g.toString(),$=async()=>d;return m.$US.handle(r,$),this.f.trace(`IPC Object URL: Registered new channel ${r}.`),{resource:g,update:E=>d=E,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${r}.`),m.$US.removeHandler(r)}}}};e.$k7b=v,e.$k7b=v=ke([_(0,w.$Jh),_(1,f.$Ek),_(2,y.$5i)],v)}),define(te[96],ie([0,1,8,3,2,65,12,111,6,41]),function(K,e,P,O,s,M,D,S,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Vo=e.$Uo=e.$To=void 0,e.$To="__$__isNewStorageMarker",e.$Uo="__$__targetStorageMarker",e.$Vo=(0,h.$Bh)("storageService");var m;(function(r){r[r.NONE=0]="NONE",r[r.SHUTDOWN=1]="SHUTDOWN"})(m||(e.WillSaveStateReason=m={}));var w;(function(r){r[r.APPLICATION=-1]="APPLICATION",r[r.PROFILE=0]="PROFILE",r[r.WORKSPACE=1]="WORKSPACE"})(w||(e.StorageScope=w={}));var y;(function(r){r[r.USER=0]="USER",r[r.MACHINE=1]="MACHINE"})(y||(e.StorageTarget=y={}));function f(r){const $=r.get(e.$Uo);if($)try{return JSON.parse($)}catch{}return Object.create(null)}e.$Wo=f;class v extends s.$kc{static{this.a=60*1e3}constructor($={flushInterval:v.a}){super(),this.m=$,this.b=this.B(new O.$id),this.c=this.B(new O.$id),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$fd),this.onWillSaveState=this.f.event,this.h=this.B(new P.$Sg(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$lc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,E,u){return O.Event.filter(this.b.event,t=>t.scope===$&&(E===void 0||t.key===E),u)}n(){this.j.value=(0,P.$Wg)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$fc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.O()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,E){const{key:u,external:t}=E;if(u===e.$Uo){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:u,target:this.J($)[u],external:t})}w($){this.f.fire({reason:$})}get($,E,u){return this.P(E)?.get($,u)}getBoolean($,E,u){return this.P(E)?.getBoolean($,u)}getNumber($,E,u){return this.P(E)?.getNumber($,u)}getObject($,E,u){return this.P(E)?.getObject($,u)}storeAll($,E){this.y(()=>{for(const u of $)this.store(u.key,u.value,u.scope,u.target,E)})}store($,E,u,t,l=!1){if((0,D.$sf)(E)){this.remove($,u,l);return}this.y(()=>{this.z($,u,t),this.P(u)?.set($,E,l)})}remove($,E,u=!1){this.y(()=>{this.z($,E,void 0),this.P(E)?.delete($,u)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,E){const u=[],t=this.J($);for(const l of Object.keys(t))t[l]===E&&u.push(l);return u}z($,E,u,t=!1){const l=this.J(E);typeof u=="number"?l[$]!==u&&(l[$]=u,this.P(E)?.set(e.$Uo,JSON.stringify(l),t)):typeof l[$]=="number"&&(delete l[$],this.P(E)?.set(e.$Uo,JSON.stringify(l),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const E=this.P($);return E?f(E):Object.create(null)}isNew($){return this.getBoolean(e.$To,$)===!0}async flush($=m.NONE){this.f.fire({reason:$});const E=this.P(-1),u=this.P(0),t=this.P(1);switch($){case m.NONE:await P.Promises.settled([E?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case m.SHUTDOWN:await P.Promises.settled([E?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return g($,E,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,E){return this.w(m.NONE),(0,c.$Dk)($)?this.R($,E):this.S($,E)}M($,E){return!($.id===E.id||b(E)&&b($))}N($,E,u){this.y(()=>{const t=new Set;for(const[l,o]of $)t.add(l),E.get(l)!==o&&this.u(u,{key:l,external:!0});for(const[l]of E.items)t.has(l)||this.u(u,{key:l,external:!0})})}}e.$Xo=v;function b(r){return r.isDefault||!!r.useDefaultFlags?.globalState}e.$Yo=b;class d extends v{constructor(){super(),this.U=this.B(new S.$Ro(new S.$So,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$Ro(new S.$So,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$Ro(new S.$So,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$Zo=d;async function g(r,$,E,u,t,l){const o=L=>{try{return JSON.parse(L)}catch{return L}},i=new Map,n=new Map;r.forEach((L,U)=>{i.set(U,L),n.set(U,o(L))});const a=new Map,k=new Map;$.forEach((L,U)=>{a.set(U,L),k.set(U,o(L))});const I=new Map,C=new Map;E.forEach((L,U)=>{I.set(U,L),C.set(U,o(L))}),console.group(u!==t?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const p=[];if(i.forEach((L,U)=>{p.push({key:U,value:L})}),console.table(p),console.groupEnd(),console.log(n),u!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];a.forEach((U,z)=>{L.push({key:z,value:U})}),console.table(L),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${l})`);const A=[];I.forEach((L,U)=>{A.push({key:U,value:L})}),console.table(A),console.groupEnd(),console.log(C)}e.$1o=g}),define(te[281],ie([0,1,23,8,3,2,9,69,7,21,111,159,5,96,25,29,13]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A5b=e.$z5b=e.$y5b=e.$x5b=void 0;class g extends M.$kc{static{this.a=2e3}get storage(){return this.f}constructor(o,i){super(),this.m=o,this.n=i,this.b=this.B(new s.$fd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$fd),this.onDidCloseStorage=this.c.event,this.f=this.B(new m.$Ro(new m.$So,{hint:m.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new O.$2g,this.whenInit=this.h.p,this.j=m.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===m.StorageState.None)try{const o=this.B(await this.t());this.f.dispose(),this.f=o,this.B(o.onDidChangeStorage(n=>this.b.fire(n))),await this.s(o);const i=o.getBoolean(f.$To);i===void 0?o.set(f.$To,!0):i&&o.set(f.$To,!1)}catch(o){this.m.error(`[storage main] initialize(): Unable to init storage due to ${o}`)}finally{this.j=m.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===y.LogLevel.Trace?o=>this.m.trace(o):void 0,logError:o=>this.m.error(o)}}s(o){return o.init()}get items(){return this.f.items}get(o,i){return this.f.get(o,i)}set(o,i){return this.f.set(o,i)}delete(o){return this.f.delete(o)}optimize(){return this.f.optimize()}async close(){const o=new S.$bd(!1);await this.w(),o.stop(),o.elapsed()>g.a&&await this.u(o),this.c.fire()}async u(o){if(this.path)try{const i=(0,P.top)(Array.from(this.f.items.entries()).map(([a,k])=>({key:a,length:k.length})),(a,k)=>k.length-a.length,5).map(a=>`${a.key}:${a.length}`).join(", "),n=(await this.n.stat(h.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${o.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=m.StorageState.Closed,await this.f.close()}}class r extends g{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,D.$9d)(this.z.globalStorageHome.with({scheme:d.Schemas.file}).fsPath,r.y)}constructor(o,i,n,a){super(n,a),this.z=o,this.C=i}async t(){return new m.$Ro(new w.$nT(this.path??w.$nT.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:m.StorageHint.STORAGE_IN_MEMORY})}}class $ extends r{constructor(o,i,n,a){super(o,i,n,a)}}e.$x5b=$;class E extends r{constructor(o,i,n,a){super(i.defaultProfile,o,n,a)}async s(o){await super.s(o),this.G(o)}G(o){o.get(v.$_k,void 0)===void 0&&o.set(v.$_k,new Date().toUTCString());const n=o.get(v.$$k,void 0),a=new Date().toUTCString();o.set(v.$al,typeof n>"u"?null:n),o.set(v.$$k,a)}}e.$y5b=E;class u extends g{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,D.$9d)(this.F.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,this.C.id,u.y)}constructor(o,i,n,a,k){super(n,k),this.C=o,this.D=i,this.F=a}async t(){const{storageFilePath:o,wasCreated:i}=await this.H();return new m.$Ro(new w.$nT(o,{logging:this.r()}),{hint:this.D.useInMemoryStorage?m.StorageHint.STORAGE_IN_MEMORY:i?m.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:w.$nT.IN_MEMORY_PATH,wasCreated:!0};const o=(0,D.$9d)(this.F.workspaceStorageHome.with({scheme:d.Schemas.file}).fsPath,this.C.id),i=(0,D.$9d)(o,u.y);return await c.Promises.exists(o)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(o,{recursive:!0}),this.I(o),{storageFilePath:i,wasCreated:!0})}async I(o){let i;if((0,b.$Lh)(this.C)?i={folder:this.C.uri.toString()}:(0,b.$Qh)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,D.$9d)(o,u.z);await c.Promises.exists(n)||await c.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$z5b=u;class t extends g{get path(){}async t(){return new m.$Ro(new m.$So,{hint:m.StorageHint.STORAGE_IN_MEMORY})}}e.$A5b=t}),define(te[282],ie([0,1,3,2,96]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$06b=void 0;class M extends O.$kc{constructor(S,h,c){super(),this.b=S,this.c=h,this.f=c;const m=this.B(new O.$lc);this.a=this.B(new P.$fd({onWillAddFirstListener:()=>m.value=this.g(),onDidRemoveLastListener:()=>m.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new O.$jc;return S.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,c)=>(h?h.push(c.key):h=[c.key],h),100)(h=>this.h(h))),S.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(h,c)=>{h||(h=new Map);let m=h.get(c.profile.id);return m||h.set(c.profile.id,m={profile:c.profile,keys:[],storage:c.storage}),m.keys.push(c.key),h},100)(h=>this.j(h))),S}h(S){const h=S.includes(s.$Uo)?[this.c.defaultProfile]:[],c=[];if(S=S.filter(m=>m!==s.$Uo),S.length){const m=(0,s.$Wo)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:S.map(w=>({key:w,scope:0,target:m[w]}))})}this.m(h,c)}j(S){const h=[],c=new Map;for(const[m,w]of S.entries()){w.keys.includes(s.$Uo)&&h.push(w.profile);const y=w.keys.filter(f=>f!==s.$Uo);if(y.length){const f=(0,s.$Wo)(w.storage.storage);c.set(m,{profile:w.profile,changes:y.map(v=>({key:v,scope:0,target:f[v]}))})}}this.m(h,[...c.values()])}m(S,h){(S.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:S})}listen(S,h,c){switch(h){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${h}`)}async call(S,h){throw new Error(`Call not found: ${h}`)}}e.$06b=M}),define(te[283],ie([0,1,7,36,16,5,34,40,41,12,120]),function(K,e,P,O,s,M,D,S,h,c,m){"use strict";var w,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$kN=e.$jN=e.$iN=void 0;let f=class extends h.$Hk{static{w=this}static{this.a="profileAssociationsMigration"}constructor(g,r,$,E,u){super($,E,r,u),this.U=g,this.W=$}O(){return this.U.getItem(w.b,[]).map(r=>({...r,location:(0,c.$jf)(r.location)?this.w.extUri.joinPath(this.profilesHome,r.location):P.URI.revive(r.location)}))}Q(){const g=this.U.getItem(w.c,{});return this.U.getItem(w.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$iN=f,e.$iN=f=w=ke([_(0,D.$dN),_(1,S.$Ck),_(2,O.$Jh),_(3,s.$6j),_(4,M.$5i)],f);let v=y=class extends f{constructor(g,r,$,E,u){super(g,r,$,E,u),this.$=g}P(g){g.length?this.$.setItem(y.b,g.map(r=>({...r,location:this.w.extUri.basename(r.location)}))):this.$.removeItem(y.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem(y.c,g):this.$.removeItem(y.c)}Q(){const g="workspaceAndProfileInfo",r=this.$.getItem(g,void 0);if(r){this.$.removeItem(g);const E=r.reduce((u,{workspace:t,profile:l})=>(u[P.URI.revive(t).toString()]=P.URI.revive(l).toString(),u),{});this.$.setItem(y.c,{workspaces:E})}const $=super.Q();return this.$.getItem(y.a,!1)||(this.R($),this.$.setItem(y.a,!0)),$}};e.$jN=v,e.$jN=v=y=ke([_(0,D.$eN),_(1,S.$Ck),_(2,O.$Jh),_(3,s.$6j),_(4,M.$5i)],v);let b=class extends v{constructor(g,r,$,E){super(new m.$hN(0,r,E,$),g,r,$,E)}async init(){return await this.$.init(),super.init()}};e.$kN=b,e.$kN=b=ke([_(0,S.$Ck),_(1,O.$Jh),_(2,s.$6j),_(3,M.$5i)],b)}),define(te[53],ie([0,1,36,16,6,5,40,41,283,34]),function(K,e,P,O,s,M,D,S,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C5b=e.$B5b=void 0,e.$B5b=(0,s.$Ch)(S.$Ek);let m=class extends h.$jN{constructor(y,f,v,b,d){super(y,f,v,b,d)}getAssociatedEmptyWindows(){const y=[];for(const f of this.C.emptyWindows.keys())y.push({id:f});return y}};e.$C5b=m,e.$C5b=m=ke([_(0,c.$eN),_(1,D.$Ck),_(2,P.$Jh),_(3,O.$6j),_(4,M.$5i)],m)}),define(te[129],ie([0,1,19,7,29]),function(K,e,P,O,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X5b=e.$W5b=e.$V5b=void 0;async function M(h,c,m){for(const y of h){const f=y.openedWorkspace;if((0,s.$Qh)(f)){const v=await m(f);if(v){if(v.folders.some(b=>P.$_f.isEqualOrParent(c,b.uri)))return y}else if(P.$_f.isEqualOrParent(c,f.configPath))return y}}const w=h.filter(y=>(0,s.$Lh)(y.openedWorkspace)&&P.$_f.isEqualOrParent(c,y.openedWorkspace.uri));if(w.length)return w.sort((y,f)=>-(y.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.$V5b=M;function D(h,c){for(const m of h)if((0,s.$Qh)(m.openedWorkspace)&&P.$_f.isEqual(m.openedWorkspace.configPath,c)||(0,s.$Lh)(m.openedWorkspace)&&P.$_f.isEqual(m.openedWorkspace.uri,c))return m}e.$W5b=D;function S(h,c){const m=w=>c.some(y=>P.$_f.isEqual(O.URI.file(y),O.URI.file(w)));for(const w of h)if(w.config?.extensionDevelopmentPath?.some(y=>m(y)))return w}e.$X5b=S}),define(te[97],ie([0,1,32,44,137,46,13,9,4,19,7,6,59,29]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oU=e.$nU=e.$mU=e.$lU=e.$kU=e.$jU=e.$iU=e.$hU=e.$gU=e.$fU=void 0,e.$fU=(0,w.$Bh)("workspacesService");function v(C){return C.hasOwnProperty("workspace")}e.$gU=v;function b(C){return C.hasOwnProperty("folderUri")}e.$hU=b;function d(C){return C.hasOwnProperty("fileUri")}e.$iU=d;function g(C){return r(C)||$(C)}e.$jU=g;function r(C){const p=C;return typeof p?.path=="string"&&(!p.name||typeof p.name=="string")}function $(C){const p=C;return typeof p?.uri=="string"&&(!p.name||typeof p.name=="string")}function E(C,p,A,L,U){if(C.scheme!==L.scheme)return{name:A,uri:C.toString(!0)};let z=p?void 0:U.relativePath(L,C);if(z!==void 0)z.length===0?z=".":h.$i&&(z=u(z));else if(C.scheme===D.Schemas.file)z=C.fsPath,h.$i&&(z=u(z));else if(U.isEqualAuthority(C.authority,L.authority))z=C.path;else return{name:A,uri:C.toString(!0)};return{name:A,path:z}}e.$kU=E;function u(C){return C=(0,M.$iv)(C),(0,P.$Ff)(C)||(C=(0,P.$Cf)(C)),C}function t(C,p,A){const L=[],U=new Set,z=A.dirname(p);for(const re of C){let ee;if(r(re))re.path&&(ee=A.resolvePath(z,re.path));else if($(re))try{ee=m.URI.parse(re.uri),ee.path[0]!==S.$6d.sep&&(ee=ee.with({path:S.$6d.sep+ee.path}))}catch(ae){console.warn(ae)}if(ee){const ae=A.getComparisonKey(ee);if(!U.has(ae)){U.add(ae);const se=re.name||A.basenameOrAuthority(ee);L.push(new f.$Vh({uri:ee,name:se,index:L.length},re))}}}return L}e.$lU=t;function l(C,p,A,L,U){const z=o(p,C),re=U.dirname(p),ee=U.dirname(L),ae=[];for(const J of z.folders){const q=r(J)?U.resolvePath(re,J.path):m.URI.parse(J.uri);let F;A?F=!1:F=!r(J)||(0,S.$8d)(J.path),ae.push(E(q,F,J.name,ee,U))}const se={insertSpaces:!1,tabSize:4,eol:h.$k||h.$j?`
`:`\r
`},oe=s.$CS(C,["folders"],ae,se);let G=s.$FS(C,oe);return(0,c.$ng)(z.remoteAuthority,(0,y.$Ok)(L))&&(G=s.$FS(G,s.$BS(G,["remoteAuthority"],se))),G}e.$mU=l;function o(C,p){const A=O.$Lm(p);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(L=>g(L));else throw new Error(`${C} looks like an invalid workspace file.`);return A}function i(C){return C.workspace&&typeof C.workspace=="object"&&typeof C.workspace.id=="string"&&typeof C.workspace.configPath=="string"}function n(C){return typeof C.folderUri=="string"}function a(C){return typeof C.fileUri=="string"}function k(C,p){const A={workspaces:[],files:[]};if(C){const L=function(z,re){for(let ee=0;ee<z.length;ee++)try{re(z[ee],ee)}catch(ae){p.warn(`Error restoring recent entry ${JSON.stringify(z[ee])}: ${ae.toString()}. Skip entry.`)}},U=C;Array.isArray(U.entries)&&L(U.entries,z=>{const re=z.label,ee=z.remoteAuthority;i(z)?A.workspaces.push({label:re,remoteAuthority:ee,workspace:{id:z.workspace.id,configPath:m.URI.parse(z.workspace.configPath)}}):n(z)?A.workspaces.push({label:re,remoteAuthority:ee,folderUri:m.URI.parse(z.folderUri)}):a(z)&&A.files.push({label:re,remoteAuthority:ee,fileUri:m.URI.parse(z.fileUri)})})}return A}e.$nU=k;function I(C){const p={entries:[]};for(const A of C.workspaces)b(A)?p.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):p.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of C.files)p.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return p}e.$oU=I}),define(te[98],ie([0,1,72,13,4,19]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q5b=e.$P5b=e.$O5b=e.$N5b=void 0,e.$N5b=128/4;function D(c){function m(){let w=c.scheme===O.Schemas.file?(0,M.$9f)(c):c.toString();return s.$k||(w=w.toLowerCase()),(0,P.createHash)("md5").update(w).digest("hex")}return{id:m(),configPath:c}}e.$O5b=D;function S(c,m){function w(){if(c.scheme!==O.Schemas.file)return(0,P.createHash)("md5").update(c.toString()).digest("hex");if(!m)return;let f;return s.$k?f=m.ino:s.$j?f=m.birthtime.getTime():s.$i&&(typeof m.birthtimeMs=="number"?f=Math.floor(m.birthtimeMs):f=m.birthtime.getTime()),(0,P.createHash)("md5").update(c.fsPath).update(f?String(f):"").digest("hex")}const y=w();if(typeof y=="string")return{id:y,uri:c}}e.$P5b=S;function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$Q5b=h}),define(te[99],ie([0,1,72,87,27,284,17,14,3,2,9,4,31,42,109]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0;class b{traceSocketEvent(p,A){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,A)}constructor(p,A=""){this.f=!0,this.debugLabel=A,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,S.$Y)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const A=L=>{this.traceSocketEvent("read",L),p(D.$Fd.wrap(L))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(p){const A=L=>{p({type:0,hadError:L,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(p){const A=()=>{p()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,S.$Y)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,S.$Y)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$qh=b;var d;(function(C){C[C.MinHeaderByteSize=2]="MinHeaderByteSize",C[C.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var g;(function(C){C[C.PeekHeader=1]="PeekHeader",C[C.ReadHeader=2]="ReadHeader",C[C.ReadBody=3]="ReadBody",C[C.Fin=4]="Fin"})(g||(g={}));class r extends c.$kc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,A){this.socket.traceSocketEvent(p,A)}constructor(p,A,L,U){super(),this.f=this.B(new h.$fd),this.g=this.B(new h.$fd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:L?.byteLength||0,recordInflateBytes:U}),this.a=this.B(new $(this,A,L,U,this.f,(z,re)=>this.m(z,re))),this.B(this.a.onError(z=>{console.error(z),(0,S.$Y)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new v.$lh,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let A=0;for(;A<p.byteLength;)this.a.writeMessage(p.slice(A,Math.min(A+262144,p.byteLength))),A+=262144}m(p,A){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let L=2;p.byteLength<126?L+=0:p.byteLength<2**16?L+=2:L+=8;const U=D.$Fd.alloc(L);if(A?U.writeUInt8(194,0):U.writeUInt8(130,0),p.byteLength<126)U.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){U.writeUInt8(126,1);let z=1;U.writeUInt8(p.byteLength>>>8&255,++z),U.writeUInt8(p.byteLength>>>0&255,++z)}else{U.writeUInt8(127,1);let z=1;U.writeUInt8(0,++z),U.writeUInt8(0,++z),U.writeUInt8(0,++z),U.writeUInt8(0,++z),U.writeUInt8(p.byteLength>>>24&255,++z),U.writeUInt8(p.byteLength>>>16&255,++z),U.writeUInt8(p.byteLength>>>8&255,++z),U.writeUInt8(p.byteLength>>>0&255,++z)}this.socket.write(D.$Fd.concat([U,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const A=this.b.peek(this.j.readLen),L=A.readUInt8(0),U=(L&128)>>>7,z=(L&64)>>>6,re=A.readUInt8(1),ee=(re&128)>>>7,ae=re&127;this.j.state=2,this.j.readLen=2+(ee?4:0)+(ae===126?2:0)+(ae===127?8:0),this.j.fin=U,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!U,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const A=this.b.read(this.j.readLen),L=A.readUInt8(1),U=(L&128)>>>7;let z=L&127,re=1;z===126?z=A.readUInt8(++re)*2**8+A.readUInt8(++re):z===127&&(z=A.readUInt8(++re)*0+A.readUInt8(++re)*0+A.readUInt8(++re)*0+A.readUInt8(++re)*0+A.readUInt8(++re)*2**24+A.readUInt8(++re)*2**16+A.readUInt8(++re)*2**8+A.readUInt8(++re));let ee=0;U&&(ee=A.readUInt8(++re)*2**24+A.readUInt8(++re)*2**16+A.readUInt8(++re)*2**8+A.readUInt8(++re)),this.j.state=3,this.j.readLen=z,this.j.mask=ee,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const A=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),t(A,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(A,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$rh=r;class $ extends c.$kc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$Fd.alloc(0)}constructor(p,A,L,U,z,re){super(),this.n=p,this.r=z,this.s=re,this.a=this.B(new h.$fd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.$fd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new h.$fd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,A?(this.b=this.B(new E(this.n,U,L,{windowBits:15})),this.f=this.B(new u(this.n,{windowBits:15})),this.B(this.b.onError(ee=>this.a.fire(ee))),this.B(this.f.onError(ee=>this.a.fire(ee)))):(this.b=null,this.f=null)}writeMessage(p){this.g.push(p),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const p=this.g.shift();if(this.f){const A=await this.w(this.f,p);this.s(A,!0)}else this.s(p,!1)}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,A){return new Promise((L,U)=>{p.write(A),p.flush(z=>L(z))})}acceptFrame(p,A,L){this.h.push({data:p,isCompressed:A,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const A=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(A)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,A,L){return new Promise((U,z)=>{p.write(A),L&&p.write(D.$Fd.fromByteArray([0,0,255,255])),p.flush(re=>U(re))})}}class E extends c.$kc{get recordedInflateBytes(){return this.j?D.$Fd.concat(this.f):D.$Fd.alloc(0)}constructor(p,A,L,U){super(),this.h=p,this.j=A,this.a=this.B(new h.$fd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(U),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(D.$Fd.wrap(z))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const A=D.$Fd.concat(this.g);this.g.length=0,p(A)})}}class u extends c.$kc{constructor(p,A){super(),this.g=p,this.a=this.B(new h.$fd),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(D.$Fd.wrap(L))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let A=D.$Fd.concat(this.f);this.f.length=0,A=A.slice(0,A.byteLength-4),p(A)})}}function t(C,p){if(p===0)return;const A=C.byteLength>>>2;for(let ae=0;ae<A;ae++){const se=C.readUInt32BE(ae*4);C.writeUInt32BE(se^p,ae*4)}const L=A*4,U=C.byteLength-L,z=p>>>24&255,re=p>>>16&255,ee=p>>>8&255;U>=1&&C.writeUInt8(C.readUInt8(L)^z,L),U>=2&&C.writeUInt8(C.readUInt8(L+1)^re,L+1),U>=3&&C.writeUInt8(C.readUInt8(L+2)^ee,L+2)}e.$sh=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function o(){const C=(0,y.$4f)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${C}-sock`;const p=process.platform!=="darwin"&&e.$sh?e.$sh:(0,s.tmpdir)(),A=(0,m.$9d)(p,`vscode-ipc-${C}.sock`);return n(A),A}e.$th=o;function i(C,p,A){const L=(0,P.createHash)("md5").update(C).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${A}-${p}-sock`;const U=A.substr(0,4),z=p.substr(0,6),re=L.substr(0,8);let ee;return process.platform!=="darwin"&&e.$sh&&!process.env.VSCODE_PORTABLE?ee=(0,m.$9d)(e.$sh,`vscode-${re}-${U}-${z}.sock`):ee=(0,m.$9d)(C,`${U}-${z}.sock`),n(ee),ee}e.$uh=i;function n(C){const p=l[w.$t];typeof p=="number"&&C.length>=p&&console.warn(`WARNING: IPC handle "${C}" is longer than ${p} chars, try a shorter --user-data-dir`)}class a extends f.$fh{static b(p){const A=h.Event.fromNodeEventEmitter(p,"connection");return h.Event.map(A,L=>({protocol:new v.$mh(new b(L,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(L,"close"))}))}constructor(p){super(a.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$vh=a;function k(C){return new Promise((p,A)=>{const L=(0,O.createServer)();L.on("error",A),L.listen(C,()=>{L.removeListener("error",A),p(new a(L))})})}e.$wh=k;function I(C,p){return new Promise((A,L)=>{const U=(0,O.createConnection)(C,()=>{U.removeListener("error",L),A(v.$nh.fromSocket(new b(U,`ipc-client${p}`),p))});U.once("error",L)})}e.$xh=I}),define(te[28],ie([0,1,55,9,4,99,36,89,6]),function(K,e,P,O,s,M,D,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u5b=e.$t5b=void 0,e.$t5b=(0,h.$Ch)(D.$Ih);class c extends S.$_l{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,O.$9d)(this.userDataPath,"clp")}get backupHome(){return(0,O.$9d)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$uh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,O.$9d)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const w in process.env)if(w.endsWith("_VSCODE_SNAP_ORIG")){const y=w.slice(0,-17);if(this.d[y])continue;process.env[y]&&(this.d[y]=process.env[y]),process.env[w]?process.env[y]=process.env[w]:delete process.env[y]}}}restoreSnapExportedVariables(){if(s.$k)for(const w in this.d)process.env[w]=this.d[w],delete this.d[w]}}e.$u5b=c,ke([P.$6g],c.prototype,"cachedLanguagesPath",null),ke([P.$6g],c.prototype,"backupHome",null),ke([P.$6g],c.prototype,"mainIPCHandle",null),ke([P.$6g],c.prototype,"mainLockfile",null),ke([P.$6g],c.prototype,"disableUpdates",null),ke([P.$6g],c.prototype,"crossOriginIsolated",null),ke([P.$6g],c.prototype,"codeCachePath",null),ke([P.$6g],c.prototype,"useCodeCache",null)}),define(te[285],ie([0,1,72,32,13,9,4,19,21,194,18,28,34,16,5,193,29,98]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$R5b=void 0;let $=class{static{r=this}static{this.a="backupWorkspaces"}constructor(u,t,l,o){this.j=u,this.k=t,this.l=l,this.m=o,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$_f,this.i={isEqual:(i,n)=>(0,O.$Hf)(i,n,!D.$k)}}async initialize(){const u=this.m.getItem(r.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(u.emptyWindows),this.d=await this.u((0,c.$K5b)(u)),this.e=await this.v((0,c.$L5b)(u)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.$rk.OFF}q(){return this.s()===f.$rk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.$rk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(u,t){this.d.some(o=>u.workspace.id===o.workspace.id)||(this.d.push(u),this.C());const l=(0,M.$9d)(this.c,u.workspace.id);return t?this.t(l,t).then(()=>l):l}async t(u,t){if(await h.Promises.exists(u)&&await this.z(u),await h.Promises.exists(t))try{await h.Promises.rename(t,u,!1)}catch(l){this.l.error(`Backup: Could not move backup folder to new location: ${l.toString()}`)}}registerFolderBackup(u){return this.e.some(t=>this.h.isEqual(u.folderUri,t.folderUri))||(this.e.push(u),this.C()),(0,M.$9d)(this.c,this.D(u))}registerEmptyWindowBackup(u){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,u.backupFolder))||(this.g.push(u),this.C()),(0,M.$9d)(this.c,u.backupFolder)}async u(u){if(!Array.isArray(u))return[];const t=new Set,l=[];for(const o of u){const i=o.workspace;if(!(0,d.$Qh)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,M.$9d)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?l.push(o):await this.z(n):await this.x(n)}}return l}async v(u){if(!Array.isArray(u))return[];const t=[],l=new Set;for(const o of u){const i=o.folderUri,n=this.h.getComparisonKey(i);if(!l.has(n)){l.add(n);const a=(0,M.$9d)(this.c,this.D(o));await this.B(a)?i.scheme!==s.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(o):await this.z(a):await this.x(a)}}return t}async w(u){if(!Array.isArray(u))return[];const t=[],l=new Set;for(const o of u){const i=o.backupFolder;if(typeof i!="string")return[];if(!l.has(i)){l.add(i);const n=(0,M.$9d)(this.c,i);await this.B(n)?t.push(o):await this.x(n)}}return t}async x(u){try{await h.Promises.rm(u,h.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let u=(0,g.$Q5b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,u.id));)u=(0,g.$Q5b)();return{backupFolder:u.id}}async z(u){const t=this.y(),l=(0,M.$9d)(this.c,t.backupFolder);try{await h.Promises.rename(u,l,!1)}catch(o){return this.l.error(`Backup: Could not rename backup folder: ${o.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const u=[];for(const t of this.d)await this.A(t)&&u.push(t);for(const t of this.e)await this.A(t)&&u.push(t);return u}A(u){let t;return(0,c.$J5b)(u)?t=(0,M.$9d)(this.c,u.backupFolder):(0,b.$dU)(u)?t=(0,M.$9d)(this.c,this.D(u)):t=(0,M.$9d)(this.c,u.workspace.id),this.B(t)}async B(u){try{const t=await h.Promises.readdir(u);for(const l of t)try{if((await h.Promises.readdir((0,M.$9d)(u,l))).length>0)return!0}catch{}}catch{}return!1}C(){const u={workspaces:this.d.map(({workspace:t,remoteAuthority:l})=>{const o={id:t.id,configURIPath:t.configPath.toString()};return l&&(o.remoteAuthority=l),o}),folders:this.e.map(({folderUri:t,remoteAuthority:l})=>{const o={folderUri:t.toString()};return l&&(o.remoteAuthority=l),o}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:l})=>{const o={backupFolder:t};return l&&(o.remoteAuthority=l),o})};this.m.setItem(r.a,u)}D(u){const t=u.folderUri;let l;return t.scheme===s.Schemas.file?l=D.$k?t.fsPath:t.fsPath.toLowerCase():l=t.toString().toLowerCase(),(0,P.createHash)("md5").update(l).digest("hex")}};e.$R5b=$,e.$R5b=$=r=ke([_(0,w.$t5b),_(1,m.$8h),_(2,v.$5i),_(3,y.$eN)],$)}),define(te[20],ie([0,1,15,38,8,3,2,4,35,12,6,5,34,28]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$w5b=e.LifecycleMainPhase=e.ShutdownReason=e.$v5b=void 0,e.$v5b=(0,m.$Bh)("lifecycleMainService");var b;(function(r){r[r.QUIT=1]="QUIT",r[r.KILL=2]="KILL"})(b||(e.ShutdownReason=b={}));var d;(function(r){r[r.Starting=1]="Starting",r[r.Ready=2]="Ready",r[r.AfterWindowOpen=3]="AfterWindowOpen",r[r.Eventually=4]="Eventually"})(d||(e.LifecycleMainPhase=d={}));let g=class extends D.$kc{static{v=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor($,E,u){super(),this.F=$,this.G=E,this.H=u,this.c=this.B(new M.$fd),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$fd),this.onWillShutdown=this.f.event,this.g=this.B(new M.$fd),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$fd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(v.b),this.m&&this.G.removeItem(v.b)}J(){const $=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$j&&this.t===0&&this.L(1))};P.app.addListener("before-quit",$);const E=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!S.$j)&&P.app.quit()};P.app.addListener("window-all-closed",E),P.app.once("will-quit",u=>{this.S("Lifecycle#app.on(will-quit) - begin"),u.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),P.app.removeListener("before-quit",$),P.app.removeListener("window-all-closed",E),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}L($){if(this.y)return this.y;const E=this.F;this.S("Lifecycle#onWillShutdown.fire()");const u=[];return this.f.fire({reason:$,join(t,l){E.trace(`Lifecycle#onWillShutdown - begin '${t}'`),u.push(l.finally(()=>{E.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(u)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase($){if($<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===$)return;this.S(`lifecycle (main): phase changed (value: ${$})`),this.n=$;const E=this.C.get(this.n);E&&(E.open(),this.C.delete(this.n))}async when($){if($<=this.n)return;let E=this.C.get($);E||(E=new s.$Fg,this.C.set($,E)),await E.wait()}registerWindow($){const E=new D.$jc;this.t++,E.add($.onWillLoad(t=>this.g.fire({window:$,workspace:t.workspace,reason:t.reason})));const u=(0,c.$uf)($.win);u.on("close",t=>{const l=$.id;if(this.r.has(l)){this.r.delete(l);return}this.S(`Lifecycle#window.on('close') - window ID ${$.id}`),t.preventDefault(),this.unload($,1).then(o=>{if(o){this.r.delete(l);return}this.r.add(l),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this.h.fire($),$.close()})}),u.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${$.id}`),this.t--,E.dispose(),this.t===0&&(!S.$j||this.j)&&this.L(1)})}async reload($,E){await this.unload($,3)||$.reload(E)}unload($,E){const u=this.z.get($.id);if(u)return u;const t=this.M($,E).finally(()=>{this.z.delete($.id)});return this.z.set($.id,t),t}async M($,E){if(!$.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${$.id}`);const u=this.j?2:E,t=await this.P($,u);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${$.id})`),this.N(t)):(await this.Q($,u),!1)}N($){return $?(this.O(!0),this.j=!1,!0):!1}O($){this.w&&(this.w($),this.w=void 0,this.u=void 0)}P($,E){return new Promise(u=>{const t=this.s++,l=`vscode:ok${t}`,o=`vscode:cancel${t}`;O.$US.once(l,()=>{u(!1)}),O.$US.once(o,()=>{u(!0)}),$.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:o,reason:E})})}Q($,E){return new Promise(u=>{const l=`vscode:reply${this.s++}`;O.$US.once(l,()=>u()),$.send("vscode:onWillUnload",{replyChannel:l,reason:E})})}quit($){return this.R($).then(E=>{if(!E&&$)try{if(S.$i){const u=(0,h.cwd)();u!==process.cwd()&&process.chdir(u)}}catch(u){this.F.error(u)}return E})}R($){return this.S(`Lifecycle#quit() - begin (willRestart: ${$})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):($&&this.G.setItem(v.b,!0),this.u=new Promise(E=>{this.w=E,this.S("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.u)}S($){this.H.args["enable-smoke-test-driver"]?this.F.info($):this.F.trace($)}setRelaunchHandler($){this.D=$}async relaunch($){this.S("Lifecycle#relaunch()");const E=process.argv.slice(1);if($?.addArgs&&E.push(...$.addArgs),$?.removeArgs)for(const l of $.removeArgs){const o=E.indexOf(l);o>=0&&E.splice(o,1)}const u=()=>{this.D?.handleRelaunch($)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:E}))};P.app.once("quit",u),await this.quit(!0)&&P.app.removeListener("quit",u)}async kill($){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$Hg)(1e3),(async()=>{for(const E of P.BrowserWindow.getAllWindows())if(E&&!E.isDestroyed()){let u;E.webContents&&!E.webContents.isDestroyed()?u=new Promise(t=>E.once("closed",t)):u=Promise.resolve(),E.destroy(),await u}})()]),P.app.exit($)}};e.$w5b=g,e.$w5b=g=v=ke([_(0,w.$5i),_(1,y.$eN),_(2,f.$t5b)],g)}),define(te[286],ie([0,1,4,3,2,6,20]),function(K,e,P,O,s,M,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n6b=e.$m6b=void 0,e.$m6b=(0,M.$Bh)("keyboardLayoutMainService");let S=class extends s.$kc{constructor(m){super(),this.a=this.B(new O.$fd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,m.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const m=await new Promise((w,y)=>{K(["native-keymap"],w,y)});this.c=h(m),P.$s||m.onDidChangeKeyboardLayout(()=>{this.c=h(m),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$n6b=S,e.$n6b=S=ke([_(0,D.$v5b)],S);function h(c){const m=c.getKeyMap(),w=c.getCurrentKeyboardLayout();return{keyboardMapping:m,keyboardLayoutInfo:w}}}),define(te[287],ie([0,1,246,8,17,14,12,18,36,94,5,51,245,284]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=void 0;let v=class extends w.$Jo{constructor(r,$,E,u){super(u),this.m=r,this.n=$,this.r=E,this.s(),this.B(r.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const r=this.m.getValue("http");this.f=r?.proxy,this.g=!!r?.proxyStrictSSL,this.h=r?.proxyAuthorization}async request(r,$){const{f:E,g:u}=this;let t;try{t=await(0,c.$Ml)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,M.$8)(i)))}const l={...process.env,...t},o=r.agent?r.agent:await(0,y.$Nq)(r.url||"",l,{proxyUrl:E,strictSSL:u});return r.agent=o,r.strictSSL=u,this.h&&(r.headers={...r.headers||{},"Proxy-Authorization":this.h}),this.c(r.isChromiumNetwork?"electron":"node",r,()=>d(r,$))}async resolveProxy(r){}};e.$Oq=v,e.$Oq=v=ke([_(0,S.$8h),_(1,h.$Jh),_(2,m.$5i),_(3,m.$6i)],v);async function b(g){return((0,P.parse)(g.url).protocol==="https:"?await new Promise((E,u)=>{K(["https"],E,u)}):await new Promise((E,u)=>{K(["http"],E,u)})).request}async function d(g,r){return O.Promises.withAsyncBody(async($,E)=>{const u=(0,P.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await b(g),l={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,D.$pf)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(l.auth=g.user+":"+g.password);const o=t(l,i=>{const n=(0,D.$nf)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)d({...g,url:i.headers.location,followRedirects:n-1},r).then($,E);else{let a=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,f.createGunzip)())),$({res:i,stream:(0,s.$Ud)(a)})}});o.on("error",E),g.timeout&&o.setTimeout(g.timeout),g.isChromiumNetwork&&o.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&o.write(g.data),o.end(),r.onCancellationRequested(()=>{o.abort(),E(new M.$3)})})}e.$Pq=d}),define(te[288],ie([0,1,15,287]),function(K,e,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p7b=void 0;function s(D){return P.net.request}class M extends O.$Oq{request(S,h){return super.request({...S||{},getRawRequest:s,isChromiumNetwork:!0},h)}}e.$p7b=M}),define(te[82],ie([0,1,7,49,3,2,36,16,6,20,5,96,281,41,53,40,13]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G5b=e.$F5b=e.$E5b=e.$D5b=void 0,e.$D5b=(0,h.$Bh)("storageMainService");let g=class extends M.$kc{constructor(E,u,t,l,o,i){super(),this.c=E,this.f=u,this.g=t,this.h=l,this.j=o,this.m=i,this.a=void 0,this.b=this.B(new s.$fd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(E=>{E.window.profile&&this.profileStorage(E.window.profile).init(),E.workspace&&this.workspaceStorage(E.workspace).init()})),this.B(this.h.onWillShutdown(E=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=E.reason,E.join("applicationStorage",this.applicationStorage.close());for(const[,u]of this.t)E.join("profileStorage",u.close());for(const[,u]of this.w)E.join("workspaceStorage",u.close())})),this.B(this.g.onWillCreateProfile(E=>{E.join((async()=>{await this.j.exists(E.profile.globalStorageHome)||await this.j.createFolder(E.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(E=>{const u=this.t.get(E.profile.id);u&&E.join(u.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const E=new y.$y5b(this.n(),this.g,this.c,this.j);return this.B((0,O.$bb)(E.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),E}profileStorage(E){if((0,w.$Yo)(E))return this.applicationStorage;let u=this.t.get(E.id);if(!u){this.c.trace(`StorageMainService: creating profile storage (${E.name})`),u=this.B(this.u(E)),this.t.set(E.id,u);const t=this.B(u.onDidChangeStorage(l=>this.b.fire({...l,storage:u,profile:E})));this.B((0,O.$bb)(u.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${E.name})`),this.t.delete(E.id),t.dispose()}))}return u}u(E){return this.a===2?new y.$A5b(this.c,this.j):new y.$x5b(E,this.n(),this.c,this.j)}workspaceStorage(E){let u=this.w.get(E.id);return u||(this.c.trace(`StorageMainService: creating workspace storage (${E.id})`),u=this.B(this.y(E)),this.w.set(E.id,u),this.B((0,O.$bb)(u.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${E.id})`),this.w.delete(E.id)}))),u}y(E){return this.a===2?new y.$A5b(this.c,this.j):new y.$z5b(E,this.n(),this.c,this.f,this.j)}isUsed(E){const u=P.URI.file(E);for(const t of[this.applicationStorage,...this.t.values(),...this.w.values()])if(t.path&&this.m.extUri.isEqualOrParent(P.URI.file(t.path),u))return!0;return!1}};e.$E5b=g,e.$E5b=g=ke([_(0,m.$5i),_(1,D.$Ih),_(2,v.$B5b),_(3,c.$v5b),_(4,S.$6j),_(5,b.$Ck)],g),e.$F5b=(0,h.$Bh)("applicationStorageMainService");let r=class extends w.$Xo{constructor(E,u){super(),this.s=E,this.U=u,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(E){if(E===-1)return this.U.applicationStorage.storage}Q(E){if(E===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:d.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$G5b=r,e.$G5b=r=ke([_(0,f.$Ek),_(1,e.$D5b)],r)}),define(te[289],ie([0,1,15,22,3,56,2,31,115,5,82,30]),function(K,e,P,O,s,M,D,S,h,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I5b=void 0;var y;(function(v){v[v.Initial=1]="Initial",v[v.StoredCredentialsUsed=2]="StoredCredentialsUsed",v[v.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let f=class extends D.$kc{constructor(b,d,g,r){super(),this.g=b,this.h=d,this.j=g,this.m=r,this.a="proxy-credentials://",this.b=void 0,this.c=y.Initial,this.f=void 0,this.n()}n(){const b=s.Event.fromNodeEventEmitter(P.app,"login",(d,g,r,$,E)=>({event:d,webContents:g,req:r,authInfo:$,callback:E}));this.B(b(this.r,this))}async r({event:b,authInfo:d,req:g,callback:r}){if(!d.isProxy)return;if(!this.b&&this.c===y.LoginDialogShown&&g.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let $;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),$=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(d);try{$=await this.b}finally{this.b=void 0}}r($?.username,$?.password)}async s(b){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const d=await this.t(b);if(d)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),d;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(b){this.g.trace("auth#doResolveProxyCredentials - enter",b);const d=String((0,M.$pi)({scheme:b.scheme,host:b.host,port:b.port}));let g,r;try{const t=this.m.get(this.a+d,-1);if(t){const l=JSON.parse(await this.j.decrypt(t));g=l.username,r=l.password}}catch(t){this.g.error(t)}if(this.c!==y.StoredCredentialsUsed&&typeof g=="string"&&typeof r=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=y.StoredCredentialsUsed,{username:g,password:r};const $=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!$){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${$.id} to handle proxy login`);const E={authInfo:b,username:this.f?.username??g,password:this.f?.password??r,replyChannel:`vscode:proxyAuthResponse:${(0,S.$4f)()}`};$.sendWhenReady("vscode:openProxyAuthenticationDialog",O.CancellationToken.None,E),this.c=y.LoginDialogShown;const u=await new Promise(t=>{const l=async(o,i,n)=>{if(i===E.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${$.id}`),$.win?.webContents.off("ipc-message",l),n){const a={username:n.username,password:n.password};try{if(n.remember){const k=await this.j.encrypt(JSON.stringify(a));this.m.store(this.a+d,k,-1,1)}else this.m.remove(this.a+d,-1)}catch(k){this.g.error(k)}t({username:a.username,password:a.password})}else t(void 0)};$.win?.webContents.on("ipc-message",l)});return this.f=u,u}};e.$I5b=f,e.$I5b=f=ke([_(0,c.$5i),_(1,w.$H5b),_(2,h.$CT),_(3,m.$F5b)],f)}),define(te[290],ie([0,1,87,27,103,99,8,2,4,18,5,24,241,242,95,125,17]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o7b=e.$n7b=e.$m7b=e.$l7b=void 0;async function g(t,l,o,i,n){let a;for(let k=3;k&&(a?.dispose(),a=await new r(t,l,o,i,n).waitForReady(),!(n&&s.$7f[n]||!s.$7f[a.tunnelLocalPort]));k--);return a}class r extends S.$kc{constructor(l,o,i,n,a){super(),this.m=o,this.n=a,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=l,this.b=P.createServer(),this.c=new D.$Fg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(o=>{o()})}async waitForReady(){const l=this.n??this.tunnelRemotePort,o=(0,b.$7u)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$8f)(l,2,1e3,o),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(l){l.pause();const o=(0,b.$5u)(this.tunnelRemoteHost)||(0,b.$7u)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,y.$Zk)(this.a,o,this.tunnelRemotePort),n=i.getSocket(),a=i.readEntireBuffer();i.dispose(),a.byteLength>0&&l.write(a.buffer),l.on("end",()=>{l.localAddress&&this.j.delete(l.localAddress),n.end()}),l.on("close",()=>n.end()),l.on("error",()=>{l.localAddress&&this.j.delete(l.localAddress),n instanceof M.$qh?n.socket.destroy():n.end()}),n instanceof M.$qh?this.t(l,n):this.s(l,n),l.localAddress&&this.j.set(l.localAddress,()=>{l.end(),n.end()})}s(l,o){o.onClose(()=>l.destroy()),o.onEnd(()=>l.end()),o.onData(i=>l.write(i.buffer)),l.on("data",i=>o.write(d.$Fd.wrap(i))),l.resume()}t(l,o){const i=o.socket;i.on("end",()=>l.end()),i.on("close",()=>l.end()),i.on("error",()=>{l.destroy()}),i.pipe(l),l.pipe(i)}}e.$l7b=r;let $=class extends b.$0u{constructor(l,o,i,n,a){super(o,a),this.u=l,this.v=i,this.w=n}isPortPrivileged(l){return(0,b.$8u)(l,this.l,h.OS,O.release())}s(l,o,i,n,a,k,I,C){const p=this.r(o,i);if(p)return++p.refcount,p.value;if((0,b.$2u)(l))return this.t(l,o,i,a,k,I,C);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${o}:${i} on local port ${a}.`);const A={commit:this.w.commit,quality:this.w.quality,addressProvider:l,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},L=g(A,n,o,i,a);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(o,i,L),L}}};e.$m7b=$,e.$m7b=$=ke([_(0,f.$Tk),_(1,m.$5i),_(2,v.$Wk),_(3,w.$kj),_(4,c.$8h)],$);let E=class extends ${constructor(l,o,i,n,a){super(l,o,i,n,a)}};e.$n7b=E,e.$n7b=E=ke([_(0,f.$Tk),_(1,m.$5i),_(2,v.$Wk),_(3,w.$kj),_(4,c.$8h)],E);let u=class extends S.$kc{constructor(l,o,i,n,a){super(),this.b=l,this.c=o,this.f=i,this.g=n,this.h=a,this.a=new Map}async openTunnel(l,o,i,n,a,k,I,C,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${k}.`),!this.a.has(l)){const A=new E(this.b,this.c,this.g,this.f,this.h);this.B(A),this.a.set(l,A),A.onTunnelClosed(async()=>{(await A.tunnels).length===0&&(A.dispose(),this.a.delete(l))})}return this.a.get(l).openTunnel(o,i,n,a,k,I,C,p)}};e.$o7b=u,e.$o7b=u=ke([_(0,f.$Tk),_(1,m.$5i),_(2,w.$kj),_(3,v.$Wk),_(4,c.$8h)],u)}),define(te[100],ie([0,1,8,22,3,18,28,20,5,24,51,48]),function(K,e,P,O,s,M,D,S,h,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M6b=e.$L6b=void 0;function y(v,b,d){return`${d.updateUrl}/api/update/${v}/${b}/${d.commit}`}e.$L6b=y;let f=class{get state(){return this.b}d(b){this.j.info("update#setState",b.type),this.b=b,this.c.fire(b)}constructor(b,d,g,r,$,E){this.f=b,this.g=d,this.h=g,this.i=r,this.j=$,this.k=E,this.b=w.$TT.Uninitialized,this.c=new s.$fd,this.onStateChange=this.c.event,b.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(w.$TT.Disabled(0));return}if(this.h.disableUpdates){this.d(w.$TT.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(w.$TT.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const b=this.g.getValue("update.mode"),d=this.m(b);if(!d){this.d(w.$TT.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(d),!this.a){this.d(w.$TT.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(w.$TT.Idle(this.q())),b==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}b==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(b){return b==="none"?void 0:this.k.quality}n(b=60*60*1e3){return(0,P.$Hg)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(b){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(b)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(b){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},O.CancellationToken.None)).res.statusCode===204}catch(d){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(d);return}}async _applySpecificUpdate(b){}q(){return 1}r(){}};e.$M6b=f,e.$M6b=f=ke([_(0,S.$v5b),_(1,M.$8h),_(2,D.$t5b),_(3,m.$Io),_(4,h.$5i),_(5,c.$kj)],f)}),define(te[291],ie([0,1,15,55,3,2,18,28,20,5,24,51,25,48,100]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N6b=void 0;let b=class extends v.$M6b{get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",(g,r)=>r)}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(g,r,$)=>({url:r,version:$,productVersion:$}))}get y(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(g,r,$,E)=>({releaseNotes:r,version:$,productVersion:$,date:E}))}constructor(g,r,$,E,u,t,l){super(g,r,E,u,t,l),this.z=$,this.u=new M.$jc,g.setRelaunchHandler(this)}handleRelaunch(g){return g?.addArgs||g?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(g){this.j.error("UpdateService error:",g);const r=this.state.type==="checking for updates"&&this.state.explicit?g:void 0;this.d(f.$TT.Idle(1,r))}s(g){let r;this.k.darwinUniversalAssetId?r=this.k.darwinUniversalAssetId:r=process.arch==="x64"?"darwin":"darwin-arm64";const $=(0,v.$L6b)(r,g,this.k);try{P.autoUpdater.setFeedURL({url:$})}catch(E){this.j.error("Failed to set update feed URL",E);return}return $}t(g){this.d(f.$TT.CheckingForUpdates(g)),P.autoUpdater.checkForUpdates()}E(g){this.state.type==="checking for updates"&&this.d(f.$TT.Downloading(g))}F(g){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:g.version}),this.d(f.$TT.Ready(g)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$TT.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$N6b=b,ke([O.$6g],b.prototype,"v",null),ke([O.$6g],b.prototype,"w",null),ke([O.$6g],b.prototype,"x",null),ke([O.$6g],b.prototype,"y",null),e.$N6b=b=ke([_(0,h.$v5b),_(1,D.$8h),_(2,y.$9k),_(3,S.$t5b),_(4,w.$Io),_(5,c.$5i),_(6,m.$kj)],b)}),define(te[292],ie([0,1,47,45,8,3,9,28,20,5,25,48]),function(K,e,P,O,s,M,D,S,h,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P6b=void 0;let y=class{get state(){return this.a}d(b){this.g.info("update#setState",b.type),this.a=b,this.b.fire(b)}constructor(b,d,g){if(this.f=b,this.g=g,this.a=w.$TT.Uninitialized,this.b=new M.$fd,this.onStateChange=this.b.event,d.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(w.$TT.Idle(this.k())),this.h(30*1e3).then(void 0,r=>this.g.error(r))}h(b=60*60*1e3){return(0,s.$Hg)(b).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(b){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(b)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(b){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(b=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${b}`),!b&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(b){}};y=ke([_(0,h.$v5b),_(1,S.$t5b),_(2,c.$5i)],y);let f=class extends y{constructor(b,d,g,r,$,E){super(g,r,$),this.o=b,this.p=d,this.q=E;const u=(0,O.watch)(D.$_d(this.o)),t=M.Event.fromNodeEventEmitter(u,"change",(n,a)=>a),l=M.Event.filter(t,n=>n==="current"),i=M.Event.debounce(l,(n,a)=>a,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{i.dispose(),u.close()})}m(){this.d(w.$TT.CheckingForUpdates(!1)),this.u().then(b=>{b?this.d(w.$TT.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$TT.Idle(2)))},b=>{this.g.error(b),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(w.$TT.Idle(2,b.message||b))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+D.$ae(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const b=await new Promise((g,r)=>(0,O.realpath)(`${D.$_d(this.o)}/current`,($,E)=>$?r($):g(E))),d=D.$ae(b);return this.p!==d}isLatestVersion(){return this.u().then(void 0,b=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$P6b=f,e.$P6b=f=ke([_(2,h.$v5b),_(3,S.$t5b),_(4,c.$5i),_(5,m.$9k)],f)}),define(te[293],ie([0,1,2,20,53,29,8,30]),function(K,e,P,O,s,M,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$96b=void 0;let h=class extends P.$kc{constructor(m,w,y){super(),this.a=w,this.b=y,this.B(m.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B(m.onBeforeCloseWindow(f=>this.c(f))),this.B(new D.$Sg(()=>this.g(),30*1e3)).schedule()}async c(m){const w=this.f(m),y=this.a.getProfileForWorkspace(w);y?.isTransient&&(this.a.unsetWorkspace(w,y.isTransient),y.isTransient&&await this.a.cleanUpTransientProfiles())}f(m){return m.openedWorkspace??(0,M.$Ph)(m.backupPath,m.isExtensionDevelopmentHost)}g(){const m=this.a.getAssociatedEmptyWindows();if(m.length===0)return;const w=this.b.getWindows().map(y=>this.f(y));for(const y of m)w.some(f=>f.id===y.id)||this.a.unsetWorkspace(y,!1)}};e.$96b=h,e.$96b=h=ke([_(0,O.$v5b),_(1,s.$B5b),_(2,S.$H5b)],h)}),define(te[61],ie([0,1,15,2,3,5,312,8,13,30,70,25,20,73,37,4,130]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$25b=e.$15b=void 0;function r(u){return typeof u.responseWindowId=="number"}let $=class extends O.$kc{static{g=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(g.b.values())}constructor(t,l,o){super(),this.t=t,this.u=l,this.w=o,this.c=String(++g.a),this.f=this.B(new s.$fd),this.onStdout=this.f.event,this.g=this.B(new s.$fd),this.onStderr=this.g.event,this.h=this.B(new s.$fd),this.onMessage=this.h.event,this.j=this.B(new s.$fd),this.onExit=this.j.event,this.m=this.B(new s.$fd),this.onCrash=this.m.event,this.n=void 0,this.r=void 0,this.s=void 0}y(t,l){let o;switch(this.s?.correlationId?o=`[UtilityProcess id: ${this.s?.correlationId}, type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`:o=`[UtilityProcess type: ${this.s?.type}, pid: ${this.r??"<none>"}]: ${t}`,l){case m.default.Error:this.t.error(o);break;case m.default.Warning:this.t.warn(o);break;case m.default.Info:this.t.trace(o);break}}z(){return this.n?(this.y("Cannot start utility process because it is already running...",m.default.Error),!1):!0}start(t){const l=this.C(t);return l&&t.payload&&this.postMessage(t.payload),l}C(t){if(!this.z())return!1;this.s=t;const l=`${this.s.type}-${this.c}`,o=h.$2f.asFileUri("bootstrap-fork.js").fsPath,i=this.s.args??[],n=this.s.execArgv??[],a=this.s.allowLoadingUnsignedLibraries,k=this.s.forceAllocationsToV8Sandbox,I="pipe",C=this.D(t);return this.y("creating new...",m.default.Info),this.n=P.utilityProcess.fork(o,i,{serviceName:l,env:C,execArgv:n,allowLoadingUnsignedLibraries:a,forceAllocationsToV8Sandbox:k,stdio:I}),this.F(this.n,this.s,l),!0}D(t){const l=t.env?{...t.env}:{...(0,v.$Vm)(process.env)};l.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(l.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),l.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,b.$i&&((0,d.isUNCAccessRestrictionsDisabled)()?l.NODE_DISABLE_UNC_ACCESS_CHECKS="1":l.NODE_UNC_HOST_ALLOWLIST=(0,d.getUNCHostAllowlist)().join("\\")),(0,f.$tl)(l);for(const o of Object.keys(l))l[o]=String(l[o]);return l}F(t,l,o){if(t.stdout){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.r=t.pid,typeof t.pid=="number"&&g.b.set(t.pid,{pid:t.pid,name:r(l)?`${l.type} [${l.responseWindowId}]`:l.type}),this.y("successfully created",m.default.Info)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.y(`received exit event with code ${i}`,m.default.Info),this.j.fire({pid:this.r,code:i,signal:"unknown"}),this.G()})),this.B(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===o&&(this.y(`crashed with code ${i.exitCode} and reason '${i.reason}'`,m.default.Error),this.u.publicLog2("utilityprocesscrash",{type:l.type,reason:i.reason,code:i.exitCode}),this.m.fire({pid:this.r,code:i.exitCode,reason:i.reason}),this.G())}))}once(t,l){const o=this.B(this.h.event(i=>{i===t&&(o.dispose(),l())}))}postMessage(t,l){this.n&&this.n.postMessage(t,l)}connect(t){const{port1:l,port2:o}=new P.MessageChannelMain;return this.postMessage(t,[o]),l}enableInspectPort(){if(!this.n||typeof this.r!="number")return!1;this.y("enabling inspect port",m.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.r),!0):!1}kill(){if(!this.n)return;this.y("attempting to kill the process...",m.default.Info),this.n.kill()?(this.y("successfully killed the process",m.default.Info),this.G()):this.y("unable to kill the process",m.default.Warning)}G(){typeof this.r=="number"&&g.b.delete(this.r),this.n=void 0}async waitForExit(t){this.n&&(this.y("waiting to exit...",m.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,S.$Hg)(t)]),this.n&&(this.y(`did not exit within ${t}ms, will kill it now...`,m.default.Info),this.kill()))}};e.$15b=$,e.$15b=$=g=ke([_(0,M.$5i),_(1,w.$9k),_(2,y.$v5b)],$);let E=class extends ${constructor(t,l,o,i){super(t,o,i),this.H=l}start(t){const l=this.H.getWindowById(t.responseWindowId);if(!l?.win||l.win.isDestroyed()||l.win.webContents.isDestroyed())return this.y("Refusing to start utility process because requesting window cannot be found or is destroyed...",m.default.Error),!0;if(!super.C(t))return!1;this.I(l.win,t);const i=this.connect(t.payload);return l.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}I(t,l){l.windowLifecycleBound&&(this.B(s.Event.filter(this.w.onWillLoadWindow,o=>o.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$25b=E,e.$25b=E=ke([_(0,M.$5i),_(1,c.$H5b),_(2,w.$9k),_(3,y.$v5b)],E)}),define(te[294],ie([0,1,14,5,20,8,61,30,25]),function(K,e,P,O,s,M,D,S,h){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$05b=void 0;let m=class{static{c=this}static{this.a=0}constructor(y,f,v,b){this.d=y,this.f=f,this.g=v,this.h=b,this.b=new Map,this.c=!1,this.f.onWillShutdown(d=>{this.c=!0,d.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(y){const f=this.b.get(y);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(y){return this.i(y).onStdout}onDynamicStderr(y){return this.i(y).onStderr}onDynamicMessage(y){return this.i(y).onMessage}onDynamicExit(y){return this.i(y).onExit}async createExtensionHost(){if(this.c)throw(0,P.$4)();const y=String(++c.a),f=new D.$25b(this.d,this.g,this.h,this.f);return this.b.set(y,f),f.onExit(({pid:v,code:b,signal:d})=>{this.d.info(`Extension host with pid ${v} exited with code: ${b}, signal: ${d}.`),setTimeout(()=>{f.dispose(),this.b.delete(y)})}),{id:y}}async start(y,f){if(this.c)throw(0,P.$4)();this.i(y).start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:y})}async enableInspectPort(y){if(this.c)throw(0,P.$4)();const f=this.b.get(y);return f?f.enableInspectPort():!1}async kill(y){if(this.c)throw(0,P.$4)();const f=this.b.get(y);f&&f.kill()}async _killAllNow(){for(const[,y]of this.b)y.kill()}async _waitForAllExit(y){const f=[];for(const[,v]of this.b)f.push(v.waitForExit(y));return M.Promises.settled(f).then(()=>{})}};e.$05b=m,e.$05b=m=c=ke([_(0,O.$5i),_(1,s.$v5b),_(2,S.$H5b),_(3,h.$9k)],m)}),define(te[295],ie([0,1,38,8,2,28,20,5,41,39,66,61,52,89,12,247,24]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F6b=void 0;let g=class extends s.$kc{constructor($,E,u,t,l,o,i,n){super(),this.c=$,this.f=E,this.g=u,this.h=t,this.j=l,this.m=o,this.n=i,this.r=n,this.a=new O.$Fg,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){P.$US.on(b.$D6b.request,($,E)=>this.t($,E,b.$D6b.response)),P.$US.on(b.$E6b.request,($,E)=>this.t($,E,b.$E6b.response)),this.B(this.h.onWillShutdown(()=>this.u()))}async t($,E,u){this.j.trace(`[SharedProcess] onWindowConnection for: ${u}`),this.a.isOpen()||this.a.open(),await this.whenReady();const t=await this.connect(u);if($.sender.isDestroyed())return t.close();$.sender.postMessage(u,E,[t])}u(){this.j.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(b.$C6b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const $=new O.$2g;this.b?this.b.once(b.$C6b.initDone,()=>$.complete()):P.$US.once(b.$C6b.initDone,()=>$.complete()),await $.p,this.j.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const $=new O.$2g;this.b?this.b.once(b.$C6b.ipcReady,()=>$.complete()):P.$US.once(b.$C6b.ipcReady,()=>$.complete()),await $.p,this.j.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new w.$15b(this.j,y.$bo,this.h));const $=(0,f.$bm)(this.f.args,this.f.isBuilt);let E;$.port&&(E=["--nolazy"],$.break?E.push(`--inspect-brk=${$.port}`):E.push(`--inspect=${$.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:E,allowLoadingUnsignedLibraries:!!process.env.VSCODE_VOICE_MODULE_PATH&&this.r.quality!=="stable"})}D(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.m.getLogLevel(),loggers:this.m.getRegisteredLoggers(),policiesData:this.n.serialize()}}async connect($){return await this.z,(0,v.$uf)(this.b).connect($)}};e.$F6b=g,e.$F6b=g=ke([_(1,M.$t5b),_(2,h.$Ek),_(3,D.$v5b),_(4,S.$5i),_(5,m.$A6b),_(6,c.$0m),_(7,d.$kj)],g)}),define(te[296],ie([0,1,28,89,20,5,52,61,110,38,2,3,37,18,13]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e7b=void 0;let b=class extends m.$kc{constructor(g,r,$,E,u){super(),this.f=g,this.g=r,this.h=$,this.j=E,this.m=u,this.a=void 0,this.b=new w.$fd,this.onRequestConnection=this.b.event,this.c=new w.$fd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$US.on("vscode:createPtyHostMessageChannel",(t,l)=>this.r(t,l)),this.B((0,m.$ic)(()=>{c.$US.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$15b(this.m,D.$bo,this.j);const g=(0,O.$am)(this.h.args,this.h.isBuilt),r=g.port?["--nolazy",`--inspect${g.break?"-brk":""}=${g.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:r,args:["--logsPath",this.h.logsHome.with({scheme:v.Schemas.file}).fsPath],env:this.n()});const $=this.a.connect(),E=new h.$3S($,"ptyHost"),u=new m.$jc;return u.add(E),u.add((0,m.$ic)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:E,store:u,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const g={...(0,y.$Vm)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},r=this.g.getValue("terminal.integrated.developer.ptyHost.latency");r&&typeof r=="number"&&(g.VSCODE_LATENCY=String(r));const $=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return $&&typeof $=="number"&&(g.VSCODE_STARTUP_DELAY=String($)),this.h.restoreSnapExportedVariables(),g}r(g,r){this.b.fire();const $=this.a.connect();if(g.sender.isDestroyed()){$.close();return}g.sender.postMessage("vscode:createPtyHostMessageChannelResult",r,[$])}};e.$e7b=b,e.$e7b=b=ke([_(1,f.$8h),_(2,P.$t5b),_(3,s.$v5b),_(4,M.$5i)],b)}),define(te[297],ie([0,1,2,6,5,30,61,25,56,3,8,20]),function(K,e,P,O,s,M,D,S,h,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d7b=e.$c7b=void 0,e.$c7b=(0,O.$Bh)("utilityProcessWorker");let y=class extends P.$kc{constructor(b,d,g,r){super(),this.b=b,this.c=d,this.f=g,this.g=r,this.a=new Map}async createWorker(b){const d=`window: ${b.reply.windowId}, moduleId: ${b.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${d})`);const g=this.h(b);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${d})`),this.disposeWorker(b));const r=new f(this.b,this.c,this.f,this.g,b);if(!r.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,r);const $=new m.$2g;return c.Event.once(r.onDidTerminate)(E=>{E.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${E.code}, signal: ${E.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${E.code}, signal: ${E.signal}`),this.a.delete(g),$.complete({reason:E})}),$.p}h(b){return(0,h.$pi)({moduleId:b.process.moduleId,windowId:b.reply.windowId})}async disposeWorker(b){const d=this.h(b),g=this.a.get(d);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${b.reply.windowId}, moduleId: ${b.process.moduleId})`),g.kill(),this.a.delete(d))}};e.$d7b=y,e.$d7b=y=ke([_(0,s.$5i),_(1,M.$H5b),_(2,S.$9k),_(3,w.$v5b)],y);let f=class extends P.$kc{constructor(b,d,g,r,$){super(),this.c=b,this.f=d,this.g=g,this.h=r,this.j=$,this.a=this.B(new c.$fd),this.onDidTerminate=this.a.event,this.b=new D.$25b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(b=>this.a.fire({code:b.code,signal:b.signal}))),this.B(this.b.onCrash(b=>this.a.fire({code:b.code,signal:"ECRASH"})))}spawn(){const d=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:d,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};f=ke([_(0,s.$5i),_(1,M.$H5b),_(2,S.$9k),_(3,w.$v5b)],f)}),define(te[298],ie([0,1,15,2,4,19,7,18,20,5,34,30,127,29]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$26b=e.$16b=e.$Z6b=void 0;let b=class extends O.$kc{static{v=this}static{this.a="windowsState"}get state(){return this.b}constructor(u,t,l,o,i){super(),this.g=u,this.h=t,this.j=l,this.m=o,this.n=i,this.b=d(this.h.getItem(v.a)),this.c=void 0,this.f=!1,this.r()}r(){P.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(u=>this.u(u)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(u=>this.u(u))}s(){this.f=!0,this.t()}t(){const u=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&u.add(t.lastActiveWindow.uiState.display))}const l=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);l&&(t.lastPluginDevelopmentHostWindow=this.w(l),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(u.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!l.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):u.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(u.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):u.add(n.uiState.display)),n}));const o=r(t);this.h.setItem(v.a,o),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",o)}u(u){if(this.j.quitRequested)return;const t=this.w(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this.b.openedWindows.forEach(l=>{const o=(0,f.$Qh)(u.openedWorkspace)&&l.workspace?.id===u.openedWorkspace.id,i=(0,f.$Lh)(u.openedWorkspace)&&l.folderUri&&M.$_f.isEqual(l.folderUri,u.openedWorkspace.uri);(o||i)&&(l.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(u){return{windowId:u.id,workspace:(0,f.$Qh)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,f.$Lh)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const t=this.z(u),l=this.n.getValue("window");if(t.mode===3){let o;t.hasDefaultState?o=!!(l?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(l.newWindowDimensions)>=0):o=!!(this.j.wasRestarted||l?.restoreFullscreen),o||(t.mode=1)}return t}z(u){const t=this.g.getLastActiveWindow();if(!u.extensionTestsPath){if(u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const k=u.workspace;if((0,f.$Qh)(k)){const C=this.state.openedWindows.filter(p=>p.workspace&&p.workspace.id===k.id).map(p=>p.uiState);if(C.length)return C[0]}if((0,f.$Lh)(k)){const C=this.state.openedWindows.filter(p=>p.folderUri&&M.$_f.isEqual(p.folderUri,k.uri)).map(p=>p.uiState);if(C.length)return C[0]}else if(u.backupPath){const C=this.state.openedWindows.filter(p=>p.backupPath===u.backupPath).map(p=>p.uiState);if(C.length)return C[0]}const I=this.c||this.state.lastActiveWindow;if(!t&&I)return I.uiState}let l;const o=P.screen.getAllDisplays();if(o.length===1)l=o[0];else{if(s.$j){const k=P.screen.getCursorScreenPoint();l=P.screen.getDisplayNearestPoint(k)}!l&&t&&(l=P.screen.getDisplayMatching(t.getBounds())),l||(l=P.screen.getPrimaryDisplay()||o[0])}let i=(0,y.$s5b)();i.x=Math.round(l.bounds.x+l.bounds.width/2-i.width/2),i.y=Math.round(l.bounds.y+l.bounds.height/2-i.height/2);const n=this.n.getValue("window");let a=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,a=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,a=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const k=t.serializeWindowState();k.mode===3?i.mode=3:i=k,a=i.mode!==3&&n.newWindowDimensions==="offset"}}return a&&(i=this.C(i)),i.hasDefaultState=!0,i}C(u){if(this.g.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const t=this.g.getWindows().map(l=>l.getBounds());for(;t.some(l=>l.x===u.x||l.y===u.y);)u.x+=30,u.y+=30;return u}};e.$Z6b=b,e.$Z6b=b=v=ke([_(0,w.$H5b),_(1,m.$eN),_(2,h.$v5b),_(3,c.$5i),_(4,S.$8h)],b);function d(E){const u={openedWindows:[]},t=E||{openedWindows:[]};return t.lastActiveWindow&&(u.lastActiveWindow=g(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=g(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(u.openedWindows=t.openedWindows.map(l=>g(l))),u}e.$16b=d;function g(E){const u={uiState:E.uiState};return E.backupPath&&(u.backupPath=E.backupPath),E.remoteAuthority&&(u.remoteAuthority=E.remoteAuthority),E.folder&&(u.folderUri=D.URI.parse(E.folder)),E.workspaceIdentifier&&(u.workspace={id:E.workspaceIdentifier.id,configPath:D.URI.parse(E.workspaceIdentifier.configURIPath)}),u}function r(E){return{lastActiveWindow:E.lastActiveWindow&&$(E.lastActiveWindow),lastPluginDevelopmentHostWindow:E.lastPluginDevelopmentHostWindow&&$(E.lastPluginDevelopmentHostWindow),openedWindows:E.openedWindows.map(u=>$(u))}}e.$26b=r;function $(E){return{workspaceIdentifier:E.workspace&&{id:E.workspace.id,configURIPath:E.workspace.configPath.toString()},folder:E.folderUri&&E.folderUri.toString(),backupPath:E.backupPath,remoteAuthority:E.remoteAuthority,uiState:E.uiState}}}),define(te[54],ie([0,1,15,3,44,2,13,9,19,21,192,64,60,28,6,5,53,129,29,97,98]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r,$,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z5b=e.$Y5b=void 0,e.$Y5b=(0,v.$Bh)("workspacesManagementMainService");let u=class extends M.$kc{constructor(l,o,i,n,a){super(),this.g=l,this.h=o,this.j=i,this.m=n,this.n=a,this.a=this.B(new O.$fd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new O.$fd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const l=(await c.Promises.readdir(this.c.with({scheme:D.Schemas.file}).fsPath)).map(o=>(0,h.$ig)(this.c,o,r.$1h));for(const o of l){const i=(0,E.$O5b)(o),n=await this.resolveLocalWorkspace(o);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(l){l.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${l}).`)}}resolveLocalWorkspace(l){return this.r(l,o=>c.Promises.readFile(o,"utf8"))}r(l,o){if(this.s(l)&&l.scheme===D.Schemas.file)try{const i=o(l.fsPath);return i instanceof Promise?i.then(n=>this.t(l,n),n=>{}):this.t(l,i)}catch{return}}s(l){return(0,r.$2h)(l,this.g)||(0,r.$7h)(l)}t(l,o){try{const i=this.u(l,o),n=(0,E.$O5b)(l);return{id:n.id,configPath:n.configPath,folders:(0,$.$lU)(i.folders,n.configPath,h.$_f),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(l,o){const i=(0,s.$Lm)(o);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,$.$jU)(n));else throw new Error(`${l.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(l,o){const{workspace:i,storedWorkspace:n}=this.w(l,o),a=i.configPath.fsPath;return await c.Promises.mkdir((0,S.$_d)(a),{recursive:!0}),await c.Promises.writeFile(a,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:o}),i}w(l=[],o){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,h.$ig)(this.c,i),a=(0,h.$ig)(n,r.$1h),k=[];for(const I of l)k.push((0,$.$kU)(I.uri,!0,I.name,n,h.$_f));return{workspace:(0,E.$O5b)(a),storedWorkspace:{folders:k,remoteAuthority:o}}}async getWorkspaceIdentifier(l){return(0,E.$O5b)(l)}isUntitledWorkspace(l){return(0,r.$2h)(l.configPath,this.g)}async deleteUntitledWorkspace(l){this.isUntitledWorkspace(l)&&(await this.y(l),this.j.isEnabled()&&this.j.unsetWorkspace(l),this.a.fire(l))}async y(l){const o=(0,h.$9f)(l.configPath);try{await c.Promises.rm((0,S.$_d)(o));const i=(0,S.$9d)(this.g.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,l.id);await c.Promises.exists(i)&&await c.Promises.writeFile((0,S.$9d)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==l.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${o} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(l,o,i){if(!l||!l.win||!l.isReady||!await this.z(l,o,i))return;const a=await this.C(l,(0,E.$O5b)(i));if(a)return this.b.fire({window:l,workspace:a.workspace}),a}async z(l,o,i){return i?(0,r.$Qh)(l.openedWorkspace)&&h.$_f.isEqual(l.openedWorkspace.configPath,i)?!1:(0,g.$W5b)(o,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:(0,m.localize)(1,null,(0,h.$fg)(i)),detail:(0,m.localize)(2,null)},P.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(l,o){if(!l.config)return;l.focus();let i;return l.config.extensionDevelopmentPath||(l.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:o,remoteAuthority:l.remoteAuthority},l.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:o,remoteAuthority:l.remoteAuthority})),(0,r.$Qh)(l.openedWorkspace)&&this.isUntitledWorkspace(l.openedWorkspace)&&await this.deleteUntitledWorkspace(l.openedWorkspace),l.config.workspace=o,l.config.backupPath=i,{workspace:o,backupPath:i}}};e.$Z5b=u,e.$Z5b=u=ke([_(0,f.$t5b),_(1,b.$5i),_(2,d.$B5b),_(3,w.$M5b),_(4,y.$T5b)],u)}),define(te[131],ie([0,1,15,38,22,6,30,29,54,12,5,61]),function(K,e,P,O,s,M,D,S,h,c,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$55b=e.$45b=e.ID=void 0,e.ID="diagnosticsMainService",e.$45b=(0,M.$Bh)(e.ID);let y=class{constructor(v,b,d){this.a=v,this.b=b,this.c=d}async getRemoteDiagnostics(v){const b=this.a.getWindows();return(await Promise.all(b.map(async g=>{const r=g.remoteAuthority;if(!r)return;const $=`vscode:getDiagnosticInfoResponse${g.id}`,E={includeProcesses:v.includeProcesses,folders:v.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(u=>{g.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:$,args:E}),O.$US.once($,(t,l)=>{l||u({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),u(l)}),setTimeout(()=>{u({hostName:r,errorMessage:`Connection to '${r}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const v=[];for(const d of P.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(d.id);g?v.push(await this.d(g)):v.push(this.e(d))}const b=[];for(const{pid:d,name:g}of w.$15b.getAll())b.push({pid:d,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:v,pidToNames:b,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(v){const b=await this.f(v),d=(0,c.$uf)(v.win);return this.e(d,b,v.remoteAuthority)}e(v,b=[],d){return{id:v.id,pid:v.webContents.getOSProcessId(),title:v.getTitle(),folderURIs:b,remoteAuthority:d}}async f(v){const b=[],d=v.openedWorkspace;if((0,S.$Lh)(d))b.push(d.uri);else if((0,S.$Qh)(d)){const g=await this.b.resolveLocalWorkspace(d.configPath);g&&g.folders.forEach($=>{b.push($.uri)})}return b}};e.$55b=y,e.$55b=y=ke([_(0,D.$H5b),_(1,h.$Y5b),_(2,m.$5i)],y)}),define(te[67],ie([0,1,47,15,27,155,55,3,2,13,9,4,7,105,86,21,103,180,60,28,6,20,5,24,79,30,29,54,17,243,235]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r,$,E,u,t,l,o,i,n,a,k,I,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j6b=e.$i6b=void 0,e.$i6b=(0,E.$Bh)("nativeHostMainService");let p=class extends h.$kc{constructor(L,U,z,re,ee,ae,se,oe){super(),this.a=L,this.b=U,this.c=z,this.f=re,this.g=ee,this.h=ae,this.j=se,this.m=oe,this.onDidOpenWindow=S.Event.map(this.a.onDidOpenWindow,G=>G.id),this.onDidTriggerSystemContextMenu=S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:G,x:J,y:q})=>({windowId:G.id,x:J,y:q})),({windowId:G})=>!!this.a.getWindowById(G)),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-maximize",(G,J)=>J.id),G=>!!this.a.getWindowById(G)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-unmaximize",(G,J)=>J.id),G=>!!this.a.getWindowById(G)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-blur",(G,J)=>J.id),G=>!!this.a.getWindowById(G)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),G=>!!G),G=>G.id),S.Event.filter(S.Event.fromNodeEventEmitter(O.app,"browser-window-focus",(G,J)=>J.id),G=>!!this.a.getWindowById(G))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(O.powerMonitor,"resume"),this.onDidChangeColorScheme=this.j.onDidChangeColorScheme,this.n=this.B(new S.$fd),this.onDidChangePassword=this.n.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(O.screen,"display-metrics-changed",(G,J,q)=>q),G=>!(Array.isArray(G)&&G.length===1&&G[0]==="workArea")),S.Event.fromNodeEventEmitter(O.screen,"display-added"),S.Event.fromNodeEventEmitter(O.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(U=>({id:U.id,workspace:U.openedWorkspace??(0,n.$Ph)(U.backupPath,U.isExtensionDevelopmentHost),title:U.win?.getTitle()??"",filename:U.getRepresentedFilename(),dirty:U.isDocumentEdited()}))}async getWindowCount(L){return this.a.getWindowCount()}async getActiveWindowId(L){const U=O.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(U)return U.id}openWindow(L,U,z){return Array.isArray(U)?this.r(L,U,z):this.s(L,U)}async r(L,U,z=Object.create(null)){U.length>0&&await this.a.open({context:5,contextWindowId:L,urisToOpen:U,cli:this.f.args,forceNewWindow:z.forceNewWindow,forceReuseWindow:z.forceReuseWindow,preferNewWindow:z.preferNewWindow,diffMode:z.diffMode,mergeMode:z.mergeMode,addMode:z.addMode,gotoLineMode:z.gotoLineMode,noRecentEntry:z.noRecentEntry,waitMarkerFileURI:z.waitMarkerFileURI,remoteAuthority:z.remoteAuthority||void 0,forceProfile:z.forceProfile,forceTempProfile:z.forceTempProfile})}async s(L,U){await this.a.openEmptyWindow({context:5,contextWindowId:L},U)}async toggleFullScreen(L){this.C(L)?.toggleFullScreen()}async handleTitleDoubleClick(L){this.C(L)?.handleTitleDoubleClick()}async isMaximized(L){const U=this.C(L);return U?.win?U.win.isMaximized():!1}async maximizeWindow(L){const U=this.C(L);U?.win&&U.win.maximize()}async unmaximizeWindow(L){const U=this.C(L);U?.win&&U.win.unmaximize()}async minimizeWindow(L){const U=this.C(L);U?.win&&U.win.minimize()}async updateWindowControls(L,U){const z=this.C(L);z&&z.updateWindowControls(U)}async focusWindow(L,U){U&&typeof U.windowId=="number"&&(L=U.windowId),this.C(L)?.focus({force:U?.force??!1})}async setMinimumSize(L,U,z){const re=this.C(L);if(re?.win){const[ee,ae]=re.win.getSize(),[se,oe]=re.win.getMinimumSize(),[G,J]=[U??se,z??oe],[q,F]=[Math.max(ee,G),Math.max(ae,J)];(se!==G||oe!==J)&&re.win.setMinimumSize(G,J),(ee!==q||ae!==F)&&re.win.setSize(q,F)}}async saveWindowSplash(L,U){this.j.saveWindowSplash(L,U)}async installShellCommand(L){const{source:U,target:z}=await this.t();try{const{symbolicLink:re}=await b.SymlinkSupport.stat(U);if(re&&!re.dangling){const ee=await(0,f.$Wp)(U);if(z===ee)return}await b.Promises.unlink(U)}catch(re){if(re.code!=="ENOENT")throw re}try{await b.Promises.symlink(z,U)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:ee}=await this.showMessageBox(L,{type:"info",message:(0,g.localize)(0,null,this.h.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(ee===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${z}' '${U}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ae)}catch{throw new Error((0,g.localize)(3,null,U))}}}async uninstallShellCommand(L){const{source:U}=await this.t();try{await b.Promises.unlink(U)}catch(z){switch(z.code){case"EACCES":{const{response:re}=await this.showMessageBox(L,{type:"info",message:(0,g.localize)(4,null,this.h.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(re===0)try{const ee=`osascript -e "do shell script \\"rm '${U}'\\" with administrator privileges"`;await(0,M.promisify)(P.exec)(ee)}catch{throw new Error((0,g.localize)(7,null,U))}break}case"ENOENT":break;default:throw z}}}async t(){const L=(0,m.$0d)(this.f.appRoot,"bin","code"),U=`/usr/local/bin/${this.h.applicationName}`;if(!await b.Promises.exists(L))throw new Error((0,g.localize)(8,null,L));return{source:U,target:L}}async showMessageBox(L,U){return this.b.showMessageBox(U,this.u(L))}async showSaveDialog(L,U){return this.b.showSaveDialog(U,this.u(L))}async showOpenDialog(L,U){return this.b.showOpenDialog(U,this.u(L))}u(L){const U=this.C(L);if(U?.win)return U.win}async pickFileFolderAndOpen(L,U){const z=await this.b.pickFileFolder(U);z&&await this.w(await Promise.all(z.map(async re=>await b.SymlinkSupport.existsDirectory(re)?{folderUri:y.URI.file(re)}:{fileUri:y.URI.file(re)})),U,L)}async pickFolderAndOpen(L,U){const z=await this.b.pickFolder(U);z&&await this.w(z.map(re=>({folderUri:y.URI.file(re)})),U,L)}async pickFileAndOpen(L,U){const z=await this.b.pickFile(U);z&&await this.w(z.map(re=>({fileUri:y.URI.file(re)})),U,L)}async pickWorkspaceAndOpen(L,U){const z=await this.b.pickWorkspace(U);z&&await this.w(z.map(re=>({workspaceUri:y.URI.file(re)})),U,L)}async w(L,U,z){await this.a.open({context:3,contextWindowId:z,cli:this.f.args,urisToOpen:L,forceNewWindow:U.forceNewWindow})}async showItemInFolder(L,U){O.shell.showItemInFolder(U)}async setRepresentedFilename(L,U){this.C(L)?.setRepresentedFilename(U)}async setDocumentEdited(L,U){this.C(L)?.setDocumentEdited(U)}async openExternal(L,U){return this.f.unsetSnapExportedVariables(),O.shell.openExternal(U),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(L,U){return O.shell.trashItem(U)}async isAdmin(){let L;return w.$i?L=(await new Promise((U,z)=>{K(["native-is-elevated"],U,z)}))():L=process.getuid?.()===0,L}async writeElevated(L,U,z,re){const ee=await new Promise((ae,se)=>{K(["@vscode/sudo-prompt"],ae,se)});return new Promise((ae,se)=>{const oe=[`"${this.z}"`];re?.unlock&&oe.push("--file-chmod"),oe.push("--file-write",`"${U.fsPath}"`,`"${z.fsPath}"`);const G={name:this.h.nameLong.replace("-",""),icns:w.$j&&this.f.isBuilt?(0,m.$9d)((0,m.$_d)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};ee.exec(oe.join(" "),G,(J,q,F)=>{q&&this.g.trace(`[sudo-prompt] received stdout: ${q}`),F&&this.g.trace(`[sudo-prompt] received stderr: ${F}`),J?se(J):ae(void 0)})})}async isRunningUnderARM64Translation(){return w.$k||w.$i?!1:O.app.runningUnderARM64Translation}get z(){return w.$i?this.f.isBuilt?(0,m.$9d)((0,m.$_d)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,m.$9d)(this.f.appRoot,"scripts","code-cli.bat"):w.$k?this.f.isBuilt?(0,m.$9d)((0,m.$_d)(process.execPath),"bin",`${this.h.applicationName}`):(0,m.$9d)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,m.$9d)(this.f.appRoot,"bin","code"):(0,m.$9d)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return v.$Hm.value()}async getOSColorScheme(){return this.j.getColorScheme()}async hasWSLFeatureInstalled(){return w.$i&&(0,I.$g6b)()}async killProcess(L,U,z){process.kill(U,z)}async readClipboardText(L,U){return O.clipboard.readText(U)}async writeClipboardText(L,U,z){return O.clipboard.writeText(U,z)}async readClipboardFindText(L){return O.clipboard.readFindText()}async writeClipboardFindText(L,U){return O.clipboard.writeFindText(U)}async writeClipboardBuffer(L,U,z,re){return O.clipboard.writeBuffer(U,Buffer.from(z.buffer),re)}async readClipboardBuffer(L,U){return k.$Fd.wrap(O.clipboard.readBuffer(U))}async hasClipboard(L,U,z){return O.clipboard.has(U,z)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){O.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){O.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){O.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){O.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){O.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,U){this.C(L)?.updateTouchBar(U)}async notifyReady(L){this.C(L)?.setReady()}async relaunch(L,U){return this.c.relaunch(U)}async reload(L,U){const z=this.C(L);if(z){if((0,n.$Qh)(z.openedWorkspace)){const re=z.openedWorkspace.configPath;if(re.scheme===c.Schemas.file&&(await this.m.resolveLocalWorkspace(re))?.transient)return this.openWindow(z.id,{forceReuseWindow:!0})}return this.c.reload(z,U?.disableExtensions!==void 0?{_:[],"disable-extensions":U.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,U){const z=this.C(U);if(z?.win)return z.win.close()}async quit(L){const U=this.a.getLastActiveWindow();U?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&U.win?U.win.close():this.c.quit()}async exit(L,U){await this.c.kill(U)}async resolveProxy(L,U){return this.C(L)?.win?.webContents?.session?.resolveProxy(U)}findFreePort(L,U,z,re,ee=1){return(0,d.$6f)(U,z,re,ee)}async openDevTools(L,U){const z=this.C(L);z?.win&&z.win.webContents.openDevTools(U)}async toggleDevTools(L){const U=this.C(L);U?.win&&U.win.webContents.toggleDevTools()}async sendInputEvent(L,U){const z=this.C(L);z?.win&&(U.type==="mouseDown"||U.type==="mouseUp")&&z.win.webContents.sendInputEvent(U)}async profileRenderer(L,U,z){const re=this.C(L);if(!re||!re.win)throw new Error;return await new C.$h6b(re.win,U,this.g).inspect(z)}async windowsGetStringRegKey(L,U,z,re){if(!w.$i)return;const ee=await new Promise((ae,se)=>{K(["@vscode/windows-registry"],ae,se)});try{return ee.GetStringRegKey(U,z,re)}catch{return}}C(L){if(typeof L=="number")return this.a.getWindowById(L)}};e.$j6b=p,ke([D.$6g],p.prototype,"z",null),e.$j6b=p=ke([_(0,i.$H5b),_(1,r.$T5b),_(2,u.$v5b),_(3,$.$t5b),_(4,t.$5i),_(5,l.$kj),_(6,o.$e6b),_(7,a.$Y5b)],p)}),define(te[299],ie([0,1,15,38,27,2,13,4,107,178,90,131,60,28,5,67,77,24,78,80,32,34,61,22,7,30,8]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r,$,E,u,t,l,o,i,n){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$l6b=void 0;const k="issue.processExplorerWindowState";let I=class{static{a=this}static{this.a="#1E1E1E"}constructor(A,L,U,z,re,ee,ae,se,oe,G,J){this.g=A,this.h=L,this.i=U,this.j=z,this.k=re,this.l=ee,this.m=ae,this.n=se,this.o=oe,this.p=G,this.q=J,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){O.$US.on("vscode:listProcesses",async A=>{const L=[];try{L.push({name:(0,c.localize)(0,null),rootProcess:await(0,h.$sr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(z=>{(0,m.$hm)(z)?L.push({name:z.hostName,rootProcess:z}):z.processes&&L.push({name:z.hostName,rootProcess:z.processes})})}catch(U){this.i.error(`Listing processes failed: ${U}`)}this.t(A,"vscode:listProcessesResponse",L)}),O.$US.on("vscode:workbenchCommand",(A,L)=>{const{id:U,from:z,args:re}=L;let ee;switch(z){case"processExplorer":ee=this.f;break;default:throw new Error(`Unexpected command source: ${z}`)}ee?.webContents.send("vscode:runAction",{id:U,from:z,args:re})}),O.$US.on("vscode:closeProcessExplorer",A=>{this.d?.close()}),O.$US.on("vscode:pidToNameRequest",async A=>{const L=await this.k.getMainDiagnostics(),U=[];for(const z of L.windows)U.push([z.pid,`window [${z.id}] (${z.title})`]);for(const{pid:z,name:re}of t.$15b.getAll())U.push([z,re]);this.t(A,"vscode:pidToNameResponse",U)})}async openReporter(A){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const L=new M.$jc,U=L.add(this.n.createIPCObjectUrl()),z=this.v(this.c,700,800);this.b=this.u(z,U,{backgroundColor:A.styles.backgroundColor,title:(0,c.localize)(1,null),zoomLevel:A.zoomLevel,alwaysOnTop:!1},"issue-reporter"),U.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:A,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:d.default}),this.b.loadURL(D.$2f.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,L.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,L.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(A){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const L=new M.$jc,U=L.add(this.n.createIPCObjectUrl()),z=this.p.getItem(k,void 0),re=C(z)?z:this.v(this.f,800,500);this.d=this.u(re,U,{backgroundColor:A.styles.backgroundColor,title:(0,c.localize)(2,null),zoomLevel:A.zoomLevel,alwaysOnTop:!0},"process-explorer"),U.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:A,product:d.default}),this.d.loadURL(D.$2f.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,L.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,L.dispose())});const ee=()=>{if(!this.d)return;const ae=this.d.getSize(),se=this.d.getPosition();if(!ae||!se)return;const oe={width:ae[0],height:ae[1],x:se[0],y:se[1]};this.p.setItem(k,oe)};this.d.on("moved",ee),this.d.on("resized",ee)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const A=await P.contentTracing.stopRecording(`${(0,E.$Qf)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,c.localize)(3,null),detail:(0,c.localize)(4,null,A),buttons:[(0,c.localize)(5,null)]},P.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,A)}async getSystemStatus(){const[A,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(A,L)}async $getSystemInfo(){const[A,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(A,L)}async $getPerformanceInfo(){try{const[A,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(A,L)}catch(A){throw this.i.warn("issueService#getPerformanceInfo ",A.message),A}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(A){this.i.error(A)}}async $showConfirmCloseDialog(){if(this.b){const{response:A}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(6,null),buttons:[(0,c.localize)(7,null),(0,c.localize)(8,null)]},this.b);A===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:A}=await this.l.showMessageBox({type:"warning",message:(0,c.localize)(9,null),buttons:[(0,c.localize)(10,null),(0,c.localize)(11,null)]},this.b);return A===0}return!1}async $getIssueReporterUri(A){if(!this.c)throw new Error("Issue reporter window not available");const L=this.q.getWindowById(this.c.id);if(!L)throw new Error("Window not found");const U=`vscode:triggerIssueUriRequestHandlerResponse${L.id}`;return n.Promises.withAsyncBody(async(z,re)=>{const ee=new l.$pd;L.sendWhenReady("vscode:triggerIssueUriRequestHandler",ee.token,{replyChannel:U,extensionId:A}),O.$US.once(U,(ae,se)=>{z(o.URI.parse(se))});try{await(0,n.$Hg)(5e3),ee.cancel(),re(new Error("Timed out waiting for issue reporter URI"))}finally{O.$US.removeHandler(U)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(A){A.isMinimized()&&A.restore(),A.focus()}t(A,L,...U){A.sender.isDestroyed()||A.sender.send(L,...U)}u(A,L,U,z){const re=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:A.width,height:A.height,minWidth:300,minHeight:200,x:A.x,y:A.y,title:U.title,backgroundColor:U.backgroundColor||a.a,webPreferences:{preload:D.$2f.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${L.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,$.$YC)(U.zoomLevel),sandbox:!0},alwaysOnTop:U.alwaysOnTop,experimentalDarkMode:!0});return re.setMenuBarVisibility(!1),re}v(A,L,U){let z;const re=P.screen.getAllDisplays();if(re.length===1)z=re[0];else{if(S.$j){const se=P.screen.getCursorScreenPoint();z=P.screen.getDisplayNearestPoint(se)}!z&&A&&(z=P.screen.getDisplayMatching(A.getBounds())),z||(z=P.screen.getPrimaryDisplay()||re[0])}const ee=z.bounds,ae={width:L,height:U,x:ee.x+ee.width/2-L/2,y:ee.y+ee.height/2-U/2};return ee.width>0&&ee.height>0&&(ae.x<ee.x&&(ae.x=ee.x),ae.y<ee.y&&(ae.y=ee.y),ae.x>ee.x+ee.width&&(ae.x=ee.x),ae.y>ee.y+ee.height&&(ae.y=ee.y),ae.width>ee.width&&(ae.width=ee.width),ae.height>ee.height&&(ae.height=ee.height)),ae}};e.$l6b=I,e.$l6b=I=a=ke([_(1,f.$t5b),_(2,v.$5i),_(3,m.$gm),_(4,w.$45b),_(5,y.$T5b),_(6,b.$i6b),_(7,r.$k6b),_(8,g.$kj),_(9,u.$eN),_(10,i.$H5b)],I);function C(p){return typeof p!="object"||p===null?!1:"x"in p&&"y"in p&&"width"in p&&"height"in p}}),define(te[300],ie([0,1,22,18,28,20,5,67,24,51,25,48,100]),function(K,e,P,O,s,M,D,S,h,c,m,w,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O6b=void 0;let f=class extends y.$M6b{constructor(b,d,g,r,$,E,u,t){super(b,d,r,$,E,t),this.e=g,this.u=u}s(b){return(0,y.$L6b)(`linux-${process.arch}`,b,this.k)}t(b){this.a&&(this.d(w.$TT.CheckingForUpdates(b)),this.i.request({url:this.a},P.CancellationToken.None).then(c.$Oo).then(d=>{!d||!d.url||!d.version||!d.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!b}),this.d(w.$TT.Idle(1))):this.d(w.$TT.AvailableForDownload(d))}).then(void 0,d=>{this.j.error(d),this.e.publicLog2("update:notAvailable",{explicit:!!b});const g=b?d.message||d:void 0;this.d(w.$TT.Idle(1,g))}))}async o(b){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):b.update.url&&this.u.openExternal(void 0,b.update.url),this.d(w.$TT.Idle(1))}};e.$O6b=f,e.$O6b=f=ke([_(0,M.$v5b),_(1,O.$8h),_(2,m.$9k),_(3,s.$t5b),_(4,c.$Io),_(5,D.$5i),_(6,S.$i6b),_(7,h.$kj)],f)}),define(te[301],ie([0,1,47,45,27,8,22,55,9,7,142,21,18,28,16,20,5,67,24,51,25,48,100]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r,$,E,u,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=void 0;async function l(a,k=1e3){for(;!a();)await(0,M.$Hg)(k)}let o;function i(){return typeof o>"u"&&(o=O.existsSync(h.$9d(h.$_d(process.execPath),"unins000.exe"))?0:1),o}let n=class extends t.$M6b{get cachePath(){const k=h.$9d((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return w.Promises.mkdir(k,{recursive:!0}).then(()=>k)}constructor(k,I,C,p,A,L,U,z,re){super(k,I,p,A,L,re),this.u=C,this.v=U,this.w=z,k.setRelaunchHandler(this)}handleRelaunch(k){return k?.addArgs||k?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(u.$TT.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(k){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),i()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,t.$L6b)(I,k,this.k)}t(k){this.a&&(this.d(u.$TT.CheckingForUpdates(k)),this.i.request({url:this.a},D.CancellationToken.None).then($.$Oo).then(I=>{const C=i();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!k}),this.d(u.$TT.Idle(C)),Promise.resolve(null)):C===1?(this.d(u.$TT.AvailableForDownload(I)),Promise.resolve(null)):(this.d(u.$TT.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(p=>w.Promises.exists(p).then(A=>{if(A)return Promise.resolve(p);const L=I.url,U=I.hash,z=`${p}.tmp`;return this.i.request({url:L},D.CancellationToken.None).then(re=>this.v.writeFile(c.URI.file(z),re.stream)).then(U?()=>(0,m.$PS)(z,I.hash):()=>{}).then(()=>w.Promises.rename(z,p,!1)).then(()=>p)})).then(p=>{const A=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:p},A?this.k.target==="user"?this.p():this.d(u.$TT.Downloaded(I)):this.d(u.$TT.Ready(I))})))}).then(void 0,I=>{this.j.error(I),this.u.publicLog2("update:notAvailable",{explicit:!!k});const C=k?I.message||I:void 0;this.d(u.$TT.Idle(i(),C))}))}async o(k){k.update.url&&this.w.openExternal(void 0,k.update.url),this.d(u.$TT.Idle(i()))}async B(k){const I=await this.cachePath;return h.$9d(I,`CodeSetup-${this.k.quality}-${k}.exe`)}async C(k=null){const I=k?L=>!new RegExp(`${this.k.quality}-${k}\\.exe$`).test(L):()=>!0,C=await this.cachePath,A=(await w.Promises.readdir(C)).filter(I).map(async L=>{try{await w.Promises.unlink(h.$9d(C,L))}catch{}});await Promise.all(A)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const k=this.state.update;this.d(u.$TT.Updating(k));const I=await this.cachePath;this.e.updateFilePath=h.$9d(I,`CodeSetup-${this.k.quality}-${k.version}.flag`),await w.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(u.$TT.Idle(i()))});const p=`${this.k.win32MutexName}-ready`,A=await new Promise((L,U)=>{K(["@vscode/windows-mutex"],L,U)});l(()=>A.isActive(p)).then(()=>this.d(u.$TT.Ready(k)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?O.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return i()}async _applySpecificUpdate(k){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),C={version:"unknown",productVersion:"unknown"};this.d(u.$TT.Downloading(C)),this.e={packagePath:k},I?this.k.target==="user"?this.p():this.d(u.$TT.Downloaded(C)):this.d(u.$TT.Ready(C))}};e.$Q6b=n,ke([S.$6g],n.prototype,"cachePath",null),e.$Q6b=n=ke([_(0,b.$v5b),_(1,y.$8h),_(2,E.$9k),_(3,f.$t5b),_(4,$.$Io),_(5,d.$5i),_(6,v.$6j),_(7,g.$i6b),_(8,r.$kj)],n)}),define(te[302],ie([0,1,15,8,22,50,3,2,13,9,65,4,7,188,64,18,60,28,63,16,20,5,24,78,252,82,25,102,79,80,30,29,54,127,134,39,34,53,66,23]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r,$,E,u,t,l,o,i,n,a,k,I,C,p,A,L,U,z,re,ee,ae,se){"use strict";var oe;Object.defineProperty(e,"__esModule",{value:!0}),e.$Y6b=void 0;var G;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(G||(G={}));let J=class extends S.$kc{static{oe=this}static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.m}get lastFocusTime(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const F=this.R.profiles.find(N=>N.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&F?F:this.R.getProfileForWorkspace(this.config.workspace??(0,p.$Ph)(this.backupPath,this.isExtensionDevelopmentHost))??this.R.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(F,N,V,Q,x,ce,Y,R,j,W,T,H,B,ne,fe,ge,ue,we,me,Se){super(),this.N=N,this.O=V,this.P=Q,this.Q=x,this.R=ce,this.S=Y,this.U=R,this.W=j,this.X=W,this.Y=T,this.Z=H,this.$=B,this.ab=ne,this.bb=fe,this.db=ge,this.eb=ue,this.fb=we,this.gb=me,this.hb=Se,this.b=this.B(new D.$fd),this.onWillLoad=this.b.event,this.c=this.B(new D.$fd),this.onDidSignalReady=this.c.event,this.f=this.B(new D.$fd),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new D.$fd),this.onDidClose=this.g.event,this.h=this.B(new D.$fd),this.onDidDestroy=this.h.event,this.n=-1,this.u=void 0,this.w=void 0,this.D=!1,this.F=[],this.G=[],this.H=void 0,this.I=void 0,this.J=this.B(this.fb.createIPCObjectUrl()),this.M=!1,this.ib=0;{const[Ie,je]=this.sb(F.state);this.s=Ie,this.N.trace("window#ctor: using window state",Ie);const ve=this.s.mode===0||this.s.mode===3,be=this.X.getValue("window"),X={width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y,backgroundColor:this.Y.getBackgroundColor(),minWidth:I.$RC.WIDTH,minHeight:I.$RC.HEIGHT,show:!ve,title:this.eb.nameLong,webPreferences:{preload:h.$2f.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.J.resource.toString()}`],v8CacheOptions:this.P.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,I.$YC)(be?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};w.$k?X.icon=(0,c.$9d)(this.P.appRoot,"resources/linux/code.png"):w.$i&&!this.P.isBuilt&&(X.icon=(0,c.$9d)(this.P.appRoot,"resources/win32/code_150x150.png")),w.$j&&!this.zb()&&(X.fullscreenable=!1),w.$j&&(X.acceptFirstMouse=!0,be?.clickThroughInactive===!1&&(X.acceptFirstMouse=!1));const le=w.$j&&be?.nativeTabs===!0;le&&(X.tabbingIdentifier=this.eb.nameShort);const de=(0,I.$WC)(this.X)==="custom";if(de&&(X.titleBarStyle="hidden",w.$j||(X.frame=!1),(0,I.$XC)(this.X))){const Ee=this.Y.getWindowSplash()?.colorInfo.titleBarBackground??this.Y.getBackgroundColor(),Re=U.$Os.fromHex(Ee).isDarker()?"#FFFFFF":"#000000";X.titleBarOverlay={height:29,color:Ee,symbolColor:Re},this.D=!0}if((0,m.mark)("code/willCreateCodeBrowserWindow"),this.m=new P.BrowserWindow(X),(0,m.mark)("code/didCreateCodeBrowserWindow"),this.j=this.m.id,w.$j&&de&&this.m.setSheetOffset(22),de&&(w.$i&&(0,I.$XC)(this.X)||w.$j)){const Ee=this.hb.getItem(oe.a);Ee&&this.updateWindowControls({height:Ee})}w.$i&&de&&this.m.hookWindowMessage(278,()=>{const[Re,Ue]=this.m.getPosition(),Oe=P.screen.getCursorScreenPoint(),Be=Oe.x-Re,We=Oe.y-Ue;return(()=>!(Be>30&&We>=0&&We<=Math.max(this.m.getBounds().height*.15,35)))()||(this.m.setEnabled(!1),this.m.setEnabled(!0),this.f.fire({x:Be,y:We})),0}),(w.$j||w.$i)&&je&&(!le||P.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(Ee=>typeof Ee=="number")&&this.m.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),ve&&((0,m.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.s.mode===3&&this.vb(!0),this.m.show(),(0,m.mark)("code/didMaximizeCodeWindow")),this.n=Date.now()}this.P.args["open-devtools"]===!0&&this.m.webContents.openDevTools(),this.pb(),this.Db(),this.jb()}setRepresentedFilename(F){w.$j?this.m.setRepresentedFilename(F):this.z=F}getRepresentedFilename(){return w.$j?this.m.getRepresentedFilename():this.z}setDocumentEdited(F){w.$j&&this.m.setDocumentEdited(F),this.C=F}isDocumentEdited(){return w.$j?this.m.isDocumentEdited():!!this.C}focus(F){w.$j&&F?.force&&P.app.focus({steal:!0}),this.m&&(this.m.isMinimized()&&this.m.restore(),this.m.focus())}setReady(){for(this.N.trace(`window#load: window reported ready (id: ${this.j})`),this.ib=2;this.F.length;)this.F.pop()(this);this.c.fire()}ready(){return new Promise(F=>{if(this.isReady)return F(this);this.F.push(F)})}get isReady(){return this.ib===2}get whenClosedOrLoaded(){return new Promise(F=>{function N(){V.dispose(),Q.dispose(),F()}const V=this.onDidClose(()=>N()),Q=this.onWillLoad(()=>N())})}jb(){this.m.on("unresponsive",()=>this.mb(1)),this.m.webContents.on("render-process-gone",(N,V)=>this.mb(2,{...V})),this.m.webContents.on("did-fail-load",(N,V,Q)=>this.mb(3,{reason:Q,exitCode:V})),this.m.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this.m.on("closed",()=>{this.g.fire(),this.dispose()}),this.m.webContents.on("did-finish-load",()=>{this.L&&(this.r=this.L,this.L=void 0)}),this.m.on("focus",()=>{this.n=Date.now()}),this.m.on("maximize",N=>{this.r&&(this.r.maximized=!0),P.app.emit("browser-window-maximize",N,this.m)}),this.m.on("unmaximize",N=>{this.r&&(this.r.maximized=!1),P.app.emit("browser-window-unmaximize",N,this.m)}),this.m.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.m.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.w?.complete(),this.w=void 0}),this.B(this.X.onDidChangeConfiguration(N=>this.pb(N))),this.B(this.Z.onDidDeleteUntitledWorkspace(N=>this.ob(N)));const F=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:F},async(N,V)=>{const Q=await this.lb();V({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,Q)})})}lb(){return this.kb||(this.kb=(0,o.$3o)(this.eb.version,this.eb,this.P,this.X,this.S,this.U,this.ab)),this.kb}async mb(F,N){switch(F){case 2:this.N.error(`CodeWindow: renderer process gone (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.N.error("CodeWindow: detected unresponsive");break;case 3:this.N.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:F,reason:N?.reason,code:N?.exitCode}),F){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.P.args["enable-smoke-test-driver"]){await this.nb(!1,!1),this.db.quit();return}if(F===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:V,checkboxChecked:Q}=await this.bb.showMessageBox({type:"warning",buttons:[(0,f.localize)(0,null),(0,f.localize)(1,null),(0,f.localize)(2,null)],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),checkboxLabel:this.r?.workspace?(0,f.localize)(5,null):void 0},this.m);if(V!==2){const x=V===0;await this.nb(x,Q)}}else if(F===2){let V;N?V=(0,f.localize)(7,null,N.reason,N.exitCode??"<unknown>"):V=(0,f.localize)(6,null);const{response:Q,checkboxChecked:x}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,f.localize)(8,null):(0,f.localize)(9,null),(0,f.localize)(10,null)],message:V,detail:this.r?.workspace?(0,f.localize)(11,null):(0,f.localize)(12,null),checkboxLabel:this.r?.workspace?(0,f.localize)(13,null):void 0},this.m),ce=Q===0;await this.nb(ce,x)}break}}async nb(F,N){const V=this.r?.workspace;if(N&&V)try{const Q=this.W.workspaceStorage(V);await Q.init(),Q.delete("memento/workbench.parts.editor"),await Q.close()}catch(Q){this.N.error(Q)}if(this.h.fire(),this.m?.destroy(),F&&this.r){let Q,x;(0,p.$Lh)(V)?Q={folderUri:V.uri}:(0,p.$Qh)(V)?Q={workspaceUri:V.configPath}:x=!0,(0,se.$Mb)(await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.P.args,_:[]},urisToOpen:Q?[Q]:void 0,forceEmpty:x,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}ob(F){this.r?.workspace?.id===F.id&&(this.r.workspace=void 0)}pb(F){if(!F||F.affectsConfiguration("window.menuBarVisibility")){const N=this.Ab();N!==this.t&&(this.t=N,this.Bb(N))}if(!F||F.affectsConfiguration("http.proxy")){let N=(this.X.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;N?.endsWith("/")&&(N=N.substr(0,N.length-1));const V=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((N||"").indexOf("@")===-1&&(N!==this.H||V!==this.I)){this.H=N,this.I=V;const Q=N||"",x=V?`${V},<local>`:"<local>";this.N.trace(`Setting proxy to '${Q}', bypassing '${x}'`),this.m.webContents.session.setProxy({proxyRules:Q,proxyBypassRules:x,pacScript:""})}}}addTabbedWindow(F){w.$j&&F.win&&this.m.addTabbedWindow(F.win)}load(F,N=Object.create(null)){this.N.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!N.isReload||!this.$.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.eb.nameLong)),this.qb(F,N),this.ib===0?this.r=F:this.L=F,this.ib=1,this.m.loadURL(h.$2f.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.P.isBuilt?"":"-dev"}.html`).toString(!0));const V=this.M;this.M=!0,!this.P.isBuilt&&!this.P.extensionTestsLocationURI&&this.B(new O.$Sg(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:F.workspace,reason:N.isReload?3:V?2:1})}qb(F,N){const V=(this.r??this.L)?.userEnv;if(V){const Q=(0,r.$Gl)(V)&&!(0,r.$Gl)(F.userEnv),x=this.isExtensionDevelopmentHost;(Q||x)&&(F.userEnv={...V,...F.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(F.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(F["disable-extensions"]=N.disableExtensions),F.fullscreen=this.isFullScreen,F.maximized=this.m.isMaximized(),F.partsSplash=this.Y.getWindowSplash(),(0,m.mark)("code/willOpenNewWindow"),F.perfMarks=(0,m.getMarks)(),this.J.update(F)}async reload(F){const N=Object.assign({},this.r);N.workspace=await this.rb(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&F&&(N.verbose=F.verbose,N.debugId=F.debugId,N.extensionEnvironment=F.extensionEnvironment,N["inspect-extensions"]=F["inspect-extensions"],N["inspect-brk-extensions"]=F["inspect-brk-extensions"],N["extensions-dir"]=F["extensions-dir"]),N.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),N.isInitialStartup=!1,N.policiesData=this.Q.serialize(),N.continueOn=this.P.continueOn,N.profiles={all:this.R.profiles,profile:this.profile||this.R.defaultProfile,home:this.R.profilesHome},N.logLevel=this.O.getLogLevel(),N.loggers={window:this.O.getRegisteredLoggers(this.id),global:this.O.getRegisteredLoggers()},this.load(N,{isReload:!0,disableExtensions:F?.["disable-extensions"]})}async rb(F){if((0,p.$Qh)(F.workspace)){const N=F.workspace.configPath;if(N.scheme===h.Schemas.file&&!await this.S.exists(N))return}else if((0,p.$Lh)(F.workspace)){const N=F.workspace.uri;if(N.scheme===h.Schemas.file&&!await this.S.exists(N))return}return F.workspace}serializeWindowState(){if(!this.m)return(0,L.$s5b)();if(this.isFullScreen){let V;try{V=P.screen.getDisplayMatching(this.getBounds())}catch{}const Q=(0,L.$s5b)();return{mode:3,display:V?V.id:void 0,width:this.s.width||Q.width,height:this.s.height||Q.height,x:this.s.x||0,y:this.s.y||0}}const F=Object.create(null);let N;if(!w.$j&&this.m.isMaximized()?N=0:N=1,N===0?F.mode=0:F.mode=1,N===1||N===0){let V;N===1?V=this.getBounds():V=this.m.getNormalBounds(),F.x=V.x,F.y=V.y,F.width=V.width,F.height=V.height}return F}updateWindowControls(F){if(F.height&&this.hb.setItem(oe.a,F.height),w.$i&&this.D)this.m.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0});else if(w.$j&&F.height!==void 0){const N=(F.height-15)/2;N?this.m.setWindowButtonPosition({x:N,y:N}):this.m.setWindowButtonPosition(null)}}sb(F){(0,m.mark)("code/willRestoreCodeWindowState");let N=!1;if(F)try{const V=P.screen.getAllDisplays();N=V.length>1,F=this.tb(F,V)}catch(V){this.N.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}return(0,m.mark)("code/didRestoreCodeWindowState"),[F||(0,L.$s5b)(),N]}tb(F,N){if(this.N.trace(`window#validateWindowState: validating window state on ${N.length} display(s)`,F),typeof F.x!="number"||typeof F.y!="number"||typeof F.width!="number"||typeof F.height!="number"){this.N.trace("window#validateWindowState: unexpected type of state values");return}if(F.width<=0||F.height<=0){this.N.trace("window#validateWindowState: unexpected negative values");return}if(N.length===1){const x=this.ub(N[0]);if(x){let ce=function(){!F||typeof F.x!="number"||typeof F.y!="number"||!x||(F.x<x.x&&(F.x=x.x),F.y<x.y&&(F.y=x.y))};this.N.trace("window#validateWindowState: 1 monitor working area",x),ce(),F.width>x.width&&(F.width=x.width),F.height>x.height&&(F.height=x.height),F.x>x.x+x.width-128&&(F.x=x.x+x.width-F.width),F.y>x.y+x.height-128&&(F.y=x.y+x.height-F.height),ce()}return F}if(F.display&&F.mode===3){const x=N.find(ce=>ce.id===F.display);if(x&&typeof x.bounds?.x=="number"&&typeof x.bounds?.y=="number"){this.N.trace("window#validateWindowState: restoring fullscreen to previous display");const ce=(0,L.$s5b)(3);return ce.x=x.bounds.x,ce.y=x.bounds.y,ce}}let V,Q;try{V=P.screen.getDisplayMatching({x:F.x,y:F.y,width:F.width,height:F.height}),Q=this.ub(V)}catch{}if(V&&Q&&F.x+F.width>Q.x&&F.y+F.height>Q.y&&F.x<Q.x+Q.width&&F.y<Q.y+Q.height)return this.N.trace("window#validateWindowState: multi-monitor working area",Q),F}ub(F){if(F.workArea.width>0&&F.workArea.height>0)return F.workArea;if(F.bounds.width>0&&F.bounds.height>0)return F.bounds}getBounds(){const[F,N]=this.m.getPosition(),[V,Q]=this.m.getSize();return{x:F,y:N,width:V,height:Q}}toggleFullScreen(){this.vb(!this.isFullScreen)}vb(F){this.zb()?this.wb(F):this.yb(F),this.sendWhenReady(F?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.t&&this.Bb(this.t,!1)}get isFullScreen(){return w.$j&&typeof this.u=="boolean"?this.u:this.m.isFullScreen()||this.m.isSimpleFullScreen()}wb(F){this.m.isSimpleFullScreen()&&this.m.setSimpleFullScreen(!1),this.xb(F)}xb(F){w.$j&&(this.u=F,this.w=new O.$2g,Promise.race([this.w.p,(0,O.$Hg)(1e3)]).finally(()=>this.u=void 0)),this.m.setFullScreen(F)}yb(F){this.m.isFullScreen()&&this.xb(!1),this.m.setSimpleFullScreen(F),this.m.webContents.focus()}zb(){const F=this.X.getValue("window");return!F||typeof F.nativeFullScreen!="boolean"||F.nativeTabs?!0:F.nativeFullScreen!==!1}isMinimized(){return this.m.isMinimized()}Ab(){let F=(0,I.$VC)(this.X);return["visible","toggle","hidden"].indexOf(F)<0&&(F="classic"),F}Bb(F,N=!0){w.$j||(F==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,f.localize)(14,null)),F==="hidden"?setTimeout(()=>{this.Cb(F)}):this.Cb(F))}Cb(F){const N=this.isFullScreen;switch(F){case"classic":this.m.setMenuBarVisibility(!N),this.m.autoHideMenuBar=N;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(w.$j)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.m.minimize();break;case"None":break;case"Maximize":default:this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}else this.m.isMaximized()?this.m.unmaximize():this.m.maximize()}close(){this.m?.close()}sendWhenReady(F,N,...V){this.isReady?this.send(F,...V):this.ready().then(()=>{N.isCancellationRequested||this.send(F,...V)})}send(F,...N){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.N.warn(`Sending IPC message to channel '${F}' for window that is destroyed`);return}try{this.m.webContents.send(F,...N)}catch(V){this.N.warn(`Error sending IPC message to channel '${F}' of window ${this.j}: ${(0,M.$mi)(V)}`)}}}updateTouchBar(F){w.$j&&this.G.forEach((N,V)=>{const Q=F[V];N.segments=this.Fb(Q)})}Db(){if(w.$j){for(let F=0;F<10;F++){const N=this.Eb();this.G.push(N)}this.m.setTouchBar(new P.TouchBar({items:this.G}))}}Eb(F=[]){const N=this.Fb(F),V=new P.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:Q=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:V.segments[Q].id,from:"touchbar"})}});return V}Fb(F=[]){return F.map(V=>{let Q;V.icon&&!a.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===h.Schemas.file&&(Q=P.nativeImage.createFromPath(y.URI.revive(V.icon.dark).fsPath),Q.isEmpty()&&(Q=void 0));let x;return typeof V.title=="string"?x=V.title:x=V.title.value,{id:V.id,label:Q?void 0:x,icon:Q}})}dispose(){super.dispose(),this.O.deregisterLoggers(this.id),this.m=null}};e.$Y6b=J,e.$Y6b=J=oe=ke([_(1,u.$5i),_(2,ae.$A6b),_(3,g.$t5b),_(4,z.$0m),_(5,ee.$B5b),_(6,$.$6j),_(7,i.$F5b),_(8,i.$D5b),_(9,b.$8h),_(10,k.$e6b),_(11,A.$Y5b),_(12,v.$M5b),_(13,n.$9k),_(14,d.$T5b),_(15,E.$v5b),_(16,t.$kj),_(17,l.$k6b),_(18,C.$H5b),_(19,re.$eN)],J)}),define(te[83],ie([0,1,15,23,8,3,46,2,13,4,19,7,21,191,6,20,5,82,97,29,54,33]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r,$,E,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$w6b=e.$v6b=void 0,e.$v6b=(0,v.$Bh)("workspacesHistoryMainService");let l=class extends S.$kc{static{t=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(i,n,a,k){super(),this.f=i,this.g=n,this.h=a,this.j=k,this.c=this.B(new M.$fd),this.onDidChangeRecentlyOpened=this.c.event,this.G=this.B(new s.$Eg(800)),this.m()}m(){this.h.when(4).then(()=>this.H()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],a=[];for(const I of i)if((0,r.$gU)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.u(n,I.workspace)&&n.push(I);else if((0,r.$hU)(I))this.w(n,I.folderUri)||n.push(I);else{const C=this.y(a,I.fileUri),p=I.fileUri.scheme===h.Schemas.file&&t.F.indexOf((0,m.$fg)(I.fileUri))>=0;!C&&!p&&(a.push(I),c.$i&&I.fileUri.scheme===h.Schemas.file&&P.app.addRecentDocument(I.fileUri.fsPath))}const k=await this.n({workspaces:n,files:a});n=k.workspaces,a=k.files,n.length>t.a&&(n.length=t.a),a.length>t.a&&(a.length=t.a),await this.s({workspaces:n,files:a}),this.c.fire(),c.$j&&this.G.trigger(()=>this.M())}async removeRecentlyOpened(i){const n=C=>{const p=this.t(C);for(const A of i)if(m.$_f.isEqual(A,p))return!1;return!0},a=await this.getRecentlyOpened(),k=a.workspaces.filter(n),I=a.files.filter(n);(k.length!==a.workspaces.length||I.length!==a.files.length)&&(await this.s({files:I,workspaces:k}),this.c.fire(),c.$j&&this.G.trigger(()=>this.M()))}async clearRecentlyOpened(){await this.s({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.n()}async n(i){const n=new u.$zi(I=>m.$_f.getComparisonKey(I));if(i?.workspaces)for(const I of i.workspaces)n.set(this.t(I),I);const a=new u.$zi(I=>m.$_f.getComparisonKey(I));if(i?.files)for(const I of i.files)a.set(this.t(I),I);const k=await this.r();for(const I of k.workspaces){const C=n.get(this.t(I));C?C.label=C.label??I.label:n.set(this.t(I),I)}for(const I of k.files){const C=a.get(this.t(I));C?C.label=C.label??I.label:a.set(this.t(I),I)}return{workspaces:[...n.values()],files:[...a.values()]}}async r(){await this.j.whenReady;let i;const n=this.j.get(t.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(a){this.f.error("Unexpected error parsing opened paths list",a)}return(0,r.$nU)(i,this.f)}async s(i){await this.j.whenReady,this.j.store(t.b,JSON.stringify((0,r.$oU)(i)),-1,1)}t(i){return(0,r.$hU)(i)?i.folderUri:(0,r.$iU)(i)?i.fileUri:i.workspace.configPath}u(i,n){return!!i.find(a=>(0,r.$gU)(a)&&a.workspace.id===n.id)}w(i,n){return!!i.find(a=>(0,r.$hU)(a)&&m.$_f.isEqual(a.folderUri,n))}y(i,n){return!!i.find(a=>m.$_f.isEqual(a.fileUri,n))}static{this.z=7}static{this.C=10}static{this.D=7}static{this.F=["COMMIT_EDITMSG","MERGE_MSG"]}async H(){c.$i&&(await this.I(),this.B(this.onDidChangeRecentlyOpened(()=>this.I())))}async I(){if(!c.$i)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const I of P.app.getJumpListSettings().removedItems){const C=I.args;if(C){const p=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(C);p&&n.push(w.URI.parse(p[2]))}}await this.removeRecentlyOpened(n);let a=!1;const k=(0,O.$Fb)((await this.getRecentlyOpened()).workspaces.slice(0,t.D).map(I=>{const C=(0,r.$gU)(I)?I.workspace:I.folderUri,{title:p,description:A}=this.J(C,I.label);let L;return w.URI.isUri(C)?L=`--folder-uri "${C.toString()}"`:(a=!0,L=`--file-uri "${C.configPath.toString()}"`),{type:"task",title:p.substr(0,255),description:A.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));k.length>0&&i.push({type:"custom",name:a?(0,f.localize)(2,null):(0,f.localize)(3,null),items:k})}i.push({type:"recent"});try{const n=P.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}J(i,n){if(n)return{title:(0,D.$qv)(n).name,description:n};if(w.URI.isUri(i))return{title:(0,m.$fg)(i),description:this.L(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,f.localize)(4,null),description:""};let a=(0,m.$fg)(i.configPath);return a.endsWith($.$Xh)&&(a=a.substr(0,a.length-$.$Xh.length-1)),{title:(0,f.localize)(5,null,a),description:this.L(i.configPath)}}L(i){return i.scheme==="file"?(0,D.$iv)(i.fsPath):i.toString()}async M(){if(!c.$j)return;P.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let a=0;for(let I=0;I<i.workspaces.length&&a<t.z;I++){const C=this.t(i.workspaces[I]);if(C.scheme===h.Schemas.file){const p=(0,m.$9f)(C);await y.Promises.exists(p)&&(n.push(p),a++)}}const k=[];for(let I=0;I<i.files.length&&a<t.C;I++){const C=this.t(i.files[I]);if(C.scheme===h.Schemas.file){const p=(0,m.$9f)(C);if(t.F.includes((0,m.$fg)(C))||n.includes(p))continue;await y.Promises.exists(p)&&(k.push(p),a++)}}k.reverse().forEach(I=>P.app.addRecentDocument(I)),n.reverse().forEach(I=>P.app.addRecentDocument(I))}};e.$w6b=l,e.$w6b=l=t=ke([_(0,d.$5i),_(1,E.$Y5b),_(2,b.$v5b),_(3,g.$F5b)],l)}),define(te[303],ie([0,1,15,8,22,46,4,7,179,18,28,20,5,230,67,24,34,25,48,80,30,83]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r,$,E,u){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$x6b=void 0;const l="menu";let o=class{static{t=this}static{this.a="lastKnownMenubarData"}constructor(a,k,I,C,p,A,L,U,z,re,ee){this.n=a,this.o=k,this.p=I,this.q=C,this.r=p,this.s=A,this.t=L,this.u=U,this.v=z,this.w=re,this.x=ee,this.m=Object.create(null),this.g=new O.$Sg(()=>this.E(),0),this.h=new O.$Sg(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$j||(0,$.$WC)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const a=this.t.getItem(t.a);a&&(a.menus&&(this.k=a.menus),a.keybindings&&(this.l=a.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(A,L,U)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.newWindow"]=(A,L,U)=>this.p.openEmptyWindow({context:2,contextWindowId:L?.id}),this.m["workbench.action.files.openFileFolder"]=(A,L,U)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:l}}),this.m["workbench.action.files.openFolder"]=(A,L,U)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:l}}),this.m["workbench.action.openWorkspace"]=(A,L,U)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(U),telemetryExtraData:{from:l}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const a=this.x.youTubeUrl;a&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.Z(a,"openYouTubeUrl"));const k=this.x.requestFeatureUrl;k&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(k,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(I,"openReportIssues"));const C=this.x.licenseUrl;C&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$v){const A=C.indexOf("?")>0?"&":"?";this.Z(`${C}${A}lang=${D.$v}`,"openLicenseUrl")}else this.Z(C,"openLicenseUrl")});const p=this.x.privacyStatementUrl;p&&C&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(p,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(a=>this.F(a)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const a=this.o.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get C(){if(!D.$j)return!1;const a=this.o.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,k){this.k=a.menus,this.l=a.keybindings,this.t.setItem(t.a,a),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(a){D.$j&&(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.d=a.newCount===0,this.D())}G(){D.$j&&(this.f=!P.BrowserWindow.getFocusedWindow(),this.D())}H(){const a=P.Menu.getApplicationMenu();if(a&&this.j.push(a),Object.keys(this.k).length===0){P.Menu.setApplicationMenu(D.$j?new P.Menu:null);return}const k=new P.Menu;let I;if(D.$j){const p=new P.Menu;I=new P.MenuItem({label:this.x.nameShort,submenu:p}),this.I(p),k.append(I)}if(D.$j&&!this.c){this.c=!0;const p=new P.Menu;p.append(new P.MenuItem({label:this.ab(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(p)}if(this.K("File")){const p=new P.Menu,A=new P.MenuItem({label:this.ab(h.localize(1,null)),submenu:p});this.M(p,"File"),k.append(A)}if(this.K("Edit")){const p=new P.Menu,A=new P.MenuItem({label:this.ab(h.localize(2,null)),submenu:p});this.M(p,"Edit"),k.append(A)}if(this.K("Selection")){const p=new P.Menu,A=new P.MenuItem({label:this.ab(h.localize(3,null)),submenu:p});this.M(p,"Selection"),k.append(A)}if(this.K("View")){const p=new P.Menu,A=new P.MenuItem({label:this.ab(h.localize(4,null)),submenu:p});this.M(p,"View"),k.append(A)}if(this.K("Go")){const p=new P.Menu,A=new P.MenuItem({label:this.ab(h.localize(5,null)),submenu:p});this.M(p,"Go"),k.append(A)}if(this.K("Run")){const p=new P.Menu,A=new P.MenuItem({label:this.ab(h.localize(6,null)),submenu:p});this.M(p,"Run"),k.append(A)}if(this.K("Terminal")){const p=new P.Menu,A=new P.MenuItem({label:this.ab(h.localize(7,null)),submenu:p});this.M(p,"Terminal"),k.append(A)}let C;if(this.K("Window")){const p=new P.Menu;C=new P.MenuItem({label:this.ab(h.localize(8,null)),submenu:p,role:"window"}),this.S(p)}if(C&&k.append(C),this.K("Help")){const p=new P.Menu,A=new P.MenuItem({label:this.ab(h.localize(9,null)),submenu:p,role:"help"});this.M(p,"Help"),k.append(A)}k.items&&k.items.length>0?P.Menu.setApplicationMenu(k):P.Menu.setApplicationMenu(null),this.h.schedule()}I(a){const k=this.U(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.T();let C;if(this.K("Preferences")){const ae=new P.Menu;this.M(ae,"Preferences"),C=new P.MenuItem({label:this.ab(h.localize(11,null)),submenu:ae})}const p=new P.Menu,A=new P.MenuItem({label:h.localize(12,null),role:"services",submenu:p}),L=new P.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),U=new P.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),z=new P.MenuItem({label:h.localize(15,null),role:"unhide"}),re=new P.MenuItem(this.Y("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(ae,se,oe)=>{const G=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||G?.isMinimized())&&await this.J(oe)&&this.w.quit(void 0)}})),ee=[k];ee.push(...I),C&&ee.push(i(),C),ee.push(i(),A,i(),L,U,z,i(),re),ee.forEach(ae=>a.append(ae))}async J(a){if(this.p.getWindowCount()===0)return!0;const k=this.o.getValue("window.confirmBeforeClose");if(k==="always"||k==="keyboardOnly"&&this.Q(a)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return I===0}return!0}K(a){if(!D.$j&&(0,$.$WC)(this.o)==="custom")return!1;switch(a){case"File":case"Help":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[a];case"Window":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[a]}}L(a,k){k.forEach(I=>{if((0,f.$s6b)(I))a.append(i());else if((0,f.$r6b)(I)){const C=new P.Menu,p=new P.MenuItem({label:this.ab(I.label),submenu:C});this.L(C,I.submenu.items),a.append(p)}else(0,f.$t6b)(I)?a.append(this.O(I)):(0,f.$u6b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.N(a),D.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?a.append(new P.MenuItem(this.Y(I.id,{label:this.ab(I.label),click:this.m[I.id]}))):a.append(this.U(I.label,I.id,!1,I.checked)):a.append(this.U(I.label,I.id,I.enabled!==!1,!!I.checked)):a.append(this.U(I.label,I.id,I.enabled!==!1,!!I.checked)))})}M(a,k){this.k&&this.k[k]&&this.L(a,this.k[k].items)}N(a){const k=this.T();k.length&&(k.forEach(I=>a.append(I)),a.append(i()))}O(a){const k=S.URI.revive(a.uri),I=a.id,C=I==="openRecentFile"?{fileUri:k}:I==="openRecentWorkspace"?{workspaceUri:k}:{folderUri:k};return new P.MenuItem(this.Y(I,{label:a.label,click:async(p,A,L)=>{const U=this.P(L);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[C],forceNewWindow:U,gotoLineMode:!1,remoteAuthority:a.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([k])}},!1))}P(a){return!!(a&&(!D.$j&&(a.ctrlKey||a.shiftKey)||D.$j&&(a.metaKey||a.altKey)))}Q(a){return!!(a.triggeredByAccelerator||a.altKey||a.ctrlKey||a.metaKey||a.shiftKey)}R(a,k,I){const C={label:this.ab(a),role:I,enabled:!0};return new P.MenuItem(this.X(k,C))}S(a){const k=new P.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new P.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),C=new P.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),p=this.U(h.localize(23,null),"workbench.action.switchWindow"),A=[];this.C&&(A.push(i()),A.push(this.U(h.localize(24,null),"workbench.action.newWindowTab")),A.push(this.R(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.R(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.R(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.R(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[k,I,i(),p,...A,i(),C].forEach(L=>a.append(L))}T(){switch(this.n.state.type){case"idle":return[new P.MenuItem({label:this.ab(h.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.ab(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.ab(h.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.ab(h.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(a,k,I,C){const p=this.ab(a),A=typeof k=="function"?k:(ee,ae,se)=>{const oe=ee?ee.userSettingsLabel:null;let G=k;Array.isArray(k)&&(G=this.P(se)?k[1]:k[0]),oe&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:oe}):this.W({type:"commandId",commandId:G})},L=typeof I=="boolean"?I:this.p.getWindowCount()>0,U=typeof C=="boolean"?C:!1,z={label:p,click:A,enabled:L};U&&(z.type="checkbox",z.checked=U);let re;return typeof k=="string"?re=k:Array.isArray(k)&&(re=k[0]),D.$j&&(re==="editor.action.clipboardCutAction"?z.role="cut":re==="editor.action.clipboardCopyAction"?z.role="copy":re==="editor.action.clipboardPasteAction"&&(z.role="paste"),re==="undo"?z.click=this.V(A,{inDevTools:ee=>ee.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?z.click=this.V(A,{inDevTools:ee=>ee.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(z.click=this.V(A,{inDevTools:ee=>ee.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.X(re,z))}V(a,k){return(I,C,p)=>{const A=P.BrowserWindow.getFocusedWindow();if(!A)return k.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return k.inDevTools(A.webContents.devToolsWebContents);a(I,C||A,p)}}W(a){let k=P.BrowserWindow.getFocusedWindow();if(!k){const C=this.p.getLastActiveWindow();C?.isMinimized()&&(k=C.win)}const I=k?this.p.getWindowById(k.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",a),D.$j&&!this.q.isBuilt&&!I.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const C={id:a.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,C)}else{const C={userSettingsLabel:a.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,C)}}else this.v.trace("menubar#runActionInRenderer: no active window found",a)}X(a,k){const I=typeof a=="string"?this.l[a]:void 0;if(I?.label){if(I.isNative!==!1)k.accelerator=I.label,k.userSettingsLabel=I.userSettingsLabel;else if(typeof k.label=="string"){const C=k.label.indexOf("[");C>=0?k.label=`${k.label.substr(0,C)} [${I.label}]`:k.label=`${k.label} [${I.label}]`}}else k.accelerator=void 0;return k}Y(a,k,I=!k.accelerator){I&&(k=this.X(a,k));const C=k.click;return k.click=(p,A,L)=>{this.$(a),C?.(p,A,L)},k}Z(a,k){this.w.openExternal(void 0,a),this.$(k)}$(a){this.r.publicLog2("workbenchActionExecuted",{id:a,from:l})}ab(a){return(0,M.$nv)(a,!this.B)}};e.$x6b=o,e.$x6b=o=t=ke([_(0,r.$UT),_(1,c.$8h),_(2,E.$H5b),_(3,m.$t5b),_(4,g.$9k),_(5,u.$v6b),_(6,d.$eN),_(7,w.$v5b),_(8,y.$5i),_(9,v.$i6b),_(10,b.$kj)],o);function i(){return new P.MenuItem({type:"separator"})}}),define(te[304],ie([0,1,6,20,5,303]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z6b=e.$y6b=void 0,e.$y6b=(0,P.$Bh)("menubarMainService");let D=class{constructor(h,c,m){this.b=h,this.c=c,this.d=m,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$x6b)}async updateMenubar(h,c){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(c,h)}};e.$z6b=D,e.$z6b=D=ke([_(0,P.$Ah),_(1,O.$v5b),_(2,s.$5i)],D)}),define(te[305],ie([0,1,15,21,130,27,23,22,3,32,49,46,2,13,9,65,4,35,19,12,7,189,64,18,60,28,16,6,20,5,77,78,59,34,80,302,129,298,29,98,83,54,79,39,53,66]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r,$,E,u,t,l,o,i,n,a,k,I,C,p,A,L,U,z,re,ee,ae,se,oe,G,J,q,F,N){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$36b=void 0;function Q(Y){return(0,ae.$Qh)(Y?.workspace)}function x(Y){return(0,ae.$Lh)(Y?.workspace)}let ce=class extends y.$kc{static{V=this}static{this.a=[]}constructor(R,j,W,T,H,B,ne,fe,ge,ue,we,me,Se,Ie,je,ve,be,X){super(),this.m=R,this.n=j,this.r=W,this.s=T,this.t=H,this.u=B,this.w=ne,this.z=fe,this.C=ge,this.D=ue,this.F=we,this.G=me,this.H=Se,this.I=Ie,this.J=je,this.L=ve,this.M=be,this.N=X,this.b=this.B(new h.$fd),this.onDidOpenWindow=this.b.event,this.c=this.B(new h.$fd),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new h.$fd),this.onDidDestroyWindow=this.f.event,this.g=this.B(new h.$fd),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new h.$fd),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ee.$Z6b(this,this.t,this.C,this.r,this.F)),this.O()}O(){this.B(this.H.onDidEnterWorkspace(R=>this.c.fire(R.window))),this.B(this.onDidSignalReadyWindow(R=>{if(R.config?.extensionDevelopmentPath||R.config?.extensionTestsPath){const j=new y.$jc;if(j.add(h.Event.any(R.onDidClose,R.onDidDestroy)(()=>j.dispose())),R.config.extensionDevelopmentPath)for(const W of R.config.extensionDevelopmentPath)j.add(this.M.addValidFileRoot(W));R.config.extensionTestsPath&&j.add(this.M.addValidFileRoot(R.config.extensionTestsPath))}}))}openEmptyWindow(R,j){const W=this.w.args,T=j?.remoteAuthority||void 0,H=!0,B=j?.forceReuseWindow,ne=!B;return this.open({...R,cli:W,forceEmpty:H,forceNewWindow:ne,forceReuseWindow:B,remoteAuthority:T})}openExistingWindow(R,j){R.focus(),this.P(j,[R])}async open(R){this.r.trace("windowsManager#open"),R.addMode&&(R.initialStartup||!this.getLastActiveWindow())&&(R.addMode=!1);const j=[],W=[],T=[],H=[],B=[];let ne,fe=0;const ge=await this.X(R);this.r.trace("windowsManager#open pathsToOpen",ge);for(const Ie of ge)x(Ie)?R.addMode?j.push(Ie):W.push(Ie):Q(Ie)?T.push(Ie):Ie.fileUri?(ne||(ne={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ie.remoteAuthority}),ne.filesToOpenOrCreate.push(Ie)):Ie.backupPath?B.push({backupFolder:(0,v.$ae)(Ie.backupPath),remoteAuthority:Ie.remoteAuthority}):fe++;R.diffMode&&ne&&ne.filesToOpenOrCreate.length>=2&&(ne.filesToDiff=ne.filesToOpenOrCreate.slice(0,2),ne.filesToOpenOrCreate=[]),R.mergeMode&&ne&&ne.filesToOpenOrCreate.length===4&&(ne.filesToMerge=ne.filesToOpenOrCreate.slice(0,4),ne.filesToOpenOrCreate=[],ne.filesToDiff=[]),ne&&R.waitMarkerFileURI&&(ne.filesToWait={paths:(0,D.$Fb)([...ne.filesToDiff,ne.filesToMerge[3],...ne.filesToOpenOrCreate]),waitMarkerFileUri:R.waitMarkerFileURI}),R.initialStartup?(H.push(...this.H.getUntitledWorkspaces()),T.push(...H),B.push(...this.D.getEmptyWindowBackups())):B.length=0;const{windows:ue,filesOpenedInWindow:we}=await this.Q(R,T,W,B,fe,ne,j);if(this.r.trace(`windowsManager#open used window count ${ue.length} (workspacesToOpen: ${T.length}, foldersToOpen: ${W.length}, emptyToRestore: ${B.length}, emptyToOpen: ${fe})`),ue.length>1)if(we)we.focus();else{const Ie=this.j.state.lastActiveWindow&&!R.forceEmpty&&!R.cli._.length&&!R.cli["file-uri"]&&!R.cli["folder-uri"]&&!(R.urisToOpen&&R.urisToOpen.length);let je=!0,ve=!0;if(Ie){const be=ue.filter(X=>this.j.state.lastActiveWindow&&X.backupPath===this.j.state.lastActiveWindow.backupPath);be.length&&(be[0].focus(),je=!1,ve=!1)}if(je)for(let be=ue.length-1;be>=0;be--){const X=ue[be];if(!(X.openedWorkspace&&H.some(le=>X.openedWorkspace&&le.workspace.id===X.openedWorkspace.id)||X.backupPath&&B.some(le=>X.backupPath&&le.backupFolder===(0,v.$ae)(X.backupPath)))){X.focus(),ve=!1;break}}ve&&ue[ue.length-1].focus()}const me=ne&&ne.filesToDiff.length>0,Se=ne&&ne.filesToMerge.length>0;if(!ue.some(Ie=>Ie.isExtensionDevelopmentHost)&&!me&&!Se&&!R.noRecentEntry){const Ie=[];for(const je of ge)Q(je)&&!je.transient?Ie.push({label:je.label,workspace:je.workspace,remoteAuthority:je.remoteAuthority}):x(je)?Ie.push({label:je.label,folderUri:je.workspace.uri,remoteAuthority:je.remoteAuthority}):je.fileUri&&Ie.push({label:je.label,fileUri:je.fileUri,remoteAuthority:je.remoteAuthority});this.G.addRecentlyOpened(Ie)}return this.P(R,ue),ue}P(R,j){const W=R.waitMarkerFileURI;R.context===0&&W&&j.length===1&&j[0]&&(async()=>{await j[0].whenClosedOrLoaded;try{await this.L.del(W)}catch{}})()}async Q(R,j,W,T,H,B,ne){const fe=[];let ge;function ue(be,X){fe.push(be),X&&(ge=be,B=void 0)}let{openFolderInNewWindow:we,openFilesInNewWindow:me}=this.ib(R);if(!R.initialStartup&&ne.length>0){const be=ne[0].remoteAuthority,X=this.nb(be);X&&ue(this.S(X,ne.map(le=>le.workspace.uri)))}const Se=W.length+j.length+T.length;if(B&&Se===0){const be=B.filesToOpenOrCreate[0]||B.filesToDiff[0]||B.filesToMerge[3],X=this.getWindows().filter(de=>B&&(0,r.$ng)(de.remoteAuthority,B.remoteAuthority));let le;be?.fileUri&&!me&&((R.context===4||R.context===0||R.context===1)&&(le=await(0,re.$V5b)(X,be.fileUri,async de=>de.configPath.scheme===f.Schemas.file?this.H.resolveLocalWorkspace(de.configPath):void 0)),le||(le=this.ob(X))),le?(0,ae.$Qh)(le.openedWorkspace)?j.push({workspace:le.openedWorkspace,remoteAuthority:le.remoteAuthority}):(0,ae.$Lh)(le.openedWorkspace)?W.push({workspace:le.openedWorkspace,remoteAuthority:le.remoteAuthority}):ue(this.R(R,le,B),!0):ue(await this.jb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:R.forceNewTabbedWindow,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile}),!0)}const Ie=(0,D.$Kb)(j,be=>be.workspace.id);if(Ie.length>0){const be=(0,D.$Fb)(Ie.map(X=>(0,re.$W5b)(this.getWindows(),X.workspace.configPath)));if(be.length>0){const X=be[0],le=(0,r.$ng)(B?.remoteAuthority,X.remoteAuthority)?B:void 0;ue(this.R(R,X,le),!!le),we=!0}for(const X of Ie){if(be.some(Ee=>Ee.openedWorkspace&&Ee.openedWorkspace.id===X.workspace.id))continue;const le=X.remoteAuthority,de=(0,r.$ng)(B?.remoteAuthority,le)?B:void 0;ue(await this.W(R,X,we,de),!!de),we=!0}}const je=(0,D.$Kb)(W,be=>r.$_f.getComparisonKey(be.workspace.uri));if(je.length>0){const be=(0,D.$Fb)(je.map(X=>(0,re.$W5b)(this.getWindows(),X.workspace.uri)));if(be.length>0){const X=be[0],le=(0,r.$ng)(B?.remoteAuthority,X.remoteAuthority)?B:void 0;ue(this.R(R,X,le),!!le),we=!0}for(const X of je){if(be.some(Ee=>(0,ae.$Lh)(Ee.openedWorkspace)&&r.$_f.isEqual(Ee.openedWorkspace.uri,X.workspace.uri)))continue;const le=X.remoteAuthority,de=(0,r.$ng)(B?.remoteAuthority,le)?B:void 0;ue(await this.W(R,X,we,de),!!de),we=!0}}const ve=(0,D.$Kb)(T,be=>be.backupFolder);if(ve.length>0)for(const be of ve){const X=be.remoteAuthority,le=(0,r.$ng)(B?.remoteAuthority,X)?B:void 0;ue(await this.U(R,!0,X,le,be),!!le),we=!0}if(fe.length===0||B){B&&!H&&H++;const be=B?B.remoteAuthority:R.remoteAuthority;for(let X=0;X<H;X++)ue(await this.U(R,we,be,B),!!B),we=!0}return{windows:(0,D.$Kb)(fe),filesOpenedInWindow:ge}}R(R,j,W){this.r.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:W}),j.focus();const T={filesToOpenOrCreate:W?.filesToOpenOrCreate,filesToDiff:W?.filesToDiff,filesToMerge:W?.filesToMerge,filesToWait:W?.filesToWait,termProgram:R?.userEnv?.TERM_PROGRAM};return j.sendWhenReady("vscode:openFiles",S.CancellationToken.None,T),j}S(R,j){this.r.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:j}),R.focus();const W={foldersToAdd:j};return R.sendWhenReady("vscode:addFolders",S.CancellationToken.None,W),R}U(R,j,W,T,H){this.r.trace("windowsManager#doOpenEmpty",{restore:!!H,remoteAuthority:W,filesToOpen:T,forceNewWindow:j});let B;return!j&&typeof R.contextWindowId=="number"&&(B=this.getWindowById(R.contextWindowId)),this.jb({userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:W,forceNewWindow:j,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:T,windowToUse:B,emptyWindowBackupInfo:H,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}W(R,j,W,T,H){return this.r.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:j,filesToOpen:T}),!W&&!H&&typeof R.contextWindowId=="number"&&(H=this.getWindowById(R.contextWindowId)),this.jb({workspace:j.workspace,userEnv:R.userEnv,cli:R.cli,initialStartup:R.initialStartup,remoteAuthority:j.remoteAuthority,forceNewWindow:W,forceNewTabbedWindow:R.forceNewTabbedWindow,filesToOpen:T,windowToUse:H,forceProfile:R.forceProfile,forceTempProfile:R.forceTempProfile})}async X(R){let j,W=!1,T=!1;if(R.urisToOpen&&R.urisToOpen.length>0?(j=await this.Y(R),W=!0):R.forceEmpty?j=[Object.create(null)]:R.cli._.length||R.cli["folder-uri"]||R.cli["file-uri"]?(j=await this.Z(R.cli),j.length===0&&j.push(Object.create(null)),W=!0):(j=await this.ab(),j.length===0&&j.push(Object.create(null)),T=!0),!R.addMode&&W){const H=j.filter(B=>x(B));if(H.length>1){const B=H[0].remoteAuthority;if(H.every(ne=>(0,r.$ng)(ne.remoteAuthority,B))){const ne=await this.H.createUntitledWorkspace(H.map(fe=>({uri:fe.workspace.uri})));j.push({workspace:ne,remoteAuthority:B}),j=j.filter(fe=>!x(fe))}}}if(R.initialStartup&&!T&&this.F.getValue("window")?.restoreWindows==="preserve"){const H=await this.ab();j.unshift(...H.filter(B=>Q(B)||x(B)||B.backupPath))}return j}async Y(R){const j={gotoLineMode:R.gotoLineMode,remoteAuthority:R.remoteAuthority},W=await Promise.all((0,D.$Fb)(R.urisToOpen||[]).map(async T=>{const H=await this.cb(T,j);if(H)return H.label=T.label,H;const B=this.eb(T);this.J.showMessageBox({type:"info",buttons:[(0,u.localize)(0,null)],message:B.scheme===f.Schemas.file?(0,u.localize)(1,null):(0,u.localize)(2,null),detail:B.scheme===f.Schemas.file?(0,u.localize)(3,null,(0,w.$hv)(B,{os:d.OS,tildify:this.w})):(0,u.localize)(4,null,B.toString(!0))},P.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$Fb)(W)}async Z(R){const j=[],W={ignoreFileNotFound:!0,gotoLineMode:R.goto,remoteAuthority:R.remote||void 0,forceOpenWorkspaceAsFile:R.diff&&R._.length===2||R.merge&&R._.length===4},T=R["folder-uri"];if(T){const ne=await Promise.all(T.map(fe=>{const ge=this.$(fe);if(ge)return this.cb({folderUri:ge},W)}));j.push(...(0,D.$Fb)(ne))}const H=R["file-uri"];if(H){const ne=await Promise.all(H.map(fe=>{const ge=this.$(fe);if(ge)return this.cb((0,ae.$7h)(fe)?{workspaceUri:ge}:{fileUri:ge},W)}));j.push(...(0,D.$Fb)(ne))}const B=await Promise.all(R._.map(ne=>W.remoteAuthority?this.hb(ne,W):this.fb(ne,W)));return j.push(...(0,D.$Fb)(B)),j}$(R){try{const j=E.URI.parse(R);if(!j.scheme){this.r.error(`Invalid URI input string, scheme missing: ${R}`);return}return j.path?j:j.with({path:"/"})}catch(j){this.r.error(`Invalid URI input string: ${R}, ${j.message}`)}}async ab(){const R=this.bb();switch(R){case"none":return[];case"one":case"all":case"preserve":case"folders":{const j=[];R!=="one"&&j.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&j.push(this.j.state.lastActiveWindow);const W=await Promise.all(j.map(async T=>{if(T.workspace){const H=await this.cb({workspaceUri:T.workspace.configPath},{remoteAuthority:T.remoteAuthority,rejectTransientWorkspaces:!0});if(Q(H))return H}else if(T.folderUri){const H=await this.cb({folderUri:T.folderUri},{remoteAuthority:T.remoteAuthority});if(x(H))return H}else if(R!=="folders"&&T.backupPath)return{backupPath:T.backupPath,remoteAuthority:T.remoteAuthority}}));return(0,D.$Fb)(W)}}}bb(){let R;return this.C.wasRestarted?R="all":(R=this.F.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(R)||(R="all")),R}async cb(R,j=Object.create(null)){const W=this.eb(R);return W.scheme===f.Schemas.file?((0,U.$UC)(R)&&(j={...j,forceOpenWorkspaceAsFile:!0}),this.fb(W.fsPath,j)):this.db(R,j)}db(R,j){let W=this.eb(R);const T=(0,A.$Ok)(W)||j.remoteAuthority;if(W=(0,r.$pg)((0,r.$jg)(W)),(0,U.$UC)(R)){if(j.gotoLineMode){const{path:H,line:B,column:ne}=(0,c.$Pf)(W.path);return{fileUri:W.with({path:H}),options:{selection:B?{startLineNumber:B,startColumn:ne||1}:void 0},remoteAuthority:T}}return{fileUri:W,remoteAuthority:T}}else if((0,U.$SC)(R))return{workspace:(0,se.$O5b)(W),remoteAuthority:T};return{workspace:(0,se.$P5b)(W),remoteAuthority:T}}eb(R){return(0,U.$SC)(R)?R.workspaceUri:(0,U.$TC)(R)?R.folderUri:R.fileUri}async fb(R,j,W){let T,H;j.gotoLineMode&&({path:R,line:T,column:H}=(0,c.$Pf)(R)),R=(0,c.$Kf)((0,v.$7d)(R),(0,g.cwd)());try{const B=await O.Promises.stat(R);if(B.isFile()){if(!j.forceOpenWorkspaceAsFile){const ne=await this.H.resolveLocalWorkspace(E.URI.file(R));if(ne)return ne.transient&&j.rejectTransientWorkspaces?void 0:{workspace:{id:ne.id,configPath:ne.configPath},type:n.FileType.File,exists:!0,remoteAuthority:ne.remoteAuthority,transient:ne.transient}}return{fileUri:E.URI.file(R),type:n.FileType.File,exists:!0,options:{selection:T?{startLineNumber:T,startColumn:H||1}:void 0}}}else{if(B.isDirectory())return{workspace:(0,se.$P5b)(E.URI.file(R),B),type:n.FileType.Directory,exists:!0};if(!d.$i&&R==="/dev/null")return{fileUri:E.URI.file(R),type:n.FileType.File,exists:!0}}}catch(B){if(B.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!W)return this.gb(R,j);const ne=E.URI.file(R);if(this.G.removeRecentlyOpened([ne]),j.ignoreFileNotFound)return{fileUri:ne,type:n.FileType.File,exists:!1}}}async gb(R,j){const W=E.URI.file(R),{response:T,checkboxChecked:H}=await this.J.showMessageBox({type:"warning",buttons:[(0,u.localize)(5,null),(0,u.localize)(6,null),(0,u.localize)(7,null)],message:(0,u.localize)(8,null,W.authority),detail:(0,u.localize)(9,null,(0,w.$hv)(W,{os:d.OS,tildify:this.w})),checkboxLabel:(0,u.localize)(10,null,W.authority),cancelId:1});if(T===0)return(0,s.addUNCHostToAllowlist)(W.authority),H&&this.B(h.Event.once(this.onDidOpenWindow)(B=>{B.sendWhenReady("vscode:configureAllowedUNCHost",S.CancellationToken.None,W.authority)})),this.fb(R,j,!0);if(T===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.gb(R,j)}hb(R,j){const W=R.charCodeAt(0),T=j.remoteAuthority;let H,B;j.gotoLineMode&&({path:R,line:H,column:B}=(0,c.$Pf)(R)),W!==47&&((0,c.$Jf)(W)&&R.charCodeAt(R.charCodeAt(1))===58&&(R=(0,c.$Cf)(R)),R=`/${R}`);const ne=E.URI.from({scheme:f.Schemas.vscodeRemote,authority:T,path:R});if(R.charCodeAt(R.length-1)!==47){if((0,ae.$7h)(R))return j.forceOpenWorkspaceAsFile?{fileUri:ne,options:{selection:H?{startLineNumber:H,startColumn:B||1}:void 0},remoteAuthority:j.remoteAuthority}:{workspace:(0,se.$O5b)(ne),remoteAuthority:T};if(j.gotoLineMode||v.$6d.basename(R).indexOf(".")!==-1)return{fileUri:ne,options:{selection:H?{startLineNumber:H,startColumn:B||1}:void 0},remoteAuthority:T}}return{workspace:(0,se.$P5b)(ne),remoteAuthority:T}}ib(R){const j=this.F.getValue("window"),W=j?.openFoldersInNewWindow||"default",T=j?.openFilesInNewWindow||"off";let H=(R.preferNewWindow||R.forceNewWindow)&&!R.forceReuseWindow;!R.forceNewWindow&&!R.forceReuseWindow&&(W==="on"||W==="off")&&(H=W==="on");let B=!1;return R.forceNewWindow||R.forceReuseWindow?B=!!R.forceNewWindow&&!R.forceReuseWindow:(d.$j?R.context===1&&(B=!0):R.context!==3&&R.context!==2&&!(R.userEnv&&R.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!R.cli.extensionDevelopmentPath&&(T==="on"||T==="off")&&(B=T==="on")),{openFolderInNewWindow:!!H,openFilesInNewWindow:B}}async openExtensionDevelopmentHostWindow(R,j){const W=(0,re.$X5b)(this.getWindows(),R);if(W)return this.C.reload(W,j.cli),W.focus(),[W];let T=j.cli["folder-uri"]||[],H=j.cli["file-uri"]||[],B=j.cli._;if(!B.length&&!T.length&&!H.length&&!j.cli.extensionTestsPath){const ge=this.j.state.lastPluginDevelopmentHostWindow,ue=ge?.workspace??ge?.folderUri;ue&&(E.URI.isUri(ue)?ue.scheme===f.Schemas.file?B=[ue.fsPath]:T=[ue.toString()]:ue.configPath.scheme===f.Schemas.file?B=[(0,r.$9f)(ue.configPath)]:H=[ue.configPath.toString()])}let ne=j.remoteAuthority;for(const ge of R)if(ge.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ue=E.URI.parse(ge),we=(0,A.$Ok)(ue);we&&(ne?(0,r.$ng)(we,ne)||this.r.error("more than one extension development path authority"):ne=we)}B=B.filter(ge=>{const ue=E.URI.file(ge);return(0,re.$W5b)(this.getWindows(),ue)?!1:(0,r.$ng)((0,A.$Ok)(ue),ne)}),T=T.filter(ge=>{const ue=this.$(ge);return ue&&(0,re.$W5b)(this.getWindows(),ue)?!1:ue?(0,r.$ng)((0,A.$Ok)(ue),ne):!1}),H=H.filter(ge=>{const ue=this.$(ge);return ue&&(0,re.$W5b)(this.getWindows(),ue)?!1:ue?(0,r.$ng)((0,A.$Ok)(ue),ne):!1}),j.cli._=B,j.cli["folder-uri"]=T,j.cli["file-uri"]=H;const fe={context:j.context,cli:j.cli,forceNewWindow:!0,forceEmpty:!B.length&&!T.length&&!H.length,userEnv:j.userEnv,noRecentEntry:!0,waitMarkerFileURI:j.waitMarkerFileURI,remoteAuthority:ne,forceProfile:j.forceProfile,forceTempProfile:j.forceTempProfile};return this.open(fe)}async jb(R){const j=this.F.getValue("window"),W=this.getLastActiveWindow(),T=W?.profile??this.z.defaultProfile;let H;!R.forceNewWindow&&!R.forceNewTabbedWindow&&(H=R.windowToUse||W,H&&H.focus());const B={...this.w.args,...R.cli,machineId:this.m,windowId:-1,mainPid:process.pid,appRoot:this.w.appRoot,execPath:process.execPath,codeCachePath:this.w.codeCachePath,backupPath:R.emptyWindowBackupInfo?(0,v.$9d)(this.w.backupHome,R.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.z.profilesHome,all:this.z.profiles,profile:T},homeDir:this.w.userHome.with({scheme:f.Schemas.file}).fsPath,tmpDir:this.w.tmpDir.with({scheme:f.Schemas.file}).fsPath,userDataDir:this.w.userDataPath,remoteAuthority:R.remoteAuthority,workspace:R.workspace,userEnv:{...this.n,...R.userEnv},filesToOpenOrCreate:R.filesToOpen?.filesToOpenOrCreate,filesToDiff:R.filesToOpen?.filesToDiff,filesToMerge:R.filesToOpen?.filesToMerge,filesToWait:R.filesToOpen?.filesToWait,logLevel:this.s.getLogLevel(),loggers:{window:[],global:this.s.getRegisteredLoggers()},logsPath:this.w.logsHome.with({scheme:f.Schemas.file}).fsPath,product:C.default,isInitialStartup:R.initialStartup,perfMarks:(0,b.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)(),arch:(0,M.arch)()},zoomLevel:typeof j?.zoomLevel=="number"?j.zoomLevel:void 0,autoDetectHighContrast:j?.autoDetectHighContrast??!0,autoDetectColorScheme:j?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.N.getColorScheme(),policiesData:this.u.serialize(),continueOn:this.w.continueOn};if(H){const ne=H.config;!B.extensionDevelopmentPath&&ne?.extensionDevelopmentPath&&(B.extensionDevelopmentPath=ne.extensionDevelopmentPath,B.extensionDevelopmentKind=ne.extensionDevelopmentKind,B["enable-proposed-api"]=ne["enable-proposed-api"],B.verbose=ne.verbose,B["inspect-extensions"]=ne["inspect-extensions"],B["inspect-brk-extensions"]=ne["inspect-brk-extensions"],B.debugId=ne.debugId,B.extensionEnvironment=ne.extensionEnvironment,B["extensions-dir"]=ne["extensions-dir"],B["disable-extensions"]=ne["disable-extensions"]),B.loggers={global:B.loggers.global,window:ne?.loggers.window??B.loggers.window}}else{const ne=this.j.getNewWindowState(B);(0,b.mark)("code/willCreateCodeWindow");const fe=H=this.I.createInstance(z.$Y6b,{state:ne,extensionDevelopmentPath:B.extensionDevelopmentPath,isExtensionTestHost:!!B.extensionTestsPath});(0,b.mark)("code/didCreateCodeWindow"),R.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(fe),V.a.push(fe),this.b.fire(fe),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,m.$bb)(fe.onDidSignalReady)(()=>this.c.fire(fe)),(0,m.$bb)(fe.onDidClose)(()=>this.mb(fe)),(0,m.$bb)(fe.onDidDestroy)(()=>this.f.fire(fe)),fe.onDidTriggerSystemContextMenu(({x:ue,y:we})=>this.h.fire({window:fe,x:ue,y:we}));const ge=(0,$.$uf)(fe.win?.webContents);ge.removeAllListeners("devtools-reload-page"),ge.on("devtools-reload-page",()=>this.C.reload(fe)),this.C.registerWindow(fe)}return B.windowId=H.id,H.isReady?this.C.unload(H,4).then(async ne=>{ne||await this.kb(H,B,R,T)}):await this.kb(H,B,R,T),H}async kb(R,j,W,T){if(j.extensionDevelopmentPath||((0,ae.$Qh)(j.workspace)?j.backupPath=this.D.registerWorkspaceBackup({workspace:j.workspace,remoteAuthority:j.remoteAuthority}):(0,ae.$Lh)(j.workspace)?j.backupPath=this.D.registerFolderBackup({folderUri:j.workspace.uri,remoteAuthority:j.remoteAuthority}):j.backupPath=this.D.registerEmptyWindowBackup({backupFolder:W.emptyWindowBackupInfo?.backupFolder??(0,se.$Q5b)().id,remoteAuthority:j.remoteAuthority})),this.z.isEnabled()){const H=j.workspace??(0,ae.$Ph)(j.backupPath,!1),B=this.lb(W,H,T),ne=B instanceof Promise?await B:B;j.profiles.profile=ne,j.extensionDevelopmentPath||await this.z.setProfileForWorkspace(H,ne)}R.load(j)}lb(R,j,W){return R.forceProfile?this.z.profiles.find(T=>T.name===R.forceProfile)??this.z.createNamedProfile(R.forceProfile):R.forceTempProfile?this.z.createTransientProfile():this.z.getProfileForWorkspace(j)??W}mb(R){const j=V.a.indexOf(R);V.a.splice(j,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const R=P.BrowserWindow.getFocusedWindow();if(R)return this.getWindowById(R.id)}getLastActiveWindow(){return this.ob(this.getWindows())}nb(R){return this.ob(this.getWindows().filter(j=>(0,r.$ng)(j.remoteAuthority,R)))}ob(R){const j=Math.max.apply(Math,R.map(W=>W.lastFocusTime));return R.find(W=>W.lastFocusTime===j)}sendToFocused(R,...j){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(R,S.CancellationToken.None,...j)}sendToAll(R,j,W){for(const T of this.getWindows())W&&W.indexOf(T.id)>=0||T.sendWhenReady(R,S.CancellationToken.None,j)}getWindows(){return V.a}getWindowCount(){return V.a.length}getWindowById(R){const j=this.getWindows().filter(W=>W.id===R);return(0,D.$Mb)(j)}getWindowByWebContents(R){const j=P.BrowserWindow.fromWebContents(R);if(j)return this.getWindowById(j.id)}};e.$36b=ce,e.$36b=ce=V=ke([_(2,I.$5i),_(3,N.$A6b),_(4,L.$eN),_(5,q.$0m),_(6,i.$t5b),_(7,F.$B5b),_(8,k.$v5b),_(9,t.$M5b),_(10,l.$8h),_(11,oe.$v6b),_(12,G.$Y5b),_(13,a.$Ah),_(14,o.$T5b),_(15,n.$6j),_(16,p.$k6b),_(17,J.$e6b)],ce)}),define(te[306],ie([0,1,64,30,83,54]),function(K,e,P,O,s,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=void 0;let D=class{constructor(h,c,m,w){this.a=h,this.b=c,this.c=m,this.d=w,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,c){const m=this.b.getWindowById(h);if(m)return this.a.enterWorkspace(m,this.b.getWindows(),c)}createUntitledWorkspace(h,c,m){return this.a.createUntitledWorkspace(c,m)}deleteUntitledWorkspace(h,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(h,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(h,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$56b=D,e.$56b=D=ke([_(0,M.$Y5b),_(1,O.$H5b),_(2,s.$v6b),_(3,P.$M5b)],D)}),define(te[307],ie([0,1,15,130,38,27,17,50,14,32,49,44,46,2,13,9,4,12,7,31,146,42,157,110,289,160,64,285,18,198,90,131,60,115,219,28,63,94,207,234,208,294,210,211,212,16,223,93,75,6,92,218,299,286,274,20,5,304,67,24,59,295,95,34,277,82,121,25,251,253,52,48,265,291,300,292,301,126,267,268,269,272,275,30,305,276,29,97,83,306,54,39,232,53,244,51,81,128,279,293,282,8,255,278,227,66,91,297,271,23,124,296,263,239,84]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r,$,E,u,t,l,o,i,n,a,k,I,C,p,A,L,U,z,re,ee,ae,se,oe,G,J,q,F,N,V,Q,x,ce,Y,R,j,W,T,H,B,ne,fe,ge,ue,we,me,Se,Ie,je,ve,be,X,le,de,Ee,Re,Ue,Oe,Be,We,Z,he,$e,ye,Ae,Fe,Le,Ne,ze,qe,He,xe,Qe,tt,nt,$t,rt,mt,wt,bt,pt,yt,vt,kt,ot,Et,St,Pt,It,Ct,at,Dt,ht,ct,At,Rt,lt,Ot){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i7b=void 0;let ut=class extends f.$kc{constructor(Ce,Pe,pe,Me,De,Te,Je,Ze,Xe,Ge,Ve,Ke){super(),this.c=Ce,this.f=Pe,this.g=pe,this.h=Me,this.j=De,this.m=Te,this.n=Je,this.s=Ze,this.t=Xe,this.u=Ge,this.w=Ve,this.y=Ke,this.z(),this.C()}z(){const Ce=Ge=>Ge?.startsWith(`${v.Schemas.vscodeWebview}://`),Pe=new Set(this.w.quality==="stable"?[]:["media"]),pe=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Ge,Ve,Ke,Ye)=>Ce(Ye.requestingUrl)?Ke(pe.has(Ve)):Ye.isMainFrame&&Ye.securityOrigin==="vscode-file://vscode-app/"?Ke(Pe.has(Ve)):Ke(!1)),P.session.defaultSession.setPermissionCheckHandler((Ge,Ve,Ke,Ye)=>Ce(Ye.requestingUrl)?pe.has(Ve):Ye.isMainFrame&&Ye.securityOrigin==="vscode-file://vscode-app/"?Pe.has(Ve):!1);const Me=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),De=Ge=>{for(let Ve=Ge;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},Te=Ge=>Ge.resourceType==="xhr"||De(Ge.frame),Je=Ge=>{const Ve=Ge.frame;if(!Ve||!this.a)return!1;const Ke=P.BrowserWindow.getAllWindows();for(const Ye of Ke)if(Ve.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Ze=(Ge,Ve)=>{if(Ge.path!=="/index.html")return!0;const Ke=Ve.frame;if(!Ke||!this.a)return!1;for(const Ye of this.a.getWindows())if(Ye.win&&Ke.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Ge,Ve)=>{const Ke=r.URI.parse(Ge.url);return Ke.scheme===v.Schemas.vscodeWebview&&!Ze(Ke,Ge)?(this.h.error("Blocked vscode-webview request",Ge.url),Ve({cancel:!0})):Ke.scheme===v.Schemas.vscodeFileResource&&!Je(Ge)?(this.h.error("Blocked vscode-file request",Ge.url),Ve({cancel:!0})):Ke.path.endsWith(".svg")&&!Me.has(Ke.scheme)?Ve({cancel:!Te(Ge)}):Ve({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Ge,Ve)=>{const Ke=Ge.responseHeaders,Ye=Ke["content-type"]||Ke["Content-Type"];if(Ye&&Array.isArray(Ye)){const it=r.URI.parse(Ge.url);if(it.path.endsWith(".svg")&&Me.has(it.scheme))return Ke["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Ke});if(!it.path.endsWith(v.Schemas.vscodeRemoteResource)&&Ye.some(_e=>_e.toLowerCase().includes("image/svg")))return Ve({cancel:!Te(Ge)})}return Ve({cancel:!1})});const Xe=P.session.defaultSession;typeof Xe.setCodeCachePath=="function"&&this.m.codeCachePath&&Xe.setCodeCachePath((0,b.$9d)(this.m.codeCachePath,"chrome")),d.$i&&(this.s.getValue("security.restrictUNCAccess")===!1?(0,O.disableUNCAccessRestrictions)():(0,O.addUNCHostToAllowlist)(this.s.getValue("security.allowedUNCHosts")))}C(){(0,h.setUnexpectedErrorHandler)(pe=>this.F(pe)),process.on("uncaughtException",pe=>{(0,h.$X)(pe)||(0,h.$Y)(pe)}),process.on("unhandledRejection",pe=>(0,h.$Y)(pe)),this.n.onWillShutdown(()=>this.dispose()),(0,E.$VS)(),P.app.on("accessibility-support-changed",(pe,Me)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Me)}),P.app.on("activate",async(pe,Me)=>{this.h.trace("app#activate"),Me||await this.a?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(pe,Me)=>{Me.on("will-navigate",De=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),Me.setWindowOpenHandler(({url:De})=>(this.b?.openExternal(void 0,De),{action:"deny"}))});let Ce=[],Pe;P.app.on("open-file",(pe,Me)=>{this.h.trace("app#open-file: ",Me),pe.preventDefault(),Ce.push((0,qe.$7h)(Me)?{workspaceUri:r.URI.file(Me)}:{fileUri:r.URI.file(Me)}),Pe!==void 0&&(clearTimeout(Pe),Pe=void 0),Pe=setTimeout(async()=>{await this.a?.open({context:1,cli:this.m.args,urisToOpen:Ce,gotoLineMode:!1,preferNewWindow:!0}),Ce=[],Pe=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),s.$US.handle("vscode:fetchShellEnv",pe=>{const Me=this.a?.getWindowByWebContents(pe.sender);let De,Te;return Me?.config?(De=Me.config,Te={...process.env,...Me.config.userEnv}):(De=this.m.args,Te=process.env),this.U(De,Te,!1)}),s.$US.handle("vscode:writeNlsFile",(pe,Me,De)=>{const Te=this.D([Me]);if(!Te||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.u.writeFile(Te,D.$Fd.fromString(De))}),s.$US.handle("vscode:readNlsFile",async(pe,...Me)=>{const De=this.D(Me);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.u.readFile(De)).value.toString()}),s.$US.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),s.$US.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),s.$US.on("vscode:reloadWindow",pe=>pe.sender.reload())}D(Ce){let Pe;for(const pe of Ce)typeof pe=="string"&&(typeof Pe!="string"?Pe=pe:Pe=(0,b.$9d)(Pe,pe));if(!(typeof Pe!="string"||!(0,b.$8d)(Pe)||!(0,c.$If)(Pe,this.m.cachedLanguagesPath,!d.$k)))return r.URI.file(Pe)}F(Ce){if(Ce){const Pe={message:`[uncaught exception in main]: ${Ce.message}`,stack:Ce.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Pe))}this.h.error(`[uncaught exception in main]: ${Ce}`),Ce.stack&&this.h.error(Ce.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.m.appRoot}`),this.h.debug("args:",this.m.args);const Ce=this.w.win32AppUserModelId;d.$i&&Ce&&P.app.setAppUserModelId(Ce);try{d.$j&&this.s.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Xe){this.h.error(Xe)}const Pe=new t.$2S;this.n.onWillShutdown(Xe=>{Xe.reason===2&&Pe.dispose()}),this.h.trace("Resolving machine identifier...");const pe=await(0,Et.$_6b)(this.t,this.h);this.h.trace(`Resolved machine identifier: ${pe}`);const{sharedProcessReady:Me,sharedProcessClient:De}=this.N(pe),Te=await this.O(pe,Me);this.B(Te.createInstance(o.$I5b)),this.B(Te.createInstance(vt.$96b)),Te.invokeFunction(Xe=>this.P(Xe,Pe,De));const Je=Te.invokeFunction(Xe=>this.G(Xe,Pe));this.H(Pe),this.n.phase=2,await Te.invokeFunction(Xe=>this.Q(Xe,Je)),this.n.phase=3,this.R(),this.B(new ot.$Sg(()=>{this.B((0,ot.$Wg)(()=>this.n.phase=4,2500))},2500)).schedule()}G(Ce,Pe){const pe=this.a=Ce.get(Le.$H5b),Me=Ce.get(Z.$IT),De=this.b=Ce.get(fe.$i6b),Te=this;Me.registerHandler({async handleURL(Ke,Ye){return Te.M(pe,Me,Ke,Ye)}});const Je=this.B(new ze.$46b({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),Ze=new u.$jh(Ke=>Je.getActiveClientId().then(Ye=>Ke===Ye)),Xe=new he.$T6b(Ze,this.h),Ge=Pe.getChannel("urlHandler",Xe);Me.registerHandler(new he.$S6b(Ge));const Ve=this.I();return this.B(new ye.$U6b(Ve?.urls,Me,pe,this.m,this.w,this.h)),Ve}H(Ce){const Pe=()=>({statusCode:404,data:"Not found"}),pe=new Ot.$T(()=>Ce.getChannel(lt.$g7b,new lt.$h7b));P.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(Me,De)=>{const Te=r.URI.parse(Me.url);if(!Te.authority.startsWith("window:"))return De(Pe());pe.value.call(lt.$f7b,[Te]).then(Je=>De({...Je,data:Buffer.from(Je.body,"base64")}),Je=>{this.h.warn("error dispatching remote resource call",Je),De({statusCode:500,data:String(Je)})})})}I(){const Ce=this.m.args["open-url"]?this.m.args._urls||[]:[];Ce.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ce);const Pe=global.getOpenUrls()||[];if(Pe.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Pe),Ce.length+Pe.length===0)return;const pe=[];return{urls:[...Ce,...Pe].map(De=>{try{return{uri:r.URI.parse(De),originalUrl:De}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",De);return}}).filter(De=>{if(!De)return!1;if(this.J(De.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",De.uri.toString(!0)),!1;const Te=this.L(De.uri);return Te?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",De.uri.toString(!0),Te),pe.push(Te),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",De.uri.toString(!0)),!0)}),openables:pe}}J(Ce){if(Ce.authority===v.Schemas.file&&d.$i){const{options:Pe,buttonIndeces:pe}=(0,Ct.$vv)({type:"warning",buttons:[(0,i.localize)(0,null),(0,i.localize)(1,null)],message:(0,i.localize)(2,null,(0,y.$hv)(Ce,{os:d.OS,tildify:this.m}),this.w.nameShort),detail:(0,i.localize)(3,null)},this.w);if(pe[P.dialog.showMessageBoxSync(Pe)]===1)return!0}return!1}L(Ce){if(Ce.path){if(Ce.authority===v.Schemas.file){const Pe=r.URI.file(Ce.fsPath);return(0,qe.$7h)(Pe)?{workspaceUri:Pe}:{fileUri:Pe}}else if(Ce.authority===v.Schemas.vscodeRemote){const Pe=Ce.path.indexOf(b.$6d.sep,1);if(Pe!==-1){const pe=Ce.path.substring(1,Pe),Me=Ce.path.substring(Pe);let De=Ce.query;const Te=new URLSearchParams(Ce.query);Te.get("windowId")==="_blank"&&(Te.delete("windowId"),De=Te.toString());const Je=r.URI.from({scheme:v.Schemas.vscodeRemote,authority:pe,path:Me,query:De,fragment:Ce.fragment});return(0,qe.$7h)(Me)?{workspaceUri:Je}:/:[\d]+$/.test(Me)?{fileUri:Je}:{folderUri:Je}}}}}async M(Ce,Pe,pe,Me){if(this.h.trace("app#handleProtocolUrl():",pe.toString(!0),Me),pe.scheme===this.w.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:r.URI.parse(pe.query).path,query:""})),this.J(pe))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let De=!1;const Te=new URLSearchParams(pe.query);Te.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Te.delete("windowId"),pe=pe.with({query:Te.toString()}),De=!0):d.$j&&Ce.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),De=!0);const Je=Te.get("continueOn");Je!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),Te.delete("continueOn"),pe=pe.with({query:Te.toString()}),this.m.continueOn=Je??void 0);const Ze=this.L(pe);return Ze?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Ze,pe.toString(!0)),(0,ht.$Mb)(await Ce.open({context:5,cli:{...this.m.args},urisToOpen:[Ze],forceNewWindow:De,gotoLineMode:!0}))?.focus(),!0):De?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,ht.$Mb)(await Ce.open({context:5,cli:{...this.m.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ue.$Ok)(pe)}))?.ready(),Pe.open(pe,Me)):(this.h.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Me),!1)}N(Ce){const Pe=this.B(this.g.createInstance(we.$F6b,Ce)),pe=(async()=>{this.h.trace("Main->SharedProcess#connect");const De=await Pe.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new l.$3S(De,"main")})();return{sharedProcessReady:(async()=>(await Pe.whenReady(),pe))(),sharedProcessClient:pe}}async O(Ce,Pe){const pe=new Y.$zh;switch(process.platform){case"win32":pe.set(Ee.$UT,new x.$yh(We.$Q6b));break;case"linux":d.$l?pe.set(Ee.$UT,new x.$yh(Be.$P6b,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(Ee.$UT,new x.$yh(Oe.$O6b));break;case"darwin":pe.set(Ee.$UT,new x.$yh(Ue.$N6b));break}pe.set(Le.$H5b,new x.$yh(Ne.$36b,[Ce,this.f],!1));const Me=new A.$U5b(this.h,this.w);pe.set(A.$T5b,Me),pe.set(T.$p6b,new x.$yh(T.$q6b,void 0,!1)),pe.set(p.$45b,new x.$yh(p.$55b,void 0,!1)),pe.set(C.$gm,u.ProxyChannel.toService((0,u.$hh)(Pe.then(Xe=>Xe.getChannel("diagnostics"))))),pe.set(R.$qtb,new x.$yh(j.$l6b,[this.f])),pe.set(L.$CT,new x.$yh(U.$65b)),pe.set(W.$m6b,new x.$yh(W.$n6b)),pe.set(fe.$i6b,new x.$yh(fe.$j6b,void 0,!1)),pe.set(Ae.$V6b,new x.$yh(Fe.$X6b)),pe.set(ne.$y6b,new x.$yh(ne.$z6b)),pe.set(ae.$9kb,new x.$yh(se.$75b)),pe.set(oe.$85b,new x.$yh(G.$05b)),pe.set(je.$D5b,new x.$yh(je.$E5b)),pe.set(je.$F5b,new x.$yh(je.$G5b));const De=new At.$e7b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.s.getValue("terminal.integrated.persistentSessionScrollback")??100},this.s,this.m,this.n,this.h),Te=new Rt.$lr(De,this.s,this.h,this.j);pe.set(ct.$Yq,Te),d.$i?pe.set(J.$$5b,new x.$yh(q.$_5b)):d.$j?pe.set(J.$$5b,new x.$yh(q.$a6b)):d.$k&&pe.set(J.$$5b,new x.$yh(q.$b6b));const Je=new a.$R5b(this.m,this.s,this.h,this.t);pe.set(n.$M5b,Je);const Ze=new tt.$Z5b(this.m,this.h,this.y,Je,Me);if(pe.set(tt.$Y5b,Ze),pe.set(He.$fU,new x.$yh(Qe.$56b,void 0,!1)),pe.set(xe.$v6b,new x.$yh(xe.$w6b,void 0,!1)),pe.set(Z.$IT,new x.$yh($e.$KT,void 0,!1)),(0,de.$ho)(this.w,this.m)){const Xe=(0,de.$mo)(this.w,this.s),Ge=(0,u.$hh)(Pe.then(_e=>_e.getChannel("telemetryAppender"))),Ve=new X.$I6b(Ge),Ke=(0,ve.$0n)((0,M.release)(),(0,M.hostname)(),process.arch,this.w.commit,this.w.version,Ce,Xe),Ye=(0,de.$no)(this.m),it={appenders:[Ve],commonProperties:Ke,piiPaths:Ye,sendErrorTelemetry:!0};pe.set(be.$9k,new x.$yh(le.$Qq,[it],!1))}else pe.set(be.$9k,de.$bo);return pe.set(bt.$kp,new x.$yh(St.$lN,void 0,!0)),pe.set(pt.$op,new x.$yh(yt.$86b,void 0,!0)),pe.set(at.$c7b,new x.$yh(at.$d7b,void 0,!0)),await ot.Promises.settled([Je.initialize(),Ze.initialize()]),this.g.createChild(pe)}P(Ce,Pe,pe){const Me=this.B(new f.$jc),De=u.ProxyChannel.fromService(Ce.get(T.$p6b),Me,{disableMarshalling:!0});this.c.registerChannel("launch",De);const Te=u.ProxyChannel.fromService(Ce.get(p.$45b),Me,{disableMarshalling:!0});this.c.registerChannel("diagnostics",Te);const Je=new $t.$66b(Ce.get(nt.$0m));Pe.registerChannel("policy",Je),pe.then(et=>et.registerChannel("policy",Je));const Ze=this.u.getProvider(v.Schemas.file);(0,g.$tf)(Ze instanceof Q.$3p);const Xe=new V.$c6b(Ze,this.h,this.m);Pe.registerChannel(F.$7M,Xe),pe.then(et=>et.registerChannel(F.$7M,Xe));const Ge=u.ProxyChannel.fromService(Ce.get(rt.$B5b),Me);Pe.registerChannel("userDataProfiles",Ge),pe.then(et=>et.registerChannel("userDataProfiles",Ge));const Ve=new mt.$Lq(Ce.get(wt.$Io));pe.then(et=>et.registerChannel("request",Ve));const Ke=new Re.$J6b(Ce.get(Ee.$UT));Pe.registerChannel("update",Ke);const Ye=u.ProxyChannel.fromService(Ce.get(R.$qtb),Me);Pe.registerChannel("issue",Ye);const it=u.ProxyChannel.fromService(Ce.get(L.$CT),Me);Pe.registerChannel("encryption",it);const _e=u.ProxyChannel.fromService(Ce.get(me.$Wk),Me);Pe.registerChannel("sign",_e);const st=u.ProxyChannel.fromService(Ce.get(W.$m6b),Me);Pe.registerChannel("keyboardLayout",st),this.b=Ce.get(fe.$i6b);const ft=u.ProxyChannel.fromService(this.b,Me);Pe.registerChannel("nativeHost",ft),pe.then(et=>et.registerChannel("nativeHost",ft));const Mt=u.ProxyChannel.fromService(Ce.get(He.$fU),Me);Pe.registerChannel("workspaces",Mt);const Lt=u.ProxyChannel.fromService(Ce.get(ne.$y6b),Me);Pe.registerChannel("menubar",Lt);const jt=u.ProxyChannel.fromService(Ce.get(Z.$IT),Me);Pe.registerChannel("url",jt);const Ft=u.ProxyChannel.fromService(Ce.get(ae.$9kb),Me);Pe.registerChannel("extensionUrlTrust",Ft);const Ut=u.ProxyChannel.fromService(Ce.get(Ae.$V6b),Me);Pe.registerChannel("webview",Ut);const dt=this.B(new Ie.$G6b(this.h,Ce.get(je.$D5b)));Pe.registerChannel("storage",dt),pe.then(et=>et.registerChannel("storage",dt));const Nt=this.B(new kt.$06b(Ce.get(je.$D5b),Ce.get(rt.$B5b),this.h));pe.then(et=>et.registerChannel("profileStorageListener",Nt));const Tt=u.ProxyChannel.fromService(Ce.get(ct.$Yq),Me);Pe.registerChannel(ct.TerminalIpcChannels.LocalPty,Tt);const Wt=u.ProxyChannel.fromService(Ce.get(J.$$5b),Me);Pe.registerChannel("externalTerminal",Wt);const gt=new Pt.$a7b(Ce.get(It.$A6b));Pe.registerChannel("logger",gt),pe.then(et=>et.registerChannel("logger",gt));const Bt=new I.$S5b(Ce.get(Le.$H5b));Pe.registerChannel("extensionhostdebugservice",Bt);const zt=u.ProxyChannel.fromService(Ce.get(oe.$85b),Me);Pe.registerChannel(oe.$95b,zt);const qt=u.ProxyChannel.fromService(Ce.get(at.$c7b),Me);Pe.registerChannel(Dt.$b7b,qt)}async Q(Ce,Pe){const pe=this.a=Ce.get(Le.$H5b),Me=(0,re.$Gl)(process.env)?0:4,De=this.m.args;if(Pe){if(Pe.openables.length>0)return pe.open({context:Me,cli:De,urisToOpen:Pe.openables,gotoLineMode:!0,initialStartup:!0});if(Pe.urls.length>0)for(const _e of Pe.urls){const st=new URLSearchParams(_e.uri.query);if(st.get("windowId")==="_blank")return st.delete("windowId"),_e.originalUrl=_e.uri.toString(!0),_e.uri=_e.uri.with({query:st.toString()}),pe.open({context:Me,cli:De,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Te=global.macOpenFiles,Je=De._.length,Ze=!!De["folder-uri"],Xe=!!De["file-uri"],Ge=De["skip-add-to-recently-opened"]===!0,Ve=De.wait&&De.waitMarkerFilePath?r.URI.file(De.waitMarkerFilePath):void 0,Ke=De.remote||void 0,Ye=De.profile,it=De["profile-temp"];if(!Je&&!Ze&&!Xe){if(De["new-window"]||Ye||it)return pe.open({context:Me,cli:De,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Ke,forceProfile:Ye,forceTempProfile:it});if(Te.length)return pe.open({context:1,cli:De,urisToOpen:Te.map(_e=>(0,qe.$7h)(_e)?{workspaceUri:r.URI.file(_e)}:{fileUri:r.URI.file(_e)}),noRecentEntry:Ge,waitMarkerFileURI:Ve,initialStartup:!0})}return pe.open({context:Me,cli:De,forceNewWindow:De["new-window"]||!Je&&De["unity-launch"],diffMode:De.diff,mergeMode:De.merge,noRecentEntry:Ge,waitMarkerFileURI:Ve,gotoLineMode:De.goto,initialStartup:!0,remoteAuthority:Ke,forceProfile:Ye,forceTempProfile:it})}R(){this.S(),P.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Ce,Pe)=>{Pe({url:Ce.url.replace(/^vscode-remote-resource:/,"http:"),method:Ce.method})}),this.U(this.m.args,process.env,!0),this.W(),d.$j&&P.app.runningUnderARM64Translation&&this.a?.sendToFocused("vscode:showTranslatedBuildWarning")}async S(){const Ce=this.w.win32MutexName;if(d.$i&&Ce)try{const Pe=await new Promise((Me,De)=>{K(["@vscode/windows-mutex"],Me,De)}),pe=new Pe.Mutex(Ce);(0,m.$bb)(this.n.onWillShutdown)(()=>pe.release())}catch(Pe){this.h.error(Pe)}}async U(Ce,Pe,pe){try{return await(0,ee.$Ml)(this.s,this.h,Ce,Pe)}catch(Me){const De=(0,S.$mi)(Me);pe?this.a?.sendToFocused("vscode:showResolveShellEnvError",De):this.h.error(De)}return{}}async W(){try{const Pe=(await this.u.readFile(this.m.argvResource)).value.toString(),pe=JSON.parse((0,w.$Tm)(Pe)),De=(0,de.$jo)(this.s)>=1;if(pe["enable-crash-reporter"]===void 0){const Te=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${De},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,$.$4f)()}"`,"}"],Je=Pe.substring(0,Pe.length-2).concat(`,
`,Te.join(`
`));await this.u.writeFile(this.m.argvResource,D.$Fd.fromString(Je))}else{const Te=Pe.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${De},`);Te!==Pe&&await this.u.writeFile(this.m.argvResource,D.$Fd.fromString(Te))}}catch(Ce){this.h.error(Ce)}}};e.$i7b=ut,e.$i7b=ut=ke([_(2,ce.$Ah),_(3,B.$5i),_(4,B.$6i),_(5,z.$t5b),_(6,H.$v5b),_(7,k.$8h),_(8,Se.$eN),_(9,N.$6j),_(10,ge.$kj),_(11,rt.$B5b)],ut)}),define(te[313],ie([0,1,15,45,7,23,8,50,14,32,49,46,13,9,65,4,35,26,21,42,99,307,10,18,238,250,28,63,200,16,221,93,75,217,92,20,224,5,77,24,78,280,125,290,51,288,95,249,34,52,79,53,39,233,231,2,40,266,66,226,91,120,270,264]),function(K,e,P,O,s,M,D,S,h,c,m,w,y,f,v,b,d,g,r,$,E,u,t,l,o,i,n,a,k,I,C,p,A,L,U,z,re,ee,ae,se,oe,G,J,q,F,N,V,Q,x,ce,Y,R,j,W,T,H,B,ne,fe,ge,ue,we,me){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Se{main(){try{this.a()}catch(ve){console.error(ve.message),P.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[ve,be,X,le,de,Ee,Re,Ue]=this.b();try{try{await this.d(X,Ue,le,de,Re)}catch(Oe){throw this.f(X,Re,Oe),Oe}await ve.invokeFunction(async Oe=>{const Be=Oe.get(ee.$5i),We=Oe.get(z.$v5b),Z=Oe.get(I.$6j),he=Oe.get(ee.$6i),$e=await this.e(Be,X,We,ve,Re,!0);return r.Promises.writeFile(X.mainLockfile,String(process.pid)).catch(ye=>{Be.warn(`app#startup(): Error writing main lockfile: ${ye.stack}`)}),Ee.logger=he.createLogger("main",{name:(0,t.localize)(0,null)}),(0,m.$bb)(We.onWillShutdown)(ye=>{Z.dispose(),le.dispose(),ye.join("instanceLockfile",r.Promises.unlink(X.mainLockfile).catch(()=>{}))}),ve.createInstance(u.$i7b,$e,be).startup()})}catch(Oe){ve.invokeFunction(this.i,Oe)}}b(){const ve=new U.$zh,be=new H.$jc;process.once("exit",()=>be.dispose());const X={_serviceBrand:void 0,...ae.default};ve.set(se.$kj,X);const le=new n.$u5b(this.j(),X),de=this.c(le);ve.set(n.$t5b,le);const Ee=new fe.$B6b((0,ee.$gj)(le),le.logsHome);ve.set(fe.$A6b,Ee);const Re=new re.$c3b(Ee.getLogLevel()),Ue=be.add(new ge.$mN(Re,[new ee.$_i(Ee.getLogLevel())]));ve.set(ee.$5i,Ue);const Oe=new C.$Dp(Ue);ve.set(I.$6j,Oe);const Be=new p.$3p(Ue);Oe.registerProvider(y.Schemas.file,Be);const We=new ne.$pr(Oe);ve.set(B.$Ck,We);const Z=new we.$hN(1,le,Ue,Oe);ve.set(x.$dN,Z),ve.set(x.$eN,Z);const he=new R.$C5b(Z,We,le,Oe,Ue);ve.set(R.$B5b,he),Oe.registerProvider(y.Schemas.vscodeUserData,new me.$t7b(y.Schemas.file,Be,y.Schemas.vscodeUserData,he,We,Ue));const $e=b.$i&&X.win32RegValueName?be.add(new W.$r7b(Ue,X.win32RegValueName)):le.policyFile?be.add(new T.$s7b(le.policyFile,Oe,Ue)):new j.$_m;ve.set(j.$0m,$e);const ye=new o.$zn(he.defaultProfile.settingsResource,Oe,$e,Ue);return ve.set(l.$8h,ye),ve.set(z.$v5b,new A.$yh(z.$w5b,void 0,!1)),ve.set(F.$Io,new A.$yh(N.$p7b,void 0,!0)),ve.set(Y.$e6b,new A.$yh(Y.$f6b)),ve.set(V.$Wk,new A.$yh(Q.$q7b,void 0,!1)),ve.set(J.$Zu,new A.$yh(q.$n7b)),ve.set(oe.$k6b,new G.$k7b(le,he,Ue)),[new L.$6p(ve,!0),de,le,ye,Z,Re,X,he]}c(ve){const be={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(X=>{const le=process.env[X];typeof le=="string"&&(be[X]=le)}),Object.assign(process.env,be),be}async d(ve,be,X,le,de){await D.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsHome.with({scheme:y.Schemas.file}).fsPath,be.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath,ve.workspaceStorageHome.with({scheme:y.Schemas.file}).fsPath,ve.localHistoryHome.with({scheme:y.Schemas.file}).fsPath,ve.backupHome].map(Ee=>Ee?r.Promises.mkdir(Ee,{recursive:!0}):void 0)),le.init(),X.initialize()]),be.init()}async e(ve,be,X,le,de,Ee){let Re;try{(0,v.mark)("code/willStartMainServer"),Re=await(0,E.$wh)(be.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),(0,m.$bb)(X.onWillShutdown)(()=>Re.dispose())}catch(Ue){if(Ue.code!=="EADDRINUSE")throw this.f(be,de,Ue),Ue;let Oe;try{Oe=await(0,E.$xh)(be.mainIPCHandle,"main")}catch(he){if(!Ee||b.$i||he.code!=="ECONNREFUSED")throw he.code==="EPERM"&&this.g((0,t.localize)(1,null,de.nameShort),(0,t.localize)(2,null),de),he;try{(0,O.unlinkSync)(be.mainIPCHandle)}catch($e){throw ve.warn("Could not delete obsolete instance handle",$e),$e}return this.e(ve,be,X,le,de,!1)}if(be.extensionTestsLocationURI&&!be.debugExtensionHost.break){const he=`Running extension tests from the command line is currently only supported if no other instance of ${de.nameShort} is running.`;throw ve.error(he),Oe.dispose(),new Error(he)}let Be;!be.args.wait&&!be.args.status&&(Be=setTimeout(()=>{this.g((0,t.localize)(3,null,de.nameShort),(0,t.localize)(4,null),de)},1e4));const We=$.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Z=$.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(be.args.status)return le.invokeFunction(async()=>{const he=new i.$wr(ce.$bo,de),$e=await Z.getMainDiagnostics(),ye=await Z.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Ae=await he.getDiagnostics($e,ye);throw console.log(Ae),new h.$$});throw b.$i&&await this.h(We,ve),ve.trace("Sending env to running instance..."),await We.start(be.args,process.env),Oe.dispose(),Be&&clearTimeout(Be),new h.$$("Sent env to running instance. Terminating...")}if(be.args.status)throw console.log((0,t.localize)(5,null,de.nameShort)),new h.$$("Terminating...");return process.env.VSCODE_PID=String(process.pid),Re}f(ve,be,X){if(X.code==="EACCES"||X.code==="EPERM"){const le=(0,M.$Fb)([ve.userDataPath,ve.extensionsPath,E.$sh]).map(de=>(0,w.$hv)(s.URI.file(de),{os:b.OS,tildify:ve}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,S.$mi)(X),le.join(`
`)),be)}}g(ve,be,X){P.dialog.showMessageBoxSync((0,ue.$vv)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ve,detail:be},X).options)}async h(ve,be){if(b.$i){const X=await ve.getMainProcessId();be.trace("Sending some foreground love to the running instance:",X);try{(await new Promise((le,de)=>{K(["windows-foreground-love"],le,de)})).allowSetForegroundWindow(X)}catch(le){be.error(le)}}}i(ve,be){const X=ve.get(ee.$5i),le=ve.get(z.$v5b);let de=0;be&&(be.isExpected?be.message&&X.trace(be.message):(de=1,be.stack?X.error(be.stack):X.error(`Startup error: ${be.toString()}`))),le.kill(de)}j(){const ve=this.k((0,a.$Dl)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const be=(0,k.$j7b)(ve.verbose);be&&((0,a.$Fl)(process.argv,"--waitMarkerFilePath",be),ve.waitMarkerFilePath=be)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const be=this.l(ve._,ve.goto);ve._=be}return ve}l(ve,be){const X=(0,d.cwd)(),le=ve.map(Re=>{let Ue=String(Re),Oe;be&&(Oe=(0,c.$Pf)(Ue),Ue=Oe.path),Ue&&(Ue=this.m(X,Ue));const Be=(0,c.$Kf)(Ue,X),We=(0,f.$ae)(Be);return We&&!(0,c.$Gf)(We)?null:be&&Oe?(Oe.path=Be,this.n(Oe)):Be}),de=b.$i||b.$j,Ee=(0,M.$Kb)(le,Re=>Re&&de?Re.toLowerCase():Re||"");return(0,M.$Fb)(Ee)}m(ve,be){return b.$i&&(be=(0,g.$ve)(be,'"')),be=(0,g.$te)((0,g.$te)(be," "),"	"),b.$i&&(be=(0,f.$0d)(ve,be),be=(0,g.$ve)(be,".")),be}n(ve){const be=[ve.path];return typeof ve.line=="number"&&be.push(String(ve.line)),typeof ve.column=="number"&&be.push(String(ve.column)),be.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/11bfd76a61a299156a9f3138ecfad70937af3527/core/vs/code/electron-main/main.js.map
